function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "index";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    if (INSTRUMENT.test && !INSTRUMENT.test.ui) Alloy.createController("test").getView().open(); else {
        var appState = require("/bootstrap/appstate"), trackingEvent = require("/tracking/tracking_event"), analytics = require("/tracking/tracking_manager");
        var globalEventsOnce = function(name, callback, options) {
            if (appState.isIndexJsExecuted()) return;
            Ti.App.addAppEventListener(name, callback, options);
        };
        try {
            !function() {
                function fbLoginCallback(win) {
                    win && (win.fbProxy = require("facebook/facebook_manager").createActivityWorker(win));
                }
                var homeView = null;
                var loginSuccess = function(data) {
                    if (homeView) {
                        homeView.exitOnClose = false;
                        homeView.close();
                        homeView = null;
                    }
                    var resourceOwner = require("services/resource_owner_service").singleton();
                    Ti.App.fireEvent("carma:window.destroy");
                    var openHomeView = function() {
                        require("featuretoggles/featuretoggles").ensureStarted();
                        require("gps/gps_manager").init();
                        data && data.callback && data.callback();
                        require("ui/tabs_helper").initTabs(data);
                        Ti.App.fireEvent("carma:initialized");
                    };
                    var userHasNoTrips = Ti.App.Properties.getBool("carma.notrip." + resourceOwner.get("userId"), false);
                    if (userHasNoTrips) Alloy.createModel("trips", {
                        urlParams: {
                            userId: resourceOwner.get("userId")
                        }
                    }).fetch().then(function(data) {
                        if (data && data.paginator && 0 !== data.paginator.totalResults) {
                            Ti.App.Properties.setBool("carma.notrip." + resourceOwner.get("userId"), false);
                            openHomeView();
                        } else Ti.App.fireEvent("carma:trips.require");
                    }).catch(function() {
                        openHomeView();
                    }); else {
                        openHomeView();
                        Alloy.createModel("trips", {
                            urlParams: {
                                userId: resourceOwner.get("userId")
                            }
                        }).fetch().then(function(data) {
                            data && data.paginator && 0 !== data.paginator.totalResults ? Ti.App.Properties.setBool("carma.notrip." + resourceOwner.get("userId"), false) : Ti.App.Properties.setBool("carma.notrip." + resourceOwner.get("userId"), true);
                        }).catch(function() {});
                    }
                    Ti.App.fireEvent("carma:push.notification.register", null);
                    require("services/user_service").findOwn();
                };
                globalEventsOnce("carma:login.success", loginSuccess, {
                    debounce: true
                });
                globalEventsOnce("carma:push.notification.open", function() {
                    homeView && (homeView = null);
                });
                globalEventsOnce("carma:logout", function() {
                    if (!homeView) {
                        homeView = Alloy.createWidget("ma.car.app.home").getView();
                        homeView.open();
                    }
                    var resourceOwner = require("services/resource_owner_service").singleton();
                    if (!resourceOwner.hasLogin()) return;
                    var oAuthToken = resourceOwner.get("token") ? resourceOwner.get("token").token : null;
                    var userId = resourceOwner.get("userId");
                    Ti.App.fireEvent("carma:push.notification.unregister", {
                        oAuthToken: oAuthToken,
                        userId: userId
                    });
                    require("gps/gps_manager").stop();
                    require("services/resource_owner_service").clear();
                    Ti.App.fireEvent("carma:window.destroy");
                    if (Ti.App.Properties.getBool("carma.server.switch")) {
                        Ti.App.Properties.setBool("carma.server.switch", false);
                        var winda = Ti.UI.createWindow({
                            backgroundColor: "#000"
                        });
                        var label = Ti.UI.createLabel({
                            text: L("server_switch.message"),
                            color: "#fff",
                            width: "auto",
                            height: "auto"
                        });
                        winda.add(label);
                        winda.open();
                    }
                    analytics.track(trackingEvent.LOGOUT);
                });
                globalEventsOnce("carma:resetpassword", function(params) {
                    LOGGER.debug("RESETPWD - reset password event");
                    Alloy.createWidget("ma.car.app.login", params).getView().open();
                });
                globalEventsOnce("carma:verify.email", function(params) {
                    var verification_service = require("services/verify_email_service");
                    verification_service.verify(params.url);
                });
                globalEventsOnce("carma:trips.require", function() {
                    Ti.App.fireEvent("carma:window.destroy");
                    var resourceOwner = require("services/resource_owner_service").singleton();
                    var requirePhoto = 1 == resourceOwner.get("userHasPhoto") ? false : true;
                    Alloy.createWidget("ma.car.app.addcommute", "widget", {
                        requirePhoto: requirePhoto
                    }).getView().open();
                });
                if (INSTRUMENT.reset) {
                    Ti.App.fireEvent("carma:logout");
                    return;
                }
                var resourceOwner = require("services/resource_owner_service").singleton();
                if (resourceOwner.hasLogin()) {
                    loginSuccess();
                    return;
                }
                var openLoginScreen = function(fbLoginCallback) {
                    homeView = Alloy.createWidget("ma.car.app.home").getView();
                    homeView.open();
                    LOGGER.debug("[CustomWindow] - open home");
                };
                var ensureStarted = function(delay) {
                    delay = delay || 0;
                    setTimeout(function() {
                        require("featuretoggles/featuretoggles").ensureStarted();
                    }, delay);
                };
                if (!Ti.App.Properties.getBool("carma:intro.displayed", false) && !INSTRUMENT.noscroller) {
                    try {
                        var intro = Alloy.createWidget("ma.car.app.intro");
                        var introView = intro.getView();
                        fbLoginCallback(introView);
                        introView.open();
                        intro.lockViews();
                    } catch (e) {
                        Ti.App.Properties.setBool("carma:intro.displayed", true);
                        openLoginScreen(fbLoginCallback);
                    }
                    return;
                }
                openLoginScreen(fbLoginCallback);
            }();
        } catch (e) {
            alert("Could not start Carma: " + JSON.stringify(e));
        }
        appState.startIndexJs();
    }
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;