function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    function getCurrentWindow() {
        var ui = require("utils/ui"), _window = ui.getWindow($.mainWindow);
        return _window;
    }
    function cleanup() {
        exports.clearHistory(0);
        exports.clearContent();
    }
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "navigation";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.appWrap = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.pct100,
        top: 0,
        left: 0,
        zIndex: 0,
        height: Ti.UI.FILL,
        id: "appWrap"
    });
    $.__views.appWrap && $.addTopLevelView($.__views.appWrap);
    $.__views.navBar = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.pct100,
        top: 0,
        left: 0,
        height: "50dp",
        zIndex: 1,
        id: "navBar"
    });
    $.__views.appWrap.add($.__views.navBar);
    $.__views.cancelArrow = Ti.UI.createView({
        left: 0,
        bottom: 0,
        height: "50dp",
        width: "70dp",
        visible: false,
        id: "cancelArrow"
    });
    $.__views.navBar.add($.__views.cancelArrow);
    $.__views.cancelArrowLabel = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontFamily: "splinico",
            fontWeight: "bold",
            fontSize: "24dp"
        },
        text: "h",
        left: "10dp",
        bottom: 0,
        height: "50dp",
        width: "60dp",
        id: "cancelArrowLabel"
    });
    $.__views.cancelArrow.add($.__views.cancelArrowLabel);
    $.__views.navBarTitle = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        height: "24dp",
        bottom: "11dp",
        left: "72dp",
        right: "72dp",
        ellipsize: true,
        wordWrap: false,
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        minimumFontSize: "10dp",
        id: "navBarTitle"
    });
    $.__views.navBar.add($.__views.navBarTitle);
    $.__views.btnDone = require("/ui/common/custom_button").createButton({
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        title: L("btn_done"),
        width: "78dp",
        height: "34dp",
        right: "5dp",
        bottom: "8dp",
        visible: false,
        id: "btnDone"
    });
    $.__views.navBar.add($.__views.btnDone);
    $.__views.btnEdit = require("/ui/common/custom_button").createButton({
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        color: Alloy.Globals.Style.Color.DarkGray,
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        normalColor: "#00333333",
        selectedColor: "#70333333",
        backgroundImage: "none",
        borderColor: Alloy.Globals.Style.Color.DarkGray,
        borderWidth: 2,
        title: L("btn_edit"),
        width: "78dp",
        height: "34dp",
        right: "5dp",
        bottom: "8dp",
        visible: false,
        id: "btnEdit"
    });
    $.__views.navBar.add($.__views.btnEdit);
    $.__views.overlay = Ti.UI.createView({
        top: 0,
        left: 0,
        height: "50dp",
        zIndex: 2,
        visible: false,
        backgroundColor: "black",
        opacity: "0.8",
        id: "overlay"
    });
    $.__views.appWrap.add($.__views.overlay);
    $.__views.main = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.pct100,
        top: "50dp",
        bottom: 0,
        scrollType: "vertical",
        layout: "vertical",
        id: "main"
    });
    $.__views.appWrap.add($.__views.main);
    $.__views.connectionIndicator = require("/ui/common/connection_indicator").createView({
        id: "connectionIndicator"
    });
    $.__views.main.add($.__views.connectionIndicator);
    $.__views.content = Ti.UI.createView({
        width: "100%",
        zIndex: 0,
        height: Ti.UI.FILL,
        id: "content"
    });
    $.__views.main.add($.__views.content);
    $.__views.bottomBar = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.pct100,
        height: "50dp",
        backgroundColor: "#802d2d2c",
        left: 0,
        bottom: 0,
        visible: false,
        zIndex: 1,
        id: "bottomBar"
    });
    $.__views.appWrap.add($.__views.bottomBar);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var Q = require("vendor/q"), animation = require("alloy/animation"), event = require("/tracking/tracking_event"), analytics = require("/tracking/tracking_manager"), stepsWidget = null, Safe = require("utils/safe"), Utils = require("utils/utils"), NavigationQueue = require("navigation/NavigationSingletonQueue");
    var TRANSITION_TIMEOUT = 3e3;
    $.prop = {};
    $.prop.historyStack = void 0;
    $.prop.historyStackOptions = void 0;
    $.prop.historyRightAction = void 0;
    $.prop.historyRightActionEnabled = void 0;
    $.prop.historyRightActionVisible = void 0;
    $.prop.historyLimit = 20;
    $.prop.index = void 0;
    $.prop.indexOptions = void 0;
    $.prop.defaultOpenTransition = {
        transition: "slideInFromRight",
        duration: 150
    };
    $.prop.defaultBackTransition = {
        transition: "slideInFromLeft",
        duration: 150
    };
    $.prop.confirmOnExit = true;
    $.prop.disableBack = false;
    $.prop.defaultDisableBack = {
        disableBack: false
    };
    $.prop.top = 0;
    $.transitions = {};
    $.mainWindow = void 0;
    $.previous = {
        controller: void 0,
        options: void 0,
        view: void 0
    };
    $.current = {
        controller: void 0,
        options: void 0,
        view: void 0
    };
    $.clearMemory = true;
    var addCoverImage = function(imagePath) {
        var deviceWidth = Ti.Platform.displayCaps.platformWidth, deviceHeight = Ti.Platform.displayCaps.platformHeight;
        var imageView = Ti.UI.createImageView({
            defaultImage: imagePath,
            image: imagePath,
            width: deviceWidth,
            height: deviceHeight,
            zIndex: 0
        });
        $.mainWindow.add(imageView);
    };
    var _prepareNavigationBar = function(options, isForOpen) {
        false === options.navBarVisible ? exports.hideNavBar() : exports.showNavBar();
        exports.setTitle(options.title);
        if (options.btnDone && true === options.btnDone.visible) {
            exports.showDoneButton();
            exports.setDoneButtonText(options.btnDone.text || L("btn_done"));
        } else exports.hideDoneButton();
        options.disableBack ? exports.hideBackButton() : exports.showBackButton();
        true && $.prop.modal && ($.cancelArrow.visible = 1 === $.prop.historyStack.length);
    };
    var sendTrackEventForCurrentPage = function(current) {
        TM.push(function() {
            var viewId = current.view.id, trackingData = {};
            viewId && (trackingData.view = viewId);
            current.controller.hasOwnProperty("trackingData") && (trackingData = _.extend(trackingData, current.controller.trackingData));
            analytics.track(event.PAGE_HIT, trackingData);
        }, process.backgroundDomain);
    };
    var animCancelArrow = function() {
        $.cancelArrow.animate({
            autoreverse: true,
            duration: 50,
            transform: Ti.UI.create2DMatrix({
                scale: .7
            })
        }, exports.back);
    };
    var animBack = function() {
        $.backArrow.animate({
            autoreverse: true,
            duration: 50,
            transform: Ti.UI.create2DMatrix({
                scale: .7
            })
        }, exports.back);
    };
    exports.init = function(args) {
        args = args || {};
        args.index = args.index || null;
        void 0 !== args.clearMemory && ($.clearMemory = args.clearMemory);
        LOGGER.debug("Initializing navigation controller...");
        if ("white" === args.theme) {
            $.navBarTitle.color = "white";
            $.cancelArrow.color = "white";
        }
        args.navBarColor && ($.navBar.backgroundColor = args.navBarColor);
        $.appWrap.top = args.top;
        $.prop.historyStack = [];
        $.prop.historyStackOptions = [];
        $.prop.historyRightAction = [];
        $.prop.historyRightActionEnabled = [];
        $.prop.historyRightActionVisible = [];
        $.mainWindow = args.mainWindow;
        delete args.mainWindow;
        args.modal && ($.cancelArrow.visible = true);
        args.coverImage && addCoverImage(args.coverImage);
        if (args.stepsWidget) {
            exports.showBottomBar();
            $.bottomBar.add(args.stepsWidget.getView());
        }
        var contentView = $.getView(), zIndex = contentView.zIndex || 0;
        contentView.zIndex = ++zIndex;
        $.mainWindow.add(contentView);
        contentView = null;
        $.mainWindow.addEventListener("open", function handler() {
            $.mainWindow.removeEventListener("open", handler);
            var animation;
            $.mainWindow.visible = true;
            exports.home(_.extend(args, {
                title: args.title ? args.title.toUpperCase() : ""
            }), args.callback);
        });
        $.cancelArrow.addEventListener("click", animCancelArrow);
        $.btnDone.addEventListener("click", doneClick);
        $.btnEdit.addEventListener("click", editClick);
        $.mainWindow.addEventListener("androidback", onAndroidBack);
        var _historyLimit = args.historyLimit;
        $.mainWindow.addEventListener("close", function handler() {
            $.mainWindow.removeEventListener("close", handler);
            $.cancelArrow.removeEventListener("click", animCancelArrow);
            $.btnDone.removeEventListener("click", doneClick);
            $.btnEdit.removeEventListener("click", editClick);
            $.mainWindow.removeEventListener("androidback", onAndroidBack);
            cleanup();
            Utils.clean($.mainWindow);
            $.mainWindow = null;
            $.current = null;
            $.previous = null;
            $.transitions = {};
            $.prop = {};
            args = {};
        });
        $.mainWindow.addAppEventListener("carma:network.change", handler = function(data) {
            $.connectionIndicator.handleNetwork(data);
        });
        for (var option in args) exports.set(option, args[option]);
        $.prop.handleClose = $.prop.handleClose;
        false === args.navBarVisible ? exports.hideNavBar() : exports.showNavBar();
        args.around && ($.prop.around = _.extend({}, args.around));
        LOGGER.info("Navigation controller initialization complete!");
    };
    exports.get = function(property) {
        return $.prop.hasOwnProperty(property) ? $.prop[property] : void 0;
    };
    exports.set = function(property, value) {
        $.prop[property] = value;
    };
    exports.getMainWindow = function() {
        return $.mainWindow;
    };
    exports.open = function(controller, options, callback) {
        if (navAnimationRunning) return;
        exports.fireEvent("nav.openstart", {
            tag: "string" != typeof controller && controller.TAG
        });
        if (!controller) throw new Error("No controller specified");
        options = _.extend({}, $.prop.defaultOpenTransition, $.prop.defaultDisableBack, options);
        if ("string" == typeof controller) {
            LOGGER.debug("Opening controller: " + controller);
            controller = Alloy.createController(controller, options);
            controller.hasOwnProperty("init") && controller.init();
        }
        $.current.controller = controller;
        $.current.options = options;
        $.current.view = $.current.controller.getView();
        if ($.prop.historyStack.length > 0) {
            var prevIndex = $.prop.historyStack.length - 1;
            $.previous.controller = $.prop.historyStack[prevIndex];
            $.previous.options = $.prop.historyStackOptions[prevIndex];
            $.previous.view = $.previous.controller.getView();
        } else {
            $.previous.controller = void 0;
            $.previous.options = void 0;
            $.previous.view = void 0;
        }
        if ($.current.controller === $.previous.controller) {
            $.current.controller.visible = true;
            callback && callback();
            return;
        }
        $.prop.historyStackOptions.push(options);
        $.prop.historyStack.push(controller);
        var transition = options.transition || void 0;
        if (!exports.hasTransition(transition)) {
            LOGGER.debug('The set transition "' + transition + "\" doesn't exist, defaulting to: " + $.prop.defaultOpenTransition.transition);
            transition = $.prop.defaultOpenTransition.transition;
        }
        var current = $.current, previous = $.previous;
        var onTransitionComplete = function() {
            $.prop.historyLimit > 0 && exports.clearHistory($.prop.historyLimit);
        };
        var executeTransition = function() {
            var dfd = Q.defer();
            $.transitions[transition](current.view, previous.view, options, dfd.resolve);
            return dfd.promise;
        };
        navAnimationRunning = true;
        return Q().then(function() {
            Safe.execute(previous.controller ? previous.controller.onBeforeHide : null);
        }).then(function() {
            _prepareNavigationBar(options, true);
        }).then(executeTransition).timeout(TRANSITION_TIMEOUT).catch(function(e) {
            LOGGER.error("[navigation] Error on .open()");
            LOGGER.error(e);
            $.transitions.none(current.view, previous.view);
        }).finally(onTransitionComplete).finally(function() {
            exports.fireEvent("nav.opencomplete", {
                tag: current.controller.TAG
            });
        }).finally(function() {
            current.controller.onOpened && current.controller.onOpened(current.controller);
        }).finally(function() {
            callback && callback();
        }).finally(function() {
            navAnimationRunning = false;
            sendTrackEventForCurrentPage(current);
        });
    };
    var navAnimationRunning = false;
    exports.back = function(options, callback) {
        if (navAnimationRunning) return;
        options = options || {};
        $.prop.historyStack = $.prop.historyStack || [];
        if (!options.force && !exports.canGoBack()) return false;
        if ($.prop.historyStack.length <= 1) {
            LOGGER.debug("At end of historyStack, closing current widget.");
            exports.exit();
            return true;
        }
        LOGGER.info("Going back in the history stack");
        exports.fireEvent("nav.backstart", {
            tag: $.current.controller.TAG
        });
        navAnimationRunning = true;
        $.previous.controller = $.prop.historyStack.pop();
        $.previous.options = $.prop.historyStackOptions.pop();
        $.previous.view = $.previous.options.hasOwnProperty("view") ? $.previous.options.view : $.previous.controller.getView();
        var curIndex = $.prop.historyStack.length - 1;
        $.current.controller = $.prop.historyStack[curIndex];
        $.current.options = $.prop.historyStackOptions[curIndex];
        $.current.view = $.current.options.hasOwnProperty("view") ? $.current.options.view : $.current.controller.getView();
        options = _.extend({}, $.current.options, $.prop.defaultBackTransition, options);
        var transition = options.transition || void 0;
        if (!exports.hasTransition(transition)) {
            LOGGER.debug('The set transition "' + transition + "\" doesn't exist, defaulting to: " + $.prop.defaultBackTransition.transition);
            transition = $.prop.defaultBackTransition.transition;
        }
        var current = $.current, previous = $.previous;
        var onTransitionComplete = function() {
            $.content.remove(previous.view);
            previous.view = null;
            previous.controller && previous.controller.destroy();
            previous.controller = void 0;
            previous.options = void 0;
            exports.setTitle(options.title);
        };
        var executeTransition = function() {
            var dfd = Q.defer();
            $.transitions[transition](current.view, previous.view, options, dfd.resolve);
            return dfd.promise;
        };
        return Q().then(function() {
            Safe.execute(previous.controller ? previous.controller.onBeforeHide : null);
        }).then(function() {
            _prepareNavigationBar(options);
        }).then(executeTransition).timeout(TRANSITION_TIMEOUT).catch(function() {
            $.transitions.none(current.view, previous.view);
        }).finally(onTransitionComplete).finally(function() {
            exports.fireEvent("nav.backcomplete", {
                tag: current.controller.TAG
            });
        }).finally(function() {
            current.controller.onOpened && current.controller.onOpened(current.controller);
        }).finally(function() {
            callback && callback();
        }).finally(function() {
            navAnimationRunning = false;
        });
    };
    exports.backTo = function(index, options, callback) {
        if (0 > index) {
            cleanup();
            return 0 !== $.prop.historyStack.length;
        }
        var size = $.prop.historyStack.length;
        if (index >= size - 1) return false;
        if (index === size - 2) return exports.back(options, callback);
        for (var i = size - 2; i > index; i--) exports._remove(i);
        return exports.back(options, callback);
    };
    exports.remove = function(controller, callback) {
        var index = exports.indexOf(controller);
        return exports._remove(index, callback);
    };
    exports._remove = function(index, callback) {
        if (0 > index || index >= $.prop.historyStack.length) return false;
        var controller = $.prop.historyStack[index];
        $.prop.historyStack.splice(index, 1);
        $.prop.historyStackOptions.splice(index, 1);
        $.prop.historyRightAction.splice(index, 1);
        $.prop.historyRightActionEnabled.splice(index, 1);
        $.prop.historyRightActionVisible.splice(index, 1);
        var view = controller.getView();
        view && $.content.remove(view);
        controller.destroy();
        callback && callback(controller);
        return true;
    };
    exports.removeByTag = function(tag) {
        if (!tag) return;
        var index = exports.indexOfTag(tag);
        if (-1 == index) return;
        if (index == $.prop.historyStack.length - 1) {
            LOGGER.error("[navigation] - Removing current controller is forbiden");
            return;
        }
        var controller = $.prop.historyStack.splice(index, 1).shift();
        $.prop.historyStackOptions.splice(index, 1);
        $.prop.historyRightAction.splice(index, 1);
        $.prop.historyRightActionEnabled.splice(index, 1);
        $.prop.historyRightActionVisible.splice(index, 1);
        if (controller) {
            var view = controller.getView();
            view && $.content.remove(view);
        }
    };
    exports.home = function(options, callback) {
        options = options ? _.extend({}, $.prop.indexOptions, options) : $.prop.indexOptions;
        options.home = true;
        exports.open($.prop.index, options, callback);
    };
    exports.addTransition = function(name, action) {
        $.transitions[name] = action;
    };
    exports.hasTransition = function(name) {
        return name ? $.transitions.hasOwnProperty(name) : false;
    };
    $.transitions.crossFade = function(newView, previousView, options, callback) {
        if (previousView) {
            var oldOpacity = previousView.opacity || 1;
            var oldZIndex = previousView.zIndex || 0;
            previousView.zIndex = 9;
            newView.applyProperties({
                opacity: 0,
                visible: true
            });
            $.content.add(newView);
            animation.crossFade(previousView, newView, options.duration, function() {
                previousView.visible = false;
                previousView.applyProperties({
                    opacity: oldOpacity,
                    zIndex: oldZIndex
                });
                callback && callback();
            });
        } else {
            var opacity = newView.opacity || 1;
            newView.applyProperties({
                opacity: 0,
                visible: true
            });
            $.content.add(newView);
            newView.animate({
                opacity: 1,
                duration: options.duration
            }, function() {
                newView.opacity = opacity;
                callback && callback();
            });
        }
    };
    $.transitions.fade = function(newView, previousView, options, callback) {
        if (previousView) {
            var transitionColor = options.transitionColor ? options.transitionColor : "#000";
            var oldZIndex = previousView.zIndex || 0;
            var oldOpacity = previousView.opacity || 1;
            previousView.zIndex = 9;
            var transitionView = Ti.UI.createView({
                backgroundColor: transitionColor,
                height: $.appWrap.height,
                width: $.appWrap.width,
                left: 0,
                top: 0,
                zIndex: 8,
                opacity: 1
            });
            newView.visible = true;
            $.content.add(transitionView);
            $.content.add(newView);
            previousView.animate({
                opacity: 0,
                duration: Math.floor(options.duration / 2)
            }, function() {
                previousView.visible = false;
                previousView.applyProperties({
                    opacity: oldOpacity,
                    zIndex: oldZIndex
                });
                transitionView.animate({
                    opacity: 0,
                    duration: Math.floor(options.duration / 2)
                }, function() {
                    $.content.remove(transitionView);
                    transitionView = null;
                    callback && callback();
                });
            });
        } else {
            var opacity = newView.opacity || 1;
            newView.applyProperties({
                opacity: 0,
                visible: true
            });
            $.content.add(newView);
            newView.animate({
                opacity: opacity,
                duration: options.duration
            }, function() {
                newView.opacity = opacity;
                callback && callback();
            });
        }
    };
    $.transitions.slideInFromRight = function(newView, previousView, options, callback) {
        if (previousView) {
            var previousViewOldLeft = previousView.left || 0;
            newView.applyProperties({
                left: $.mainWindow.size.width,
                visible: true
            });
            $.content.add(newView);
            var onTransitionEnd = function() {
                if (!newView) return;
                newView = null;
            };
            newView.animate({
                left: 0,
                duration: options.duration
            }, onTransitionEnd);
            setTimeout(onTransitionEnd, options.duration + 500);
            previousView.animate({
                left: -$.mainWindow.size.width,
                duration: options.duration
            }, function() {
                previousView.visible = false;
                previousView.applyProperties({
                    left: previousViewOldLeft
                });
                previousView = null;
                callback && callback();
            });
        } else {
            newView.applyProperties({
                left: $.mainWindow.size.width,
                visible: true
            });
            $.content.add(newView);
            newView.animate({
                left: 0,
                duration: options.duration
            }, function() {
                newView.left = 0;
                newView = null;
                callback && callback();
            });
        }
    };
    $.transitions.slideInFromLeft = function(newView, previousView, options, callback) {
        if (previousView) {
            var previousViewOldLeft = previousView.left || 0;
            newView.applyProperties({
                left: -$.mainWindow.size.width,
                visible: true
            });
            $.content.add(newView);
            var onTransitionEnd = function() {
                if (!newView) return;
                newView.left = 0;
                newView = null;
            };
            newView.animate({
                left: 0,
                duration: options.duration
            }, onTransitionEnd);
            setTimeout(onTransitionEnd, options.duration + 500);
            previousView.animate({
                left: $.mainWindow.size.width,
                duration: options.duration
            }, function() {
                previousView.visible = false;
                previousView.applyProperties({
                    left: previousViewOldLeft
                });
                previousView = null;
                callback && callback();
            });
        } else {
            newView.applyProperties({
                left: -$.mainWindow.size.width,
                visible: true
            });
            $.content.add(newView);
            newView.animate({
                left: 0,
                duration: options.duration
            }, function() {
                newView.left = 0;
                newView = null;
                callback && callback();
            });
        }
    };
    $.transitions.none = function(newView, previousView, options, callback) {
        newView.applyProperties({
            visible: true,
            left: 0
        });
        if (previousView) {
            $.content.remove(newView);
            previousView.visible = false;
            $.content.add(newView);
            callback && callback();
        } else {
            $.content.remove(newView);
            $.content.add(newView);
            callback && callback();
        }
    };
    exports.clearContent = function() {
        $.content.removeAllChildren();
    };
    exports.hasHistory = function() {
        return $.prop.historyStack.length > 1 ? true : false;
    };
    exports.clearHistory = function(historyLimit) {
        historyLimit = historyLimit || 0 === historyLimit ? 0 > historyLimit ? 1 : historyLimit : 1;
        if ($.prop.historyStack.length > 1 && historyLimit < $.prop.historyStack.length) while ($.prop.historyStack.length > historyLimit) {
            var oldController = $.prop.historyStack.shift();
            var oldOptions = $.prop.historyStackOptions.shift();
            $.prop.historyRightAction.shift();
            $.prop.historyRightActionEnabled.shift();
            $.prop.historyRightActionVisible.shift();
            if (oldController) {
                oldController.destroy();
                oldController = null;
                oldOptions = null;
            }
        }
    };
    exports.indexOf = function(controller) {
        if (!controller || !$.prop.historyStack) return -1;
        for (var i = $.prop.historyStack.length - 1; i >= 0; i--) if (controller === $.prop.historyStack[i]) return i;
        return -1;
    };
    exports.indexOfTag = function(tag) {
        if (!tag || $.prop.historyStack.length < 2) return -1;
        for (var i = $.prop.historyStack.length - 1; i >= 0; i--) if (tag === $.prop.historyStack[i].TAG) return i;
        return -1;
    };
    exports.size = function() {
        return $.prop.historyStack ? $.prop.historyStack.length : 0;
    };
    exports.popHistory = function(qty) {
        if (qty > 0) while (qty && $.prop.historyStack.length) {
            var oldController = $.prop.historyStack.pop();
            var oldOptions = $.prop.historyStackOptions.pop();
            $.prop.historyRightAction.pop();
            $.prop.historyRightActionEnabled.pop();
            $.prop.historyRightActionVisible.pop();
            oldController.destroy();
            oldController = null;
            oldOptions = null;
            --qty;
        }
    };
    exports._lock = false;
    exports.lock = function() {
        exports._lock = true;
    };
    exports.unlock = function() {
        exports._lock = false;
    };
    var onAndroidBack = function() {
        if ($.prop.disableBack) return;
        exports.back();
    };
    exports.exit = function() {
        if (!$.prop.around || !$.prop.around.exit || !$.prop.around.exit()) {
            LOGGER.info("Navigation exit method invoked!");
            var animation;
            if (!$.mainWindow) return;
            Utils.clean($.mainWindow);
            $.mainWindow.close();
        }
        $.prop.handleClose && $.prop.handleClose();
    };
    exports.getPrevious = function() {
        return $.previous;
    };
    exports.getPreviousController = function() {
        return $.previous.controller;
    };
    exports.getPreviousOptions = function() {
        return $.previous.options;
    };
    exports.getPreviousView = function() {
        return $.previous.view;
    };
    exports.getCurrent = function() {
        return $.current;
    };
    exports.getCurrentController = function() {
        return $.current.controller;
    };
    exports.getCurrentOptions = function() {
        return $.current.options;
    };
    exports.getCurrentView = function() {
        return $.current.view;
    };
    exports.addEventListener = function(eventName, action) {
        $.appWrap.addEventListener(eventName, action);
    };
    exports.removeEventListener = function(eventName, action) {
        $.appWrap.removeEventListener(eventName, action);
    };
    exports.fireEvent = function(eventName, params) {
        var tag = exports.getCurrentController() ? exports.getCurrentController().TAG : null, _params = _.extend({
            tag: tag
        }, params);
        $.appWrap.fireEvent(eventName, _params);
    };
    exports.hideBottomBar = function() {
        $.bottomBar.applyProperties({
            visible: false
        });
        $.main.bottom = 0;
    };
    exports.showBottomBar = function() {
        $.bottomBar.applyProperties({
            visible: true
        });
        $.main.bottom = "50dp";
    };
    exports.hideBackButton = function() {};
    exports.showBackButton = function() {};
    exports.deleteTitle = function() {
        exports.setTitle("");
    };
    exports.setTitle = function(text) {
        text = text || "";
        text = text.trim();
        text = text.toUpperCase();
        $.navBarTitle.text = text;
    };
    var doneClickAttached = false;
    var doneClick = function() {
        LOGGER.error("Done.click is triggered.");
        exports.fireEvent("done.click");
    };
    exports.showDoneButton = function() {
        if (!$.btnDone.visible) {
            $.btnDone.show();
            doneClickAttached || (doneClickAttached = true);
        }
    };
    exports.hideDoneButton = function() {
        if ($.btnDone.visible) {
            $.btnDone.hide();
            doneClickAttached && (doneClickAttached = false);
        }
    };
    exports.setDoneButtonText = function(text) {
        $.btnDone.setTitle(text);
    };
    var editClick = function() {
        exports.fireEvent("edit.click");
    };
    exports.showEditButton = function() {
        $.btnEdit.show();
    };
    exports.hideEditButton = function() {
        $.btnEdit.hide();
    };
    exports.showNavBar = function() {
        $.navBar.applyProperties({
            visible: true,
            height: "50dp"
        });
        $.main.applyProperties({
            top: "50dp"
        });
    };
    exports.hideNavBar = function() {
        $.navBar.applyProperties({
            visible: false,
            height: 0
        });
        $.main.applyProperties({
            top: 0
        });
    };
    exports.enablePopupMode = function() {
        $.overlay.applyProperties({
            visible: true
        });
    };
    exports.disablePopupMode = function() {
        $.overlay.applyProperties({
            visible: false
        });
    };
    exports.whitenNavBar = function() {
        $.navBar.backgroundColor = "white";
        var _window;
        $.navBarTitle.color = Alloy.Globals.Style.Color.DarkGray;
        $.cancelArrow.color = Alloy.Globals.Style.Color.DarkGray;
    };
    exports.transparentNavBar = function() {
        $.navBar.backgroundColor = "transparent";
        var _window;
        $.navBarTitle.color = "white";
        $.cancelArrow.color = "white";
    };
    exports.reposition = function() {
        $.transitions.none($.current.view, $.previous.view);
    };
    exports.canGoBack = function() {
        if ($.current && $.current.controller.canGoBack && !$.current.controller.canGoBack()) return false;
        return true;
    };
    NavigationQueue.bind(exports, "back", {
        unique: true
    });
    NavigationQueue.bind(exports, "open");
    NavigationQueue.bind(exports, "reposition");
    Ti.App.addAppEventListener("resumed", exports.reposition);
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;