function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "simpleWindow";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.popup = require("/ui/common/custom_window").createWindow({
        orientationModes: [ Ti.UI.PORTRAIT ],
        top: 0,
        left: 0,
        height: Ti.UI.FILL,
        width: Ti.UI.FILL,
        backgroundColor: "#FFF",
        navBarHidden: true,
        id: "popup"
    });
    $.__views.popup && $.addTopLevelView($.__views.popup);
    $.__views.navBar = Ti.UI.createView({
        width: "100%",
        top: 0,
        left: 0,
        height: 0,
        zIndex: 1,
        id: "navBar"
    });
    $.__views.popup.add($.__views.navBar);
    $.__views.cancelArrowLabel = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontFamily: "splinico",
            fontWeight: "bold",
            fontSize: "24dp"
        },
        text: "h",
        left: "10dp",
        bottom: 0,
        height: "50dp",
        width: "60dp",
        id: "cancelArrowLabel"
    });
    $.__views.navBar.add($.__views.cancelArrowLabel);
    $.__views.navBarTitle = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        height: "24dp",
        bottom: "11dp",
        left: "72dp",
        right: "72dp",
        ellipsize: true,
        wordWrap: false,
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        minimumFontSize: "10dp",
        id: "navBarTitle"
    });
    $.__views.navBar.add($.__views.navBarTitle);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {};
    exports = new (require("/carmalib/controller").extend($, {
        events: {
            "click cancelArrowLabel": "_arrowLabelClickHandler"
        },
        _opened: false,
        initialize: function() {
            args.enableNavBar && !args.title && ($.navBar.height = "50dp");
            if (args.title) {
                $.navBar.height = "50dp";
                $.navBarTitle.text = args.title;
            }
            this._initEventListeners();
        },
        _initEventListeners: function() {
            $.popup.addEventListener("open", function onOpen() {
                $.popup.removeEventListener("open", onOpen);
                require("/ui/windowManager").trackWindow($.popup);
            });
            $.popup.addEventListener("close", function onClose() {
                $.popup.removeEventListener("close", onClose);
                $.destroy();
            });
        },
        open: function(options) {
            options = options || {};
            if (options.title) {
                $.navBar.height = "50dp";
                $.navBarTitle.text = options.title;
            }
            options.view && $.popup.add(options.view);
            $.popup.open();
        },
        close: function() {
            $.popup.close();
        },
        _arrowLabelClickHandler: function() {
            var self = this;
            $.cancelArrowLabel.animate({
                autoreverse: true,
                duration: 50,
                transform: Ti.UI.create2DMatrix().scale(.7)
            }, function() {
                self.close();
                $.cancelArrowLabel.transform = Ti.UI.create2DMatrix().scale(1);
            });
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;