function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "test";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.test = Ti.UI.createWindow({
        orientationModes: [ Ti.UI.PORTRAIT ],
        layout: "vertical",
        height: Ti.UI.SIZE,
        id: "test"
    });
    $.__views.test && $.addTopLevelView($.__views.test);
    $.__views.grep = Ti.UI.createLabel({
        color: "black",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        font: {
            fontSize: "15dp"
        },
        id: "grep"
    });
    $.__views.test.add($.__views.grep);
    $.__views.tests = Ti.UI.createLabel({
        color: "black",
        text: "running...",
        font: {
            fontSize: "50dp"
        },
        id: "tests"
    });
    $.__views.test.add($.__views.tests);
    $.__views.success = Ti.UI.createLabel({
        color: "green",
        font: {
            fontSize: "50dp"
        },
        id: "success"
    });
    $.__views.test.add($.__views.success);
    $.__views.failures = Ti.UI.createLabel({
        color: "red",
        font: {
            fontSize: "50dp"
        },
        id: "failures"
    });
    $.__views.test.add($.__views.failures);
    exports.destroy = function() {};
    _.extend($, $.__views);
    var Mocha = require("/vendor/ti-mocha");
    var win = Ti.UI.createWindow({
        backgroundColor: "#fff",
        height: Ti.UI.FILL,
        fullscreen: false,
        exitOnClose: true,
        id: "myWindow"
    });
    var view = Ti.UI.createView({
        height: Ti.UI.FILL,
        width: Ti.UI.FILL,
        backgroundColor: "#fff",
        id: "myView"
    });
    win.add(view);
    win.addEventListener("open", function() {
        $.grep.text = _.template("Using <%= grep %> filter", {
            grep: INSTRUMENT.test.grep || "NO"
        });
        var config = require(INSTRUMENT.test.config);
        mocha.setup({
            useColors: INSTRUMENT.test.useColors,
            grep: INSTRUMENT.test.grep,
            reporter: "ti-spec-splinter",
            ui: "bdd"
        });
        var runner = mocha.run(function() {
            var stats = _.extend({}, {
                tests: 0,
                passes: 0,
                failures: 0
            }, runner ? runner.stats : {});
            $.tests.text = _.template("<%= tests %> Total", stats);
            $.success.text = _.template("<%= passes %> Passed", stats);
            $.failures.text = _.template("<%= failures %> Failed", stats);
            var reportFile = null;
            if (INSTRUMENT.test.report) {
                reportFile = Ti.Filesystem.getFile(Ti.Filesystem.tempDirectory, INSTRUMENT.test.report);
                var result = JSON.stringify(stats, 0, 4);
                reportFile.write(result);
                console.log("Test Report: " + INSTRUMENT.test.report);
                console.log(result);
            }
        });
    });
    win.open();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;