var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            url: "AUTO_RIDE_REQUEST",
            fetch: function(options) {
                options = options || {};
                options.url = _.template(require("carmalib/url").AUTO_RIDE_REQUEST, {
                    userId: require("services/resource_owner_service").singleton().get("userId"),
                    rideRequestId: options.rideRequestId
                });
                return this.constructor.__super__.fetch.apply(this, [ options ]);
            }
        });
        return Model;
    }
};

model = Alloy.M("auto_ride_request", exports.definition, []);

collection = Alloy.C("auto_ride_request", exports.definition, model);

exports.Model = model;

exports.Collection = collection;