var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            getTopups: function(options) {
                options = options || {};
                options.url = _.template(require("/carmalib/url").AVAILABLE_TOPUP, {
                    currencyCode: options.currencyCode
                });
                return this.fetch(options);
            },
            getTopupsForProvider: function(options) {
                options = options || {};
                options.url = _.template(require("/carmalib/url").AVAILABLE_TOPUP_PROVIDER, {
                    currencyCode: options.currencyCode,
                    paymentProvider: options.paymentProvider
                });
                return this.fetch(options);
            }
        });
        return Model;
    }
};

model = Alloy.M("available_topup", exports.definition, []);

collection = Alloy.C("available_topup", exports.definition, model);

exports.Model = model;

exports.Collection = collection;