var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            url: "BATCH_API",
            parse: function(response) {
                return response;
            },
            Builder: function() {
                var model = this;
                return {
                    _batchCalls: [],
                    _isInProgress: false,
                    batchCall: function() {
                        var q = model.save({
                            apiCallRequests: this._batchCalls
                        });
                        this._batchCalls = [];
                        return q;
                    },
                    createModel: function(urlTemplate, options) {
                        return this._pushModel(urlTemplate, options, "POST");
                    },
                    deleteModel: function(urlTemplate, options) {
                        return this._pushModel(urlTemplate, options, "DELETE");
                    },
                    _pushModel: function(urlTemplate, options, method) {
                        var url = this._getUrl(urlTemplate, options);
                        if (!url) throw "urlTemplate or url must be specified.";
                        this._batchCalls.push({
                            method: method,
                            url: url
                        });
                        return this;
                    },
                    _getUrl: function(urlTemplate, options) {
                        options = options || {};
                        return options.url || _.template(require("/carmalib/url")[urlTemplate || options.urlTemplate], options);
                    }
                };
            }
        });
        return Model;
    }
};

model = Alloy.M("batch_api", exports.definition, []);

collection = Alloy.C("batch_api", exports.definition, model);

exports.Model = model;

exports.Collection = collection;