var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        }
    },
    extendModel: function(Model) {
        "BEACONS", _.extend(Model.prototype, {
            list: function(options) {
                options = options || {};
                options.url = _.template(require("carmalib/url").BEACONS, {
                    userId: require("services/resource_owner_service").singleton().get("userId")
                });
                return this.fetch(options);
            },
            connect: function(beaconId, options) {
                if (!beaconId) return;
                options = options || {};
                options.url = _.template(require("carmalib/url").BEACONS, {
                    userId: require("services/resource_owner_service").singleton().get("userId")
                }) + "/" + beaconId;
                return this.save(options);
            },
            "delete": function(beaconId, options) {
                if (!beaconId) return;
                options = options || {};
                options.url = _.template(require("carmalib/url").BEACONS, {
                    userId: require("services/resource_owner_service").singleton().get("userId")
                }) + "/" + beaconId;
                return this.destroy(options);
            }
        });
        return Model;
    }
};

model = Alloy.M("beacons", exports.definition, []);

collection = Alloy.C("beacons", exports.definition, model);

exports.Model = model;

exports.Collection = collection;