var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

exports.definition = {
    config: {
        adapter: {
            type: "properties",
            collection_name: "cached_preferences"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            getPreference: function(prop) {
                if (!this.has("preference")) {
                    LOGGER.info("No preferences...");
                    return null;
                }
                var preferences = this.get("preference");
                var value = null;
                preferences && preferences.forEach(function(pref) {
                    pref.name === prop && (value = pref.value);
                });
                return value;
            },
            getPreferredCurrency: function() {
                return this.getPreference("preferred_currency");
            },
            getPreferredDistanceUnit: function() {
                return this.getPreference("preferred_distance_unit");
            },
            getPreferredTimeFormat: function() {
                return this.getPreference("preferred_time_format");
            },
            getLocationSpecificCard: function(id) {
                return this.getPreference("preferred_location_" + id);
            }
        });
        return Model;
    }
};

model = Alloy.M("cached_preferences", exports.definition, []);

collection = Alloy.C("cached_preferences", exports.definition, model);

exports.Model = model;

exports.Collection = collection;