var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

exports.definition = {
    config: {
        adapter: {
            type: "persistentrest",
            persistentType: "nosql",
            collectionName: "carma_completeness",
            personal: true
        },
        merge: true,
        idAttribute: "userId"
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            url: "CARMA_COMPLETENESS",
            initialize: function() {
                var resourceOwner = require("services/resource_owner_service").singleton();
                this.set("userId", resourceOwner.get("userId"));
            }
        });
        return Model;
    },
    extendCollection: function(Collection) {
        _.extend(Collection.prototype, {
            url: "CARMA_COMPLETENESS"
        });
        return Collection;
    }
};

model = Alloy.M("carma_completeness", exports.definition, []);

collection = Alloy.C("carma_completeness", exports.definition, model);

exports.Model = model;

exports.Collection = collection;