var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            find: function(tripId, role, baseEffectiveTime) {
                var options = {};
                options.url = _.template(require("/carmalib/url").CARPOOL_FINDING, {
                    userId: require("/services/resource_owner_service").singleton().get("userId")
                });
                return this.save({
                    baseEffectiveTime: baseEffectiveTime,
                    tripId: tripId,
                    userRole: role
                }, options);
            }
        });
        return Model;
    }
};

model = Alloy.M("carpool_finding", exports.definition, []);

collection = Alloy.C("carpool_finding", exports.definition, model);

exports.Model = model;

exports.Collection = collection;