var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            url: "FREE_RIDER",
            initialize: function(attributes, options) {
                options = options || {};
                this.set("userId", options.userId || this.getSelfId());
            },
            addFreeRider: function(freeRiderId, options) {
                options = _.extend({}, options, {
                    urlParams: {
                        freeRiderId: freeRiderId
                    }
                });
                this.id = null;
                return this.save({}, options);
            },
            deleteFreeRider: function(freeRiderId, options) {
                options = _.extend({}, options, {
                    urlParams: {
                        freeRiderId: freeRiderId
                    }
                });
                this.id = 1;
                return this.destroy(options);
            },
            fetch: function() {
                throw new Error("Not support operation on free_rider.");
            },
            getSelfId: function() {
                return require("services/resource_owner_service").singleton().get("userId");
            }
        });
        return Model;
    }
};

model = Alloy.M("free_rider", exports.definition, []);

collection = Alloy.C("free_rider", exports.definition, model);

exports.Model = model;

exports.Collection = collection;