var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            generate: function(options) {
                this.url = _.template(require("/carmalib/url").INVITES_REQUEST_URL, {
                    entity: options.entity
                }) + "?method=" + options.method;
                delete options.method;
                if (options.groupId) {
                    this.url += "&groupId=" + options.groupId;
                    delete options.groupId;
                }
                return this.save();
            }
        });
        return Model;
    }
};

model = Alloy.M("invitation", exports.definition, []);

collection = Alloy.C("invitation", exports.definition, model);

exports.Model = model;

exports.Collection = collection;