var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

var url = require("/carmalib/url");

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            url: "CREATE_INVITE_CODE",
            HIT_LANDING_PAGE: "HIT_LANDING_PAGE",
            NATIVE_APP_INSTALLED: "NATIVE_APP_INSTALLED",
            ALREADY_REGISTERED: "ALREADY_REGISTERED",
            HIT_MAIN_RESOURCE: "HIT_MAIN_RESOURCE",
            SIGNUP: "SIGNUP",
            getInviteDetails: function(options) {
                options = options || {};
                options.method = "GET";
                options.url = _.template(url.GET_INVITE, {
                    inviteId: options.inviteId
                });
                return this.save(null, options);
            },
            trackInviteEvent: function(options) {
                options = options || {};
                options.method = "POST";
                options.url = _.template(url.TRACK_INVITE, {
                    inviteId: options.inviteId,
                    eventType: options.eventType
                });
                return this.save(null, options);
            }
        });
        return Model;
    }
};

model = Alloy.M("invite_code", exports.definition, []);

collection = Alloy.C("invite_code", exports.definition, model);

exports.Model = model;

exports.Collection = collection;