var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

var url = require("/carmalib/url");

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            url: "USER_NOTIFICATION",
            count: function(userId) {
                var options = {};
                options.background = true;
                options.url = _.template(require("/carmalib/url").USER_NOTIFICATION, {
                    userId: userId
                }) + "/count";
                return this.fetch(options);
            },
            findAll: function(userId) {
                var options = {};
                options.url = _.template(require("/carmalib/url").USER_NOTIFICATION, {
                    userId: userId
                }) + "?dropoffNotificationPageSize=4&userFields=ALIAS,PHOTO_URL,GENDER";
                return this.fetch(options);
            },
            deleteDropOff: function(userId, notificationId) {
                var options = {};
                options.url = _.template(require("/carmalib/url").USER_NOTIFICATION, {
                    userId: userId
                }) + "/dropoffNotifications/" + notificationId;
                return this.destroy(options);
            }
        });
        return Model;
    }
};

model = Alloy.M("notification", exports.definition, []);

collection = Alloy.C("notification", exports.definition, model);

exports.Model = model;

exports.Collection = collection;