var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            token: function(userId, payValue, payMethod) {
                var options = {};
                options.url = _.template(require("/carmalib/url").PAYPAL_TOKEN, {
                    userId: userId
                });
                return this.save({
                    amount: payValue,
                    paymentOption: payMethod,
                    deviceType: "mobile"
                }, options);
            },
            topup: function(userId, token) {
                var options = {};
                options.url = _.template(require("/carmalib/url").PAYPAL_TOPUP, {
                    userId: userId
                }) + "?tokenId=" + token;
                return this.save(null, options);
            }
        });
        return Model;
    }
};

model = Alloy.M("paypal", exports.definition, []);

collection = Alloy.C("paypal", exports.definition, model);

exports.Model = model;

exports.Collection = collection;