var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

var url = require("/carmalib/url");

exports.definition = {
    config: {
        adapter: {
            type: "persistentrest",
            persistentType: "nosql",
            collectionName: "public_profile",
            merge: false,
            cappedSize: 300
        },
        idAttribute: "userId",
        url: url.PUBLIC_PROFILE
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            fetchProfiles: function(options) {
                options = options || {};
                options.url = _.template(require("/carmalib/url").PUBLIC_PROFILE_LIST, {
                    ids: options.idList
                });
                delete options.idList;
                if (options.userFields) {
                    options.url += "&userFields=" + options.userFields;
                    delete options.userFields;
                }
                return this.fetch(options);
            }
        });
        return Model;
    }
};

model = Alloy.M("public_profile", exports.definition, []);

collection = Alloy.C("public_profile", exports.definition, model);

exports.Model = model;

exports.Collection = collection;