var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

var url = require("/carmalib/url"), _ = require("/alloy/underscore")._;

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        },
        background: true
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            createToken: function(data) {
                var options = {};
                options.url = _.template(require("/carmalib/url").CREATE_PUSH_TOKEN, data);
                options.method = "POST";
                options.headers = {};
                options.headers.Authorization = "Bearer " + data.oAuthToken;
                delete data.oAuthToken;
                options.success = function() {
                    LOGGER.info("PN: Push Token created on the server");
                };
                options.error = function(model, xhr) {
                    LOGGER.error("PN: Error trying to add push token: " + JSON.stringify(xhr));
                };
                this.id = null;
                this.save(data, options);
            },
            deleteToken: function(data) {
                var options = {};
                options.url = _.template(require("/carmalib/url").DELETE_PUSH_TOKEN, data);
                options.headers = options.headers || {};
                options.headers.Authorization = "Bearer " + data.oAuthToken;
                options.success = function() {
                    LOGGER.info("PN: Push Token deleted from the server");
                };
                options.error = function(model, xhr) {
                    LOGGER.error("PN: Error trying to remove push token: " + JSON.stringify(xhr));
                };
                this.id = 1;
                this.destroy(options);
            }
        });
        return Model;
    }
};

model = Alloy.M("pushToken", exports.definition, []);

collection = Alloy.C("pushToken", exports.definition, model);

exports.Model = model;

exports.Collection = collection;