var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

exports.definition = {
    config: {
        adapter: {
            type: "properties",
            collection_name: "ride_booking_record"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            id: "ride_booking_record",
            markAsRead: function(bookingId, timestamp) {
                this.set("booking" + bookingId, timestamp);
                this.save();
            },
            isRead: function(bookingId) {
                return this.has("booking" + bookingId);
            },
            markAsPop: function(bookingId, timestamp) {
                this.set("bookingPop" + bookingId, timestamp);
                this.save();
            },
            isPop: function(bookingId) {
                return this.has("bookingPop" + bookingId);
            },
            clearBefore: function(timestamp) {
                var json = this.toJSON();
                for (var key in json) json[key] < timestamp - 72e5 && this.unset(key);
                this.save();
            }
        });
        return Model;
    }
};

model = Alloy.M("ride_booking_record", exports.definition, []);

collection = Alloy.C("ride_booking_record", exports.definition, model);

exports.Model = model;

exports.Collection = collection;