var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            url: "RIDE_HISTORY_COUNT",
            parse: function(response) {
                return {
                    count: response && response.paginator ? response.paginator.totalResults : 0,
                    distance: response && response.totalDistance ? response.totalDistance : 0,
                    rides: response && response.totalRides ? response.totalRides : 0,
                    drives: response && response.totalDrives ? response.totalDrives : 0,
                    users: response && response.totalUsersCarpooledWith ? response.totalUsersCarpooledWith : 0,
                    earning: response && response.totalDriverEarning ? response.totalDriverEarning : 0
                };
            }
        });
        return Model;
    }
};

model = Alloy.M("ride_history_count", exports.definition, []);

collection = Alloy.C("ride_history_count", exports.definition, model);

exports.Model = model;

exports.Collection = collection;