var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

var STRIPE_KEYS = {
    "carma.stripe.payment.dev": "pk_test_gaWvP8kh27Mq4VPUYAftMx1i",
    "carma.stripe.payment.prod": "pk_live_5zB0moNXMmgTB84RXkmsXAF4"
};

exports.definition = {
    config: {
        adapter: {
            type: "externalrestapi"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            _url: "https://api.stripe.com/v1/tokens",
            addCard: function(attrs, options) {
                options = options || {};
                options.headers = options.headers || {};
                var headers = this._getStripeHeaders();
                options.headers = headers;
                options.url = this._url;
                return this.save(attrs, options);
            },
            _getStripeHeaders: function() {
                var profile = require("bootstrap/env").getProfile(), propertyKey = "carma.stripe.payment.";
                propertyKey += "production" === profile.id ? "prod" : "dev";
                var publicApiKey = STRIPE_KEYS[propertyKey], auth = "Basic " + Ti.Utils.base64encode(publicApiKey);
                return {
                    Authorization: auth,
                    "Content-Type": "application/x-www-form-urlencoded"
                };
            }
        });
        return Model;
    }
};

model = Alloy.M("stripe_api", exports.definition, []);

collection = Alloy.C("stripe_api", exports.definition, model);

exports.Model = model;

exports.Collection = collection;