var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            _paymentProvider: "Stripe",
            addCard: function(paymentProvider, userPaymentToken, options) {
                options = options || {};
                options.url = _.template(require("/carmalib/url").STRIPE_PAYMENT_PROVIDER, {
                    userId: require("/services/resource_owner_service").singleton().get("userId"),
                    paymentProvider: paymentProvider
                });
                return this.save(userPaymentToken, options);
            },
            getCards: function(options) {
                options = options || {};
                options.url = _.template(require("/carmalib/url").STRIPE_PAYMENT_PROVIDER, {
                    userId: require("/services/resource_owner_service").singleton().get("userId"),
                    paymentProvider: this._paymentProvider
                });
                return this.fetch(options);
            },
            deleteCard: function(options) {
                options = options || {};
                options.url = _.template(require("/carmalib/url").STRIPE_PAYMENT_PROVIDER, {
                    userId: require("/services/resource_owner_service").singleton().get("userId"),
                    paymentProvider: options.id
                });
                return this.destroy(options);
            }
        });
        return Model;
    }
};

model = Alloy.M("stripe_card", exports.definition, []);

collection = Alloy.C("stripe_card", exports.definition, model);

exports.Model = model;

exports.Collection = collection;