var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

var Q = require("vendor/q");

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            _paymentProvider: "Stripe",
            topup: function(attrs) {
                attrs = attrs || {};
                if (!attrs || !attrs.amount || !attrs.token) return Q.fcall(function() {
                    throw new Error("[stripe_transaction.js] Not enough data provided");
                });
                var provider = attrs.paymentProvider || this._paymentProvider;
                delete attrs.paymentProvider;
                var options = {};
                options.url = _.template(require("/carmalib/url").STRIPE_PAYMENT_TRANSACTION, {
                    userId: require("/services/resource_owner_service").singleton().get("userId"),
                    paymentProvider: provider
                });
                return this.save(attrs, options);
            }
        });
        return Model;
    }
};

model = Alloy.M("stripe_transaction", exports.definition, []);

collection = Alloy.C("stripe_transaction", exports.definition, model);

exports.Model = model;

exports.Collection = collection;