var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            TX_TAG_TEMPLATE: "txtag_enrollment",
            FASTRAK_TEMPLATE: "fastrak_enrollment",
            getTags: function(options) {
                options = options || {};
                options.url = _.template(require("carmalib/url").USER_VEHICLES, {
                    userId: options.userId,
                    emailTemplate: null
                });
                var tags = this.fetch(options);
                return this.fetch(options);
            },
            saveTag: function(attrs, userId) {
                var options = {};
                var emailTemplate = "txtag" === attrs.tollTagType ? this.TX_TAG_TEMPLATE : this.FASTRAK_TEMPLATE;
                options.url = _.template(require("carmalib/url").USER_VEHICLES, {
                    userId: userId,
                    emailTemplate: emailTemplate
                });
                return this.save(attrs, options);
            },
            updateTag: function(attrs, userId, txtagId) {
                var options = {};
                var emailTemplate = "txtag" === attrs.tollTagType ? this.TX_TAG_TEMPLATE : this.FASTRAK_TEMPLATE;
                options.url = _.template(require("carmalib/url").USER_VEHICLE, {
                    userId: userId,
                    vehicleId: txtagId,
                    emailTemplate: emailTemplate
                });
                return this.save(attrs, options);
            },
            deleteTag: function(attrs, userId, txtagId) {
                var options = {};
                var emailTemplate = "txtag" === attrs.tollTagType ? this.TX_TAG_TEMPLATE : this.FASTRAK_TEMPLATE;
                options.url = _.template(require("carmalib/url").USER_VEHICLE, {
                    userId: userId,
                    vehicleId: txtagId,
                    emailTemplate: emailTemplate
                });
                return this.destroy(options);
            }
        });
        return Model;
    }
};

model = Alloy.M("toll_tag", exports.definition, []);

collection = Alloy.C("toll_tag", exports.definition, model);

exports.Model = model;

exports.Collection = collection;