var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            url: "USER_TRIP",
            getTrip: function(tripId, options) {
                options = options || {};
                var resourceOwner = require("services/resource_owner_service").singleton();
                options.url = _.template(require("/carmalib/url").USER_TRIP, {
                    userId: resourceOwner.get("userId")
                }) + "/" + tripId;
                return this.fetch(options);
            },
            saveTrip: function(attrs, options) {
                options = options || {};
                var resourceOwner = require("services/resource_owner_service").singleton();
                options.url = _.template(require("/carmalib/url").USER_TRIP, {
                    userId: resourceOwner.get("userId")
                });
                attrs && attrs.id && (options.url = options.url + "/" + attrs.id);
                if (options.hasOwnProperty("clearDeviation")) {
                    options.clearDeviation && (options.url = options.url + "?clearDeviation=true");
                    delete options.clearDeviation;
                }
                return this.save(attrs, options);
            },
            deleteTrip: function(tripId, options) {
                if (!tripId) {
                    LOGGER.debug("[trips.js] - deleteTrip no tripId provided");
                    return;
                }
                options = options || {};
                var resourceOwner = require("services/resource_owner_service").singleton();
                options.url = _.template(require("/carmalib/url").USER_TRIP, {
                    userId: resourceOwner.get("userId")
                });
                options.url = options.url + "/" + tripId;
                options.url && (options.url = options.url + "?force=true");
                return this.destroy(options);
            }
        });
        return Model;
    }
};

model = Alloy.M("trip", exports.definition, []);

collection = Alloy.C("trip", exports.definition, model);

exports.Model = model;

exports.Collection = collection;