var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            getTrip: function(options) {
                options = options || {};
                if (!options.tripId) {
                    LOGGER.error("[tripV2] - getTrip, no tripId provided");
                    return;
                }
                options.url = _.template(require("/carmalib/url").USER_TRIP_V2, {
                    tripId: options.tripId
                });
                if (options.tripFields) {
                    options.url += "?tripFields=" + options.tripFields;
                    delete options.tripFields;
                }
                if (options.relativeTime) {
                    options.url += -1 !== options.url.indexOf("?") ? "&" : "?";
                    options.url += "relativeTime=" + options.relativeTime;
                    delete options.relativeTime;
                }
                return this.fetch(options);
            }
        });
        return Model;
    }
};

model = Alloy.M("tripV2", exports.definition, []);

collection = Alloy.C("tripV2", exports.definition, model);

exports.Model = model;

exports.Collection = collection;