var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            deviate: function(tripId, baseEffectiveTime, deviationMins) {
                var options = {};
                options.url = _.template(require("/carmalib/url").USER_TRIP_DEVIATION, {
                    userId: require("/services/resource_owner_service").singleton().get("userId"),
                    tripId: tripId
                });
                return this.save({
                    baseEffectiveTime: baseEffectiveTime,
                    deviationMins: deviationMins
                }, options);
            }
        });
        return Model;
    }
};

model = Alloy.M("trip_deviation", exports.definition, []);

collection = Alloy.C("trip_deviation", exports.definition, model);

exports.Model = model;

exports.Collection = collection;