var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

exports.definition = {
    config: {
        adapter: {
            type: "persistentrest",
            persistentType: "nosql",
            collectionName: "trip_matches_explore",
            personal: true
        },
        handleError: [ "trip_not_found" ]
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            url: "USER_TRIP_MATCHES",
            bestMatches: function(options) {
                options = options || {};
                options.url = "USER_TRIP_BEST_MATCHES";
                return this.fetch(options);
            }
        });
        return Model;
    }
};

model = Alloy.M("trip_matches_explore", exports.definition, []);

collection = Alloy.C("trip_matches_explore", exports.definition, model);

exports.Model = model;

exports.Collection = collection;