var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

var url = require("/carmalib/url");

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            rate: function(userId, journeyId, rating, comment, options) {
                options = options || {};
                options.url = _.template(require("/carmalib/url").TRIP_RATING, {
                    userId: userId,
                    journeyId: journeyId
                });
                rating > 0 && (options.url = options.url + "&rating=" + rating / 5);
                comment && comment.trim().length > 0 && (options.url = options.url + "&comment=" + encodeURIComponent(comment));
                return this.save(null, options);
            }
        });
        return Model;
    }
};

model = Alloy.M("trip_rating", exports.definition, []);

collection = Alloy.C("trip_rating", exports.definition, model);

exports.Model = model;

exports.Collection = collection;