var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            url: "USER_TRIPS",
            getTrips: function(options) {
                options = options || {};
                var resourceOwner = require("services/resource_owner_service").singleton(), userId = resourceOwner.get("userId");
                var url = _.template(require("/carmalib/url").USER_TRIPS, {
                    userId: userId
                });
                options.relativeTime && (url += "?relativeTime=" + options.relativeTime);
                return this.fetch({
                    url: url
                });
            }
        });
        return Model;
    }
};

model = Alloy.M("trips", exports.definition, []);

collection = Alloy.C("trips", exports.definition, model);

exports.Model = model;

exports.Collection = collection;