var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

exports.definition = {
    config: {
        adapter: {
            type: "persistentrest",
            persistentType: "nosql",
            collectionName: "trips_nextn",
            personal: true
        },
        handleError: [ "no_trips", "all_trips_disabled" ],
        idAttribute: "ownerUid"
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            url: "USER_TRIPS_NEXTN",
            getNextTrip: function(options) {
                options = options || {};
                options.url = require("/carmalib/url").USER_NEXT_TRIP;
                if (options.tripFields) {
                    options.url += "?tripFields=" + options.tripFields;
                    delete options.tripFields;
                }
                if (options.relativeTime) {
                    options.url += -1 !== options.url.indexOf("?") ? "&" : "?";
                    options.url += "relativeTime=" + options.relativeTime;
                    delete options.relativeTime;
                }
                return this.fetch(options);
            },
            getNextnTrips: function(options) {
                options = options || {};
                var resourceOwner = require("services/resource_owner_service").singleton();
                options.url = _.template(require("/carmalib/url").USER_TRIPS_NEXTN, {
                    userId: resourceOwner.get("userId"),
                    numTrips: options.numTrips
                });
                var time = Date.now() - 9e5;
                options.url += -1 !== options.url.indexOf("?") ? "&" : "?";
                options.url += "relativeTime=" + time;
                return this.fetch(options);
            }
        });
        return Model;
    }
};

model = Alloy.M("trips_nextn", exports.definition, []);

collection = Alloy.C("trips_nextn", exports.definition, model);

exports.Model = model;

exports.Collection = collection;