var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            url: "USER_MESSAGES",
            countUnread: function(options) {
                options = options || {};
                options.url = require("/carmalib/url").USER_MESSAGES + "/countUnread";
                return this.fetch(options);
            },
            markThreadRead: function(options) {
                options = options || {};
                options.url = _.template(require("/carmalib/url").MARK_THREAD_READ, options);
                delete options.thredId;
                delete options.userId;
                return this.save({}, options);
            },
            countThreadUnread: function(options) {
                options = options || {};
                options.url = _.template(require("/carmalib/url").COUNT_THREAD_UNREAD, options);
                delete options.thredId;
                delete options.userId;
                return this.fetch(options);
            },
            deleteChat: function(options) {
                options = options || {};
                options.url = _.template(require("/carmalib/url").USER_MESSAGES, options);
                options.url = options.url + "/threads/" + options.threadId;
                delete options.thredId;
                delete options.userId;
                return this.destroy(options);
            },
            poke: function(attr) {
                var options = {};
                attr = attr || {};
                options.url = _.template(require("/carmalib/url").USER_MESSAGES, {
                    userId: attr.recipientUser
                });
                return this.save(attr, options);
            },
            sendGroupMessage: function(attr) {
                var options = {};
                attr = attr || {};
                options.url = _.template(require("/carmalib/url").GROUP_MESSAGES, {
                    groupId: attr.groupId
                });
                delete attr.groupId;
                return this.save(attr, options);
            }
        });
        return Model;
    }
};

model = Alloy.M("user_messages", exports.definition, []);

collection = Alloy.C("user_messages", exports.definition, model);

exports.Model = model;

exports.Collection = collection;