var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            url: "USER_SEARCH",
            getSearchUsers: function(options) {
                options = options || {};
                var resourceOwner = require("services/resource_owner_service").singleton();
                options.url = _.template(require("/carmalib/url").USER_SEARCH, {
                    userId: options.userId,
                    keyword: options.keyword
                });
                options.url = options.lat && options.lon ? options.url + "&lat=" + options.lat + "&lon=" + options.lon + "&userFields=FULL_PUBLIC,DISTANCE" : options.url + "&userFields=FULL_PUBLIC";
                return this.fetch(options);
            },
            search: function(keyword, location, options) {
                options = options || {};
                keyword = keyword || options.keyword;
                location = location || options.location;
                options.url = _.template(require("/carmalib/url").USER_SEARCH, {
                    userId: options.userId,
                    keyword: keyword
                });
                options.url = _.isEmpty(location) ? options.url + "&userFields=FULL_PUBLIC" : options.url + "&lat=" + location.lat + "&lon=" + location.lon + "&userFields=FULL_PUBLIC,DISTANCE";
                return this.fetch(options);
            }
        });
        return Model;
    }
};

model = Alloy.M("user_search", exports.definition, []);

collection = Alloy.C("user_search", exports.definition, model);

exports.Model = model;

exports.Collection = collection;