var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

var Globals = require("/v6/infrastructure/Globals"), completenessService = Globals.IOC.get("completenessService");

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            url: "USER_VALIDATION_CONFIRM",
            fetch: function(options) {
                options = options || {};
                var success = options.success || function() {};
                options.success = function() {
                    completenessService.refresh();
                    success();
                };
                return this.constructor.__super__.fetch.apply(this, [ options ]);
            }
        });
        return Model;
    }
};

model = Alloy.M("verification_confirm", exports.definition, []);

collection = Alloy.C("verification_confirm", exports.definition, model);

exports.Model = model;

exports.Collection = collection;