var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

var Globals = require("/v6/infrastructure/Globals"), completenessService = Globals.IOC.get("completenessService");

completenessService.refresh();

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            url: "WELCOME_USER_V2",
            save: function(attrs, options) {
                attrs = attrs || {};
                options = options || {};
                var success = options.success || function() {};
                options.success = function() {
                    completenessService.refresh();
                    success();
                };
                return this.constructor.__super__.save.apply(this, [ attrs, options ]);
            },
            parse: function(response) {
                return response;
            }
        });
        return Model;
    }
};

model = Alloy.M("welcome_user", exports.definition, []);

collection = Alloy.C("welcome_user", exports.definition, model);

exports.Model = model;

exports.Collection = collection;