function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.activity/" + s : s.substring(0, index) + "/ma.car.app.activity/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.activity");
    this.__widgetId = "ma.car.app.activity";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.activityWrapper = Ti.UI.createView({
        width: "100%",
        height: 0,
        layout: "vertical",
        id: "activityWrapper"
    });
    $.__views.activityWrapper && $.addTopLevelView($.__views.activityWrapper);
    $.__views.nearbyActivityTitle = Ti.UI.createLabel({
        color: "#fff",
        text: L("widget_activity_nearby_activity"),
        width: Ti.UI.SIZE,
        height: "50dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        backgroundColor: "transparent",
        id: "nearbyActivityTitle"
    });
    $.__views.activityWrapper.add($.__views.nearbyActivityTitle);
    $.__views.activityCard = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "vertical",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        backgroundColor: "#fff",
        id: "activityCard"
    });
    $.__views.activityWrapper.add($.__views.activityCard);
    $.__views.content = Ti.UI.createView({
        layout: "vertical",
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        id: "content"
    });
    $.__views.activityCard.add($.__views.content);
    $.__views.avatarContainer = Ti.UI.createView({
        layout: "horizontal",
        height: Ti.UI.SIZE,
        width: Ti.UI.SIZE,
        top: "15dp",
        id: "avatarContainer"
    });
    $.__views.content.add($.__views.avatarContainer);
    $.__views.__alloyId796 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        top: "10dp",
        bottom: "15dp",
        id: "__alloyId796"
    });
    $.__views.content.add($.__views.__alloyId796);
    $.__views.nearbyActivity = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp"
        },
        id: "nearbyActivity"
    });
    $.__views.__alloyId796.add($.__views.nearbyActivity);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, parentWindow = TABS_HELPER.rootWindow();
    exports = new (require("/carmalib/controller").extend($, {
        initialActivity: false,
        _renderedUsers: [],
        _imgSize: 0,
        _margin: 0,
        _opening: false,
        events: {
            "click[ios] activityCard": "showActivityView",
            "click[android] activityCard": "showActivityView"
        },
        initialize: function() {
            _.bindAll(this, "showActivityView");
            this.setup();
            this._imgSize = parseInt(.9 * require("/platform/units").SystemUnitToDip(Alloy.Globals.Style.Size.Width.grid11 / 10), 10);
            this._margin = parseInt(.1 * require("/platform/units").SystemUnitToDip(Alloy.Globals.Style.Size.Width.grid11 / 10), 10);
        },
        setup: function() {
            var self = this;
            require("gps/gps_manager").lastLocation() ? self.getInitialActivity() : require("gps/gps_service").isLocationServiceEnabled() && parentWindow.addAppEventListener("carma:valid.location.update", function checkLocation() {
                parentWindow.removeAppEventListener("carma:valid.location.update", checkLocation);
                LOGGER.info("[GPS Manager] - Location available now. Checking again for Recent Activity");
                self.getInitialActivity();
            });
        },
        getInitialActivity: function() {
            if (!this.initialActivity) {
                this.initialActivity = true;
                var self = this;
                require("/services/activity_service").findAll().then(function(data) {
                    if (null !== data) {
                        self._renderUsers(data.merged);
                        self._renderInfo(data.recentActivity.length, data.recentSignups.length);
                    }
                });
            }
        },
        _renderUsers: function(users) {
            var maxItems = users.length < 10 ? users.length : 10;
            if (!maxItems) return;
            do {
                var user = users.shift(), userId = user.userId || user.user && user.user.userId, hasPhoto = user.userHasPhoto || user.user && user.user.userHasPhoto;
                if (-1 === this._renderedUsers.indexOf(userId) && hasPhoto) {
                    this._renderedUsers.push(userId);
                    this._createUser(user);
                    --maxItems;
                }
            } while (users.length && maxItems > 0);
            this._renderedUsers.length && ($.activityWrapper.height = Ti.UI.SIZE);
        },
        _createUser: function(user) {
            var imageView = Ti.UI.createImageView({
                width: this._imgSize + "dp",
                height: this._imgSize + "dp",
                right: this._margin + "dp",
                image: "/images/default_photo_male-rounded.png"
            });
            var userPhotoUrl = user.photoUrl || user.user && user.user.photoUrl;
            if (userPhotoUrl) {
                var photoUrl = require("utils/photoURL").toURL(userPhotoUrl, {
                    width: this._imgSize,
                    height: this._imgSize,
                    circular: true
                });
                require("/utils/photoCache").getRemoteFile(photoUrl).then(function(image) {
                    imageView.image = image;
                });
            }
            $.avatarContainer.add(imageView);
        },
        _renderInfo: function(rides, signups) {
            var activityMessage = "";
            rides > 0 && (activityMessage = String.format(L("widget_activity_recent_trips"), "" + rides));
            if (signups > 0) {
                rides > 0 && (activityMessage += " | ");
                activityMessage += String.format(L("widget_activity_new_users"), "" + signups);
            }
            "" === activityMessage && (activityMessage = L("widget_activity_nearby_activity"));
            $.nearbyActivity.text = activityMessage;
        },
        showActivityView: function() {
            if (this._opening) return;
            var self = this, activityView = Alloy.createWidget("ma.car.app.activity", "activity_window");
            this._opening = true;
            setTimeout(function() {
                self._opening = false;
            }, 5e3);
            activityView.getView().addEventListener("close", function handler() {
                activityView.getView().removeEventListener("close", handler);
                self._opening = false;
            });
            try {
                activityView.getView().open();
            } catch (e) {
                this._opening = false;
            }
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;