function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.addcommute/" + s : s.substring(0, index) + "/ma.car.app.addcommute/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.addcommute");
    this.__widgetId = "ma.car.app.addcommute";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "pickPhoto";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.photoContainer = Ti.UI.createView({
        width: "100%",
        bottom: "50dp",
        id: "photoContainer"
    });
    $.__views.photoContainer && $.addTopLevelView($.__views.photoContainer);
    $.__views.photoPicker = Ti.UI.createView({
        width: "91.66666666666666%",
        height: "373dp",
        bottom: 0,
        id: "photoPicker"
    });
    $.__views.photoContainer.add($.__views.photoPicker);
    $.__views.sayCheese = Ti.UI.createLabel({
        color: "#fff",
        shadowColor: "#70000000",
        shadowOffset: {
            x: 1,
            y: 1
        },
        text: L("widget_add_commute_say_cheese"),
        font: {
            fontSize: "46dp"
        },
        top: 0,
        id: "sayCheese"
    });
    $.__views.photoPicker.add($.__views.sayCheese);
    $.__views.photoHint = Ti.UI.createLabel({
        color: "#fff",
        text: L("widget_add_commute_hint"),
        font: {
            fontSize: "18dp"
        },
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        top: "60dp",
        id: "photoHint"
    });
    $.__views.photoPicker.add($.__views.photoHint);
    $.__views.photoWrapper = Ti.UI.createView({
        top: "129dp",
        width: "194dp",
        height: "194dp",
        backgroundColor: "transparent",
        id: "photoWrapper"
    });
    $.__views.photoPicker.add($.__views.photoWrapper);
    $.__views.photoSelected = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        width: "194dp",
        height: "194dp",
        zIndex: 1,
        id: "photoSelected"
    });
    $.__views.photoWrapper.add($.__views.photoSelected);
    $.__views.addPhotoButton = require("/ui/common/custom_button").createButton({
        width: "83.33333333333334%",
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "60dp",
        font: {
            fontSize: "18dp"
        },
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        title: L("widget_add_commute_add_photo"),
        bottom: "10dp",
        id: "addPhotoButton"
    });
    $.__views.photoPicker.add($.__views.addPhotoButton);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var Navigation = Alloy.Globals.Nav.AddComute, event = require("/tracking/tracking_event"), analytics = require("/tracking/tracking_manager"), stepsWidget = Alloy.Globals.StepsWidget;
    exports = new (require("/carmalib/controller").extend($, {
        TAG: "pickPhoto",
        _photoUploaded: false,
        initialize: function() {
            Ti.App.Properties.removeProperty("tripObject");
            this._showPhotoPicker();
            this._attachEventListeners();
        },
        _showPhotoPicker: function() {
            analytics.track(event.SIGNUP_PHOTO_SCREEN, {});
            var resourceOwner = require("services/resource_owner_service").singleton(), gender = resourceOwner.get("gender");
            if ("m" === gender) {
                $.photoSelected.defaultImage = WPATH("/images/photo_picker_male.png");
                $.photoSelected.image = WPATH("/images/photo_picker_male.png");
            } else {
                $.photoSelected.defaultImage = WPATH("/images/photo_picker_female.png");
                $.photoSelected.image = WPATH("/images/photo_picker_female.png");
            }
        },
        _focusView: function(focussed) {
            $.photoPicker.setOpacity(focussed ? 1 : .1);
        },
        onRightActionClick: function() {
            var nextWidget = Alloy.createWidget("ma.car.app.addcommute", "selectRole");
            stepsWidget.hideLeftAction();
            Navigation.open(nextWidget);
        },
        _attachEventListeners: function() {
            var self = this;
            $.addPhotoButton.addEventListener("click", function() {
                self._focusView(false);
                var selectPhoto = function() {
                    require("photo/photo_manager").pickPhoto().then(function(media) {
                        var executor = require("utils/executor");
                        var funcs = [];
                        funcs.push(function() {
                            return require("services/photo_service").saveUserImage(media);
                        });
                        funcs.push(function() {
                            var resourceOwner = require("services/resource_owner_service").singleton();
                            $.photoSelected.image = _.template(require("carmalib/url").USER_PHOTO, {
                                userId: resourceOwner.get("userId"),
                                width: $.photoSelected.rect.width,
                                height: $.photoSelected.rect.height,
                                timestamp: Date.now()
                            });
                            stepsWidget.enableRightAction();
                            self._hideSayCheese();
                            $.addPhotoButton.setTitle(L("widget_add_commute_retake_photo"));
                            self._photoUploaded = true;
                            analytics.track(event.SIGNUP_PHOTO_ADDED, {});
                        });
                        executor(funcs).error(function(e) {
                            if (502 === e.status) {
                                Carma.UI.createAlertWindow({
                                    title: L("error_title"),
                                    message: L("photo_module_upload_timeout")
                                }).show();
                                return;
                            }
                            Carma.UI.createAlertWindow({
                                title: L("error_title"),
                                message: L("photo_module_upload_error")
                            }).show();
                        }).run();
                    }).catch(function(e) {
                        LOGGER.error(e);
                        self._focusView(true);
                    }).finally(function() {
                        self._focusView(true);
                    });
                };
                selectPhoto();
            });
        },
        onLeftActionClick: function() {
            var self = this;
            var buttons = [ L("widget_add_commute_skip_photo_skip"), L("widget_add_commute_skip_photo_add") ], cancelIndex = 0;
            var dialog = Ti.UI.createAlertDialog({
                cancel: cancelIndex,
                buttonNames: buttons,
                title: L("widget_add_commute_skip_photo_title"),
                message: L("widget_add_commute_skip_photo_message")
            });
            dialog.addEventListener("click", function(e) {
                if (e.index === cancelIndex) {
                    analytics.track(event.SIGNUP_PHOTO_SKIPPED, {});
                    self.onRightActionClick();
                } else $.photoPicker.fireEvent("click");
                Ti.App.fireEvent("photo.popup.onclose");
            });
            dialog.show();
        },
        onOpened: function() {
            stepsWidget.setCurrentController(this);
            if (this._photoUploaded) {
                stepsWidget.enableRightAction();
                stepsWidget.hideLeftAction();
            } else stepsWidget.showLeftAction();
            stepsWidget.hideBackButton(false);
        },
        _hideSayCheese: function() {
            $.sayCheese.animate({
                opacity: 0,
                duration: 300
            });
            $.photoHint.animate({
                top: 80,
                duration: 500
            });
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;