function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.addcommute/" + s : s.substring(0, index) + "/ma.car.app.addcommute/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.addcommute");
    this.__widgetId = "ma.car.app.addcommute";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "steps";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.stepsWrapper = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.FILL,
        top: 0,
        left: 0,
        id: "stepsWrapper"
    });
    $.__views.stepsWrapper && $.addTopLevelView($.__views.stepsWrapper);
    $.__views.textLeft = Ti.UI.createLabel({
        color: "#fff",
        width: "25%",
        font: {
            fontSize: "18dp"
        },
        left: Alloy.Globals.Style.Size.Width.pct4,
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        visible: false,
        id: "textLeft"
    });
    $.__views.stepsWrapper.add($.__views.textLeft);
    $.__views.bottomBarCenter = Ti.UI.createView({
        width: "50%",
        id: "bottomBarCenter"
    });
    $.__views.stepsWrapper.add($.__views.bottomBarCenter);
    $.__views.stepsContainer = Ti.UI.createView({
        width: Ti.UI.SIZE,
        layout: "horizontal",
        top: "18dp",
        id: "stepsContainer"
    });
    $.__views.bottomBarCenter.add($.__views.stepsContainer);
    $.__views.textRight = Ti.UI.createLabel({
        color: "#858585",
        width: "25%",
        font: {
            fontSize: "18dp"
        },
        right: Alloy.Globals.Style.Size.Width.pct4,
        textAlign: Ti.UI.TEXT_ALIGNMENT_RIGHT,
        visible: false,
        id: "textRight"
    });
    $.__views.stepsWrapper.add($.__views.textRight);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, Navigation = Alloy.Globals.Nav.AddComute;
    exports = new (require("/carmalib/controller").extend($, {
        _steps: [],
        _isRightEnabled: true,
        _isLeftEnabled: true,
        _currentController: null,
        events: {
            "click textLeft": "_leftActionClicked",
            "click textRight": "_rightActionClicked"
        },
        initialize: function() {
            _.bindAll(this, "highlightNextStep", "downplayStep", "buildSteps", "enableRightAction", "disableRightAction", "getRightEnabled");
            args.steps && this.buildSteps(args.steps);
            this._attachEventListener();
            this.setLeftText(L("widget_add_commute_skip"));
            this.setRightText(L("widget_add_commute_next"));
        },
        _attachEventListener: function() {
            Navigation.addEventListener("nav.backcomplete", this.downplayStep);
            Navigation.addEventListener("nav.opencomplete", this.highlightNextStep);
        },
        buildSteps: function(steps) {
            if (!steps) {
                LOGGER.info("No steps provided (0)...");
                return;
            }
            var step = this._renderNextStep(1), separator = null;
            this._steps.push({
                step: step,
                enabled: false
            });
            $.stepsContainer.add(step);
            for (var i = 1; steps > i; ++i) {
                separator = Ti.UI.createView();
                $.addClass(separator, "separator");
                $.stepsContainer.add(separator);
                step = this._renderNextStep(i + 1);
                $.stepsContainer.add(step);
                this._steps.push({
                    step: step,
                    separator: separator,
                    enabled: false
                });
            }
        },
        _renderNextStep: function(step) {
            var container = Ti.UI.createView({
                width: "14dp",
                height: "14dp"
            });
            var view = Ti.UI.createView({
                backgroundImage: 1 === step ? "/images/stepHighlighted.png" : "/images/normalStep.png",
                width: "14dp",
                height: "14dp",
                zIndex: 1
            });
            var label = Ti.UI.createLabel({
                color: "#fff",
                text: step,
                textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
                font: {
                    fontSize: "11dp"
                }
            });
            label.setTop("-1dp");
            container.add(view);
            view.add(label);
            return container;
        },
        highlightNextStep: function() {
            if (!this._steps.length) return;
            var index = 0;
            while (this._steps[index].enabled) {
                ++index;
                if (index >= this._steps.length) return;
            }
            this._steps[index].enabled = true;
            this._steps[index].step && this._steps[index].step.getChildren()[0].setBackgroundImage("/images/stepHighlighted.png");
            this._steps[index].separator && this._steps[index].separator.setBackgroundColor("#6699ff");
        },
        downplayStep: function() {
            if (!this._steps.length) return;
            var index = 0;
            while (this._steps[index] && this._steps[index].enabled) ++index;
            --index;
            if (0 === index) return;
            this._steps[index].enabled = false;
            this._steps[index].step && this._steps[index].step.getChildren()[0].setBackgroundImage("/images/normalStep.png");
            this._steps[index].separator && this._steps[index].separator.setBackgroundColor("#858585");
        },
        setRightText: function(rightAction) {
            $.textRight.applyProperties({
                text: rightAction,
                visible: true
            });
        },
        getRightText: function() {
            return $.textRight.text;
        },
        _rightActionClicked: function() {
            if (!$.textRight.visible || !this._isRightEnabled) return;
            this._currentController.hasOwnProperty("onRightActionClick") && this._currentController.onRightActionClick();
        },
        hideRightAction: function() {
            $.textRight.setVisible(false);
        },
        enableRightAction: function() {
            $.textRight.setColor("#ff6600");
            this._isRightEnabled = true;
        },
        disableRightAction: function() {
            $.textRight.setColor("#858585");
            this._isRightEnabled = false;
        },
        getRightEnabled: function() {
            return this._isRightEnabled;
        },
        setRightVisible: function(visible) {
            $.textRight.visible = visible;
        },
        getRightVisible: function() {
            return $.textRight.visible;
        },
        setLeftText: function(leftAction) {
            $.textLeft.applyProperties({
                text: leftAction,
                visible: true
            });
        },
        getLeftText: function() {
            return $.textLeft.text;
        },
        _leftActionClicked: function() {
            if (!$.textLeft.visible || !this._isLeftEnabled) return;
            this._currentController.hasOwnProperty("onLeftActionClick") && this._currentController.onLeftActionClick();
        },
        showLeftAction: function() {
            $.textLeft.setVisible(true);
        },
        hideLeftAction: function() {
            $.textLeft.setVisible(false);
        },
        getLeftVisible: function() {
            return $.textLeft.visible;
        },
        setCurrentController: function(controller) {
            this._currentController = controller;
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;