function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.boardingv6/" + s : s.substring(0, index) + "/ma.car.app.boardingv6/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.boardingv6");
    this.__widgetId = "ma.car.app.boardingv6";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "crew_row";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.crew_row = Ti.UI.createTableViewRow({
        height: "60dp",
        backgroundColor: "#ffffffff",
        id: "crew_row"
    });
    $.__views.crew_row && $.addTopLevelView($.__views.crew_row);
    $.__views.container = Ti.UI.createView({
        top: 0,
        left: "13dp",
        right: "13dp",
        height: "60dp",
        backgroundColor: "transparent",
        id: "container"
    });
    $.__views.crew_row.add($.__views.container);
    $.__views.driverPhoto = require("/ui/common/profile").createView({
        left: 0,
        width: "50dp",
        height: "50dp",
        top: "6dp",
        id: "driverPhoto"
    });
    $.__views.container.add($.__views.driverPhoto);
    $.__views.driverName = Ti.UI.createLabel({
        color: "#333",
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        left: "62dp",
        top: "21dp",
        id: "driverName"
    });
    $.__views.container.add($.__views.driverName);
    $.__views.driverDistance = Ti.UI.createLabel({
        color: "#E7E7E7",
        font: {
            fontSize: "12dp"
        },
        id: "driverDistance"
    });
    $.__views.container.add($.__views.driverDistance);
    $.__views.btnStartTrip = require("/ui/common/custom_button").createButton({
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        normalColor: "#00333333",
        selectedColor: "#70333333",
        backgroundImage: "none",
        borderColor: Alloy.Globals.Style.Color.DarkGray,
        borderWidth: 2,
        right: 0,
        width: Ti.UI.SIZE,
        height: "40dp",
        top: "9dp",
        bottom: "9dp",
        title: "",
        id: "btnStartTrip"
    });
    $.__views.container.add($.__views.btnStartTrip);
    $.__views.__alloyId43 = Ti.UI.createLabel({
        color: "#333",
        font: {
            fontSize: "15dp"
        },
        left: "12dp",
        right: "12dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        width: Ti.UI.SIZE,
        text: L("widget_crew_start_trip"),
        id: "__alloyId43"
    });
    $.__views.btnStartTrip.add($.__views.__alloyId43);
    $.__views.separater = Ti.UI.createView({
        top: "59dp",
        height: 1,
        backgroundColor: "#666",
        width: Ti.UI.FILL,
        id: "separater"
    });
    $.__views.container.add($.__views.separater);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var driver = arguments[0].driver || {}, isLastOne = arguments[0].isLastOne || false, boardShown = false;
    var metersToMiles = function(val) {
        val = Number(val);
        var miles = 1e3 * val * .621371;
        miles = miles.toFixed(0);
        return miles;
    };
    exports = new (require("/carmalib/controller").extend($, {
        events: {
            "click btnStartTrip": "_startTrip"
        },
        initialize: function() {
            this._renderDriverRow();
        },
        _renderDriverRow: function() {
            $.driverPhoto.setUser(_.extend(driver, {
                hideStatus: true,
                photoUrl: driver.photoUrl,
                layout: "circular-small"
            }));
            $.driverName.text = driver.name;
            "BOOKING" === driver.reason && $.driverPhoto.highlightUser();
            $.separater.visible = !isLastOne;
        },
        getDriver: function() {
            return driver;
        },
        _startTrip: function() {
            if (!boardShown && !require("services/action_record_service").get("boardShown")) {
                var buttons = [ L("btn_cancel"), L("btn_confirm") ], cancelIndex = 0;
                buttons = [ L("btn_confirm"), L("btn_cancel") ];
                cancelIndex = 1;
                var dialog = Ti.UI.createAlertDialog({
                    cancel: cancelIndex,
                    buttonNames: buttons,
                    title: L("widget_crew_board_help_title"),
                    message: L("widget_crew_board_help_message")
                });
                var self = this;
                dialog.addEventListener("click", function(e) {
                    if (e.index === cancelIndex) return;
                    self._doStartTrip();
                });
                dialog.show();
                require("services/action_record_service").set("boardShown", true);
                return;
            }
            this._doStartTrip();
        },
        _doStartTrip: function() {
            boardShown = true;
            $.handleDriverSelection({
                data: {
                    driver: driver.id
                }
            });
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;