function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.boardingv6/" + s : s.substring(0, index) + "/ma.car.app.boardingv6/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.boardingv6");
    this.__widgetId = "ma.car.app.boardingv6";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "location";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.win = require("/ui/common/custom_window").createWindow({
        orientationModes: [ Ti.UI.PORTRAIT ],
        backgroundImage: null,
        modal: false,
        opacity: 1,
        width: Ti.UI.FILL,
        height: Ti.UI.FILL,
        backgroundColor: "#fff",
        id: "win",
        navBarHidden: "true"
    });
    $.__views.win && $.addTopLevelView($.__views.win);
    $.__views.locationView = Ti.UI.createView({
        width: "100%",
        bottom: 0,
        left: 0,
        height: "100%",
        id: "locationView"
    });
    $.__views.win.add($.__views.locationView);
    $.__views.tableHeader = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: 0,
        left: 0,
        height: Alloy.Globals.Style.Size.Height.pct70,
        id: "tableHeader"
    });
    $.__views.__alloyId45 = Ti.UI.createView({
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        bottom: "50dp",
        id: "__alloyId45"
    });
    $.__views.tableHeader.add($.__views.__alloyId45);
    $.__views.__alloyId46 = Ti.UI.createLabel({
        color: "#333",
        font: {
            fontSize: "15dp"
        },
        left: 0,
        bottom: "50dp",
        text: L("widget_location_title"),
        id: "__alloyId46"
    });
    $.__views.__alloyId45.add($.__views.__alloyId46);
    $.__views.locationSubTitle = Ti.UI.createLabel({
        color: "#333",
        font: {
            fontSize: "36dp"
        },
        left: 0,
        bottom: "10dp",
        id: "locationSubTitle"
    });
    $.__views.__alloyId45.add($.__views.locationSubTitle);
    $.__views.addLocation = Ti.UI.createLabel({
        color: "#333",
        font: {
            fontSize: "12dp"
        },
        right: 0,
        bottom: "10dp",
        width: "64dp",
        height: "64dp",
        backgroundColor: "transparent",
        borderColor: "#333",
        borderWidth: "1dp",
        borderRadius: Alloy.Globals.Style.Unit.unit32,
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        text: L("widget_add_location"),
        id: "addLocation",
        visible: "false"
    });
    $.__views.__alloyId45.add($.__views.addLocation);
    $.__views.__alloyId47 = Ti.UI.createView({
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        bottom: "10dp",
        id: "__alloyId47"
    });
    $.__views.tableHeader.add($.__views.__alloyId47);
    $.__views.passengerPhoto = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        borderColor: "#fff",
        borderWidth: "1px",
        width: "36dp",
        height: "36dp",
        borderRadius: Alloy.Globals.Style.Unit.unit18,
        id: "passengerPhoto",
        left: "0dp",
        bottom: "0dp"
    });
    $.__views.__alloyId47.add($.__views.passengerPhoto);
    $.__views.lblName = Ti.UI.createLabel({
        color: "#333",
        font: {
            fontSize: "15dp"
        },
        id: "lblName",
        left: "50dp",
        bottom: "18dp"
    });
    $.__views.__alloyId47.add($.__views.lblName);
    $.__views.lblTime = Ti.UI.createLabel({
        color: "#333",
        font: {
            fontSize: "12dp"
        },
        id: "lblTime",
        left: "50dp",
        bottom: "0dp"
    });
    $.__views.__alloyId47.add($.__views.lblTime);
    $.__views.locationTable = Ti.UI.createTableView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        left: Alloy.Globals.Style.Size.Width.pct4,
        backgroundColor: "transparent",
        separatorColor: "#333",
        separatorInsets: {
            left: 0,
            right: 0
        },
        showHorizontalScrollIndicator: false,
        showVerticalScrollIndicator: false,
        visible: true,
        headerView: $.__views.tableHeader,
        id: "locationTable"
    });
    $.__views.locationView.add($.__views.locationTable);
    $.__views.addressContainer = Ti.UI.createView({
        top: 0,
        left: 0,
        width: "100%",
        visible: false,
        id: "addressContainer"
    });
    $.__views.win.add($.__views.addressContainer);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, avatarUtils = require("/ui/common/Avatar"), dimension = require("/platform/dimension"), PublicProfile = require("/services/public_profile_service"), Globals = require("/v6/infrastructure/Globals"), ProfileService = Globals.IOC.get("ProfileService");
    errorCodes = require("services/error_codes"), moment = require("/vendor/moment"), 
    i18n = require("i18n/i18n"), trip = args.trip, type = args.type;
    positionTimestamp = args.timestamp;
    exports = new (require("/carmalib/controller").extend($, {
        _rowControllers: [],
        _locations: [],
        _selectLocationOpen: false,
        events: {
            "click locationTable": "_selectRow",
            "touchstart addLocation": "_touchSelectLocation",
            "touchend addLocation": "_releaseSelectLocation",
            "touchcancel addLocation": "_releaseSelectLocation",
            "click[android] addLocation": "_selectLocation",
            "click[ios] addLocation": "_selectLocation",
            "click[android] btnClose": "_close",
            "click[ios] btnClose": "_close"
        },
        initialize: function() {
            _.bindAll(this, "renderLocationList", "_close");
            require("/ui/windowManager").trackWindow($.win);
            this.renderLocationList();
            this._initLocationWidget();
            $.locationSubTitle.text = L(type === errorCodes.ERROR_SOURCE_BOARDING ? "widget_location_start" : "widget_location_end");
            $.addLocation.visible = require("bootstrap/network").isConnected();
            var self = this;
            $.win.addEventListener("androidback", this._close);
            trip instanceof Array && 1 == trip.length && (trip = trip[0]);
            trip instanceof Array ? this._setupForMultipleTrip() : this._setupForSingleTrip();
        },
        _setupForSingleTrip: function() {
            var timestamp = positionTimestamp ? positionTimestamp : trip.get(errorCodes.ERROR_SOURCE_BOARDING === type ? "startTimestamp" : "endTimestamp");
            $.lblTime.text = i18n.formatDateTime(moment(timestamp));
            var isDriver = trip.get("rider");
            var id = isDriver ? trip.get("rider").id : trip.get("driver").id;
            if (id || isDriver) {
                var cachedProfile = ProfileService.getCachedProfile(id);
                cachedProfile ? this._renderUserProfile(cachedProfile) : ProfileService.getProfile(id, ProfileService.BASIC_DETAIL).then(this._renderUserProfile);
            } else {
                var phone = trip.get("driver").phone;
                if (phone) {
                    var self = this;
                    var phoneProfile = ProfileService.getProfileByPhoneNumber(phone);
                    self._renderUserProfile(phoneProfile ? phoneProfile : {
                        phone: phone
                    });
                } else this._renderUserProfile(null);
            }
        },
        _setupForMultipleTrip: function() {
            $.lblTime.text = i18n.formatDateTime(moment(positionTimestamp ? positionTimestamp : Date.now()));
            $.passengerPhoto.image = avatarUtils.getDefaultGroupPhoto();
            var userIds = [];
            _.each(trip, function(passengerTrip) {
                var rider = passengerTrip.get("rider") || {};
                rider.id && userIds.push(rider.id);
            });
            ProfileService.getUserProfiles(userIds).then(this._renderUsersName);
        },
        _renderUsersName: function(profiles) {
            var usersAlias = [];
            for (var i = 0; i < profiles.length; i++) usersAlias.push(profiles[i].alias);
            $.lblName.text = usersAlias.join(", ");
        },
        _renderUserProfile: function(profile) {
            if (!profile) {
                $.lblName.text = L("widget_location_unregistered_user");
                $.passengerPhoto.image = avatarUtils.getDefaultPhotoByGender(false);
                return;
            }
            if (profile.phone && !profile.alias) {
                $.lblName.text = profile.phone;
                $.passengerPhoto.image = avatarUtils.getDefaultPhotoByGender(false);
                return;
            }
            $.lblName.text = profile.alias;
            avatarUtils.getUserPhoto(profile, false, {
                circular: false
            }).then(function(avatarCachePath) {
                $.passengerPhoto.image = avatarCachePath;
            }).catch(function() {
                $.passengerPhoto.image = avatarUtils.getDefaultPhoto(profile);
            });
        },
        _initLocationWidget: function() {
            var self = this;
            var locationSelectionWidget = Alloy.createWidget("ma.car.app.location", {
                label: L("widget_set_location_label"),
                hintText: L("widget_set_location_placeholder"),
                darkTheme: args.darkTheme,
                success: function(location) {
                    $.win.fireEvent("location", {
                        location: location
                    });
                    $.win.close();
                }
            });
            $.addressContainer.applyProperties({
                top: parseInt(dimension.windowTopInSystemUnit()) + 40,
                height: parseInt(dimension.windowHeightInSystemUnit()) - 40
            });
            $.addressContainer.add(locationSelectionWidget.getView());
        },
        _close: function() {
            if (!this._isSoloDriving(trip)) {
                $.win.removeEventListener("androidback", this._close);
                $.win.close();
                return;
            }
            var buttons = [ L("btn_cancel"), L("widget_location_selection_cancel_confirm") ], self = this, cancelIndex = 0;
            buttons = [ L("widget_location_selection_cancel_confirm"), L("btn_cancel") ];
            cancelIndex = 1;
            var dialog = Ti.UI.createAlertDialog({
                cancel: cancelIndex,
                buttonNames: buttons,
                title: L("widget_location_selection_help_title"),
                message: L("widget_location_selection_help_message")
            });
            dialog.addEventListener("click", function clickHandler(e) {
                dialog.removeEventListener("click", clickHandler);
                if (e.index !== cancelIndex) {
                    Ti.App.fireEvent("carma:location.selection.cancelled", trip);
                    $.win.removeEventListener("androidback", self._close);
                    $.win.close();
                }
            });
            dialog.show();
        },
        _isSoloDriving: function(trip) {
            if (_.isArray(trip)) return false;
            if (!trip.get("drivingSolo")) return false;
            return "" + trip.get("drivingSolo") == "true";
        },
        renderLocationList: function() {
            var locations = [];
            var self = this;
            require("services/favourite_locations_service").getFavouriteLocations().progress(function(data) {
                self._addOfflineRows(data.location);
            }).then(function(update) {
                self._addOnlineRows(update ? update.location : null);
            }).catch(function(err) {
                LOGGER.error("ERROR GETING FAVS:" + JSON.stringify(err));
            });
        },
        _addOfflineRows: function(locations) {
            if (this._selectLocationOpen) return;
            var rows = this._createTableRows(locations);
            if (0 === rows.length) return;
            LOGGER.debug("render location rows from  data");
            $.locationTable.applyProperties({
                data: rows,
                visible: true
            });
            for (var i = 0; i < rows.length; i++) $.locationTable.appendRow(rows[i]);
            this._setRowsPosition();
        },
        _addOnlineRows: function(locations) {
            if (this._selectLocationOpen) return;
            var rows = this._createTableRows(locations);
            if (0 === rows.length) return;
            $.locationTable.applyProperties({
                visible: true
            });
            for (var i = 0; i < rows.length; i++) $.locationTable.appendRow(rows[i]);
            this._setRowsPosition();
        },
        _setRowsPosition: function() {
            return;
            var numOfRows, tableHeight, adjustment;
        },
        _selectRow: function(e) {
            var index = e.index;
            this._rowControllers[index].selectRow();
            for (var i = 0; i < this._rowControllers.length; i++) i !== index && this._rowControllers[i].deselectRow();
            var location = this._locations[index];
            $.win.fireEvent("location", {
                location: location
            });
            $.win.close();
        },
        _createTableRows: function(locations) {
            if (!locations || 0 === locations.length) return [];
            var rows = [];
            for (var i = 0; i < locations.length; i++) {
                var location = locations[i];
                location.accuracy = -1;
                location.lon = location.longitude;
                location.lat = location.latitude;
                location.userGenerated = true;
                if (!this._locationAlreadyAdded(location)) {
                    this._locations.push(location);
                    var rowController = Widget.createController("location_row", location);
                    this._rowControllers.push(rowController);
                    rows.push(rowController.getView());
                }
            }
            return rows;
        },
        _locationAlreadyAdded: function(location) {
            if (this._locations) for (var i = 0; i < this._locations.length; i++) if (this._locations[i].lon === location.lon && this._locations[i].lat === location.lat) return true;
            return false;
        },
        _selectLocation: function() {
            this._selectLocationOpen = true;
            var self, animation;
            $.locationTable.applyProperties({
                visible: false
            });
            $.addressContainer.visible = true;
        },
        _touchSelectLocation: function() {
            $.addLocation.backgroundColor = "#85ffffff";
        },
        _releaseSelectLocation: function() {
            $.addLocation.backgroundColor = "#85000000";
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;