function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.boardingv6/" + s : s.substring(0, index) + "/ma.car.app.boardingv6/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.boardingv6");
    this.__widgetId = "ma.car.app.boardingv6";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "passengers_list";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.passengersList = Ti.UI.createScrollView({
        showVerticalScrollIndicator: false,
        showHorizontalScrollIndicator: false,
        backgroundColor: "transparent",
        horizontalWrap: false,
        height: "100%",
        scrollType: "horizontal",
        id: "passengersList"
    });
    $.__views.passengersList && $.addTopLevelView($.__views.passengersList);
    $.__views.horizontalWrapper = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: "100%",
        layout: "horizontal",
        id: "horizontalWrapper"
    });
    $.__views.passengersList.add($.__views.horizontalWrapper);
    $.__views.inCarList = Ti.UI.createView({
        height: "100%",
        width: Ti.UI.SIZE,
        visible: false,
        id: "inCarList"
    });
    $.__views.horizontalWrapper.add($.__views.inCarList);
    $.__views.inCarLabel = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        text: L("wiget_passengers_list_in_car"),
        top: 0,
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        id: "inCarLabel"
    });
    $.__views.inCarList.add($.__views.inCarLabel);
    $.__views.trips = Ti.UI.createView({
        layout: "horizontal",
        width: Ti.UI.SIZE,
        height: Ti.UI.FILL,
        horizontalWrap: false,
        top: "30dp",
        id: "trips"
    });
    $.__views.inCarList.add($.__views.trips);
    $.__views.notInCarList = Ti.UI.createView({
        height: "100%",
        width: Ti.UI.SIZE,
        visible: false,
        id: "notInCarList"
    });
    $.__views.horizontalWrapper.add($.__views.notInCarList);
    $.__views.notInCarLabel = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        text: L("wiget_passengers_list_not_in_car"),
        top: 0,
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        id: "notInCarLabel"
    });
    $.__views.notInCarList.add($.__views.notInCarLabel);
    $.__views.bookings = Ti.UI.createView({
        layout: "horizontal",
        width: Ti.UI.SIZE,
        height: Ti.UI.FILL,
        horizontalWrap: false,
        top: "30dp",
        id: "bookings"
    });
    $.__views.notInCarList.add($.__views.bookings);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, bookings = args.bookings || null, passengers = args.passengers || null, photoCache = require("/utils/photoCache"), appSound = require("/utils/appSound");
    exports = new (require("/carmalib/controller").extend($, {
        _events: [],
        _passengersIds: [],
        _trips: [],
        initialize: function() {
            _.bindAll(this, "appendPassengers", "isEmpty", "deletePassenger", "reset", "addEventListener", "fireEvent", "isLastOne", "_showUserProfile");
            this._renderListForBookings();
            this._renderListForPassengers();
        },
        _renderListForBookings: function() {
            if (!bookings) {
                this._toggleBookingsList(false);
                return;
            }
            var self = this, now = Date.now(), halfHour = 18e5;
            var resourceOwner = require("/services/resource_owner_service").singleton(), userId = resourceOwner.get("userId");
            var validBookings = _.filter(bookings, function(booking) {
                return "ACCEPTED" === booking.state && booking.rider.userId !== userId && booking.bookingDate - now <= halfHour;
            });
            if (!validBookings) {
                this._toggleBookingsList(false);
                return false;
            }
            var bookingListShown = false;
            _.each(validBookings, function(booking) {
                if (!self._isAlreadyPassenger(booking.rider.userId)) {
                    bookingListShown || self._toggleBookingsList(true);
                    self._createBookingRiderRow(booking.rider);
                    bookingListShown = true;
                }
            });
            this._refreshScrollView();
            return true;
        },
        _createBookingRiderRow: function(user) {
            this._passengersIds.push({
                id: user.userId,
                type: "booking"
            });
            var userContainer = Ti.UI.createView({
                width: "75dp",
                height: Ti.UI.FILL,
                userId: user.userId,
                alias: user.alias
            });
            userContainer.addEventListener("click", this._showUserProfile);
            var view = require("/ui/common/profile").createView({
                user: _.extend({}, user, {
                    disableProfile: false,
                    hideStatus: true,
                    layout: "circular-small"
                })
            });
            view.applyProperties({
                transform: null,
                top: "4dp",
                touchEnabled: false
            });
            userContainer.add(view);
            var label = Ti.UI.createLabel({
                color: "#fff",
                text: user.firstName,
                bottom: 0,
                font: {
                    fontSize: "15dp",
                    fontWeight: "bold"
                },
                height: "36dp",
                touchEnabled: false,
                width: "75dp",
                ellipsize: true,
                verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_TOP,
                textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER
            });
            userContainer.add(label);
            $.bookings.add(userContainer);
            var self = this;
            TM.push(function() {
                self._playAnimation(view);
            });
        },
        _toggleBookingsList: function(show) {
            if (show) {
                $.notInCarList.applyProperties({
                    visible: true,
                    width: Ti.UI.SIZE
                });
                $.inCarList.visible && ($.inCarList.right = "25dp");
                return;
            }
            $.notInCarList.applyProperties({
                visible: false,
                width: 0
            });
            $.inCarList.right = 0;
        },
        _renderListForPassengers: function() {
            if (!passengers) {
                this._togglePassengersList(false);
                return;
            }
            this._togglePassengersList(true);
            var self = this;
            _.each(passengers, function(passenger) {
                self._createPassengerRiderRow(passenger);
            });
            this._refreshScrollView();
        },
        _createPassengerRiderRow: function(tripInfo) {
            var passengerType = this._isAlreadyPassenger(tripInfo.get("rider").id);
            if ("trip" === passengerType) return;
            "booking" === passengerType && this.deletePassenger(tripInfo.get("rider").id);
            this._passengersIds.push({
                id: tripInfo.get("rider").id,
                type: "trip"
            });
            var userContainer = Ti.UI.createView({
                width: "75dp",
                height: Ti.UI.FILL,
                userId: tripInfo.get("rider").id,
                journeyId: tripInfo.get("journeyId")
            });
            this._trips.push(tripInfo);
            userContainer.addEventListener("click", this._showUserProfile);
            var view = require("/ui/common/profile").createView({
                top: 0,
                user: _.extend({}, {
                    disableProfile: false,
                    hideStatus: true,
                    layout: "circular-small"
                })
            });
            var label = Ti.UI.createLabel({
                color: "#fff",
                bottom: 0,
                font: {
                    fontSize: "15dp",
                    fontWeight: "bold"
                },
                height: "36dp",
                touchEnabled: false,
                width: "75dp",
                ellipsize: true,
                verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_TOP,
                textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER
            });
            this._downloadUserData(tripInfo.get("rider").id, view, label, tripInfo);
            userContainer.add(view);
            userContainer.add(label);
            $.trips.add(userContainer);
            this._togglePassengersList(true);
            var self = this;
            TM.push(function() {
                self._playAnimation(view);
                appSound.play("joincar");
            });
        },
        _downloadUserData: function(id, view, label, tripInfo) {
            var setProfile = function(data) {
                tripInfo.set("alias", data.alias);
                tripInfo.set("firstName", data.firstName);
                label.text = data.firstName;
                view.setUser(_.extend({}, data, {
                    disableProfile: false,
                    hideStatus: true,
                    layout: "circular-small"
                }));
                data.canUserTakeFreeRide;
                data.isFavourite;
            };
            var Globals = require("/v6/infrastructure/Globals"), ProfileService = Globals.IOC.get("ProfileService");
            var cachedProfile = ProfileService.getCachedProfile(id);
            cachedProfile ? setProfile(cachedProfile) : ProfileService.getProfile(id, ProfileService.BASIC_DETAIL).then(setProfile);
        },
        _togglePassengersList: function(show) {
            if (show) {
                $.inCarList.applyProperties({
                    visible: true,
                    width: Ti.UI.SIZE,
                    right: $.notInCarList.visible ? "25dp" : 0
                });
                return;
            }
            $.inCarList.applyProperties({
                visible: false,
                width: 0,
                right: 0
            });
        },
        _refreshScrollView: function() {
            var passengers = this._passengersIds.length, unitCalc = require("/platform/units");
            $.passengersList.contentWidth = unitCalc.dipToSystemUnit(75 * passengers + parseInt($.inCarList.right));
        },
        _playAnimation: function(view) {
            return;
            var self;
        },
        _deleteAnimation: function(view, container) {
            view.animate({
                transform: Ti.UI.create2DMatrix().scale(.2),
                duration: 300
            }, function() {
                container.remove(view);
            });
        },
        _startRadarAnimation: function(view, radarView) {
            function spin120() {
                animation.transform = transform120;
                radarView.animate(animation);
            }
            function spin240() {
                animation.transform = transform240;
                radarView.animate(animation);
            }
            function spin360() {
                animation.transform = transform360;
                radarView.animate(animation);
            }
            if (!radarView) return;
            radarView.opacity = 1;
            var transform120 = Ti.UI.create2DMatrix().rotate(120);
            var transform240 = Ti.UI.create2DMatrix().rotate(240);
            var transform360 = Ti.UI.create2DMatrix().rotate(360);
            var animation = Ti.UI.createAnimation({
                duration: 1e3,
                delay: 0
            });
            spin120();
            setInterval(spin120, 2750);
            setTimeout(function() {
                spin240();
                setInterval(spin240, 2750);
            }, 1e3);
            setTimeout(function() {
                spin360();
                setInterval(spin360, 2750);
            }, 2e3);
        },
        _isAlreadyPassenger: function(id) {
            for (var i = 0; i < this._passengersIds.length; ++i) if (this._passengersIds[i].id === id) return this._passengersIds[i].type;
            return false;
        },
        _showUserProfile: function(e) {
            Ti.App.fireEvent("carma:profile.open", {
                userId: e.source.userId
            });
        },
        _getTripForJourneyId: function(id) {
            for (var i = 0; i < this._trips.length; ++i) if (this._trips[i].get("journeyId") === id) return this._trips[i];
        },
        appendBookings: function(pendingBookings) {
            if (!pendingBookings) {
                LOGGER.debug("[passengers_list] - Bookings required");
                return;
            }
            bookings = pendingBookings;
            return this._renderListForBookings();
        },
        appendPassengers: function(passengersTrip) {
            if (!passengersTrip) {
                LOGGER.debug("[passengers_list] - Passengers required");
                return;
            }
            passengers = passengersTrip;
            this._renderListForPassengers();
        },
        getPassengers: function() {
            return this._passengersIds;
        },
        getOnboardPassengerCount: function() {
            var count = 0;
            for (var i = 0; i < this._passengersIds.length; ++i) "trip" === this._passengersIds[i].type && count++;
            return count;
        },
        getPassengerTrips: function() {
            return this._trips;
        },
        deletePassenger: function(id) {
            for (var i = 0; i < this._passengersIds.length; ++i) if (this._passengersIds[i].id === id) {
                this._passengersIds.splice(i, 1);
                break;
            }
            for (i = 0; i < this._trips.length; ++i) if (this._trips[i].get("rider").id === id) {
                this._trips.splice(i, 1);
                break;
            }
            var children = $.trips.getChildren(), length = children.length;
            for (i = 0; length > i; ++i) if (children[i].userId === id) {
                children[i].removeEventListener("click", this._showUserProfile);
                this._deleteAnimation(children[i], $.trips);
                1 === length && this._togglePassengersList(false);
                return;
            }
            children = $.bookings.getChildren();
            length = children.length;
            for (i = 0; length > i; ++i) if (children[i].userId === id) {
                children[i].removeEventListener("click", this._showUserProfile);
                this._deleteAnimation(children[i], $.bookings);
                1 === length && this._toggleBookingsList(false);
                return;
            }
        },
        isLastOne: function() {
            return 1 === this._passengersIds.length;
        },
        isEmpty: function() {
            return !this._passengersIds.length;
        },
        isPassangersEmpty: function() {
            for (var i = 0; i < this._passengersIds.length; ++i) if ("trip" === this._passengersIds[i].type) return false;
            return true;
        },
        reset: function() {
            var children = $.trips.getChildren();
            for (var i = 0; i < children.length; ++i) children[i].removeEventListener("click", this._showUserProfile);
            children = $.bookings.getChildren();
            for (i = 0; i < children.length; ++i) children[i].removeEventListener("click", this._showUserProfile);
            $.trips.removeAllChildren();
            $.bookings.removeAllChildren();
            this._togglePassengersList(false);
            this._toggleBookingsList(false);
            this._passengersIds = [];
            this._trips = [];
        },
        addEventListener: function(name, callback) {
            this._events[name] = callback;
        },
        fireEvent: function(name, data) {
            name in this._events && this._events[name](data);
        },
        clearEventListener: function() {
            this._events = [];
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;