function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.carmaCompleteness/" + s : s.substring(0, index) + "/ma.car.app.carmaCompleteness/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.carmaCompleteness");
    this.__widgetId = "ma.car.app.carmaCompleteness";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "completedList";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.scrollView = Ti.UI.createScrollView({
        showVerticalScrollIndicator: false,
        showHorizontalScrollIndicator: false,
        backgroundColor: "transparent",
        top: 0,
        left: 0,
        width: "100%",
        id: "scrollView"
    });
    $.__views.scrollView && $.addTopLevelView($.__views.scrollView);
    $.__views.scrollViewWrapper = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: 0,
        layout: "vertical",
        id: "scrollViewWrapper"
    });
    $.__views.scrollView.add($.__views.scrollViewWrapper);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, data = args.data || {}, appSound = require("/utils/appSound"), Queue = require("/utils/queue"), Q = require("/vendor/q"), deepLinker = require("/bootstrap/deepLinker"), Globals = require("/v6/infrastructure/Globals"), completenessService = Globals.IOC.get("completenessService"), ui = require("utils/ui");
    exports = new (require("/carmalib/controller").extend($, {
        events: {},
        _views: {},
        _animationQueue: new Queue(),
        _completenessSoundLength: 850,
        _completenessModel: null,
        _opening: false,
        _goButtons: [],
        initialize: function() {
            _.bindAll(this, "_renderCompleteness", "_removeGoButtonEvents");
            this._renderRows();
        },
        init: function() {
            var self = this, _window = ui.getWindow($.scrollView);
            _window.addEventListener("close", function handler() {
                _window.removeEventListener("close", handler);
                self._animationQueue.clear();
                self._removeGoButtonEvents();
            });
            this._completenessModel = Alloy.createModel("carma_completeness");
            this._completenessModel.fetch({
                localOnly: true
            }).then(this._renderCompleteness).done();
        },
        _removeGoButtonEvents: function() {
            this._goButtons && this._goButtons.length > 0 && _.each(this._goButtons, function(goButton) {
                if (goButton && goButton.clickEventHandler) {
                    goButton.removeEventListener("click", goButton.clickEventHandler);
                    goButton = null;
                }
            });
            this._goButtons = null;
        },
        _playCheckMarkAnimation: function(views, skipAnimation) {
            function animation() {
                appSound.play("completeness");
                views[0].applyProperties({
                    visible: true
                });
                return Q().delay(self._completenessSoundLength);
            }
            views[1].applyProperties({
                visible: false,
                touchEnabled: false
            });
            if (skipAnimation) {
                views[0].applyProperties({
                    transform: null,
                    visible: true
                });
                return;
            }
            var self = this;
            this._animationQueue.stop = true;
            this._animationQueue.push(animation);
            this._animationQueue.stop = false;
        },
        _playGoButtonAnimation: function(views, skipAnimation) {
            views[0].applyProperties({
                visible: false,
                touchEnabled: false
            });
            if (skipAnimation || true) {
                views[1].applyProperties({
                    transform: null,
                    visible: true,
                    touchEnabled: true
                });
                return;
            }
            views[1].animate({
                duration: 300,
                transform: Ti.UI.create2DMatrix().scale(1.3)
            }, function() {
                views[1].animate({
                    duration: 150,
                    transform: Ti.UI.create2DMatrix().scale(1)
                });
            });
            views[1].touchEnabled = true;
        },
        _renderCompleteness: function(localData) {
            if (!data) return;
            var completed = [], pending = [], noAnimation = [], localAchievements = localData.items;
            _.each(data.items, function(item) {
                var localItem = _.findWhere(localAchievements, {
                    type: item.type
                });
                if (item.skipAnimation) noAnimation.push(item); else {
                    localItem.alreadySeen = true;
                    localItem.completed = item.completed;
                    localItem.skipAnimation = true;
                    item.completed ? completed.push(item) : pending.push(item);
                }
            });
            this._completenessModel.save(localData, {
                localOnly: true
            }).then(function(data) {
                completenessService.refresh();
            }).done();
            var self = this;
            TM.push(function() {
                self._renderAlreadySeenAchievements(noAnimation, true);
                self._renderCompleted(completed);
                self._renderPending(pending);
                self._renderAlreadySeenAchievements(noAnimation, false);
            });
        },
        _renderCompleted: function(completed) {
            if (!completed.length) return;
            var self = this;
            _.each(completed, function(item) {
                self._playCheckMarkAnimation(self._views[item.type], false);
            });
        },
        _renderPending: function(pending) {
            function animation() {
                appSound.play("gobutton");
                _.each(pending, function(item) {
                    self._playGoButtonAnimation(self._views[item.type], false);
                });
            }
            if (!pending.length) return;
            var self = this;
            this._animationQueue.stop = true;
            this._animationQueue.push(animation);
            this._animationQueue.stop = false;
        },
        _renderAlreadySeenAchievements: function(alreadySeenItems, completed) {
            function scheduled() {
                _.each(alreadySeenItems, function(item) {
                    item.completed && completed ? self._playCheckMarkAnimation(self._views[item.type], true) : item.completed || completed || self._playGoButtonAnimation(self._views[item.type], true);
                });
            }
            if (!alreadySeenItems.length) return;
            var self = this;
            this._animationQueue.stop = true;
            this._animationQueue.push(scheduled);
            this._animationQueue.stop = false;
        },
        _renderRows: function() {
            var items = data.items, itemsLength = items.length, self = this;
            _.each(items, function(item, index) {
                var row = Ti.UI.createView();
                $.addClass(row, "row");
                var lblContainer = Ti.UI.createView();
                $.addClass(lblContainer, "lbl-container");
                var title = Ti.UI.createLabel({
                    text: item.title
                });
                $.addClass(title, "lbl-medium-bold lbl-title");
                var subtitle = Ti.UI.createLabel({
                    text: item.description
                });
                $.addClass(subtitle, "lbl-small lbl-subtitle");
                var goButton = require("/ui/common/custom_button").createButton({
                    font: {
                        fontSize: "15dp"
                    },
                    color: Alloy.Globals.Style.Color.DarkGray,
                    borderRadius: Alloy.Globals.Style.Unit.unit3,
                    normalColor: "#00333333",
                    selectedColor: "#70333333",
                    backgroundImage: "none",
                    borderColor: Alloy.Globals.Style.Color.DarkGray,
                    borderWidth: 2,
                    title: L("btn_go"),
                    right: "8dp",
                    width: "60dp",
                    height: "40dp",
                    transform: null,
                    visible: false,
                    touchEnabled: false
                });
                if (item.confirmUrl) {
                    goButton.clickEventHandler = function() {
                        self._processClickEvent(item.confirmUrl);
                    };
                    goButton.addEventListener("click", goButton.clickEventHandler);
                    self._goButtons.push(goButton);
                }
                var checkMark = Ti.UI.createLabel();
                $.addClass(checkMark, "icon icon-ok green-check");
                row.add(lblContainer);
                lblContainer.add(title);
                lblContainer.add(subtitle);
                row.add(goButton);
                row.add(checkMark);
                $.scrollViewWrapper.add(row);
                if (itemsLength > index + 1) {
                    var hr = Ti.UI.createView();
                    $.addClass(hr, "hr");
                    $.scrollViewWrapper.add(hr);
                }
                self._views[item.type] = [ checkMark, goButton ];
            });
        },
        _processClickEvent: function(confirmUrl) {
            if (this._opening) return;
            this._opening = true;
            var self = this, _window = ui.getWindow($.scrollView);
            _window && _window.close && setTimeout(function() {
                _window.close();
                self._opening = false;
            }, 200);
            deepLinker.handleUrl(confirmUrl);
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;