function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.carmaCompleteness/" + s : s.substring(0, index) + "/ma.car.app.carmaCompleteness/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.carmaCompleteness");
    this.__widgetId = "ma.car.app.carmaCompleteness";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.completenessWrapper = Ti.UI.createView({
        width: "100%",
        layout: "vertical",
        transform: Alloy.Globals.scaleDown,
        height: 0,
        id: "completenessWrapper"
    });
    $.__views.completenessWrapper && $.addTopLevelView($.__views.completenessWrapper);
    $.__views.completenessTitle = Ti.UI.createLabel({
        color: "#fff",
        text: L("widget_completeness_title"),
        width: Ti.UI.SIZE,
        height: "50dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        backgroundColor: "transparent",
        id: "completenessTitle"
    });
    $.__views.completenessWrapper.add($.__views.completenessTitle);
    $.__views.completenessCard = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "vertical",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        backgroundColor: "#fff",
        id: "completenessCard"
    });
    $.__views.completenessWrapper.add($.__views.completenessCard);
    $.__views.completenessContainer = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        top: "10dp",
        bottom: "10dp",
        layout: "horizontal",
        id: "completenessContainer"
    });
    $.__views.completenessCard.add($.__views.completenessContainer);
    $.__views.avatar = Ti.UI.createImageView({
        defaultImage: "/images/default_photo_male-rounded.png",
        backgroundColor: "#fff",
        borderColor: "#fff",
        borderWidth: 1,
        left: 0,
        width: "60dp",
        height: "60dp",
        borderRadius: Alloy.Globals.Style.Unit.unit30,
        id: "avatar"
    });
    $.__views.completenessContainer.add($.__views.avatar);
    $.__views.percentage = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        font: {
            fontSize: "36dp"
        },
        text: "0%",
        left: "10dp",
        width: "115dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        id: "percentage"
    });
    $.__views.completenessContainer.add($.__views.percentage);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var avatarUtils = require("/ui/common/Avatar"), photoURL = require("/utils/photoURL"), photoCache = require("/utils/photoCache"), parentWindow = TABS_HELPER.rootWindow(), Globals = require("/v6/infrastructure/Globals"), completenessService = Globals.IOC.get("completenessService"), completenessModule = Alloy.createModel("carma_completeness");
    exports = new (require("/carmalib/controller").extend($, {
        events: {
            "click completenessCard": "_openCompletenessWindow"
        },
        _percentageAnimationInterval: null,
        _completenessResponse: null,
        initialize: function() {
            _.bindAll(this, "_checkDataAndShowCard", "reload", "_showUserPhoto");
            this._showUserPhoto();
            var self = this, callbackFirstLoad = function(data) {
                self._checkDataAndShowCard(data);
            };
            this._loadCarmaProgress(callbackFirstLoad);
            this._initEventListeners();
        },
        _initEventListeners: function() {
            var self = this, callbackUpdate = function(data) {
                self._updatePercentage(data);
            };
            completenessService.addListener(completenessService.REFRESH_EVENT, function() {
                self._loadCarmaProgress(callbackUpdate);
            });
            parentWindow.addAppEventListener("carma:boarding.details_updated", function() {
                self._loadCarmaProgress(callbackUpdate);
            });
            parentWindow.addAppEventListener("app.carma.profile.change", function() {
                self._showUserPhoto();
                self._loadCarmaProgress(callbackUpdate);
            });
            parentWindow.addAppEventListener("carma.webview.close", function() {
                self._loadCarmaProgress(callbackUpdate);
            });
        },
        reload: function() {
            var self = this;
            this._loadCarmaProgress(function(data) {
                self._updatePercentage(data);
            });
            this._showUserPhoto();
        },
        _showUserPhoto: function() {
            var resourceOwner = require("services/resource_owner_service").singleton(), userObject = resourceOwner.toJSON();
            var url = photoURL.toURL(userObject.photoUrl, {
                width: 60,
                height: 60,
                circular: true
            });
            var photoPath = photoCache.getCached(url);
            if (photoPath === $.avatar.image) return;
            if (photoPath) $.avatar.image = photoPath; else {
                $.avatar.image = avatarUtils.getDefaultPhoto(userObject);
                photoCache.downloadAvatar(url).then(function(url) {
                    $.avatar.image = url;
                });
            }
        },
        _loadCarmaProgress: function(callback) {
            if (!callback) return;
            var localData = null, self = this;
            completenessModule.fetch().progress(function(data) {
                localData = data;
            }).then(function(serverData) {
                self._processResponseForAnimations(serverData, localData);
                callback(serverData);
            }).catch(this._handleError).done();
        },
        _processResponseForAnimations: function(serverData, localData) {
            if (!serverData || !localData) return;
            _.each(serverData.items, function(item) {
                var localItem = _.findWhere(localData.items, {
                    type: item.type
                });
                item.skipAnimation = localItem.alreadySeen && localItem.completed === item.completed;
            });
        },
        _checkDataAndShowCard: function(data) {
            if (!data) return;
            if (false === data.showCard && 1 === data.ratio) return;
            1 === data.ratio ? data.showCard = false : data.showCard || (data.showCard = true);
            completenessModule.save(data, {
                localOnly: true
            });
            this._completenessResponse = data;
            var self = this;
            TM.push(function() {
                var animationCompleted = false;
                setTimeout(function() {
                    if (!animationCompleted) {
                        $.completenessWrapper.transform = Ti.UI.create2DMatrix().scale(1);
                        self._startPercentageAnimation(data);
                    }
                }, 500);
                $.completenessWrapper.height = Ti.UI.SIZE;
                $.completenessWrapper.animate({
                    transform: Ti.UI.create2DMatrix().scale(1),
                    duration: 250
                }, function() {
                    animationCompleted = true;
                    self._startPercentageAnimation(data);
                });
            });
        },
        _startPercentageAnimation: function(data) {
            this._percentageAnimationInterval && this._stopPercentageAnimationSteps();
            var newValue = data.initValue || 0, self = this, limit = Math.round(100 * data.ratio);
            this._percentageAnimationInterval = setInterval(function() {
                newValue += 5;
                newValue = limit > newValue ? newValue : limit;
                self._percentageAnimationStep(newValue, newValue === limit);
            }, 50);
        },
        _percentageAnimationStep: function(newValue, endAnimation) {
            if (endAnimation) {
                this._stopPercentageAnimationSteps();
                $.percentage.animate({
                    autoreverse: true,
                    duration: 100,
                    transform: Ti.UI.create2DMatrix({
                        scale: 1.3
                    })
                }, function() {
                    $.percentage.transform = Ti.UI.create2DMatrix().scale(1);
                });
            }
            $.percentage.text = newValue + "%";
        },
        _stopPercentageAnimationSteps: function() {
            clearInterval(this._percentageAnimationInterval);
            this._percentageAnimationInterval = null;
        },
        _handleError: function() {
            alert("Could not fetch completeness progress");
        },
        _updatePercentage: function(data) {
            if (!data) return;
            var _currentRatio = (this._completenessResponse ? this._completenessResponse.ratio : 0) || 0, currentRatio = Math.round(100 * _currentRatio), newRatio = Math.round(100 * data.ratio);
            if (currentRatio === newRatio) {
                _.isEqual(this._completenessResponse, data) || (this._completenessResponse = data);
                return;
            }
            this._completenessResponse = data;
            data.initValue = currentRatio;
            this._startPercentageAnimation(data);
        },
        _openCompletenessWindow: function() {
            if (!this._completenessResponse) return;
            Alloy.createWidget("ma.car.app.carmaCompleteness", "completeness_window", {
                data: this._completenessResponse
            }).getView().open();
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;