function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.common/" + s : s.substring(0, index) + "/ma.car.app.common/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.common");
    this.__widgetId = "ma.car.app.common";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "map";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.mapWindow = Ti.UI.createView({
        top: 0,
        left: 0,
        width: "100%",
        height: "100%",
        backgroundColor: "white",
        id: "mapWindow"
    });
    $.__views.mapWindow && $.addTopLevelView($.__views.mapWindow);
    $.__views.headerContainer = Ti.UI.createView({
        top: 0,
        left: 0,
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "vertical",
        zIndex: 1,
        backgroundColor: "white",
        id: "headerContainer"
    });
    $.__views.mapWindow.add($.__views.headerContainer);
    $.__views.mapview = Alloy.Globals.Map.createView({
        width: "100%",
        mapType: Alloy.Globals.Map.NORMAL_TYPE,
        id: "mapview"
    });
    $.__views.mapWindow.add($.__views.mapview);
    $.__views.mapDescription = Ti.UI.createLabel({
        color: "#000",
        font: {
            fontSize: "15dp"
        },
        bottom: "10dp",
        width: "90%",
        height: "40dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        text: L("widget_samantha_confirmed_trip_map_des"),
        visible: false,
        id: "mapDescription"
    });
    $.__views.mapWindow.add($.__views.mapDescription);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var i18n = require("i18n/i18n"), units = require("/platform/units");
    var Globals = require("/v6/infrastructure/Globals"), LoggingService = Globals.IOC.get("LoggingService");
    var args = arguments[0] || {}, trip = args.trip, buddies = args.buddies;
    var buddyAnnotation = null, avatarLoadedCount = 0;
    exports = new (require("/carmalib/controller").extend($, {
        _buddyPostionInterval: null,
        _avatar: null,
        _mapAnnotation: [],
        _headUserLocation: [],
        _headUserTime: [],
        events: {},
        initialize: function() {
            _.bindAll(this, "_refreshBuddiesPosition", "onDestroy");
            this._addLocationAnnotation();
            this._initBuddiesAnnotations();
            this._loadMap();
        },
        _openProfile: function(buddy) {
            if (!buddy) return;
            Ti.App.fireEvent("carma:profile.open", {
                userId: buddy.userId
            });
        },
        _addLocationAnnotation: function() {
            $.mapview.region = {
                latitude: (trip.origin.latitude + trip.destination.latitude) / 2,
                longitude: (trip.origin.longitude + trip.destination.longitude) / 2,
                latitudeDelta: 1.2 * Math.abs(trip.origin.latitude - trip.destination.latitude),
                longitudeDelta: 1.2 * Math.abs(trip.origin.longitude - trip.destination.longitude)
            };
            var originPros = {
                latitude: trip.origin.latitude,
                longitude: trip.origin.longitude,
                title: trip.origin.address,
                subtitle: i18n.formatTime(moment(trip.schedule.effectiveTime)),
                pincolor: Alloy.Globals.Map.ANNOTATION_GREEN
            };
            args.dontUseTime && delete originPros.subtitle;
            var originAnnotation = Alloy.Globals.Map.createAnnotation(originPros);
            var destinationAnnotation = Alloy.Globals.Map.createAnnotation({
                latitude: trip.destination.latitude,
                longitude: trip.destination.longitude,
                title: trip.destination.address,
                pincolor: Alloy.Globals.Map.ANNOTATION_RED
            });
            $.mapview.addAnnotation(originAnnotation);
            $.mapview.addAnnotation(destinationAnnotation);
            this._mapAnnotation.push(originAnnotation);
            this._mapAnnotation.push(destinationAnnotation);
        },
        _initBuddiesAnnotations: function() {
            var self = this;
            var size = 0;
            _.each(buddies, function(buddy) {
                self._getBuddyAnnotation(buddy);
                size++;
            });
            var screenHeight = units.SystemUnitToDip(Ti.Platform.displayCaps.platformHeight);
            var mapTop = 60 * size + "dp";
            var mapHeight = screenHeight - 60 * size + "dp";
            $.mapview.applyProperties({
                top: mapTop,
                height: mapHeight
            });
        },
        _getBuddyAnnotation: function(buddy) {
            if (!buddy) return;
            var self = this;
            var pixs50 = units.dipToPixel(50);
            var buddyPhotoUrl = buddy.photoUrl.replace("/image/upload/", "/image/upload/w_" + pixs50 + ",h_" + pixs50 + ",c_fill,r_max,bo_2px_solid_white/").replace(".jpg", ".png");
            require("/utils/photoCache").getRemoteFile(buddyPhotoUrl).then(function(localPath) {
                buddy.avatar = localPath;
            }).catch(function(e) {}).finally(function() {
                avatarLoadedCount++;
                avatarLoadedCount === buddies.length && self._getInitialBuddiesPosition();
            });
            var pixs52 = units.dipToPixel(52);
            var avatarPhotoUrl = buddy.photoUrl.replace("/image/upload/", "/image/upload/w_" + pixs52 + ",h_" + pixs52 + ",c_fill,r_max/").replace(".jpg", ".png");
            require("/utils/photoCache").getRemoteFile(avatarPhotoUrl).then(function(localPath) {
                buddy.smallAvatar = localPath;
                if (buddy.avatarImageView) {
                    buddy.avatarImageView.image = localPath;
                    delete buddy.avatarImageView;
                }
            }).catch(function(e) {
                LOGGER.error("[map] - smallAvatar error: " + JSON.stringify(e));
            }).finally(function() {});
        },
        _addHeaderAvatar: function(buddy, name, address, time) {
            this._avatar = null;
            this._avatar = Ti.UI.createImageView();
            var header = Ti.UI.createView(), lastSeenUser = Ti.UI.createLabel();
            lastSeenLocation = Ti.UI.createLabel();
            lastSeenTime = Ti.UI.createLabel();
            lastSeen = Ti.UI.createView();
            $.addClass(header, "header");
            $.addClass(this._avatar, "avatar1");
            $.addClass(lastSeen, "lastSeen");
            $.addClass(lastSeenUser, "lastSeenUser lbl-small-bold");
            $.addClass(lastSeenLocation, "lastSeenLocation lbl-small");
            $.addClass(lastSeenTime, "lastSeenTime lbl-small");
            buddy.smallAvatar ? this._avatar.image = buddy.smallAvatar : buddy.avatarImageView = this._avatar;
            lastSeenUser.setText(name);
            lastSeenLocation.setText(address);
            lastSeenTime.setText(time);
            header.add(this._avatar);
            header.add(lastSeen);
            lastSeen.add(lastSeenUser);
            lastSeen.add(lastSeenLocation);
            lastSeen.add(lastSeenTime);
            $.headerContainer.add(header);
            var self = this;
            this._avatar.clickEvent = function() {
                self._openProfile(buddy);
            };
            this._avatar.addEventListener("click", this._avatar.clickEvent);
            this._headUserLocation[buddy.userId] = lastSeenLocation;
            this._headUserTime[buddy.userId] = lastSeenTime;
        },
        _getInitialBuddiesPosition: function() {
            this._refreshBuddiesPosition();
            this._buddyPostionInterval = setInterval(this._refreshBuddiesPosition, 3e4);
        },
        _refreshBuddiesPosition: function() {
            var self = this;
            _.each(buddies, function(buddy) {
                self._getBuddyPosition(buddy);
            });
        },
        _getBuddyPosition: function(buddy) {
            var self = this;
            Alloy.createModel("live_location", {
                urlParams: {
                    userId: buddy.userId
                }
            }).fetch().then(function(data) {
                if (data.lastKnownLocation.latitude && (!buddy.buddyAnnotation || data.lastKnownLocation.latitude != buddy.buddyAnnotation.latitude || data.lastKnownLocation.longitude != buddy.buddyAnnotation.longitude)) {
                    if (buddy.buddyAnnotation) {
                        $.mapview.removeAnnotation(buddy.buddyAnnotation);
                        $.mapview.addAnnotation(Alloy.Globals.Map.createAnnotation({
                            latitude: buddy.buddyAnnotation.latitude,
                            longitude: buddy.buddyAnnotation.longitude,
                            image: "/images/dot.png",
                            canShowCallout: false
                        }));
                        buddy.buddyAnnotation = null;
                    }
                    buddy.buddyAnnotation = Alloy.Globals.Map.createAnnotation({
                        latitude: data.lastKnownLocation.latitude,
                        longitude: data.lastKnownLocation.longitude,
                        title: buddy.alias,
                        image: buddy.avatar,
                        pincolor: Alloy.Globals.Map.ANNOTATION_ORANGE
                    });
                    LOGGER.error("[map] - add annotation: " + JSON.stringify(buddy.buddyAnnotation));
                    $.mapview.addAnnotation(buddy.buddyAnnotation);
                }
                if (self._headUserLocation[buddy.userId] && self._headUserTime[buddy.userId]) {
                    self._headUserLocation[buddy.userId].setText(String.format(L("widget_decision_samantha_map_lastseen"), data.lastKnownLocation.address));
                    self._headUserTime[buddy.userId].setText(i18n.formatDateTime(moment(data.lastKnownLocation.timestamp)));
                } else {
                    self._addHeaderAvatar(buddy, buddy.alias, String.format(L("widget_decision_samantha_map_lastseen"), data.lastKnownLocation.address), i18n.formatDateTime(moment(data.lastKnownLocation.timestamp)));
                    $.mapDescription.visible = true;
                }
            }).catch(function(e) {
                LOGGER.error(JSON.stringify(e));
            }).finally(function() {});
        },
        _loadMap: function() {
            var url = "http://maps.googleapis.com/maps/api/directions/json?origin=" + trip.origin.latitude + "," + trip.origin.longitude + "&destination=" + trip.destination.latitude + "," + trip.destination.longitude + "&sensor=true";
            var xhr = Ti.Network.createHTTPClient({
                onerror: function() {},
                onload: function() {
                    try {
                        var xml = this.responseText;
                        var leg = JSON.parse(this.responseText).routes[0].legs[0];
                        var position = leg.steps;
                        var points = [];
                        if (null != position[0]) {
                            points.push({
                                latitude: position[0].start_location.lat,
                                longitude: position[0].start_location.lng
                            });
                            for (var i = 0; i < position.length; i++) {
                                var decodedPolyline = require("/utils/gmap").decode(position[i].polyline.points);
                                for (var j = 0; j < decodedPolyline.length; j++) null != decodedPolyline[j] && points.push({
                                    latitude: decodedPolyline[j][0],
                                    longitude: decodedPolyline[j][1]
                                });
                            }
                            var route = {
                                points: points,
                                color: "blue",
                                width: units.dipToPixel(5)
                            };
                            var minlat = Math.min(trip.origin.latitude, trip.destination.latitude);
                            var maxlat = Math.max(trip.origin.latitude, trip.destination.latitude);
                            var minlon = Math.min(trip.origin.longitude, trip.destination.longitude);
                            var maxlon = Math.max(trip.origin.longitude, trip.destination.longitude);
                            for (var i = 0; i < points.length; i++) {
                                points[i].latitude < minlat ? minlat = points[i].latitude : points[i].latitude > maxlat && (maxlat = points[i].latitude);
                                points[i].longitude < minlon ? minlon = points[i].longitude : points[i].longitude > maxlon && (maxlon = points[i].longitude);
                            }
                            $.mapview.region = {
                                latitude: (minlat + maxlat) / 2,
                                longitude: (minlon + maxlon) / 2,
                                latitudeDelta: 1.2 * Math.abs(maxlat - minlat),
                                longitudeDelta: 1.2 * Math.abs(maxlon - minlon)
                            };
                        }
                    } catch (e) {}
                },
                onerror: function() {},
                timeout: 2e4
            });
            xhr.setRequestHeader("Content-Type", "application/json; charset=utf-8");
            xhr.open("GET", url);
            LoggingService.log("network", url);
            xhr.send(null);
        },
        onDestroy: function() {
            for (var i = 0; i < this._mapAnnotation.length; i++) $.mapview.removeAnnotation(this._mapAnnotation[i]);
            $.mapview = null;
            Alloy.Globals.Map.region = {};
            this._mapAnnotation = null;
            clearInterval(this._buddyPostionInterval);
            if (this._avatar && this._avatar.clickEvent) {
                this._avatar.removeEventListener("click", this._avatar.clickEvent);
                this._avatar = null;
            }
            this._headUserLocation = null;
            this._headUserTime = null;
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;