function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.favorites/" + s : s.substring(0, index) + "/ma.car.app.favorites/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.favorites");
    this.__widgetId = "ma.car.app.favorites";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "add_user";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.addFavoriteContainer = Ti.UI.createView({
        layout: "vertical",
        width: "100%",
        height: "100%",
        id: "addFavoriteContainer"
    });
    $.__views.addFavoriteContainer && $.addTopLevelView($.__views.addFavoriteContainer);
    $.__views.inputFavorite = Ti.UI.createTextField({
        paddingLeft: "10dp",
        height: "60dp",
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        width: Alloy.Globals.Style.Size.Width.grid11,
        borderWidth: 1,
        borderColor: "#a4a4a4",
        softKeyboardOnFocus: Ti.UI.Android.SOFT_KEYBOARD_SHOW_ON_FOCUS,
        id: "inputFavorite"
    });
    $.__views.addFavoriteContainer.add($.__views.inputFavorite);
    $.__views.scrollView = Ti.UI.createScrollView({
        showVerticalScrollIndicator: false,
        showHorizontalScrollIndicator: false,
        backgroundColor: "transparent",
        width: "100%",
        layout: "vertical",
        visible: false,
        id: "scrollView"
    });
    $.__views.addFavoriteContainer.add($.__views.scrollView);
    $.__views.scrollViewMask = Ti.UI.createView({
        backgroundColor: "transparent",
        width: "100%",
        height: "100%",
        visible: false,
        id: "scrollViewMask"
    });
    $.__views.addFavoriteContainer.add($.__views.scrollViewMask);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, type = args.type;
    gps = require("gps/gps_manager"), locationValidator = require("/validator/validator_factory").currentLocation(), 
    navigation = args.navigation || Alloy.Globals.Nav.Profile;
    exports = new (require("/carmalib/controller").extend($, {
        events: {
            "click[ios] scrollView": "_addFavorite",
            "click[android] scrollView": "_addFavorite"
        },
        TAG: "ADD_FAVORITE",
        currentKeyword: "",
        initialize: function() {
            _.bindAll(this, "_placeSearch", "_renderSearchUsers", "onDestroy", "onFocus", "_renderUserRow");
            $.scrollViewMask.visible = false;
            $.inputFavorite.addEventListener("change", this._placeSearch);
            $.scrollView.addEventListener("touchstart", this._hideKeyBoard);
            $.scrollView.addEventListener("scroll", this._hideKeyBoard);
            $.inputFavorite.addEventListener("postlayout", this.onFocus);
        },
        _addFavorite: function() {
            $.scrollViewMask.visible = true;
        },
        _hideKeyBoard: function() {
            $.inputFavorite.blur();
        },
        _placeSearch: function(data) {
            if (!this._verifyKeyword(data)) return;
            var lastLocation = gps.lastLocation() || {}, self = this, keyword = data.value;
            this.currentKeyword = keyword;
            Alloy.createModel("user_search").search(keyword, locationValidator.isGPSPositionValid(lastLocation, true) ? lastLocation : null).then(function(response) {
                LOGGER.info("[favorites/add_favorite.js] - get return data");
                self.currentKeyword === keyword && self._renderSearchUsers(response);
            }).catch(function() {
                LOGGER.error("[favorites/add_favorite.js] - error fetching search users");
            });
        },
        _verifyKeyword: function(event) {
            if (!event || !event.value || event.value.length <= 2) return false;
            if (this.currentKeyword === event.value) return false;
            return true;
        },
        onFocus: function() {
            $.inputFavorite.removeEventListener("postlayout", this.onFocus);
            $.inputFavorite.focus();
        },
        onDestroy: function() {
            $.inputFavorite.removeEventListener("change", this._placeSearch);
            $.scrollView.removeEventListener("touchstart", this._hideKeyBoard);
            $.scrollView.removeEventListener("scroll", this._hideKeyBoard);
            $.inputFavorite.removeEventListener("postlayout", this.onFocus);
        },
        _renderSearchUsers: function(response) {
            var users = response.users, container = $.scrollView;
            container.visible = false;
            container.removeAllChildren();
            _.each(users, this._renderUserRow);
            container.visible = true;
        },
        _renderUserRow: function(user) {
            if (this.isFavoriteAcquired() && user.isFavourite || this.isFreeRiderAcquired() && user.canUserTakeFreeRide) return;
            var userRow = Alloy.createWidget("ma.car.app.favorites", "user_row", {
                type: type,
                user: user
            });
            userRow.on("added.row", function(response) {
                $.trigger("added", response);
                navigation.back();
            });
            $.scrollView.add(userRow.getView());
        },
        isFavoriteAcquired: function() {
            return "favorite" === type;
        },
        isFreeRiderAcquired: function() {
            return "freeRider" === type;
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;