function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.favorites/" + s : s.substring(0, index) + "/ma.car.app.favorites/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.favorites");
    this.__widgetId = "ma.car.app.favorites";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "frame";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.frame = Ti.UI.createView({
        width: "33%",
        height: "90dp",
        left: 0,
        id: "frame"
    });
    $.__views.frame && $.addTopLevelView($.__views.frame);
    $.__views.__alloyId993 = Ti.UI.createView({
        top: "4dp",
        width: Ti.UI.FILL,
        height: "64dp",
        id: "__alloyId993"
    });
    $.__views.frame.add($.__views.__alloyId993);
    $.__views.avatar = Ti.UI.createImageView({
        defaultImage: "/images/default_photo_female-rounded.png",
        width: "64dp",
        height: "64dp",
        borderRadius: Alloy.Globals.Style.Unit.unit32,
        id: "avatar"
    });
    $.__views.__alloyId993.add($.__views.avatar);
    $.__views.btnFrameEdit = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        width: "24dp",
        height: "24dp",
        image: "/images/icon-delete.png",
        visible: false,
        id: "btnFrameEdit"
    });
    $.__views.__alloyId993.add($.__views.btnFrameEdit);
    $.__views.alias = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        top: "68dp",
        font: {
            fontSize: "13dp"
        },
        id: "alias"
    });
    $.__views.frame.add($.__views.alias);
    $.__views.favoriteIcon = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        top: "48dp",
        left: "22dp",
        width: "21dp",
        height: "21dp",
        image: "/images/favouriteicon.png",
        visible: false,
        id: "favoriteIcon"
    });
    $.__views.frame.add($.__views.favoriteIcon);
    $.__views.freeIcon = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        top: "48dp",
        left: "22dp",
        width: "21dp",
        height: "21dp",
        image: "/images/freetripscoin.png",
        visible: false,
        id: "freeIcon"
    });
    $.__views.frame.add($.__views.freeIcon);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var user = arguments[0].user || {}, type = arguments[0].type || "favorite", avatarUtil = require("ui/common/Avatar"), Globals = require("/v6/infrastructure/Globals"), favouriteUserService = Globals.IOC.get("favoriteUserService"), ProfileService = Globals.IOC.get("ProfileService"), freeRiderService = Globals.IOC.get("freeRiderService");
    exports = new (require("/carmalib/controller").extend($, {
        MODE_BROWSE: "browse",
        MODE_EDIT: "edit",
        TYPE_FAVORITE: "favorite",
        TYPE_FREE_RIDER: "freeRider",
        events: {
            "click[ios] frame": "_onClicked",
            "click[android] frame": "_onClicked"
        },
        _user: null,
        _mode: null,
        initialize: function() {
            this._mode = this.MODE_BROWSE;
            this._renderFrame(user);
        },
        update: function(user) {
            this._renderFrame(user);
        },
        enterEditModeSmoothly: function() {
            this._mode = this.MODE_EDIT;
            var iconView = this._getIcon();
            var matrix = Ti.UI.create2DMatrix();
            matrix.scale(1, 1);
            var scaleAndRotateAnimation = Ti.UI.createAnimation({
                duration: 300,
                transform: matrix
            }), greyOutAnimation = Ti.UI.createAnimation({
                opacity: .6,
                duration: 300
            }), hideAnimation = Ti.UI.createAnimation({
                opacity: 0,
                duration: 300
            });
            $.btnFrameEdit.transform = Ti.UI.create2DMatrix().scale(.1);
            $.btnFrameEdit.visible = true;
            $.avatar.animate(greyOutAnimation);
            iconView.animate(hideAnimation, function() {
                iconView.visible = false;
            });
            $.btnFrameEdit.animate(scaleAndRotateAnimation, function() {
                $.btnFrameEdit.transform = null;
            });
        },
        exitEditMode: function() {
            var iconView = this._getIcon();
            $.avatar.opacity = 1;
            iconView.opacity = 1;
            iconView.visible = true;
            $.btnFrameEdit.visible = false;
            this._mode = this.MODE_BROWSE;
        },
        isBrowseMode: function() {
            return "browse" === this._mode;
        },
        isEditMode: function() {
            return "edit" === this._mode;
        },
        isFavoriteType: function() {
            return type === this.TYPE_FAVORITE;
        },
        isFreeRiderType: function() {
            return type === this.TYPE_FREE_RIDER;
        },
        _renderFrame: function(user) {
            this._user = user;
            var photoCache = require("/utils/photoCache"), url = require("/utils/photoURL").toURL(user.photoUrl, {
                width: 60,
                height: 60
            });
            var photoPath = photoCache.getCached(url);
            if (photoPath) $.avatar.image = photoPath; else {
                var defaultImage = avatarUtil.getDefaultPhotoByGender(!user.gender && "m" !== user.gender);
                $.avatar.image = defaultImage;
                $.avatar.defaultImage = defaultImage;
                photoCache.downloadAvatar(url).then(function(url) {
                    $.avatar.image = url;
                });
            }
            $.alias.text = user.alias;
            $.freeIcon.visible = this.isFreeRiderType();
            $.favoriteIcon.visible = this.isFavoriteType();
        },
        _onClicked: function() {
            if (this.isBrowseMode()) {
                Ti.App.fireEvent("carma:profile.open", {
                    userId: user.userId
                });
                $.trigger("update.favorites", user);
                return;
            }
            if (this.isFavoriteType() && this.isEditMode()) {
                favouriteUserService.removeFavouriteUser(user.userId).done();
                Ti.App.fireEvent("carma:favourite.users.toggle", {
                    action: "remove",
                    user: user
                });
                return;
            }
            if (this.isFreeRiderType() && this.isEditMode()) {
                freeRiderService.removeFreeRider(user).then(function() {
                    ProfileService.updateFreeRide(user.userId, false);
                }).done();
                Ti.App.fireEvent("carma:free.rider.removed", user);
                return;
            }
        },
        _getIcon: function() {
            return this.isFreeRiderType() ? $.freeIcon : $.favoriteIcon;
        },
        _chooseFreeRider: function() {
            if (!this.getView().zIndex) {
                Ti.App.fireEvent("carma:profile.open", {
                    userId: user.userId
                });
                $.trigger("update.favorites", user);
                return;
            }
            if (false == $.freeIcon.visible) {
                $.freeIcon.visible = true;
                $.favoriteIcon.animate({
                    duration: 200,
                    transform: Ti.UI.create2DMatrix({
                        scale: .1
                    })
                }, function() {
                    $.favoriteIcon.visible = false;
                });
                $.freeIcon.animate({
                    duration: 200,
                    transform: Ti.UI.create2DMatrix({
                        scale: 1.2
                    })
                }, function() {
                    $.freeIcon.animate({
                        duration: 100,
                        transform: Ti.UI.create2DMatrix({
                            scale: 1
                        })
                    });
                    $.trigger("add.freeRider", user);
                });
            } else {
                $.favoriteIcon.visible = true;
                $.favoriteIcon.animate({
                    duration: 200,
                    transform: Ti.UI.create2DMatrix({
                        scale: 1.2
                    })
                }, function() {
                    $.favoriteIcon.animate({
                        duration: 100,
                        transform: Ti.UI.create2DMatrix({
                            scale: 1
                        })
                    });
                });
                $.freeIcon.animate({
                    duration: 200,
                    transform: Ti.UI.create2DMatrix({
                        scale: .1
                    })
                }, function() {
                    $.freeIcon.visible = false;
                    $.trigger("remove.freeRider", user);
                });
            }
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;