function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.favorites/" + s : s.substring(0, index) + "/ma.car.app.favorites/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.favorites");
    this.__widgetId = "ma.car.app.favorites";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "user_row";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.userRowContainer = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        height: "81dp",
        id: "userRowContainer"
    });
    $.__views.userRowContainer && $.addTopLevelView($.__views.userRowContainer);
    $.__views.userPhoto = Ti.UI.createImageView({
        defaultImage: "/images/default_photo_male-rounded.png",
        top: "10dp",
        left: "0dp",
        width: "60dp",
        height: "60dp",
        borderRadius: Alloy.Globals.Style.Unit.unit30,
        id: "userPhoto"
    });
    $.__views.userRowContainer.add($.__views.userPhoto);
    $.__views.userAlias = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        left: "70dp",
        top: "34dp",
        font: {
            fontSize: "13dp"
        },
        id: "userAlias"
    });
    $.__views.userRowContainer.add($.__views.userAlias);
    $.__views.icon = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        right: "15dp",
        width: "32dp",
        height: "32dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_CENTER,
        visible: false,
        id: "icon"
    });
    $.__views.userRowContainer.add($.__views.icon);
    $.__views.userRowHr = Ti.UI.createView({
        width: "100%",
        top: "80dp",
        left: 0,
        height: "2dp",
        backgroundColor: Alloy.Globals.Style.Color.DarkGray,
        id: "userRowHr"
    });
    $.__views.userRowContainer.add($.__views.userRowHr);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, user = args.user, type = args.type, avatarUtil = require("ui/common/Avatar"), Globals = require("/v6/infrastructure/Globals"), favouriteUserService = Globals.IOC.get("favoriteUserService"), ProfileService = Globals.IOC.get("ProfileService"), freeRiderService = Globals.IOC.get("freeRiderService");
    exports = new (require("/carmalib/controller").extend($, {
        events: {
            "click[ios] userRowContainer": "_add",
            "click[android] userRowContainer": "_add"
        },
        initialize: function() {
            this._renderUser(user);
        },
        _renderUser: function(user) {
            var photoCache = require("/utils/photoCache"), url = require("/utils/photoURL").toURL(user.photoUrl, {
                width: 60,
                height: 60
            }), photoPath = photoCache.getCached(url);
            if (photoPath) $.userPhoto.image = photoPath; else {
                var defaultImage = avatarUtil.getDefaultPhotoByGender(!user.gender && "m" !== user.gender);
                $.userPhoto.image = defaultImage;
                $.userPhoto.defaultImage = defaultImage;
                photoCache.downloadAvatar(url).then(function(url) {
                    $.userPhoto.image = url;
                });
            }
            $.userAlias.text = user.alias;
            this._initIcon();
            $.icon.visible = this.isFavoriteAcquired() && !!user.isFavourite || this.isFreeRiderAcquired() && !!user.canUserTakeFreeRide;
        },
        _add: function() {
            if (!this.isFavoriteAcquired() && !this.isFreeRiderAcquired()) {
                LOGGER.error("Unknown type[" + type + "] on user search result.");
                return;
            }
            if ($.icon.visible) return;
            var isAnimationEnd = false, isActionDone = false, self = this, onReady = function() {
                if (!isAnimationEnd || !isActionDone) return;
                $.trigger("added.row", user);
                self.isFavoriteAcquired() && Ti.App.fireEvent("carma:favourite.add");
            };
            this._showSmoothly($.icon, function() {
                isAnimationEnd = true;
                onReady();
            });
            var self = this, promise = this.isFavoriteAcquired() ? favouriteUserService.addFavouriteUser(user) : freeRiderService.addFreeRider(user);
            promise.then(function() {
                isActionDone = true;
                self.isFreeRiderAcquired() && ProfileService.updateFreeRide(user.userId, true);
                onReady();
            });
        },
        _initIcon: function() {
            if (this.isFavoriteAcquired()) {
                $.icon.image = "/images/favouriteicon.png";
                return;
            }
            if (this.isFreeRiderAcquired()) {
                $.icon.image = "/images/freetripscoin.png";
                return;
            }
            LOGGER.error("Can not render icon for unknown type[" + type + "].");
        },
        _showSmoothly: function(view, onAnimationEnd) {
            view.transform = Ti.UI.create2DMatrix().scale(.1);
            view.visible = true;
            view.animate({
                duration: 200,
                transform: Ti.UI.create2DMatrix({
                    scale: 1.2
                })
            }, function() {
                view.animate({
                    duration: 100,
                    transform: Ti.UI.create2DMatrix({
                        scale: 1
                    })
                }, function() {
                    view.transform = null;
                    onAnimationEnd && onAnimationEnd(view);
                });
            });
        },
        isFavoriteAcquired: function() {
            return "favorite" === type;
        },
        isFreeRiderAcquired: function() {
            return "freeRider" === type;
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;