function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.fbsignup/" + s : s.substring(0, index) + "/ma.car.app.fbsignup/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.fbsignup");
    this.__widgetId = "ma.car.app.fbsignup";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "phonenumber";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.viewWrapper = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.pct100,
        top: 0,
        left: 0,
        height: "100%",
        id: "viewWrapper"
    });
    $.__views.viewWrapper && $.addTopLevelView($.__views.viewWrapper);
    $.__views.viewContainer = Ti.UI.createScrollView({
        width: Alloy.Globals.Style.Size.Width.pct100,
        bottom: "0dp",
        height: Ti.UI.SIZE,
        layout: "vertical",
        showVerticalScrollIndicator: false,
        showHorizontalScrollIndicator: false,
        contentHeight: "auto",
        contentWidth: "99%",
        scrollingEnabled: "false",
        id: "viewContainer"
    });
    $.__views.viewWrapper.add($.__views.viewContainer);
    $.__views.__alloyId23 = Ti.UI.createTextField({
        paddingLeft: "10dp",
        height: "1px",
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        width: "1px",
        softKeyboardOnFocus: Ti.UI.Android.SOFT_KEYBOARD_HIDE_ON_FOCUS,
        id: "__alloyId23"
    });
    $.__views.viewContainer.add($.__views.__alloyId23);
    $.__views.lblTitle = Ti.UI.createLabel({
        color: "#fff",
        width: Alloy.Globals.Style.Size.Width.grid11,
        font: {
            fontSize: "15dp"
        },
        text: L("widget_fbsignup_title"),
        top: "15dp",
        id: "lblTitle"
    });
    $.__views.viewContainer.add($.__views.lblTitle);
    $.__views.lblMessage = Ti.UI.createLabel({
        color: "#fff",
        width: Alloy.Globals.Style.Size.Width.grid11,
        font: {
            fontSize: "15dp"
        },
        text: L("widget_fbsignup_message"),
        top: "15dp",
        id: "lblMessage"
    });
    $.__views.viewContainer.add($.__views.lblMessage);
    $.__views.__alloyId24 = Ti.UI.createView({
        top: "10dp",
        height: ".4dp",
        id: "__alloyId24"
    });
    $.__views.viewContainer.add($.__views.__alloyId24);
    $.__views.wgtPhone = Alloy.createWidget("ma.car.app.common.phone", "widget", {
        id: "wgtPhone",
        __parentSymbol: $.__views.viewContainer
    });
    $.__views.wgtPhone.setParent($.__views.viewContainer);
    $.__views.btnSubmit = require("/ui/common/custom_button").createButton({
        width: Alloy.Globals.Style.Size.Width.grid11,
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "60dp",
        font: {
            fontSize: "18dp"
        },
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        title: L("btn_submit"),
        top: "15dp",
        id: "btnSubmit"
    });
    $.__views.viewContainer.add($.__views.btnSubmit);
    $.__views.__alloyId25 = Ti.UI.createView({
        top: "10dp",
        height: ".4dp",
        id: "__alloyId25"
    });
    $.__views.viewContainer.add($.__views.__alloyId25);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var assert = require("/utils/assert");
    var executor = require("utils/executor");
    var fbManager = require("facebook/facebook_manager");
    var fbSignup = require("/facebook/facebook_signup");
    var fbSignin = require("facebook/facebook_signin");
    var ErrorDialog = require("/ui/common/validation_error");
    var AnimatedBottomView = require("/ui/common/animated_bottom_view");
    var phoneValidator = require("/validator/validator_factory").phone();
    var args = arguments[0] || {};
    assert.required(args, [ "token", "user" ]);
    var fbToken = args.token;
    var user = args.user;
    var _handleError = function(error) {
        if (error.status && "400" === error.status.toString() && "invalid_fields" === error.errorCode) for (var i in error.errorDetails.errorFields) {
            var field = ("" + error.errorDetails.errorFields[i]).toLowerCase();
            if ("phone_number" === field) {
                $.wgtPhone.txtNumber.showError(L("widget_fbsignup_error_invalid_phone"));
                ErrorDialog.show();
                return;
            }
        } else if (error.status && "403" === error.status.toString() && "telephone_number_already_registered" === error.errorCode) {
            $.wgtPhone.txtNumber.showError(L("widget_signup_error_duplicated_phone_number"));
            ErrorDialog.show();
            return;
        }
        Carma.UI.createAlertWindow({
            title: L("error_title"),
            message: L("widget_fbsignup_msg_signup_error")
        }).show();
        fbManager.logout();
    };
    var _createUserAccount = function(dataWithPhoneNumber) {
        var funcs = [];
        funcs.push(function() {
            return fbSignup.save(fbToken, dataWithPhoneNumber);
        });
        funcs.push(function() {
            return fbSignin.authenticate(fbToken);
        });
        funcs.push(function() {
            var verification = Widget.createWidget("ma.car.app.verification", {
                __parentSymbol: $.getView(),
                requirePhoto: false,
                nav: Alloy.Globals.Nav.FbSingup
            });
            Alloy.Globals.Nav.FbSingup.open(verification, {
                title: L("widget_signup_title_verify")
            });
        });
        executor(funcs).error(_handleError).run();
    };
    var _updateUserAccount = function(dataWithPhoneNumber) {
        var funcs = [];
        funcs.push(function() {
            return Alloy.createModel("signup").save(dataWithPhoneNumber);
        });
        funcs.push(function() {
            var verification = Widget.createWidget("ma.car.app.verification", {
                __parentSymbol: $.getView(),
                nav: Alloy.Globals.Nav.FbSingup
            });
            Alloy.Globals.Nav.FbSingup.open(verification, {
                title: L("widget_signup_title_verify")
            });
        });
        executor(funcs).error(_handleError).run();
    };
    $.btnSubmit.addEventListener("click", function() {
        var dataWithPhoneNumber = {
            country: $.wgtPhone.getSelectedCountry().cca3,
            phoneNumber: $.wgtPhone.getNumber()
        };
        if (!phoneValidator.isPhoneNumber(dataWithPhoneNumber.phoneNumber)) {
            $.wgtPhone.txtNumber.showError(L("widget_fbsignup_error_invalid_phone"));
            ErrorDialog.show();
            return;
        }
        var resourceOwner = require("services/resource_owner_service").singleton();
        if (!resourceOwner.hasLogin()) {
            var invite = Ti.App.Properties.getObject("invite");
            invite && invite.id && (dataWithPhoneNumber.inviteId = invite.id);
            _createUserAccount(dataWithPhoneNumber);
            return;
        }
        dataWithPhoneNumber.email = resourceOwner.get("email");
        dataWithPhoneNumber.userId = resourceOwner.get("userId");
        _updateUserAccount(dataWithPhoneNumber);
    });
    var extension = {
        initialize: function() {
            this._initView();
            this._initViewAnimation();
        },
        _initView: function() {
            var name = user.first_name || user.last_name || "";
            $.lblTitle.text = String.format(L("widget_fbsignup_title"), name);
            $.addClass($.wgtPhone.viewPhonenumber, "section");
        },
        _initViewAnimation: function() {
            return;
        }
    };
    exports = new (require("/carmalib/controller").extend($, extension))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;