function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.future2/" + s : s.substring(0, index) + "/ma.car.app.future2/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.future2");
    this.__widgetId = "ma.car.app.future2";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "bestMatchesBuffer";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.buffer = Ti.UI.createView({
        height: Ti.UI.SIZE,
        width: "100%",
        top: 0,
        left: 0,
        id: "buffer"
    });
    $.__views.buffer && $.addTopLevelView($.__views.buffer);
    $.__views.ridesWrapper = Ti.UI.createView({
        height: Ti.UI.SIZE,
        width: "100%",
        top: 0,
        left: 0,
        id: "ridesWrapper"
    });
    $.__views.buffer.add($.__views.ridesWrapper);
    $.__views.ridesMatches = Alloy.createWidget("ma.car.app.future2", "matchesList", {
        id: "ridesMatches",
        listType: "RIDE",
        __parentSymbol: $.__views.ridesWrapper
    });
    $.__views.ridesMatches.setParent($.__views.ridesWrapper);
    $.__views.drivesWrapper = Ti.UI.createView({
        height: Ti.UI.SIZE,
        width: "100%",
        top: 0,
        left: 0,
        id: "drivesWrapper"
    });
    $.__views.buffer.add($.__views.drivesWrapper);
    $.__views.drivesMatches = Alloy.createWidget("ma.car.app.future2", "matchesList", {
        id: "drivesMatches",
        listType: "DRIVE",
        __parentSymbol: $.__views.drivesWrapper
    });
    $.__views.drivesMatches.setParent($.__views.drivesWrapper);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var Q = require("/vendor/q"), Globals = require("/v6/infrastructure/Globals"), bookingService = Globals.IOC.get("bookingService"), exploreService = Globals.IOC.get("exploreService");
    exports = new (require("/carmalib/controller").extend($, {
        initialize: function() {
            _.bindAll(this, "_processMatches", "_toggleWrappers", "_toggleWrappersEvent");
            this._initEventListeners();
        },
        _initEventListeners: function() {
            exploreService.on(exploreService.SEARCH_TYPE_CHANGED, this._toggleWrappersEvent);
        },
        renderMatches: function(data) {
            return Q(data).then(this._toggleWrappers).then(this._processMatches).then(this._getBookingsForCurrentTrip).then(function(data) {
                return bookingService.getRelevantBookings(data);
            }).then(this._refreshAskWithCurrentBookings).catch(this._handleError);
        },
        _toggleWrappers: function(data) {
            var type = exploreService.getSearchType();
            if (!type) {
                var rideMatches = data.rideMatches, driveMatches = data.driveMatches, tripMatchedAgainst = rideMatches.tripMatchedAgainst || driveMatches.tripMatchedAgainst;
                type = "RIDE" === tripMatchedAgainst.type ? "DRIVE" : "RIDE";
            }
            this._switchWrappers(type);
            return data;
        },
        _switchWrappers: function(searchType) {
            if ("RIDE" === searchType) {
                $.ridesWrapper.height = Ti.UI.SIZE;
                $.drivesWrapper.height = 0;
            } else {
                $.ridesWrapper.height = 0;
                $.drivesWrapper.height = Ti.UI.SIZE;
            }
        },
        _processMatches: function(data) {
            if (!data) return;
            var rideMatches = data.rideMatches, driveMatches = data.driveMatches;
            return Q.all([ this._renderBestMatches(rideMatches, $.ridesMatches), this._renderBestMatches(driveMatches, $.drivesMatches) ]);
        },
        _renderBestMatches: function(data, container) {
            return container.renderMatches(data);
        },
        _handleError: function(error) {
            LOGGER.error("[BestMatchesBuffer] - " + error.toString());
        },
        _getBookingsForCurrentTrip: function() {
            return exploreService.getBookingsForCurrentTrip();
        },
        _refreshAskWithCurrentBookings: function(bookings) {
            $.ridesMatches.refreshAskWithCurrentBookings(bookings);
            $.drivesMatches.refreshAskWithCurrentBookings(bookings);
        },
        _toggleWrappersEvent: function() {
            var newSearchType = exploreService.getSearchType();
            this._switchWrappers(newSearchType);
        },
        showBuffer: function() {
            $.buffer.height = Ti.UI.SIZE;
        },
        hideBuffer: function() {
            $.buffer.height = 0;
            $.ridesMatches.clearMatches();
            $.drivesMatches.clearMatches();
        },
        clearContent: function() {
            $.ridesMatches.clearMatches();
            $.drivesMatches.clearMatches();
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;