function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.future2/" + s : s.substring(0, index) + "/ma.car.app.future2/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.future2");
    this.__widgetId = "ma.car.app.future2";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "bookingRow";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.bookingRow = Ti.UI.createView({
        width: "91.66666666666666%",
        height: Ti.UI.SIZE,
        top: 0,
        id: "bookingRow"
    });
    $.__views.bookingRow && $.addTopLevelView($.__views.bookingRow);
    $.__views.userAvatar = require("/ui/common/profile").createView({
        backgroundColor: "#fff",
        borderColor: "#fff",
        borderWidth: 1,
        defaultImage: "/images/default_photo_male-rounded.png",
        left: 0,
        width: "48dp",
        height: "48dp",
        borderRadius: Alloy.Globals.Style.Unit.unit24,
        top: "4dp",
        id: "userAvatar"
    });
    $.__views.bookingRow.add($.__views.userAvatar);
    $.__views.departureName = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        height: "18dp",
        left: "60dp",
        right: "55dp",
        top: "4dp",
        ellipsize: true,
        id: "departureName"
    });
    $.__views.bookingRow.add($.__views.departureName);
    $.__views.departureAddress = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp"
        },
        height: "18dp",
        left: "60dp",
        right: "55dp",
        top: "21dp",
        ellipsize: true,
        id: "departureAddress"
    });
    $.__views.bookingRow.add($.__views.departureAddress);
    $.__views.arrivalAddress = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp"
        },
        height: "18dp",
        left: "60dp",
        right: "55dp",
        top: "38dp",
        ellipsize: true,
        id: "arrivalAddress"
    });
    $.__views.bookingRow.add($.__views.arrivalAddress);
    $.__views.cancelBookingBtn = require("/ui/common/custom_button").createButton({
        width: "100%",
        font: {
            fontSize: "15dp"
        },
        color: Alloy.Globals.Style.Color.DarkGray,
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        normalColor: "#00333333",
        selectedColor: "#70333333",
        backgroundImage: "none",
        borderColor: Alloy.Globals.Style.Color.DarkGray,
        borderWidth: 2,
        indicator: true,
        indicatorStyle: Ti.UI.ActivityIndicatorStyle.DARK,
        top: "65dp",
        title: L("widget_btn_cancel_booking_button"),
        bottom: "10dp",
        height: "40dp",
        id: "cancelBookingBtn"
    });
    $.__views.bookingRow.add($.__views.cancelBookingBtn);
    $.__views.lblOkWrapper = Ti.UI.createView({
        top: "15dp",
        height: Ti.UI.SIZE,
        width: "50dp",
        right: 0,
        id: "lblOkWrapper"
    });
    $.__views.bookingRow.add($.__views.lblOkWrapper);
    $.__views.lblOk = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontFamily: "splinico",
            fontSize: "18dp"
        },
        text: "c",
        width: "30dp",
        height: "30dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        borderWidth: 1,
        backgroundColor: Alloy.Globals.Style.Color.LightBlue,
        borderColor: Alloy.Globals.Style.Color.LightBlue,
        borderRadius: Alloy.Globals.Style.Unit.unit30,
        id: "lblOk"
    });
    $.__views.lblOkWrapper.add($.__views.lblOk);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, Globals = require("/v6/infrastructure/Globals"), bookingService = Globals.IOC.get("bookingService"), moment = require("/vendor/moment");
    exports = new (require("/carmalib/controller").extend($, {
        events: {
            "click cancelBookingBtn": "_confirmCancelBooking"
        },
        _bookingData: args.booking,
        _partner: null,
        _cancelAnimationTime: 550,
        _animationTimes: {
            right: 150,
            left: 300
        },
        initialize: function() {
            _.bindAll(this, "_playCancelBookingAnimation");
            this._renderBooking();
        },
        _renderBooking: function() {
            if (!this._bookingData) return;
            var myUserId = require("services/resource_owner_service").singleton().get("userId");
            this._partner = this._bookingData.driver.userId === myUserId ? this._bookingData.rider : this._bookingData.driver;
            $.userAvatar.setUser(this._partner);
            $.departureName.text = require("i18n/i18n").formatTime(moment(this._bookingData.bookingDate)) + " - " + this._partner.alias;
            $.departureAddress.text = this._bookingData.trip.baseTrip.origin.address;
            $.arrivalAddress.text = String.format(L("widget_future_to_destination"), this._bookingData.trip.baseTrip.destination.address);
        },
        _confirmCancelBooking: function() {
            var self = this, dialog = Ti.UI.createAlertDialog({
                cancel: 0,
                buttonNames: [ L("widget_btn_keep_booking"), L("widget_btn_cancel_booking") ],
                message: String.format(L("widget_future_cancel_message"), this._partner.firstName, this._bookingData.trip.baseTrip.destination.address),
                title: L("widget_future_cancel_title")
            });
            dialog.addEventListener("click", function(e) {
                1 === e.index ? self._cancelBooking() : $.cancelBookingBtn.stopIndicator();
            });
            dialog.show();
        },
        _cancelBooking: function() {
            bookingService.decline(this._bookingData.id, this._partner.firstName, this._cancelAnimationTime).then(this._playCancelBookingAnimation).catch(this._handleError);
        },
        _playCancelBookingAnimation: function() {
            function animationLeft() {
                $.bookingRow.animate({
                    left: -Ti.Platform.displayCaps.platformWidth,
                    opacity: 0,
                    duration: self._animationTimes.left
                });
            }
            $.bookingRow.applyProperties({
                left: Alloy.Globals.Style.Size.Width.halfGrid,
                opacity: 1
            });
            var self = this;
            $.bookingRow.animate({
                left: .5 * Ti.Platform.displayCaps.platformWidth,
                duration: this._animationTimes.right
            }, animationLeft);
        },
        _handleError: function(error) {
            $.cancelBookingBtn.stopIndicator();
            LOGGER.error("[bookingRow.js] " + error.toString());
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;