function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.future2/" + s : s.substring(0, index) + "/ma.car.app.future2/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.future2");
    this.__widgetId = "ma.car.app.future2";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "bookings";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.bookingsWrapper = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.pct100,
        top: 0,
        left: 0,
        height: Ti.UI.SIZE,
        backgroundColor: "white",
        id: "bookingsWrapper"
    });
    $.__views.bookingsWrapper && $.addTopLevelView($.__views.bookingsWrapper);
    $.__views.bookingsBuffer1 = Ti.UI.createView({
        top: 0,
        left: 0,
        height: Ti.UI.SIZE,
        width: "100%",
        layout: "vertical",
        backgroundColor: "white",
        id: "bookingsBuffer1"
    });
    $.__views.bookingsWrapper.add($.__views.bookingsBuffer1);
    $.__views.bookingsBuffer2 = Ti.UI.createView({
        top: 0,
        left: 0,
        height: Ti.UI.SIZE,
        width: "100%",
        layout: "vertical",
        backgroundColor: "white",
        visible: false,
        id: "bookingsBuffer2"
    });
    $.__views.bookingsWrapper.add($.__views.bookingsBuffer2);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var Globals = require("/v6/infrastructure/Globals"), bookingService = Globals.IOC.get("bookingService"), Q = require("/vendor/q");
    exports = new (require("/carmalib/controller").extend($, {
        _loading: false,
        _currentBuffer: null,
        _isFirstCall: true,
        _batchData: null,
        initialize: function() {
            _.bindAll(this, "loadBookings", "_filterAcceptedBookings", "_renderBookings", "_handleError", "_bookingsLoadFinished", "_flipBuffers", "_getData");
        },
        initWidget: function() {
            this.loadBookings();
        },
        setBatchData: function(data) {
            this._batchData = data;
            this.loadBookings();
        },
        loadBookings: function() {
            if (this._loading) return;
            this._prepareBookingsLoad();
            return Q().then(this._getData).then(this._filterAcceptedBookings).then(this._renderBookings).catch(this._handleError).finally(this._flipBuffers).finally(this._bookingsLoadFinished);
        },
        _getData: function() {
            if (this._batchData) {
                var batchData = this._batchData;
                this._batchData = null;
                return batchData;
            }
            return bookingService.findAll(true);
        },
        _prepareBookingsLoad: function() {
            this._loading = true;
            if (this._isFirstCall) {
                this._currentBuffer = $.bookingsBuffer1;
                $.bookingsWrapper.opacity = 0;
            } else this._currentBuffer = "bookingsBuffer1" === this._currentBuffer.id ? $.bookingsBuffer2 : $.bookingsBuffer1;
        },
        _bookingsLoadFinished: function() {
            this._loading = false;
            this._isFirstCall = false;
        },
        _filterAcceptedBookings: function(bookings) {
            if (!bookings || !bookings.paginator.totalResults) throw {
                errorCode: "no_bookings_found",
                message: "[bookings.js] - No bookings found"
            };
            return bookings.rideBookings;
        },
        _renderBookings: function(acceptedBookings) {
            var self = this, daysTitles = [];
            _.each(acceptedBookings, function(booking) {
                var dayTitle = self._createDayTitle(booking);
                if (-1 === daysTitles.indexOf(dayTitle)) {
                    daysTitles.push(dayTitle);
                    self._appendTitleDay(dayTitle);
                }
                self._buildBookingRow(booking);
            });
        },
        _createDayTitle: function(booking) {
            var title = L("widget_future_bookings_title") + " ";
            title += require("i18n/i18n").formatTodayDate(booking.bookingDate);
            return title.toUpperCase();
        },
        _appendTitleDay: function(title) {
            var titleLbl = Ti.UI.createLabel({
                text: title
            });
            $.addClass(titleLbl, "lbl-medium-bold day-title dark-gray");
            this._currentBuffer.add(titleLbl);
        },
        _buildBookingRow: function(booking) {
            var widget = Widget.createController("bookingRow", {
                booking: booking
            });
            this._currentBuffer.add(widget.getView());
        },
        _flipBuffers: function() {
            this._currentBuffer.visible = true;
            var prevBuffer = "bookingsBuffer1" === this._currentBuffer.id ? $.bookingsBuffer2 : $.bookingsBuffer1;
            prevBuffer.applyProperties({
                visible: false
            });
            prevBuffer.removeAllChildren();
            if (this._isFirstCall) {
                setTimeout(function() {
                    $.bookingsWrapper.opacity = 1;
                }, 350);
                $.bookingsWrapper.animate({
                    opacity: 1,
                    duration: 300
                });
            }
        },
        _handleError: function(error) {
            error = error || {};
            switch (error.errorCode) {
              case "no_bookings_found":
                break;

              default:
                LOGGER.error(error.message);
            }
        },
        checkTripEventType: function(data) {
            data = data || {};
            data.deleteTrip && this.loadBookings();
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;