function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.future2/" + s : s.substring(0, index) + "/ma.car.app.future2/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.future2");
    this.__widgetId = "ma.car.app.future2";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "filters";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.filterScreen = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.pct100,
        top: 0,
        left: 0,
        height: "100%",
        backgroundColor: "white",
        id: "filterScreen"
    });
    $.__views.filterScreen && $.addTopLevelView($.__views.filterScreen);
    $.__views.scrollView = Ti.UI.createScrollView({
        width: Alloy.Globals.Style.Size.Width.pct100,
        layout: "vertical",
        top: "50dp",
        bottom: "70dp",
        id: "scrollView"
    });
    $.__views.filterScreen.add($.__views.scrollView);
    $.__views.filtersContainer = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        height: "44dp",
        top: 0,
        borderWidth: "1dp",
        borderColor: Alloy.Globals.Style.Color.DarkGray,
        layout: "horizontal",
        id: "filtersContainer"
    });
    $.__views.scrollView.add($.__views.filtersContainer);
    $.__views.eitherFilterContainer = Ti.UI.createView({
        backgroundColor: Alloy.Globals.Style.Color.DarkGray,
        width: "33%",
        id: "eitherFilterContainer"
    });
    $.__views.filtersContainer.add($.__views.eitherFilterContainer);
    $.__views.eitherFilter = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "15dp"
        },
        text: L("widget_future_filter_either"),
        id: "eitherFilter"
    });
    $.__views.eitherFilterContainer.add($.__views.eitherFilter);
    $.__views.__alloyId1086 = Ti.UI.createView({
        width: "1px",
        right: 0,
        height: "100%",
        backgroundColor: Alloy.Globals.Style.Color.DarkGray,
        id: "__alloyId1086"
    });
    $.__views.eitherFilterContainer.add($.__views.__alloyId1086);
    $.__views.driversFilterContainer = Ti.UI.createView({
        width: "33.5%",
        id: "driversFilterContainer"
    });
    $.__views.filtersContainer.add($.__views.driversFilterContainer);
    $.__views.driversFilter = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp"
        },
        text: L("widget_future_filter_drivers"),
        id: "driversFilter"
    });
    $.__views.driversFilterContainer.add($.__views.driversFilter);
    $.__views.__alloyId1087 = Ti.UI.createView({
        width: "1px",
        right: 0,
        height: "100%",
        backgroundColor: Alloy.Globals.Style.Color.DarkGray,
        id: "__alloyId1087"
    });
    $.__views.driversFilterContainer.add($.__views.__alloyId1087);
    $.__views.ridersFilterContainer = Ti.UI.createView({
        width: "33%",
        id: "ridersFilterContainer"
    });
    $.__views.filtersContainer.add($.__views.ridersFilterContainer);
    $.__views.ridersFilter = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp"
        },
        text: L("widget_future_filter_riders"),
        id: "ridersFilter"
    });
    $.__views.ridersFilterContainer.add($.__views.ridersFilter);
    $.__views.applyFiltersButton = require("/ui/common/custom_button").createButton({
        width: Alloy.Globals.Style.Size.Width.grid11,
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "60dp",
        font: {
            fontSize: "18dp"
        },
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        bottom: Alloy.Globals.Style.Size.Width.halfGrid,
        title: L("widget_future_apply_filters"),
        id: "applyFiltersButton"
    });
    $.__views.filterScreen.add($.__views.applyFiltersButton);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var Globals = require("/v6/infrastructure/Globals"), exploreService = Globals.IOC.get("exploreService"), exploreController = require("/v6/common/ExploreController");
    exports = new (require("/carmalib/controller").extend($, {
        events: {
            "click applyFiltersButton": "_applyFilters"
        },
        _searchTargetTypes: [ "RIDE_OR_DRIVE", "DRIVE", "RIDE" ],
        _containers: [ $.eitherFilterContainer, $.driversFilterContainer, $.ridersFilterContainer ],
        _labels: [ $.eitherFilter, $.driversFilter, $.ridersFilter ],
        _selected: 0,
        _filterChanged: false,
        initialize: function() {
            this._initEventListeners();
        },
        _initEventListeners: function() {
            var self = this;
            $.eitherFilterContainer.addEventListener("click", function() {
                self._clickCallback(0);
            });
            $.driversFilterContainer.addEventListener("click", function() {
                self._clickCallback(1);
            });
            $.ridersFilterContainer.addEventListener("click", function() {
                self._clickCallback(2);
            });
        },
        _clickCallback: function(index) {
            if (this._selected === index) return;
            this._filterChanged = true;
            this._selected = index;
            this._toggleButtons();
        },
        _toggleButtons: function() {
            for (var i = 0; 3 > i; ++i) if (this._selected === i) {
                this._containers[i].backgroundColor = Alloy.Globals.Style.Color.DarkGray;
                this._labels[i].color = "white";
            } else {
                this._containers[i].backgroundColor = "transparent";
                this._labels[i].color = Alloy.Globals.Style.Color.DarkGray;
            }
        },
        _applyFilters: function() {
            this._filterChanged && exploreService.setSearchType(this._searchTargetTypes[this._selected]);
            exploreController.emit(exploreController.FILTERS_CLOSE);
            this._filterChanged = false;
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;