function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.future2/" + s : s.substring(0, index) + "/ma.car.app.future2/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.future2");
    this.__widgetId = "ma.car.app.future2";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "matchesList";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.emptyMatchesList = Ti.UI.createView({
        height: 0,
        width: "100%",
        top: 0,
        left: 0,
        layout: "vertical",
        id: "emptyMatchesList"
    });
    $.__views.emptyMatchesList && $.addTopLevelView($.__views.emptyMatchesList);
    $.__views.emptyMatchesImage = Ti.UI.createImageView({
        defaultImage: "/images/nomatches.png",
        width: "83.33333333333334%",
        height: "auto",
        image: "/images/nomatches.png",
        id: "emptyMatchesImage"
    });
    $.__views.emptyMatchesList.add($.__views.emptyMatchesImage);
    $.__views.emptyMatchesMessage = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        width: "83.33333333333334%",
        font: {
            fontSize: "15dp"
        },
        text: L("widget_future_empty_match_message"),
        height: Ti.UI.SIZE,
        top: "20dp",
        bottom: "20dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        id: "emptyMatchesMessage"
    });
    $.__views.emptyMatchesList.add($.__views.emptyMatchesMessage);
    $.__views.inviteFriendsButton = require("/ui/common/custom_button").createButton({
        width: "50%",
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        title: L("widget_samantha_nomatches_btn"),
        bottom: "20dp",
        height: "40dp",
        id: "inviteFriendsButton"
    });
    $.__views.emptyMatchesList.add($.__views.inviteFriendsButton);
    $.__views.matchesView = Ti.UI.createView({
        height: Ti.UI.SIZE,
        width: "100%",
        top: 0,
        left: 0,
        layout: "vertical",
        id: "matchesView"
    });
    $.__views.matchesView && $.addTopLevelView($.__views.matchesView);
    $.__views.matchesContainer = Ti.UI.createView({
        height: Ti.UI.SIZE,
        width: "100%",
        top: 0,
        left: 0,
        layout: "vertical",
        id: "matchesContainer"
    });
    $.__views.matchesView.add($.__views.matchesContainer);
    $.__views.moreContainer = Ti.UI.createView({
        height: 0,
        id: "moreContainer"
    });
    $.__views.matchesView.add($.__views.moreContainer);
    $.__views.loadMore = require("/ui/common/tactile_label").createLabel({
        color: Alloy.Globals.Style.Color.LightBlue,
        width: "100%",
        font: {
            fontSize: "15dp"
        },
        height: "60dp",
        backgroundColor: "#ffffffff",
        text: L("widget_future_lbl_more"),
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        id: "loadMore"
    });
    $.__views.moreContainer.add($.__views.loadMore);
    $.__views.loadingMore = Ti.UI.createActivityIndicator({
        style: Ti.UI.ActivityIndicatorStyle.DARK,
        id: "loadingMore"
    });
    $.__views.moreContainer.add($.__views.loadingMore);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, Q = require("/vendor/q"), Globals = require("/v6/infrastructure/Globals"), exploreService = Globals.IOC.get("exploreService"), bookingService = Globals.IOC.get("bookingService"), inviteService = Globals.IOC.get("inviteService");
    exports = new (require("/carmalib/controller").extend($, {
        _matchesRows: {},
        _loading: false,
        _listType: args.listType,
        events: {
            "click loadMore": "_loadNextBestMatches",
            "click inviteFriendsButton": "_inviteFriendsAction"
        },
        initialize: function() {
            _.bindAll(this, "_checkLocalMatches", "_renderBestMatches", "_matchesLoadFinished", "_handleError", "_getBookingsForCurrentTrip", "refreshAskWithCurrentBookings");
        },
        renderMatches: function(data) {
            return Q(data).then(this._checkLocalMatches).then(this._renderBestMatches).catch(this._handleError).done();
        },
        _checkLocalMatches: function(data) {
            if (!data || !data.paginator.totalResults) throw data;
            return data;
        },
        _renderBestMatches: function(data) {
            if (!data) return;
            this._renderMatchesContainer();
            var self = this, groupingKey = data.tripMatchedAgainst.baseTrip.id + "-" + data.tripMatchedAgainst.baseTrip.schedule.baseEffectiveTime;
            _.each(data.matches, function(match) {
                self._buildMatchRow(match, groupingKey);
            });
            this._toggleMoreButton();
        },
        _buildMatchRow: function(match, groupingKey) {
            var widget = Widget.createController("matchRow", {
                match: match,
                groupingKey: groupingKey
            });
            $.matchesContainer.add(widget.getView());
            this._matchesRows[widget.getUserTripId()] = widget;
        },
        _toggleMoreButton: function() {
            $.loadingMore.hide();
            if (exploreService.isThereNextBestMatchesPageForType(this._listType)) {
                $.moreContainer.height = Ti.UI.SIZE;
                $.loadMore.show();
            } else $.moreContainer.height = 0;
        },
        _handleError: function(error, loadingMore) {
            if (!error || loadingMore) {
                LOGGER.error("[matchesList.js] - " + error);
                return;
            }
            if (!error.paginator.totalResults) {
                this._renderEmptyMatchesList();
                return;
            }
            LOGGER.error("[matchesList.js] - " + error);
        },
        _loadNextBestMatches: function() {
            if (this._loading) return;
            this._prepareViewToLoadMore();
            var self = this;
            Q().then(function() {
                return exploreService.getBestMatches({
                    nextPage: true
                });
            }).then(this._checkLocalMatches).then(this._renderBestMatches).then(this._getBookingsForCurrentTrip).then(function(data) {
                return bookingService.getRelevantBookings(data);
            }).then(this.refreshAskWithCurrentBookings).catch(function(error) {
                self._handleError(error, true);
            }).finally(this._matchesLoadFinished).done();
        },
        _prepareViewToLoadMore: function() {
            this._loading = true;
            setTimeout(function() {
                $.loadMore.hide();
                $.loadingMore.show();
            }, 300);
        },
        _getBookingsForCurrentTrip: function() {
            return exploreService.getBookingsForCurrentTrip();
        },
        _matchesLoadFinished: function() {
            $.loadingMore.hide();
            this._loading = false;
        },
        _renderEmptyMatchesList: function() {
            $.emptyMatchesList.applyProperties({
                height: Ti.UI.SIZE,
                opacity: 0
            });
            $.matchesContainer.height = 0;
            this._fadeInView($.emptyMatchesList);
        },
        _renderMatchesContainer: function() {
            $.matchesContainer.applyProperties({
                height: Ti.UI.SIZE
            });
            $.emptyMatchesList.height = 0;
        },
        _fadeInView: function(view) {
            setTimeout(function() {
                view.opacity = 1;
            }, 300);
            view.animate({
                opacity: 1,
                duration: 300
            });
        },
        _inviteFriendsAction: function() {
            inviteService.inviteFriend();
        },
        refreshAskWithCurrentBookings: function(bookings) {
            bookings = bookings || {};
            var myUserId = require("services/resource_owner_service").singleton().get("userId"), self = this;
            _.each(bookings, function(booking) {
                var trip = booking.sourceTrip.ownerUid === myUserId ? booking.trip.baseTrip : booking.sourceTrip.baseTrip, groupingKeyForTrip = bookingService.generateGroupingKeyForTrip(trip);
                self._matchesRows[groupingKeyForTrip] && self._matchesRows[groupingKeyForTrip].setBookingObject(booking);
            });
        },
        clearMatches: function() {
            _.each(this._matchesRows, function(controller) {
                controller.destroy();
            });
            this._matchesRows = {};
            $.matchesContainer.hide();
            $.matchesContainer.removeAllChildren();
            $.emptyMatchesList.height = 0;
            $.moreContainer.height = 0;
            $.matchesContainer.show();
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;