function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.future2/" + s : s.substring(0, index) + "/ma.car.app.future2/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.future2");
    this.__widgetId = "ma.car.app.future2";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "roleTabs";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.roleTabsContainer = Ti.UI.createView({
        width: "100%",
        height: "40dp",
        backgroundColor: Alloy.Globals.Style.Color.Grey,
        bottom: "5dp",
        layout: "horizontal",
        id: "roleTabsContainer"
    });
    $.__views.roleTabsContainer && $.addTopLevelView($.__views.roleTabsContainer);
    $.__views.driverTab = Ti.UI.createView({
        width: "50%",
        height: "40dp",
        id: "driverTab"
    });
    $.__views.roleTabsContainer.add($.__views.driverTab);
    $.__views.driverTabLbl = Ti.UI.createLabel({
        color: "#999",
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        top: "4dp",
        id: "driverTabLbl"
    });
    $.__views.driverTab.add($.__views.driverTabLbl);
    $.__views.driverArrow = Ti.UI.createView({
        width: "14dp",
        height: "14dp",
        backgroundColor: "white",
        transform: Alloy.Globals.Style.Rotate.rt45,
        top: "45dp",
        id: "driverArrow"
    });
    $.__views.driverTab.add($.__views.driverArrow);
    $.__views.riderTab = Ti.UI.createView({
        width: "50%",
        height: "40dp",
        id: "riderTab"
    });
    $.__views.roleTabsContainer.add($.__views.riderTab);
    $.__views.riderTabLbl = Ti.UI.createLabel({
        color: "#999",
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        top: "4dp",
        id: "riderTabLbl"
    });
    $.__views.riderTab.add($.__views.riderTabLbl);
    $.__views.riderArrow = Ti.UI.createView({
        width: "14dp",
        height: "14dp",
        backgroundColor: "white",
        transform: Alloy.Globals.Style.Rotate.rt45,
        top: "45dp",
        id: "riderArrow"
    });
    $.__views.riderTab.add($.__views.riderArrow);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var Globals = require("/v6/infrastructure/Globals"), exploreService = Globals.IOC.get("exploreService");
    exports = new (require("/carmalib/controller").extend($, {
        events: {
            "click driverTab": "_driverTabClick",
            "click riderTab": "_riderTabClick"
        },
        initialize: function() {},
        renderTabsInfo: function(data) {
            var rideMatches = data.rideMatches, driveMatches = data.driveMatches, matches = rideMatches || driveMatches, tripMatchedAgainst = rideMatches.tripMatchedAgainst || driveMatches.tripMatchedAgainst;
            var driverCount = matches.numDriverMatches, riderCount = matches.numRiderMatches;
            $.driverTabLbl.text = driverCount + " " + L(1 === driverCount ? "mode_driver" : "mode_driver_plural");
            $.riderTabLbl.text = riderCount + " " + L(1 === riderCount ? "mode_rider" : "mode_rider_plural");
            var searchType = exploreService.getSearchType();
            searchType || (searchType = "RIDE" === tripMatchedAgainst.baseTrip.type ? "DRIVE" : "RIDE");
            this._switchTabs(searchType, false);
        },
        _driverTabClick: function() {
            if (this._switchingTabs) return;
            this._switchingTabs = true;
            this._switchTabs("DRIVE", true);
        },
        _riderTabClick: function() {
            if (this._switchingTabs) return;
            this._switchingTabs = true;
            this._switchTabs("RIDE", true);
        },
        _switchTabs: function(tabToEnable, animate) {
            if (exploreService.getSearchType() === tabToEnable) {
                this._switchingTabs = false;
                return;
            }
            exploreService.setSearchType(tabToEnable);
            this._toggleTabs($.riderTabLbl, $.riderArrow, "RIDE" === tabToEnable, animate);
            this._toggleTabs($.driverTabLbl, $.driverArrow, "DRIVE" === tabToEnable, animate);
        },
        _toggleTabs: function(tab, arrow, enable, animate) {
            tab.color = enable ? Alloy.Globals.Style.Color.DarkGray : "#999";
            if (enable) if (animate) {
                arrow.animate({
                    top: "33dp",
                    duration: 300
                });
                var self = this;
                setTimeout(function() {
                    self._switchingTabs = false;
                }, 350);
            } else {
                arrow.top = "33dp";
                var self = this;
                setTimeout(function() {
                    self._switchingTabs = false;
                }, 350);
            } else arrow.top = "45dp";
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;