function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.help/" + s : s.substring(0, index) + "/ma.car.app.help/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.help");
    this.__widgetId = "ma.car.app.help";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "help";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.container = Ti.UI.createView({
        height: "100%",
        backgroundColor: "#FFF",
        id: "container"
    });
    $.__views.container && $.addTopLevelView($.__views.container);
    var __alloyId705 = [];
    $.__views.help = Ti.UI.createScrollableView({
        width: "98%",
        showPagingControl: false,
        disableBounce: true,
        pagingControlColor: "#FFF",
        pagingControlAlpha: 1,
        pageIndicatorTintColor: "#CCC",
        currentPageIndicatorTintColor: "#000",
        top: 0,
        height: Ti.UI.FILL,
        backgroundColor: "#FFF",
        views: __alloyId705,
        id: "help"
    });
    $.__views.container.add($.__views.help);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var ui = require("utils/ui"), Queue = require("/utils/queue"), BaseController = require("/carmalib/controller");
    var args = arguments[0] || {};
    var Internal = {};
    Internal.getSupportProfile = function() {
        var locationChecker = require("utils/location_check");
        pilot = locationChecker.checkPilotArea();
        var profile = {
            id: 7984,
            name: "Audrey",
            isAustin: false
        };
        if (null != pilot) {
            if (pilot === locationChecker.AUSTIN || pilot === locationChecker.SFBAY) {
                profile.id = 1557820714;
                profile.name = "Lauren";
                profile.isAustin = true;
            }
            if (pilot === locationChecker.SFBAY) {
                profile.id = 386502458;
                profile.name = "Teresa";
            } else if (pilot === locationChecker.BERGEN) {
                profile.id = 9125;
                profile.name = "Kristian";
            }
        }
        return profile;
    };
    var Controller = BaseController.extend($, {
        _currentPage: 0,
        _ui: new Queue({
            name: "ui",
            timeout: 500
        }),
        _pagination: null,
        events: {
            "scrollend help": "onScrollEnd"
        },
        initialize: function() {
            this._ui.bind(this, "onScrollEnd", {
                unique: true
            });
            var support = Internal.getSupportProfile(), cards = [];
            cards.push(this.createProfileCard(support));
            support.isAustin && cards.push(this.createAustinCard(support));
            cards.push(this.createReachCard(support));
            cards.push(this.createTripCard(support));
            cards.push(this.createPricingCard(support));
            cards.push(this.createFreeRideCard(support));
            cards.push(this.createSupportCard(support));
            var views = _.map(cards, function(widget) {
                return widget.getView();
            });
            $.help.applyProperties({
                views: views
            });
            var PagingControl = require(WPATH("/PagingControl"));
            this._pagination = new PagingControl($.help);
            $.help.add(this._pagination.getView());
        },
        onDestroy: function() {
            this._ui.clear();
            this._pagination && this._pagination.destroy();
            $.help.applyProperties({
                views: []
            });
        },
        onScrollEnd: function(e) {
            var event = require("/tracking/tracking_event"), views = $.help.getViews(), currentView = $.help.getCurrentPage();
            require("/tracking/tracking_manager").track(event.PAGE_HIT, {
                view: views[currentView].title,
                index: currentView
            });
        },
        closeWindow: function() {
            var _window = ui.getWindow($.help);
            _window && _window.close && setTimeout(function() {
                _window.close();
            }, 200);
        },
        createProfileCard: function(support) {
            var self = this;
            var action = function() {
                self.closeWindow();
                Ti.App.fireEvent("carma:profile.open", {});
            };
            var card = Alloy.createWidget("ma.car.app.help", "card", {
                title: L("widget_howto_profile_title"),
                text: L("widget_howto_profile_message"),
                image: "Profile.png",
                action: L("widget_howto_profile_where"),
                actionFn: action
            });
            return card;
        },
        createReachCard: function(support) {
            var self = this;
            var action = function() {
                self.closeWindow();
                Ti.App.fireEvent("carma:plantrip.tab", {});
            };
            var card = Alloy.createWidget("ma.car.app.help", "card", {
                id: "reachout",
                title: L("widget_howto_reachout_title"),
                text: L("widget_howto_reachout_message"),
                image: "Reachout.png",
                action: L("widget_howto_reachout_where"),
                actionFn: action
            });
            return card;
        },
        createTripCard: function(support) {
            var self = this;
            var action = function() {
                self.closeWindow();
                Ti.App.fireEvent("carma:starttrip.tab", {});
            };
            var card = Alloy.createWidget("ma.car.app.help", "card", {
                id: "trip",
                title: L("widget_howto_trip_title"),
                text: L("widget_howto_trip_message"),
                image: "Log.png",
                action: L("widget_howto_trip_where"),
                actionFn: action
            });
            return card;
        },
        createSupportCard: function(support) {
            var self = this;
            var action = function() {
                self.closeWindow();
                if (support.id) Ti.App.fireEvent("carma:profile.open", {
                    userId: support.id
                }); else {
                    var resourceOwner = require("/services/resource_owner_service").singleton();
                    var userId = resourceOwner.get("userId");
                    var emailDialog = Ti.UI.createEmailDialog();
                    emailDialog.subject = L("widget_howto_support_email_subject");
                    emailDialog.toRecipients = [ "support@car.ma" ];
                    emailDialog.messageBody = String.format(L("widget_howto_support_email_content"), userId + "");
                    emailDialog.open();
                }
            };
            var supportText = String.format(L("widget_howto_support_message"), support.name + "");
            var supportWhere = L("widget_howto_support_email");
            support.id && (supportWhere = String.format(L("widget_howto_support_where"), support.name + ""));
            var card = Alloy.createWidget("ma.car.app.help", "card", {
                id: "support",
                title: L("widget_howto_support_title"),
                text: supportText,
                image: "Question.png",
                action: supportWhere,
                actionFn: action
            });
            return card;
        },
        createPricingCard: function(support) {
            var self = this;
            var action = function() {
                self.closeWindow();
                Ti.App.fireEvent("carma:profile.open", {});
            };
            var card = Alloy.createWidget("ma.car.app.help", "card", {
                id: "pricing",
                title: L("widget_howto_pricing_title"),
                text: L("widget_howto_pricing_message"),
                image: "TipsPayment.png",
                action: L("widget_howto_pricing_where"),
                actionFn: action
            });
            return card;
        },
        createFreeRideCard: function(support) {
            var self = this;
            var action = function() {
                self.closeWindow();
                var resourceOwner = require("services/resource_owner_service").singleton();
                var navigation = Alloy.createController("navigation");
                var wrapperWindow = Alloy.createController("simpleWindow").getView();
                var favoriteView = Alloy.createWidget("ma.car.app.favorites", {
                    userId: resourceOwner.get("userId"),
                    navigation: navigation
                });
                navigation.init({
                    index: favoriteView,
                    historyLimit: 20,
                    mainWindow: wrapperWindow,
                    transition: "none",
                    modal: true,
                    title: L("widget_profile_summary_favourite_title"),
                    navBarColor: "#FFF"
                });
                wrapperWindow.open();
            };
            var card = Alloy.createWidget("ma.car.app.help", "card", {
                id: "freeRide",
                title: L("widget_howto_free_ride_title"),
                text: L("widget_howto_free_ride_message"),
                image: "moneyheart_large.png",
                action: L("widget_howto_pricing_where"),
                actionFn: action
            });
            return card;
        },
        createAustinCard: function() {
            var self = this;
            var action = function() {
                self.closeWindow();
                Ti.App.fireEvent("carma:profile.open", {
                    action: "tolltag"
                });
            };
            var card = Alloy.createWidget("ma.car.app.help", "card", {
                title: L("widget_howto_txtag_title"),
                text: L("widget_howto_txtag_message"),
                image: "TxTag.png",
                action: L("widget_howto_txtag_where"),
                actionFn: action
            });
            return card;
        }
    });
    exports = new Controller();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;