function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.helpcard/" + s : s.substring(0, index) + "/ma.car.app.helpcard/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.helpcard");
    this.__widgetId = "ma.car.app.helpcard";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.container = Ti.UI.createView({
        width: "100%",
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "container"
    });
    $.__views.container && $.addTopLevelView($.__views.container);
    $.__views.cardTitle = Ti.UI.createLabel({
        color: "#fff",
        text: "TIPS",
        width: Ti.UI.SIZE,
        height: "50dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        backgroundColor: "transparent",
        id: "cardTitle"
    });
    $.__views.container.add($.__views.cardTitle);
    $.__views.cardContent = Ti.UI.createView({
        height: Ti.UI.SIZE,
        backgroundColor: "#FFF",
        layout: "horizontal",
        horizontalWrap: false,
        width: "100%",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        id: "cardContent"
    });
    $.__views.container.add($.__views.cardContent);
    $.__views.image = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        width: "70dp",
        height: "63dp",
        image: WPATH("/images/card-image.png"),
        bottom: "12dp",
        id: "image"
    });
    $.__views.cardContent.add($.__views.image);
    $.__views.contentOuter = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        id: "contentOuter"
    });
    $.__views.cardContent.add($.__views.contentOuter);
    $.__views.content = Ti.UI.createView({
        top: "15dp",
        bottom: "15dp",
        width: "95%",
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "content"
    });
    $.__views.contentOuter.add($.__views.content);
    $.__views.title = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        text: L("widget_helpcard_title"),
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        left: 0,
        id: "title"
    });
    $.__views.content.add($.__views.title);
    $.__views.text = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp"
        },
        text: L("widget_helpcard_text"),
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        left: 0,
        id: "text"
    });
    $.__views.content.add($.__views.text);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, utils = require("/utils/utils"), Q = require("/vendor/q"), Queue = require("/utils/queue"), BaseController = require("/carmalib/controller");
    var Controller = BaseController.extend($, {
        _opening: false,
        _ui: new Queue({
            name: "ui",
            timeout: 1e3
        }),
        events: {
            "click[android] cardContent": "onClick",
            "singletap[ios] cardContent": "onClick"
        },
        initialize: function() {
            _.bindAll(this, "onPostlayout");
            this._ui.bind(this, "onClick", {
                unique: true
            });
            $.cardContent.addEventListener("postlayout", this.onPostlayout);
        },
        onPostlayout: function(e) {
            if ($.cardContent.size.height > 0) {
                $.cardContent.removeEventListener("postlayout", this.onPostlayout);
                $.image.applyProperties({
                    bottom: (utils.defaultToDp($.cardContent.size.height) - 63) / 2 + "dp"
                });
            }
        },
        onDestroy: function() {
            this._ui.clear();
        },
        onClick: function() {
            if (this._opening) return;
            this._opening = true;
            var self = this;
            return Q().finally(function() {
                Alloy.createWidget("ma.car.app.help").getView().open();
            }).finally(function() {
                return Q.delay(500);
            }).finally(function() {
                $.cardContent.opacity = 1;
            }).finally(function() {
                self._opening = false;
            });
        }
    });
    exports = new Controller();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;