function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.home/" + s : s.substring(0, index) + "/ma.car.app.home/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    function loginFacebook(fbManager) {
        fbManager.login({
            success: function(data) {
                LOGGER.info("FB sign-in successfully");
                _handleFBAuthorize(data);
            },
            error: function(e) {
                if (e && e.cancelled) return;
                if (e && "5" === e.code.toString()) {
                    Carma.UI.createAlertWindow({
                        title: L("widget_home_msg_login_facebook_error"),
                        message: L("widget_home_msg_login_error")
                    }).show();
                    return;
                }
                if (e && "-1" === e.code.toString()) {
                    Carma.UI.createAlertWindow({
                        title: L("widget_home_msg_login_facebook_denied_error"),
                        message: L("widget_home_msg_login_facebook_error_msg")
                    }).show();
                    return;
                }
                Carma.UI.createAlertWindow({
                    title: L("widget_home_msg_login_facebook_error"),
                    message: L("widget_home_msg_login_error_unknown")
                }).show();
                fbManager.logout();
            }
        });
    }
    function renewCredentialsAndLoginAgain(fbManager) {}
    function showUserImage(image, gender) {
        $.avatar.image = image;
    }
    function showInviteScreen(inviteCode) {
        var inviteModel = Alloy.createModel("invite_code");
        inviteModel.getInviteDetails({
            inviteId: inviteCode
        }).then(function(data) {
            var userId = data.invitingUser.userId;
            var firstName = data.invitingUser.firstName;
            var profileImage = data.invitingUser.photoUrl;
            $.standardContainer.applyProperties({
                visible: false,
                height: 0
            });
            $.inviteContainer.applyProperties({
                visible: true
            });
            $.lblHeaderTitle.applyProperties({
                html: L("widget_invite_welcome_label")
            });
            $.lblConditions.applyProperties({
                visible: true,
                height: Ti.UI.SIZE
            });
            $.footerContainer.applyProperties({
                visible: false
            });
            showUserImage(profileImage, data.invitingUser.userGender);
            var message = String.format(L("widget_invite_friend_label"), firstName);
            $.lblFriend.applyProperties({
                text: message
            });
            Ti.App.Properties.setObject("invite", {
                id: inviteCode,
                userId: userId,
                firstName: firstName,
                profileImage: profileImage
            });
            if (!Ti.App.Properties.getBool("carma:tracking.sent", false)) {
                Ti.App.Properties.setBool("carma:tracking.sent", true);
                inviteModel.trackInviteEvent({
                    inviteId: inviteCode,
                    eventType: inviteModel.NATIVE_APP_INSTALLED
                });
            }
        }).catch(function(e) {
            require(WPATH("yozioState")).setProcessing(false);
        });
    }
    var Widget = new (require("alloy/widget"))("ma.car.app.home");
    this.__widgetId = "ma.car.app.home";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.windowHome = require("/ui/common/custom_window").createWindow({
        orientationModes: [ Ti.UI.PORTRAIT ],
        top: 0,
        left: 0,
        height: "100%",
        width: "100%",
        navBarHidden: true,
        id: "windowHome",
        autoClose: "false"
    });
    $.__views.windowHome && $.addTopLevelView($.__views.windowHome);
    $.__views.homeBackground = Ti.UI.createImageView({
        defaultImage: "/images/background.png",
        top: 0,
        left: 0,
        width: Alloy.Globals.Style.Size.Width.pct100,
        height: Alloy.Globals.Style.Size.Height.pct100,
        image: "/images/background.png",
        zIndex: -1,
        opacity: 1,
        id: "homeBackground"
    });
    $.__views.windowHome.add($.__views.homeBackground);
    $.__views.dynamicHomeBackgroundLayer = Ti.UI.createImageView({
        defaultImage: "/images/background.png",
        top: 0,
        left: 0,
        width: Alloy.Globals.Style.Size.Width.pct100,
        height: Alloy.Globals.Style.Size.Height.pct100,
        image: "/images/background.png",
        opacity: 0,
        id: "dynamicHomeBackgroundLayer"
    });
    $.__views.windowHome.add($.__views.dynamicHomeBackgroundLayer);
    $.__views.viewHome = Ti.UI.createView({
        height: "100%",
        id: "viewHome"
    });
    $.__views.windowHome.add($.__views.viewHome);
    $.__views.viewHeader = Ti.UI.createView({
        top: 0,
        height: "165dp",
        id: "viewHeader"
    });
    $.__views.viewHome.add($.__views.viewHeader);
    $.__views.devInfo = Alloy.createWidget("ma.car.app.devinfo", "widget", {
        id: "devInfo",
        right: "true",
        __parentSymbol: $.__views.viewHeader
    });
    $.__views.devInfo.setParent($.__views.viewHeader);
    $.__views.imgLogo = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        top: "30dp",
        width: "60dp",
        image: "/images/logo.png",
        id: "imgLogo"
    });
    $.__views.viewHeader.add($.__views.imgLogo);
    $.__views.lblHeaderTitle = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "15dp"
        },
        text: L("widget_home_msg_free_credit"),
        top: "115dp",
        width: "200dp",
        textAlign: "center",
        html: L("widget_home_msg_free_credit_android"),
        id: "lblHeaderTitle"
    });
    $.__views.viewHeader.add($.__views.lblHeaderTitle);
    $.__views.headerBorderBottom = Ti.UI.createView({
        height: "0",
        backgroundColor: "#585864",
        bottom: 0,
        id: "headerBorderBottom"
    });
    $.__views.viewHeader.add($.__views.headerBorderBottom);
    $.__views.viewBody = Ti.UI.createView({
        top: "165dp",
        bottom: "50dp",
        id: "viewBody"
    });
    $.__views.viewHome.add($.__views.viewBody);
    $.__views.standardContainer = Ti.UI.createView({
        id: "standardContainer"
    });
    $.__views.viewBody.add($.__views.standardContainer);
    $.__views.btnSignupWithFacebook = require("/ui/common/custom_button").createButton({
        width: Alloy.Globals.Style.Size.Width.grid11,
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "60dp",
        font: {
            fontSize: "18dp"
        },
        normalColor: "#4a6ea9",
        selectedColor: "#31538b",
        backgroundImage: "none",
        top: "50dp",
        title: "",
        id: "btnSignupWithFacebook",
        enabled: "true"
    });
    $.__views.standardContainer.add($.__views.btnSignupWithFacebook);
    $.__views.__alloyId9 = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontFamily: "splinico",
            fontSize: "28dp"
        },
        text: "f",
        left: "11dp",
        width: "50dp",
        height: "60dp",
        id: "__alloyId9"
    });
    $.__views.btnSignupWithFacebook.add($.__views.__alloyId9);
    $.__views.__alloyId10 = Ti.UI.createView({
        left: "50dp",
        width: "1px",
        height: "100%",
        backgroundColor: "#fff",
        id: "__alloyId10"
    });
    $.__views.btnSignupWithFacebook.add($.__views.__alloyId10);
    $.__views.__alloyId11 = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "18dp"
        },
        left: "60dp",
        text: L("widget_home_btn_signup_facebook"),
        id: "__alloyId11"
    });
    $.__views.btnSignupWithFacebook.add($.__views.__alloyId11);
    $.__views.btnSignupWithEmail = require("/ui/common/custom_button").createButton({
        width: Alloy.Globals.Style.Size.Width.grid11,
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "60dp",
        font: {
            fontSize: "18dp"
        },
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        top: "120dp",
        title: "",
        id: "btnSignupWithEmail",
        enabled: "true"
    });
    $.__views.standardContainer.add($.__views.btnSignupWithEmail);
    $.__views.__alloyId12 = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontFamily: "splinico",
            fontSize: "28dp"
        },
        text: "b",
        left: "11dp",
        width: "50dp",
        height: "60dp",
        id: "__alloyId12"
    });
    $.__views.btnSignupWithEmail.add($.__views.__alloyId12);
    $.__views.__alloyId13 = Ti.UI.createView({
        left: "50dp",
        width: "1px",
        height: "100%",
        backgroundColor: "#fff",
        id: "__alloyId13"
    });
    $.__views.btnSignupWithEmail.add($.__views.__alloyId13);
    $.__views.__alloyId14 = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "18dp"
        },
        left: "60dp",
        text: L("widget_home_btn_signup_email"),
        id: "__alloyId14"
    });
    $.__views.btnSignupWithEmail.add($.__views.__alloyId14);
    $.__views.separator = Ti.UI.createView({
        top: "200dp",
        height: "2dp",
        backgroundColor: "#fff",
        id: "separator"
    });
    $.__views.standardContainer.add($.__views.separator);
    $.__views.btnLogin = require("/ui/common/custom_button").createButton({
        width: Alloy.Globals.Style.Size.Width.grid11,
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "60dp",
        font: {
            fontSize: "18dp"
        },
        normalColor: "#00ffffff",
        selectedColor: "#70ffffff",
        backgroundImage: "none",
        borderColor: "#fff",
        borderWidth: 2,
        disableAnimation: true,
        top: "220dp",
        title: L("btn_login"),
        id: "btnLogin",
        enabled: "true"
    });
    $.__views.standardContainer.add($.__views.btnLogin);
    $.__views.inviteContainer = Ti.UI.createView({
        layout: "vertical",
        bottom: "0dp",
        id: "inviteContainer",
        visible: "false"
    });
    $.__views.viewBody.add($.__views.inviteContainer);
    $.__views.avatar = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        borderColor: "#fff",
        borderWidth: 1,
        top: 0,
        width: "120dp",
        height: "120dp",
        borderRadius: Alloy.Globals.Style.Unit.unit60,
        id: "avatar"
    });
    $.__views.inviteContainer.add($.__views.avatar);
    $.__views.lblFriend = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "18dp"
        },
        top: "20dp",
        textAlign: "center",
        width: "90%",
        id: "lblFriend"
    });
    $.__views.inviteContainer.add($.__views.lblFriend);
    $.__views.btnRedeemInvite = require("/ui/common/custom_button").createButton({
        width: Alloy.Globals.Style.Size.Width.grid11,
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "60dp",
        font: {
            fontSize: "18dp"
        },
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        top: "20dp",
        title: "",
        id: "btnRedeemInvite",
        enabled: "true"
    });
    $.__views.inviteContainer.add($.__views.btnRedeemInvite);
    $.__views.redeemInvite = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "18dp"
        },
        id: "redeemInvite",
        text: L("widget_invite_redeem_label")
    });
    $.__views.btnRedeemInvite.add($.__views.redeemInvite);
    $.__views.btnSignupWithFacebookInvite = require("/ui/common/custom_button").createButton({
        width: Alloy.Globals.Style.Size.Width.grid11,
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "60dp",
        font: {
            fontSize: "18dp"
        },
        normalColor: "#4a6ea9",
        selectedColor: "#31538b",
        backgroundImage: "none",
        top: "10p",
        visible: "false",
        title: "",
        id: "btnSignupWithFacebookInvite",
        enabled: "true"
    });
    $.__views.inviteContainer.add($.__views.btnSignupWithFacebookInvite);
    $.__views.__alloyId15 = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontFamily: "splinico",
            fontSize: "28dp"
        },
        text: "f",
        left: "11dp",
        width: "50dp",
        height: "60dp",
        id: "__alloyId15"
    });
    $.__views.btnSignupWithFacebookInvite.add($.__views.__alloyId15);
    $.__views.__alloyId16 = Ti.UI.createView({
        left: "50dp",
        width: "1px",
        height: "100%",
        backgroundColor: "#fff",
        id: "__alloyId16"
    });
    $.__views.btnSignupWithFacebookInvite.add($.__views.__alloyId16);
    $.__views.__alloyId17 = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "18dp"
        },
        left: "60dp",
        text: L("widget_home_btn_signup_facebook"),
        id: "__alloyId17"
    });
    $.__views.btnSignupWithFacebookInvite.add($.__views.__alloyId17);
    $.__views.btnSignupWithEmailInvite = require("/ui/common/custom_button").createButton({
        width: Alloy.Globals.Style.Size.Width.grid11,
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "60dp",
        font: {
            fontSize: "18dp"
        },
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        top: "10dp",
        visible: "false",
        title: "",
        id: "btnSignupWithEmailInvite",
        enabled: "true"
    });
    $.__views.inviteContainer.add($.__views.btnSignupWithEmailInvite);
    $.__views.__alloyId18 = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontFamily: "splinico",
            fontSize: "28dp"
        },
        text: "b",
        left: "11dp",
        width: "50dp",
        height: "60dp",
        id: "__alloyId18"
    });
    $.__views.btnSignupWithEmailInvite.add($.__views.__alloyId18);
    $.__views.__alloyId19 = Ti.UI.createView({
        left: "50dp",
        width: "1px",
        height: "100%",
        backgroundColor: "#fff",
        id: "__alloyId19"
    });
    $.__views.btnSignupWithEmailInvite.add($.__views.__alloyId19);
    $.__views.__alloyId20 = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "18dp"
        },
        left: "60dp",
        text: L("widget_home_btn_signup_email"),
        id: "__alloyId20"
    });
    $.__views.btnSignupWithEmailInvite.add($.__views.__alloyId20);
    $.__views.separatorInvite = Ti.UI.createView({
        top: "200dp",
        height: "2dp",
        backgroundColor: "#fff",
        id: "separatorInvite",
        visible: "false"
    });
    $.__views.inviteContainer.add($.__views.separatorInvite);
    $.__views.btnLoginInvite = require("/ui/common/custom_button").createButton({
        width: Alloy.Globals.Style.Size.Width.grid11,
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "60dp",
        font: {
            fontSize: "18dp"
        },
        normalColor: "#00ffffff",
        selectedColor: "#70ffffff",
        backgroundImage: "none",
        borderColor: "#fff",
        borderWidth: 2,
        disableAnimation: true,
        top: "10dp",
        title: L("btn_login"),
        visible: "false",
        id: "btnLoginInvite",
        enabled: "true"
    });
    $.__views.inviteContainer.add($.__views.btnLoginInvite);
    $.__views.viewFooter = Ti.UI.createView({
        left: 0,
        height: "50dp",
        backgroundColor: "#10ffffff",
        zIndex: 1,
        layout: "vertical",
        id: "viewFooter"
    });
    $.__views.viewHome.add($.__views.viewFooter);
    $.__views.lblConditions = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "15dp"
        },
        textAlign: "center",
        bottom: "5dp",
        text: L("widget_invite_credit_conditions_footer"),
        visible: "false",
        height: 0,
        id: "lblConditions"
    });
    $.__views.viewFooter.add($.__views.lblConditions);
    $.__views.footerContainer = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "footerContainer"
    });
    $.__views.viewFooter.add($.__views.footerContainer);
    $.__views.__alloyId21 = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "10dp"
        },
        text: L("widget_home_msg_view"),
        id: "__alloyId21"
    });
    $.__views.footerContainer.add($.__views.__alloyId21);
    $.__views.lblTerms = Ti.UI.createLabel({
        color: "#003366",
        font: {
            fontSize: "10dp"
        },
        left: "2dp",
        height: "24dp",
        id: "lblTerms",
        text: L("widget_home_msg_terms")
    });
    $.__views.footerContainer.add($.__views.lblTerms);
    $.__views.__alloyId22 = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "10dp"
        },
        left: "2dp",
        text: L("widget_home_msg_and"),
        id: "__alloyId22"
    });
    $.__views.footerContainer.add($.__views.__alloyId22);
    $.__views.lblPrivacy = Ti.UI.createLabel({
        color: "#003366",
        font: {
            fontSize: "10dp"
        },
        left: "2dp",
        height: "24dp",
        id: "lblPrivacy",
        text: L("widget_home_msg_privacy")
    });
    $.__views.footerContainer.add($.__views.lblPrivacy);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var event = require("/tracking/tracking_event"), analytics = require("/tracking/tracking_manager"), link = require("/ui/link"), fbManager = require("facebook/facebook_manager");
    require("/ui/windowManager").trackWindow($.windowHome);
    $.windowHome.fbProxy = fbManager.createActivityWorker($.windowHome);
    var _handleFBAuthorize = function(data) {
        var fbToken = data.token;
        var executor = require("utils/executor");
        executor(function() {
            LOGGER.info("Signin-ing with Facebook access token");
            return require("facebook/facebook_signin").authenticate(fbToken).then(function() {
                analytics.track(event.LOGIN, {
                    source: "Facebook"
                });
                var defer = require("vendor/q").defer();
                Ti.App.fireEvent("carma:login.success", {
                    callback: function() {
                        defer.resolve({});
                    }
                });
                return defer.promise;
            });
        }).error(function(e) {
            LOGGER.error("Sign-in with FB Failed: " + JSON.stringify(e));
            if (e && e.cancelled) return;
            if (e && e.status && "401" === e.status.toString()) {
                fbManager.user().then(function(fbData) {
                    data.user = fbData.user;
                    analytics.track(event.SIGNUP_STARTED, {
                        source: "Facebook"
                    });
                    var view = Alloy.createWidget("ma.car.app.fbsignup", "widget", data).getView();
                    view.open();
                }).catch(function(e) {
                    fbManager.logout();
                    e && "5" === e.code.toString() && renewCredentialsAndLoginAgain(fbManager);
                });
                return;
            }
            if (e && e.status && "502" === e.status.toString()) {
                Carma.UI.createAlertWindow({
                    title: L("error_title"),
                    message: "Server is busy. Try again..."
                }).show();
                return;
            }
            Carma.UI.createAlertWindow({
                title: L("error_title"),
                message: L("widget_home_msg_login_error")
            }).show();
            fbManager.logout();
        }).run();
    };
    var displayOfflineMessage = function(message) {
        Ti.UI.createAlertDialog({
            message: message
        }).show();
    };
    var enableButtons = function(flag) {
        $.btnSignupWithFacebook.enabled = flag;
        $.btnSignupWithEmail.enabled = flag;
        $.btnLogin.enabled = flag;
        $.btnSignupWithFacebookInvite.enabled = flag;
        $.btnSignupWithEmailInvite.enabled = flag;
        $.btnLoginInvite.enabled = flag;
    };
    var handleFacebook = function() {
        enableButtons(false);
        Ti.App.fireEvent("carma:dispose.intro");
        if (!Ti.Network.online) {
            displayOfflineMessage(L("widget_login_fbsignup_error_offline"));
            enableButtons(true);
            return;
        }
        enableButtons(true);
        loginFacebook(fbManager);
    };
    $.btnSignupWithFacebook.addEventListener("click", function() {
        if (!$.btnSignupWithFacebook.enabled) return;
        handleFacebook();
    });
    $.btnSignupWithFacebookInvite.addEventListener("click", function() {
        if (!$.btnSignupWithFacebookInvite.enabled) return;
        handleFacebook();
    });
    var signupFeatureToggle = require("featuretoggles/featuretoggles").getValue("showEmailSignup");
    if (null !== signupFeatureToggle) {
        var event = require("/tracking/tracking_event");
        if (2 === signupFeatureToggle) {
            $.btnSignupWithEmail.visible = false;
            $.btnSignupWithFacebook.top = "120dp";
            require("/tracking/tracking_manager").track(event.AVAILABLE_SIGNUP_MODE, {
                option: "facebook"
            });
        } else require("/tracking/tracking_manager").track(event.AVAILABLE_SIGNUP_MODE, {
            option: "all"
        });
    }
    var handleSignup = function() {
        analytics.track(event.SIGNUP_STARTED, {
            source: "Email"
        });
        enableButtons(false);
        Ti.App.fireEvent("carma:dispose.intro");
        if (!Ti.Network.online) {
            displayOfflineMessage(L("widget_login_signup_error_offline"));
            enableButtons(true);
            return;
        }
        var view = Alloy.createWidget("ma.car.app.signup").getView();
        view.open();
    };
    $.btnSignupWithEmail.addEventListener("click", function() {
        if (!$.btnSignupWithEmail.enabled) return;
        handleSignup();
    });
    $.btnSignupWithEmailInvite.addEventListener("click", function() {
        if (!$.btnSignupWithEmailInvite.enabled) return;
        handleSignup();
    });
    var handleLogin = function() {
        enableButtons(false);
        Ti.App.fireEvent("carma:dispose.intro");
        if (!Ti.Network.online) {
            displayOfflineMessage(L("widget_login_error_offline"));
            enableButtons(true);
            return;
        }
        var view = Alloy.createWidget("ma.car.app.login").getView();
        view.open();
    };
    $.btnLogin.addEventListener("click", function() {
        if (!$.btnLogin.enabled) return;
        handleLogin();
    });
    $.btnLoginInvite.addEventListener("click", function() {
        if (!$.btnLogin.enabled) return;
        handleLogin();
    });
    $.lblTerms.addEventListener("click", function() {
        if ($.lblTerms.enabled || false) {
            $.lblTerms.enabled = false;
            setTimeout(function() {
                $.lblTerms.enabled = true;
            }, 1500);
            var view = Alloy.createWidget("ma.car.app.tos", {
                type: "terms"
            }).getView();
            view.open();
        }
    });
    $.lblPrivacy.addEventListener("click", function() {
        if ($.lblPrivacy.enabled || false) {
            $.lblPrivacy.enabled = false;
            setTimeout(function() {
                $.lblPrivacy.enabled = true;
            }, 1500);
            var view = Alloy.createWidget("ma.car.app.tos", {
                type: "privacy"
            }).getView();
            view.open();
        }
    });
    $.windowHome.addEventListener("androidback", function() {
        require("ma.car.ti.module.android.utils").moveTaskToBack(true);
    });
    $.windowHome.addEventListener("postlayout", function onPostLayout() {
        $.windowHome.removeEventListener("postlayout", onPostLayout);
        link.makeUnderlinedLink($.lblTerms);
        link.makeUnderlinedLink($.lblPrivacy);
    });
    $.windowHome.addEventListener("open", function handler() {
        $.windowHome.removeEventListener("open", handler);
        $.windowHome.backgroundImage = Ti.App.Properties.getString("lastBlurredBackgroundImagePath", "/images/background.png");
        var event = require("/tracking/tracking_event");
        require("/tracking/tracking_manager").track(event.PAGE_HIT, {
            view: "home"
        });
    });
    var screenHeight = require("utils/utils").pixelToDp(Ti.Platform.displayCaps.platformHeight);
    $.viewFooter.top = screenHeight - 74 + "dp";
    480 >= screenHeight && $.viewBody.applyProperties({
        top: "150dp"
    });
    $.btnRedeemInvite.addEventListener("click", function() {
        if (!$.btnRedeemInvite.enabled) return;
        analytics.track(event.REDEEM_CLICKED, {});
        var completeAnimation = function() {
            $.viewFooter.remove($.lblConditions);
            $.footerContainer.applyProperties({
                visible: true
            });
            $.viewBody.applyProperties({
                top: "110dp",
                bottom: "0dp"
            });
            $.inviteContainer.applyProperties({
                bottom: "0dp"
            });
            $.btnRedeemInvite.applyProperties({
                visible: false
            });
            $.lblHeaderTitle.applyProperties({
                visible: false
            });
            $.lblFriend.applyProperties({
                text: L("widget_invite_cash_ready"),
                top: "10dp"
            });
            $.inviteContainer.remove($.btnRedeemInvite);
            $.btnSignupWithFacebookInvite.applyProperties({
                visible: true
            });
            $.btnSignupWithEmailInvite.applyProperties({
                visible: true
            });
            $.separatorInvite.applyProperties({
                top: "10dp",
                visible: true
            });
            $.btnLoginInvite.applyProperties({
                visible: true
            });
        };
        $.viewHeader.applyProperties({
            height: "110dp"
        });
        completeAnimation();
    });
    var yozioRetries = 0;
    var getMetaDataForIOS = function(yozio) {
        var metadata = yozio.getMetaData();
        if (_.isEmpty(metadata)) {
            yozioRetries++;
            4 > yozioRetries && setTimeout(function() {
                getMetaDataForIOS(yozio);
            }, 1e3);
        } else metadata.inviteCode && showInviteScreen(metadata.inviteCode);
    };
    var yozioSetup = function() {
        var yozio = require("com.yozio.module");
        yozio.setAppKey("2df6da22-8620-4fcc-8be2-cbdf4c0af021", "6ae2e10e-8e6b-41a8-a605-4fecf6adf80a", function(data) {
            var metadata = null;
            metadata = _.isEmpty(data) ? yozio.getMetaData() : data.body;
            metadata && metadata.inviteCode && showInviteScreen(metadata.inviteCode);
        });
    };
    Ti.App.Properties.getBool("carma:intro.displayed", false) ? TM.push(function() {
        yozioSetup();
    }) : Ti.App.addEventListener("carma:scroller.build.complete", function() {
        TM.push(function() {
            yozioSetup();
        });
    });
    exports = {
        getScrollView: function() {
            return $.viewHome;
        }
    };
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;