function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.loading/" + s : s.substring(0, index) + "/ma.car.app.loading/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    function init() {
        if ($.loadingMask.images) {
            useImages = true;
            $.loadingInner.remove($.loadingIndicator);
            $.loadingIndicator = null;
        } else {
            $.loadingInner.remove($.loadingImages);
            $.loadingImages = null;
            $.loadingIndicator.applyProperties({
                style: Ti.UI.ActivityIndicatorStyle.DARK + Ti.UI.ActivityIndicatorStyle.BIG
            });
        }
        $.loadingMask.addEventListener("androidback", cancel);
        update(args.message, args.cancelable);
        $.loadingMask.addEventListener("open", function() {
            LOGGER.debug("SPN: window onOpen");
            isOpen = true;
            Ti.App.fireEvent("carma:progress.started");
        });
        $.loadingMask.addEventListener("close", function() {
            Ti.App.fireEvent("carma:progress.stopped");
        });
        args = null;
    }
    function update(_message, _cancelable) {
        $.loadingMessage.text = _message || "";
        cancelable = _cancelable;
    }
    function cancel(e) {
        if (!cancelable) {
            if (true && "androidback" === e.type) {
                var intent = Ti.Android.createIntent({
                    action: Ti.Android.ACTION_MAIN
                });
                intent.addCategory(Ti.Android.CATEGORY_HOME);
                Ti.Android.currentActivity.startActivity(intent);
            }
            return;
        }
        close();
        _.isFunction(cancelable) && cancelable();
        return;
    }
    function open() {
        LOGGER.debug("SPN: window open");
        $.loadingMask.open();
        $.loadingOuter.animate({
            opacity: 1,
            duration: 600
        });
        useImages ? $.loadingImages.start() : $.loadingIndicator.show();
    }
    function close() {
        LOGGER.debug("SPN: window close");
        if (false || isOpen) _close(); else var interval = setInterval(function() {
            if (isOpen) {
                _close();
                clearInterval(interval);
            }
        }, 100);
    }
    function _close() {
        LOGGER.debug("SPN: window _close");
        $.loadingOuter.animate({
            opacity: 0,
            duration: 300
        });
        setTimeout(function() {
            LOGGER.debug("SPN: actually closing window");
            $.loadingMask.close();
        }, 300);
        useImages ? $.loadingImages.stop() : $.loadingIndicator.hide();
        cancelable = null;
    }
    function onFocus(e) {
        $.hasFocus = true;
    }
    function onBlur(e) {
        $.hasFocus = false;
    }
    var Widget = new (require("alloy/widget"))("ma.car.app.loading");
    this.__widgetId = "ma.car.app.loading";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "window";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.loadingMask = require("/ui/common/custom_window").createWindow({
        orientationModes: [ Ti.UI.PORTRAIT ],
        backgroundColor: "transparent",
        backgroundImage: null,
        opacity: 1,
        modal: false,
        id: "loadingMask",
        navBarHidden: "true"
    });
    $.__views.loadingMask && $.addTopLevelView($.__views.loadingMask);
    cancel ? $.__views.loadingMask.addEventListener("click", cancel) : __defers["$.__views.loadingMask!click!cancel"] = true;
    onFocus ? $.__views.loadingMask.addEventListener("focus", onFocus) : __defers["$.__views.loadingMask!focus!onFocus"] = true;
    onBlur ? $.__views.loadingMask.addEventListener("blur", onBlur) : __defers["$.__views.loadingMask!blur!onBlur"] = true;
    $.__views.loadingOuter = Ti.UI.createView({
        top: 0,
        bottom: 0,
        width: Ti.UI.FILL,
        height: Ti.UI.FILL,
        backgroundColor: "#CFFF",
        opacity: 0,
        id: "loadingOuter"
    });
    $.__views.loadingMask.add($.__views.loadingOuter);
    $.__views.loadingInner = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "loadingInner"
    });
    $.__views.loadingOuter.add($.__views.loadingInner);
    $.__views.loadingIndicator = Ti.UI.createActivityIndicator({
        top: "0dp",
        style: Ti.UI.ActivityIndicatorStyle.DARK,
        id: "loadingIndicator"
    });
    $.__views.loadingInner.add($.__views.loadingIndicator);
    $.__views.loadingImages = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        top: "0dp",
        images: [ "/images/nl.fokkezb.loading/00.png", "/images/nl.fokkezb.loading/01.png", "/images/nl.fokkezb.loading/02.png", "/images/nl.fokkezb.loading/03.png", "/images/nl.fokkezb.loading/04.png", "/images/nl.fokkezb.loading/05.png", "/images/nl.fokkezb.loading/06.png", "/images/nl.fokkezb.loading/07.png", "/images/nl.fokkezb.loading/08.png", "/images/nl.fokkezb.loading/09.png", "/images/nl.fokkezb.loading/10.png", "/images/nl.fokkezb.loading/11.png" ],
        id: "loadingImages"
    });
    $.__views.loadingInner.add($.__views.loadingImages);
    $.__views.loadingMessage = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "15dp"
        },
        top: "20dp",
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        text: L("loadingMessage", "Loading.."),
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        id: "loadingMessage"
    });
    $.__views.loadingInner.add($.__views.loadingMessage);
    exports.destroy = function() {};
    _.extend($, $.__views);
    var args = arguments[0] || {}, useImages = false, cancelable = false, isOpen = false;
    init();
    exports.hasFocus = true;
    exports.open = open;
    exports.update = update;
    exports.close = close;
    __defers["$.__views.loadingMask!click!cancel"] && $.__views.loadingMask.addEventListener("click", cancel);
    __defers["$.__views.loadingMask!focus!onFocus"] && $.__views.loadingMask.addEventListener("focus", onFocus);
    __defers["$.__views.loadingMask!blur!onBlur"] && $.__views.loadingMask.addEventListener("blur", onBlur);
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;