function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.location/" + s : s.substring(0, index) + "/ma.car.app.location/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.location");
    this.__widgetId = "ma.car.app.location";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.addressContainer = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.pct100,
        top: 0,
        left: 0,
        height: "100%",
        id: "addressContainer"
    });
    $.__views.addressContainer && $.addTopLevelView($.__views.addressContainer);
    $.__views.addressSelector = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        bottom: "10dp",
        left: Alloy.Globals.Style.Size.Width.pct4,
        height: "105dp",
        id: "addressSelector"
    });
    $.__views.addressContainer.add($.__views.addressSelector);
    $.__views.__alloyId518 = Ti.UI.createTextField({
        paddingLeft: "10dp",
        height: "1px",
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        width: "1px",
        softKeyboardOnFocus: Ti.UI.Android.SOFT_KEYBOARD_HIDE_ON_FOCUS,
        id: "__alloyId518"
    });
    $.__views.addressSelector.add($.__views.__alloyId518);
    $.__views.locationLabel = Ti.UI.createLabel({
        color: "#333",
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: 0,
        left: 0,
        height: "40dp",
        font: {
            fontSize: "18dp"
        },
        text: L("widget_set_location_label"),
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_BOTTOM,
        id: "locationLabel"
    });
    $.__views.addressSelector.add($.__views.locationLabel);
    $.__views.locationSelector = Ti.UI.createTextField({
        paddingLeft: "10dp",
        height: "60dp",
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: "45dp",
        left: 0,
        hintText: L("widget_set_location_placeholder"),
        borderColor: "#333",
        borderWidth: "1dp",
        softKeyboardOnFocus: Ti.UI.Android.SOFT_KEYBOARD_SHOW_ON_FOCUS,
        id: "locationSelector"
    });
    $.__views.addressSelector.add($.__views.locationSelector);
    $.__views.addressTable = Ti.UI.createTableView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: "105dp",
        backgroundColor: "transparent",
        separatorColor: "transparent",
        separatorInsets: {
            left: 0,
            right: 0
        },
        height: Ti.UI.FILL,
        visible: false,
        id: "addressTable"
    });
    $.__views.addressContainer.add($.__views.addressTable);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, Q = require("vendor/q"), AnimatedBottomView = require("/ui/common/animated_bottom_view"), GPS = require("/gps/gps_manager"), css = require("/ui/css"), gpsLocation = require("/gps/location");
    exports = new (require("/carmalib/controller").extend($, {
        _viewAnimation: null,
        _locationSelectorBlurHasFocus: false,
        _inScroll: false,
        _favoriteLocations: null,
        _favoriteLocationsRows: [],
        _tableRow: null,
        _arrowLabel: null,
        _addressLabel: null,
        _topWindow: null,
        events: {
            "focus locationSelector": "_locationSelectorFocus",
            "blur locationSelector": "_locationSelectorBlur",
            "click addressTable": "_rowSelected",
            "scroll addressTable": "_scrollAddressTable",
            "scrollend addressTable": "_scrollEndAddressTable"
        },
        initialize: function() {
            _.bindAll(this, "_renderAddresses", "_clearAddressTable", "_placeSearch", "_geocoding", "_useLocation", "_locationSelectorFocus", "_locationSelectorBlur", "_scrollAddressTable", "_scrollEndAddressTable", "_loadCurrentLocation", "_displayCurrentLocationRow", "_focusEventHandler", "onDestroy", "_androidBackHandler");
            this._customiseUI();
            this._setupViewAnimation();
            var self = this;
            $.locationSelector.addEventListener("focus", this._focusEventHandler);
            $.locationSelector.addEventListener("change", this._placeSearch);
        },
        _focusEventHandler: function() {
            $.locationSelector.removeEventListener("focus", this._focusEventHandler);
            this._loadFavoriteLocations();
        },
        setAddress: function(address) {
            var self = this;
            $.locationSelector.removeEventListener("change", this._placeSearch);
            $.locationSelector.value = address;
            setTimeout(function() {
                $.locationSelector.addEventListener("change", self._placeSearch);
            }, 500);
        },
        focusTextfield: function() {
            var value = $.locationSelector.value;
            $.locationSelector.setSelection(value.length, value.length);
            setTimeout(function() {
                $.locationSelector.focus();
            }, 200);
        },
        _androidFix: function() {
            var ui = require("/utils/ui");
            this._topWindow = ui.getWindow($.addressContainer);
            this._topWindow.addEventListener("androidback", this._androidBackHandler);
        },
        _androidBackHandler: function() {
            this._clearAddressTable();
        },
        _customiseUI: function() {
            args.label && ($.locationLabel.text = args.label);
            args.hintText && ($.locationSelector.hintText = args.hintText);
            if (args.hideLabel) {
                $.locationLabel.hide();
                $.locationSelector.top = 0;
                $.addressTable.top = "65dp";
            }
            var styles = null;
            styles = args.darkTheme ? {
                "#addressTable": {
                    separatorColor: "#333"
                },
                "#locationSelector": {
                    borderColor: "#333"
                },
                "#locationLabel": {
                    color: "#333"
                }
            } : {
                "#addressTable": {
                    separatorColor: "#fff"
                },
                "#locationSelector": {
                    borderColor: "#fff"
                },
                "#locationLabel": {
                    color: "#fff"
                }
            };
            css.setStyle($, styles);
        },
        _setupViewAnimation: function() {
            var animated = "animated" in args ? args.animated : true;
            if (!animated) {
                $.addressSelector.top = 0;
                return;
            }
            var self = this;
            $.addressContainer.addEventListener("postlayout", function handler() {
                $.addressContainer.removeEventListener("postlayout", handler);
                var containerHeight = $.addressContainer.size.height;
                if (containerHeight > 0) {
                    var bottomWhenViewOnTop = containerHeight - $.addressSelector.size.height;
                    self._viewAnimation = new AnimatedBottomView();
                    self._viewAnimation.setup({
                        container: $.addressSelector,
                        triggers: [ $.locationSelector ],
                        bottomWhenViewOnTop: bottomWhenViewOnTop,
                        bottom: "10dp",
                        beforeMoveToBottom: self._beforeMoveToBottom
                    });
                    self._androidFix();
                }
            });
        },
        _placeSearch: function() {
            var keyword = $.locationSelector.value;
            if (0 === keyword.length) {
                this._renderAddresses({
                    result: this._favoriteLocations,
                    favorite: true
                });
                return;
            }
            if (keyword.length < 2) {
                $.addressTable.data = [];
                return;
            }
            var self = this, lastLocation = GPS.lastLocation() || {}, hashKey = "Addresses: " + JSON.stringify({
                input: keyword,
                latitude: Math.round(100 * lastLocation.lat) / 100,
                longitude: Math.round(100 * lastLocation.lon) / 100,
                country: GeoIPCountryCode
            }), placeSearchParams = {
                input: keyword,
                latitude: lastLocation.lat,
                longitude: lastLocation.lon,
                country: GeoIPCountryCode
            };
            var previousAddresses = Ti.App.Properties.getString(hashKey);
            if (previousAddresses) {
                self._renderAddresses(JSON.parse(previousAddresses));
                return;
            }
            gpsLocation.placeSearch(placeSearchParams).then(function(data) {
                return self._geocoding(data, keyword);
            }, function(data) {
                return self._geocoding(data, keyword);
            }).then(function(addresses) {
                Ti.App.Properties.setString(hashKey, JSON.stringify(addresses));
                $.locationSelector.value === keyword && self._renderAddresses(addresses);
            }).catch(function(e) {
                $.addressTable.data = [];
                LOGGER.error("Error getting location: " + JSON.stringify(e));
            });
        },
        _geocoding: function(data, keyword) {
            if (data.result && data.result.length > 0) return data;
            return gpsLocation.geocode({
                address: keyword,
                regionCode: GeoIPCountryCode
            });
        },
        _renderAddresses: function(data) {
            data = data || {};
            if (!data.result) return;
            var rows = [];
            if (data.favorite) {
                this._favoriteLocationsRows = this._favoriteLocationsRows.length ? this._favoriteLocationsRows : this._buildRowsForFavorite(data);
                rows = this._favoriteLocationsRows;
            }
            _.each(data.result, function(address) {
                var tableRow = Ti.UI.createTableViewRow({
                    reference: address.reference,
                    lat: address.lat || address.latitude,
                    lon: address.lon || address.longitude,
                    className: "geocoding",
                    address: address.address
                });
                var addressLabel = Ti.UI.createLabel({
                    top: 0,
                    width: "100%",
                    height: "46dp",
                    color: args.darkTheme ? Alloy.Globals.Style.Color.DarkGray : "#fff",
                    text: address.address,
                    font: {
                        fontSize: "18dp"
                    }
                });
                var separator = Ti.UI.createView({
                    bottom: 0,
                    height: "1px",
                    backgroundColor: "#333",
                    width: "100%"
                });
                tableRow.add(addressLabel);
                tableRow.add(separator);
                rows.push(tableRow);
            });
            LOGGER.debug("[Location] setting data to table...");
            $.addressTable.data = rows;
            $.addressTable.visible = true;
        },
        _scrollAddressTable: function() {
            if (this._locationSelectorBlurHasFocus && !this._inScroll) {
                $.locationSelector.blur();
                Ti.UI.Android.hideSoftKeyboard();
            }
            this._inScroll = true;
        },
        _scrollEndAddressTable: function() {
            this._inScroll = false;
        },
        _beforeMoveToBottom: function() {
            if ($.addressTable.visible) return false;
        },
        _rowSelected: function(e) {
            var row = e.row;
            if (false === row.touchEnabled) return;
            if (!(row.reference || row.lat && row.lon && row.address)) return;
            $.locationSelector.blur();
            var location = {
                reference: row.reference,
                lat: row.lat,
                lon: row.lon,
                latitude: row.lat,
                longitude: row.lon,
                address: row.address,
                timestamp: Date.now(),
                accuracy: 3e3
            };
            this.setAddress(location.address);
            this._startSpinner(location).then(this._getLatLon).then(this._useLocation).then(this._clearAddressTable).catch(this._handleError).finally(this._stopSpinner);
        },
        _startSpinner: function(location) {
            return Q.fcall(function() {
                Ti.App.fireEvent("carma:progress.start");
                return location;
            });
        },
        _stopSpinner: function() {
            Ti.App.fireEvent("carma:progress.stop");
        },
        _getLatLon: function(location) {
            if (!location.reference) return location;
            var deferred = Q.defer();
            gpsLocation.placeDetails({
                reference: location.reference
            }).then(function(data) {
                location.lat = data.result.lat;
                location.lon = data.result.lon;
                location.timestamp = Date.now();
                location.accuracy = 3e3;
                delete location.reference;
                deferred.resolve(location);
            }).catch(function(e) {
                LOGGER.error(e);
                deferred.reject();
            });
            return deferred.promise;
        },
        _locationSelectorFocus: function() {
            this._locationSelectorBlurHasFocus = true;
            this._placeSearch();
        },
        _locationSelectorBlur: function() {
            this._locationSelectorBlurHasFocus = false;
        },
        _useLocation: function(location) {
            args.success && args.success(location);
            return true;
        },
        _clearAddressTable: function(forceDown) {
            $.addressTable.visible = false;
            this._viewAnimation && ($.locationSelector.value.length < 1 || forceDown) && this._viewAnimation.forceMoveViewToBottom();
        },
        _handleError: function(error) {
            LOGGER.error("Error resolving location: " + JSON.stringify(error));
        },
        _loadFavoriteLocations: function() {
            var self = this;
            require("services/favourite_locations_service").getFavouriteLocations().progress(function(data) {
                self._favoriteLocations = data.location;
                "" === $.locationSelector.value && self._renderAddresses({
                    result: self._favoriteLocations,
                    favorite: true
                });
            }).then(function(update) {
                self._favoriteLocations = update && update.location || self._favoriteLocations;
                "" === $.locationSelector.value && self._renderAddresses({
                    result: self._favoriteLocations,
                    favorite: true
                });
            }).catch(function(err) {
                LOGGER.error("ERROR GETING FAVS:" + JSON.stringify(err));
            });
        },
        _buildRowsForFavorite: function(data) {
            data = data || {};
            var rows = [];
            require("/gps/gps_service").isLocationServiceEnabled() && this._buildCurrentLocationRow();
            data.result && data.result.length && rows.push(this._buildRecentLocationsTitle());
            return rows;
        },
        _buildCurrentLocationRow: function() {
            var tableRow = Ti.UI.createTableViewRow({
                lat: 0,
                lon: 0,
                address: null
            });
            var arrowLabel = Ti.UI.createLabel({
                top: 0,
                left: 0,
                height: "46dp",
                width: "30dp",
                textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
                color: "#99ccff",
                text: "k",
                font: {
                    fontFamily: "splinico",
                    fontSize: "18dp"
                },
                opacity: 0
            });
            var addressLabel = Ti.UI.createLabel({
                top: 0,
                left: "30dp",
                height: "46dp",
                color: "#99ccff",
                text: L("current_location"),
                font: {
                    fontSize: "18dp"
                }
            });
            var separator = Ti.UI.createView({
                bottom: 0,
                height: "1px",
                backgroundColor: "#333",
                width: "100%"
            });
            tableRow.add(arrowLabel);
            tableRow.add(addressLabel);
            tableRow.add(separator);
            this._tableRow = tableRow;
            this._arrowLabel = arrowLabel;
            this._addressLabel = addressLabel;
            this._loadCurrentLocation();
            return tableRow;
        },
        _buildRecentLocationsTitle: function() {
            var separator = Ti.UI.createView({
                bottom: 0,
                height: "1px",
                backgroundColor: "#333",
                width: "100%"
            });
            var tableRow = Ti.UI.createTableViewRow({
                className: "geocoding",
                touchEnabled: false,
                selectionStyle: null
            });
            var addressLabel = Ti.UI.createLabel({
                width: "100%",
                height: "46dp",
                color: args.darkTheme ? Alloy.Globals.Style.Color.DarkGray : "#fff",
                text: L("widget_set_location_recent_locations"),
                font: {
                    fontSize: "18dp",
                    fontWeight: "bold"
                }
            });
            tableRow.add(addressLabel);
            tableRow.add(separator);
            return tableRow;
        },
        _loadCurrentLocation: function() {
            var gps = require("gps/gps_manager"), currentLocation = gps.lastLocation(), locationValidator = require("/validator/validator_factory").currentLocation(), self = this;
            if (!locationValidator.isLocationValidForPickupDropoff(currentLocation, true)) {
                self._displayErrorStatus();
                return;
            }
            this._tableRow.lat = currentLocation.lat;
            this._tableRow.lon = currentLocation.lon;
            require("/gps/location").reverseGeocode({
                latitude: currentLocation.lat,
                longitude: currentLocation.lon
            }).then(this._displayCurrentLocationRow).catch(function() {
                self._displayErrorStatus();
            });
        },
        _displayCurrentLocationRow: function(data) {
            if (!data || !data.result || !data.result.address) return;
            if (data.result.address === this._tableRow.address) return;
            this._tableRow.address = data.result.address;
            this._favoriteLocationsRows.unshift(this._tableRow);
            this._showArrowLbl(false);
            this._updateAddressLblText(data.result.address, false);
            var section = $.addressTable.data[0] || null, currentLocationRow = section ? section.rows[0] : null;
            currentLocationRow != this._tableRow && $.addressTable.insertRowBefore(0, this._tableRow, {
                animated: false
            });
        },
        _displayErrorStatus: function() {},
        _showArrowLbl: function(error) {
            this._arrowLabel.color = error ? "red" : "#99ccff";
            var self = this;
            this._arrowLabel.animate({
                opacity: 1,
                duration: 500
            }, function() {
                self._arrowLabel.opacity = 1;
            });
            setTimeout(function() {
                self._arrowLabel.opacity = 1;
            }, 600);
        },
        _updateAddressLblText: function(text, error) {
            this._addressLabel.applyProperties({
                opacity: 0,
                text: text,
                color: error ? "red" : "#99ccff"
            });
            var self = this;
            this._addressLabel.animate({
                opacity: 1,
                duration: 500
            }, function() {
                self._addressLabel.opacity = 1;
            });
            setTimeout(function() {
                self._addressLabel.opacity = 1;
            }, 600);
        },
        _addCurrentLocationUpdateListener: function() {
            Ti.App.addEventListener("carma:valid.location.update", this._loadCurrentLocation);
        },
        onDestroy: function() {
            Ti.App.removeEventListener("carma:valid.location.update", this._loadCurrentLocation);
            $.locationSelector.removeEventListener("focus", this._focusEventHandler);
            $.locationSelector.removeEventListener("change", this._placeSearch);
            this._topWindow.removeEventListener("androidback", this._androidBackHandler);
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;