function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.login/" + s : s.substring(0, index) + "/ma.car.app.login/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.login");
    this.__widgetId = "ma.car.app.login";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "forgotPassword";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.forgotPasswordContainer = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.pct100,
        top: 0,
        left: 0,
        height: "100%",
        id: "forgotPasswordContainer"
    });
    $.__views.forgotPasswordContainer && $.addTopLevelView($.__views.forgotPasswordContainer);
    $.__views.forgotPasswordView = Ti.UI.createScrollView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        bottom: 0,
        left: Alloy.Globals.Style.Size.Width.pct4,
        height: "290dp",
        showVerticalScrollIndicator: false,
        showHorizontalScrollIndicator: false,
        contentHeight: "320dp",
        contentWidth: "99%",
        scrollingEnabled: "false",
        scrollType: "vertical",
        id: "forgotPasswordView"
    });
    $.__views.forgotPasswordContainer.add($.__views.forgotPasswordView);
    $.__views.__alloyId0 = Ti.UI.createTextField({
        paddingLeft: "10dp",
        height: "1px",
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        width: "1px",
        softKeyboardOnFocus: Ti.UI.Android.SOFT_KEYBOARD_HIDE_ON_FOCUS,
        id: "__alloyId0"
    });
    $.__views.forgotPasswordView.add($.__views.__alloyId0);
    $.__views.resetPassword = Ti.UI.createLabel({
        color: "#fff",
        width: Alloy.Globals.Style.Size.Width.grid11,
        font: {
            fontSize: "15dp"
        },
        top: "50dp",
        text: L("widget_login_msg_reset_password"),
        id: "resetPassword"
    });
    $.__views.forgotPasswordView.add($.__views.resetPassword);
    $.__views.email = require("/ui/common/custom_textfield").createTextField({
        paddingLeft: "10dp",
        height: "60dp",
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: "105dp",
        hintText: L("widget_login_input_hint_email"),
        keyboardType: Ti.UI.KEYBOARD_EMAIL,
        returnKeyType: Ti.UI.RETURNKEY_GO,
        id: "email"
    });
    $.__views.forgotPasswordView.add($.__views.email);
    $.__views.submit = require("/ui/common/custom_button").createButton({
        width: Alloy.Globals.Style.Size.Width.grid11,
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "60dp",
        font: {
            fontSize: "18dp"
        },
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        top: "180dp",
        title: L("widget_login_button_reset_password"),
        id: "submit"
    });
    $.__views.forgotPasswordView.add($.__views.submit);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, Q = require("vendor/q"), Validator = require("/validator/validator_factory"), ErrorDialog = require("/ui/common/validation_error"), AnimatedBottomView = require("/ui/common/animated_bottom_view"), navigation = Alloy.Globals.Nav.Login;
    exports = new (require("/carmalib/controller").extend($, {
        _resetRequest: null,
        events: {
            "return email": "_resetPassword",
            "click[ios] submit": "_resetPassword",
            "click[android] submit": "_resetPassword"
        },
        initialize: function() {
            _.bindAll(this, "_reset", "_resetSuccess", "_resetError", "_stopSpinner", "_resetPassword");
            this._initModels();
            this._setupViewAnimation();
            this._prefillEmail();
        },
        _initModels: function() {
            this._resetRequest = Widget.createModel("resetrequest");
        },
        _setupViewAnimation: function() {
            return;
        },
        _prefillEmail: function() {
            var email = args.email;
            Validator.string().isEmpty(email) || ($.email.value = email);
        },
        _resetPassword: function() {
            $.email.clearError();
            if (Validator.form().checkCustomTextFieldsEmpty([ $.email ])) {
                ErrorDialog.show();
                return;
            }
            var email = $.email.value;
            if (!Validator.string().isEmpty(email) && !Validator.email().isEmail(email)) {
                $.email.showError(L("widget_login_error_invalid_email"));
                ErrorDialog.show();
                return;
            }
            this._startSpinner().then(this._reset).then(this._resetSuccess).catch(this._resetError);
        },
        _startSpinner: function() {
            return Q.fcall(function() {
                Ti.App.fireEvent("carma:progress.start");
                return true;
            });
        },
        _reset: function() {
            var email = $.email.value;
            this._resetRequest.clear();
            return this._resetRequest.save({
                identity: {
                    type: "PRIMARY_EMAIL",
                    key: email
                },
                template: "password_renewal_request_rtr_mobile_web"
            });
        },
        _resetSuccess: function() {
            var dialog = Ti.UI.createAlertDialog({
                buttonNames: [ L("widget_login_popup_title_reset_button_ok") ],
                title: L("widget_login_popup_title_reset_requested"),
                message: L("widget_login_popup_message_reset_requested")
            });
            var self = this;
            dialog.addEventListener("click", function(e) {
                self._stopSpinner();
                navigation.back();
            });
            dialog.show();
        },
        _resetError: function(error) {
            this._stopSpinner();
            LOGGER.info("Error to be handled....");
            var errorMessage = "";
            errorMessage = L(404 === error.status ? "widget_login_error_email_not_exist" : "widget_login_error_forgotpassword_uknown");
            ErrorDialog.showSimple(errorMessage);
        },
        _stopSpinner: function() {
            Ti.App.fireEvent("carma:progress.stop");
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;