function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.login/" + s : s.substring(0, index) + "/ma.car.app.login/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.login");
    this.__widgetId = "ma.car.app.login";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "resetPassword";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.resetPasswordContainer = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.pct100,
        top: 0,
        left: 0,
        height: "100%",
        id: "resetPasswordContainer"
    });
    $.__views.resetPasswordContainer && $.addTopLevelView($.__views.resetPasswordContainer);
    $.__views.resetPasswordView = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        bottom: 0,
        left: Alloy.Globals.Style.Size.Width.pct4,
        height: "310dp",
        id: "resetPasswordView"
    });
    $.__views.resetPasswordContainer.add($.__views.resetPasswordView);
    $.__views.__alloyId3 = Ti.UI.createTextField({
        paddingLeft: "10dp",
        height: "1px",
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        width: "1px",
        softKeyboardOnFocus: Ti.UI.Android.SOFT_KEYBOARD_HIDE_ON_FOCUS,
        id: "__alloyId3"
    });
    $.__views.resetPasswordView.add($.__views.__alloyId3);
    $.__views.resetPasswordDesc = Ti.UI.createLabel({
        color: "#fff",
        width: Alloy.Globals.Style.Size.Width.grid11,
        font: {
            fontSize: "15dp"
        },
        top: "10dp",
        text: L("widget_login_resetpassword_desc"),
        id: "resetPasswordDesc"
    });
    $.__views.resetPasswordView.add($.__views.resetPasswordDesc);
    $.__views.password = require("/ui/common/custom_textfield").createTextField({
        paddingLeft: "10dp",
        height: "60dp",
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: "80dp",
        hintText: L("widget_login_resetpassword_password_hint"),
        passwordMask: true,
        returnKeyType: Ti.UI.RETURNKEY_NEXT,
        id: "password"
    });
    $.__views.resetPasswordView.add($.__views.password);
    $.__views.repassword = require("/ui/common/custom_textfield").createTextField({
        paddingLeft: "10dp",
        height: "60dp",
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: "150dp",
        hintText: L("widget_login_resetpassword_repasword_hint"),
        passwordMask: true,
        returnKeyType: Ti.UI.RETURNKEY_GO,
        id: "repassword"
    });
    $.__views.resetPasswordView.add($.__views.repassword);
    $.__views.submit = require("/ui/common/custom_button").createButton({
        width: Alloy.Globals.Style.Size.Width.grid11,
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "60dp",
        font: {
            fontSize: "18dp"
        },
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        top: "220dp",
        title: L("widget_login_resetpassword_button_submit"),
        id: "submit"
    });
    $.__views.resetPasswordView.add($.__views.submit);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var Q = require("vendor/q"), navigation = Alloy.Globals.Nav.Login, Validator = require("/validator/validator_factory"), FieldsRoller = require("/ui/common/fields_roller"), ErrorDialog = require("/ui/common/validation_error"), AnimatedBottomView = require("/ui/common/animated_bottom_view"), args = arguments[0] || {};
    exports = new (require("/carmalib/controller").extend($, {
        _resetConfirm: null,
        _token: null,
        _email: null,
        events: {
            "return repassword": "_resetPassword",
            "click[ios] submit": "_resetPassword",
            "click[android] submit": "_resetPassword"
        },
        initialize: function() {
            _.bindAll(this, "_reset", "_resetSuccess", "_resetError", "_stopSpinner", "_resetPassword");
            LOGGER.info("[resetPassword] - path: " + args.path);
            this._initUrlParams(args.path);
            LOGGER.info("[resetPassword] - email: " + this._email + ", token: " + this._token);
            this._initModels();
            this._setupViewAnimation();
            new FieldsRoller([ {
                from: $.password,
                to: $.repassword
            } ]);
        },
        _initUrlParams: function(url) {
            if (!url) return;
            this._email = this._getUrlParma("email", url);
            this._token = this._getUrlParma("token", url);
        },
        _getUrlParma: function(key, url) {
            if (!url) return;
            var match = url.match("[?&]" + key + "=([^&#]+)");
            return match ? match[1] : null;
        },
        _initModels: function() {
            this._resetConfirm = Widget.createModel("resetpasswordconfirm");
        },
        _setupViewAnimation: function() {
            return;
        },
        _resetPassword: function() {
            $.password.clearError();
            $.password.blur();
            $.repassword.clearError();
            $.repassword.blur();
            if (!this._email || !this._token) {
                Ti.UI.createAlertDialog({
                    message: "Something wrong with your reset password link, try to regain it."
                }).show();
                return;
            }
            if (Validator.form().checkCustomTextFieldsEmpty([ $.password, $.repassword ])) {
                ErrorDialog.show();
                return;
            }
            var password = $.password.value, repassword = $.repassword.value;
            if (password.length < 6) {
                $.password.showError(L("widget_login_resetpassword_field_error_restriction"));
                ErrorDialog.show();
                return;
            }
            if (password !== repassword) {
                $.repassword.showError(L("widget_login_resetpassword_field_error_not_match"));
                ErrorDialog.show();
                return;
            }
            var network = require("/bootstrap/network");
            network.isConnected() ? this._startSpinner().then(this._reset).then(this._resetSuccess).catch(this._resetError) : this._resetError({
                errorCode: "network_offline"
            });
        },
        _startSpinner: function() {
            return Q.fcall(function() {
                Ti.App.fireEvent("carma:progress.start");
                return true;
            });
        },
        _reset: function() {
            var password = $.password.value;
            this._resetConfirm.clear();
            return this._resetConfirm.resetPassword(this._email, this._token, password);
        },
        _resetSuccess: function() {
            var dialog = Ti.UI.createAlertDialog({
                buttonNames: [ L("widget_login_resetpassword_success_button") ],
                title: L("widget_login_resetpassword_success_title"),
                message: L("widget_login_resetpassword_success_message")
            });
            var self = this;
            dialog.addEventListener("click", function() {
                self._stopSpinner();
                if (navigation.getPreviousView()) navigation.back(); else {
                    navigation.open(Alloy.createWidget("ma.car.app.login", "login"), {
                        title: L("widget_login_title_login")
                    });
                    navigation.clearHistory(1);
                }
            });
            dialog.show();
        },
        _resetError: function(error) {
            this._stopSpinner();
            LOGGER.info("[ResetPassword] - Error handler: " + error.errorCode);
            var errorMessage = "";
            errorMessage = L("reset_request_not_found" === error.errorCode ? "widget_login_resetpassword_error_expired" : "network_offline" === error.errorCode ? "widget_login_resetpassword_error_network" : "widget_login_resetpassword_error_general");
            Ti.UI.createAlertDialog({
                title: L("widget_login_resetpassword_error_title"),
                message: errorMessage,
                buttonNames: [ L("widget_login_resetpassword_error_button") ]
            }).show();
        },
        _stopSpinner: function() {
            Ti.App.fireEvent("carma:progress.stop");
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;