var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            url: "OAUTH_TOKEN",
            parse: function(response) {
                if (response.access_token && response.expires_in) return {
                    token: response.access_token,
                    expiresIn: response.expires_in
                };
                return {};
            },
            requestToken: function(email, password, options) {
                var oauth = require("bootstrap/env").getOAuth();
                var request = {
                    client_id: oauth.clientId,
                    client_secret: oauth.secret,
                    grant_type: "password",
                    username: email,
                    password: password
                };
                options = options || {};
                options.headers = {
                    "Content-Type": "application/x-www-form-urlencoded"
                };
                return this.save(request, options);
            }
        });
        return Model;
    }
};

model = Alloy.M("oauthtoken", exports.definition, []);

collection = Alloy.C("oauthtoken", exports.definition, model);

exports.Model = model;

exports.Collection = collection;