var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            url: "PASSWORD_RESET_CONFIRM",
            resetPassword: function(email, token, newPassword, options) {
                if (!email || !token || !newPassword) return;
                options = options || {};
                var request = {
                    identity: {
                        type: "PRIMARY_EMAIL",
                        key: email
                    },
                    token: token,
                    newPassword: newPassword,
                    template: "password_renewal_confirm_rtr_mobile_web"
                };
                return this.save(request, options);
            }
        });
        return Model;
    }
};

model = Alloy.M("resetpasswordconfirm", exports.definition, []);

collection = Alloy.C("resetpasswordconfirm", exports.definition, model);

exports.Model = model;

exports.Collection = collection;