function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.messenger/" + s : s.substring(0, index) + "/ma.car.app.messenger/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.messenger");
    this.__widgetId = "ma.car.app.messenger";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.messagesWindow = require("/ui/common/child_window").createView({
        width: Ti.UI.FILL,
        height: Ti.UI.FILL,
        left: 0,
        top: 0,
        backgroundColor: "white",
        id: "messagesWindow"
    });
    $.__views.messagesWindow && $.addTopLevelView($.__views.messagesWindow);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, navigation = Alloy.Globals.Nav.Messages = Alloy.createController("navigation"), chatWidget = null;
    exports = new (require("/carmalib/controller").extend($, {
        _opened: false,
        _messageCenter: null,
        initialize: function() {
            _.bindAll(this, "open", "reset");
            this._initWidget();
        },
        _initWidget: function() {
            var self = this, widget = Alloy.createWidget("ma.car.app.messenger", "messageCenter");
            this._messageCenter = widget;
            $.messagesWindow.addEventListener("open", function handler() {
                $.messagesWindow.removeEventListener("open", handler);
                self._opened = true;
                setTimeout(function() {
                    widget.init();
                }, 500);
            });
            $.messagesWindow.addEventListener("close", function closeHandler() {
                $.messagesWindow.removeEventListener("close", closeHandler);
                widget.onDestroy();
                widget = null;
            });
            this._initNavigation(widget);
        },
        _initNavigation: function(messageView) {
            navigation.init({
                index: messageView,
                historyLimit: 20,
                mainWindow: $.messagesWindow,
                handleClose: args.handleClose,
                transition: "none",
                disableBack: true,
                navBarVisible: true,
                title: L("widget_messenger_messages_title_uppercase"),
                around: args.around,
                clearMemory: false
            });
        },
        open: function(params) {
            params = params || {};
            if (params.threadId) {
                chatWidget = chatWidget || Alloy.createWidget("ma.car.app.messenger", "chat");
                var deferred = chatWidget.loadChat(params);
                if (navigation.hasHistory()) return;
                var navigateToChat = function() {
                    var options = {
                        navBarVisible: true
                    }, title = params.title || params.alias;
                    title && (options.title = title.toUpperCase());
                    navigation.open(chatWidget, options, function() {
                        try {
                            params.callback && params.callback();
                        } finally {
                            Ti.App.fireEvent("carma:chat.opened");
                        }
                    });
                };
                this._opened ? navigateToChat() : $.messagesWindow.addEventListener("open", function handler() {
                    $.messagesWindow.removeEventListener("open", handler);
                    navigateToChat();
                });
            }
            this._opened || $.messagesWindow.open();
        },
        reset: function() {
            navigation && navigation.hasHistory() ? navigation.canGoBack() && navigation.backTo(0) : this._messageCenter.reset();
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;