function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.people/" + s : s.substring(0, index) + "/ma.car.app.people/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.people");
    this.__widgetId = "ma.car.app.people";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "people";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.peopleContainer = Ti.UI.createView({
        layout: "vertical",
        width: "100%",
        height: "100%",
        id: "peopleContainer"
    });
    $.__views.peopleContainer && $.addTopLevelView($.__views.peopleContainer);
    $.__views.inputPeople = Ti.UI.createTextField({
        paddingLeft: "10dp",
        height: "60dp",
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        width: Alloy.Globals.Style.Size.Width.grid11,
        borderWidth: 1,
        borderColor: "#a4a4a4",
        id: "inputPeople"
    });
    $.__views.peopleContainer.add($.__views.inputPeople);
    $.__views.scrollView = Ti.UI.createScrollView({
        showVerticalScrollIndicator: false,
        showHorizontalScrollIndicator: false,
        backgroundColor: "transparent",
        width: "100%",
        layout: "vertical",
        id: "scrollView"
    });
    $.__views.peopleContainer.add($.__views.scrollView);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, gps = require("gps/gps_manager"), locationValidator = require("/validator/validator_factory").currentLocation();
    exports = new (require("/carmalib/controller").extend($, {
        currentKeyword: "",
        initialize: function() {
            _.bindAll(this, "_placeSearch", "_renderSearchUsers", "onFocus", "onDestroy");
            $.inputPeople.addEventListener("change", this._placeSearch);
            $.scrollView.addEventListener("touchstart", this._hideKeyBoard);
            $.scrollView.addEventListener("scroll", this._hideKeyBoard);
            $.inputPeople.addEventListener("postlayout", this.onFocus);
        },
        onFocus: function() {
            $.inputPeople.removeEventListener("postlayout", this.onFocus);
            $.inputPeople.focus();
        },
        onDestroy: function() {
            $.inputPeople.removeEventListener("change", this._placeSearch);
            $.scrollView.removeEventListener("touchstart", this._hideKeyBoard);
            $.scrollView.removeEventListener("scroll", this._hideKeyBoard);
            $.inputPeople.removeEventListener("postlayout", this.onFocus);
        },
        _hideKeyBoard: function() {
            $.inputPeople.blur();
        },
        _placeSearch: function(data) {
            if (data.value && data.value.length > 2) {
                var lastLocation = gps.lastLocation() || {}, self = this, inputKeyword = data.value;
                this.currentKeyword = data.value;
                Alloy.createModel("user_search").search(data.value, locationValidator.isGPSPositionValid(lastLocation, true) ? lastLocation : null).then(function(data) {
                    setTimeout(function() {
                        self.currentKeyword === inputKeyword && self._renderSearchUsers(data);
                    }, 200);
                }).catch(function() {
                    LOGGER.info("[favorites/add_favorite.js] - error fetching search users");
                });
            }
        },
        _renderSearchUsers: function(data) {
            var users = data.users;
            var container = $.scrollView;
            container.removeAllChildren();
            _.each(users, function(user) {
                var userRow = Alloy.createWidget("ma.car.app.people", "people_row", user);
                container.add(userRow.getView());
            });
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;