function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.people/" + s : s.substring(0, index) + "/ma.car.app.people/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.people");
    this.__widgetId = "ma.car.app.people";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "people_row";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.userRowContainer = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        height: "81dp",
        id: "userRowContainer"
    });
    $.__views.userRowContainer && $.addTopLevelView($.__views.userRowContainer);
    $.__views.userPhoto = Ti.UI.createImageView({
        defaultImage: "/images/default_photo_female-rounded.png",
        top: "10dp",
        left: "0dp",
        width: "60dp",
        height: "60dp",
        borderRadius: Alloy.Globals.Style.Unit.unit30,
        borderColor: "#fff",
        borderWidth: "1dp",
        id: "userPhoto"
    });
    $.__views.userRowContainer.add($.__views.userPhoto);
    $.__views.userAlias = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        left: "70dp",
        top: "34dp",
        font: {
            fontSize: "13dp"
        },
        id: "userAlias"
    });
    $.__views.userRowContainer.add($.__views.userAlias);
    $.__views.favoriteIcon = require("/ui/common/tactile_label").createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        font: {
            fontFamily: "splinico",
            fontSize: "24dp"
        },
        text: "j",
        top: "15dp",
        right: "15dp",
        width: "50dp",
        height: "50dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_CENTER,
        visible: false,
        id: "favoriteIcon"
    });
    $.__views.userRowContainer.add($.__views.favoriteIcon);
    $.__views.userRowHr = Ti.UI.createView({
        width: "100%",
        top: "80dp",
        left: 0,
        height: "2dp",
        backgroundColor: Alloy.Globals.Style.Color.DarkGray,
        id: "userRowHr"
    });
    $.__views.userRowContainer.add($.__views.userRowHr);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, Q = require("/vendor/q");
    exports = new (require("/carmalib/controller").extend($, {
        events: {
            "click[ios] userRowContainer": "_showProfile",
            "click[android] userRowContainer": "_showProfile"
        },
        initialize: function() {
            this._renderUser(args);
        },
        _renderUser: function(args) {
            var photoCache = require("/utils/photoCache"), url = require("/utils/photoURL").toURL(args.photoUrl, {
                width: 60,
                height: 60
            });
            var photoPath = photoCache.getCached(url);
            if (photoPath) $.userPhoto.image = photoPath; else {
                if ("m" === args.gender) {
                    $.userPhoto.image = WPATH("/images/photo_picker_male.png");
                    $.userPhoto.defaultImage = WPATH("/images/photo_picker_male.png");
                } else {
                    $.userPhoto.image = WPATH("/images/photo_picker_female.png");
                    $.userPhoto.defaultImage = WPATH("/images/photo_picker_female.png");
                }
                photoCache.downloadAvatar(url).then(function(url) {
                    $.userPhoto.image = url;
                });
            }
            $.userAlias.text = args.alias;
            args.isFavourite && ($.favoriteIcon.visible = true);
        },
        _showProfile: function() {
            Ti.App.fireEvent("carma:profile.open", {
                userId: args.userId
            });
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;