function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.picker/" + s : s.substring(0, index) + "/ma.car.app.picker/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.picker");
    this.__widgetId = "ma.car.app.picker";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.overlay = Ti.UI.createView({
        backgroundColor: "#80000000",
        zIndex: 5,
        opacity: 0,
        visible: false,
        id: "overlay"
    });
    $.__views.overlay && $.addTopLevelView($.__views.overlay);
    $.__views.pickerContainer = Ti.UI.createView({
        width: "83.33333333333334%",
        layout: "vertical",
        backgroundColor: "#000",
        height: Ti.UI.SIZE,
        id: "pickerContainer"
    });
    $.__views.overlay.add($.__views.pickerContainer);
    $.__views.picker = Ti.UI.createPicker({
        id: "picker"
    });
    $.__views.pickerContainer.add($.__views.picker);
    $.__views.separator = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: "1px",
        backgroundColor: "#aaa",
        id: "separator"
    });
    $.__views.pickerContainer.add($.__views.separator);
    $.__views.doneButton = Ti.UI.createButton({
        title: L("widget_picker_done"),
        font: {
            fontSize: "18dp"
        },
        color: "#fff",
        right: "10dp",
        backgroundColor: "transparent",
        width: Ti.UI.FILL,
        height: "45dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        id: "doneButton"
    });
    $.__views.pickerContainer.add($.__views.doneButton);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, eventListeners = {};
    var _processArguments = function(args) {
        "pickerType" in args && $.picker.setType(args.pickerType);
    };
    var _attachEventListeners = function() {
        $.picker.addEventListener("change", function(params) {
            "change" in eventListeners && eventListeners.change(params);
        });
        $.picker.addEventListener("click", function(params) {
            "click" in eventListeners && eventListeners.click(params);
        });
        var button = $.doneButton;
        button.addEventListener("click", function() {
            exports.close();
        });
    };
    var addRow = function(items) {
        $.picker.add(items);
    };
    var openPopup = function(currentTime) {
        var value = currentTime ? currentTime : new Date();
        var callback = function(params) {
            if (params.cancel) return;
            "close" in eventListeners && eventListeners.close(params);
        };
        if ($.picker.type === Ti.UI.PICKER_TYPE_TIME) $.picker.showTimePickerDialog({
            callback: callback,
            value: value
        }); else if ($.picker.type === Ti.UI.PICKER_TYPE_DATE) $.picker.showDatePickerDialog({
            callback: callback,
            value: value
        }); else {
            $.overlay.visible = true;
            $.overlay.animate({
                opacity: 1,
                duration: 300
            });
        }
    };
    var closePopup = function() {
        function callback() {
            $.overlay.visible = false;
            "close" in eventListeners && eventListeners.close();
        }
        $.overlay.animate({
            opacity: 0,
            duration: 300
        }, callback);
    };
    _processArguments(args);
    _attachEventListeners();
    exports.add = addRow;
    exports.open = openPopup;
    exports.close = closePopup;
    exports.addEventListener = function(event, callback) {
        eventListeners[event] = callback;
    };
    exports.getHeight = function() {
        return $.iosPickerContainer.size.height;
    };
    exports.getValue = function() {
        return $.picker.getValue();
    };
    exports.getType = function() {
        return $.picker.getType();
    };
    exports.applyProperties = function(props) {
        $.picker.applyProperties(props);
    };
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;