function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.profile/" + s : s.substring(0, index) + "/ma.car.app.profile/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.profile");
    this.__widgetId = "ma.car.app.profile";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "contact";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.contactContainer = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: "10dp",
        left: Alloy.Globals.Style.Size.Width.pct4,
        height: Ti.UI.SIZE,
        id: "contactContainer"
    });
    $.__views.contactContainer && $.addTopLevelView($.__views.contactContainer);
    $.__views.separator = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: 0,
        left: 0,
        height: "2px",
        backgroundColor: Alloy.Globals.Style.Color.DarkGray,
        visible: false,
        id: "separator"
    });
    $.__views.contactContainer.add($.__views.separator);
    $.__views.actionBar = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: 0,
        left: 0,
        height: "30dp",
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        borderColor: Alloy.Globals.Style.Color.DarkGray,
        borderWidth: "1px",
        visible: false,
        id: "actionBar"
    });
    $.__views.contactContainer.add($.__views.actionBar);
    $.__views.call = require("/ui/common/custom_button").createButton({
        width: "33.33333333333333%",
        font: {
            fontSize: "15dp"
        },
        color: Alloy.Globals.Style.Color.DarkGray,
        borderRadius: 0,
        normalColor: "#00333333",
        selectedColor: "#70333333",
        backgroundImage: "none",
        borderColor: "transparent",
        borderWidth: 2,
        top: 0,
        left: 0,
        height: "30dp",
        title: L("widget_profile_action_call"),
        id: "call"
    });
    $.__views.actionBar.add($.__views.call);
    $.__views.leftSeparator = Ti.UI.createView({
        top: 0,
        height: "30dp",
        width: "1px",
        backgroundColor: Alloy.Globals.Style.Color.DarkGray,
        left: "33.3%",
        id: "leftSeparator"
    });
    $.__views.actionBar.add($.__views.leftSeparator);
    $.__views.message = require("/ui/common/custom_button").createButton({
        width: "33.33333333333333%",
        font: {
            fontSize: "15dp"
        },
        color: Alloy.Globals.Style.Color.DarkGray,
        borderRadius: 0,
        normalColor: "#00333333",
        selectedColor: "#70333333",
        backgroundImage: "none",
        borderColor: "transparent",
        borderWidth: 2,
        top: 0,
        left: "33.3%",
        height: "30dp",
        title: L("widget_profile_action_message"),
        id: "message"
    });
    $.__views.actionBar.add($.__views.message);
    $.__views.rightSeparator = Ti.UI.createView({
        top: 0,
        height: "30dp",
        width: "1px",
        backgroundColor: Alloy.Globals.Style.Color.DarkGray,
        right: "33.3%",
        id: "rightSeparator"
    });
    $.__views.actionBar.add($.__views.rightSeparator);
    $.__views.poke = require("/ui/common/custom_button").createButton({
        width: "33.33333333333333%",
        font: {
            fontSize: "15dp"
        },
        color: Alloy.Globals.Style.Color.DarkGray,
        borderRadius: 0,
        normalColor: "#00333333",
        selectedColor: "#70333333",
        backgroundImage: "none",
        borderColor: "transparent",
        borderWidth: 2,
        top: 0,
        right: 0,
        height: "30dp",
        title: L("widget_profile_action_poke"),
        id: "poke"
    });
    $.__views.actionBar.add($.__views.poke);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, trackingEvent = require("/tracking/tracking_event"), analytics = require("/tracking/tracking_manager"), Globals = require("/v6/infrastructure/Globals"), MessageService = Globals.IOC.get("messageService");
    exports = new (require("/carmalib/controller").extend($, {
        _isMyProfile: args.isMyProfile,
        _phoneNumber: 0,
        _userId: 0,
        _alias: "",
        events: {
            "click[ios] call": "_callUser",
            "click[ios] message": "_openMessages",
            "click[ios] poke": "_pokeUser",
            "click[android] call": "_callUser",
            "click[android] message": "_openMessages",
            "click[android] poke": "_pokeUser"
        },
        initialize: function() {
            _.bindAll(this, "showProfile", "_callUser");
            $.contactContainer.remove($.actionBar);
            $.contactContainer.remove($.separator);
        },
        showProfile: _.once(function(profile) {
            this._phoneNumber = profile.phoneNumber;
            this._userId = profile.userId;
            this._alias = profile.alias;
            this._showOrHideCallButton(!!this._phoneNumber);
            if (this._isMyProfile) {
                $.contactContainer.add($.separator);
                $.separator.visible = true;
            } else {
                $.contactContainer.add($.actionBar);
                $.actionBar.visible = true;
            }
        }),
        _showOrHideCallButton: function(show) {
            if (show) {
                $.call.applyProperties({
                    width: "33.333%"
                });
                $.removeClass($.message, "col-rel-6");
                $.removeClass($.poke, "col-rel-6");
                $.addClass($.message, "col-rel-4");
                $.addClass($.poke, "col-rel-4");
                $.leftSeparator.applyProperties({
                    width: "1dp"
                });
                $.rightSeparator.applyProperties({
                    left: null
                });
                $.message.applyProperties({
                    left: "33.333%"
                });
            } else {
                $.call.applyProperties({
                    width: 0
                });
                $.removeClass($.message, "col-rel-4");
                $.removeClass($.poke, "col-rel-4");
                $.addClass($.message, "col-rel-6");
                $.addClass($.poke, "col-rel-6");
                $.leftSeparator.applyProperties({
                    width: 0
                });
                $.rightSeparator.applyProperties({
                    left: "50%"
                });
                $.message.applyProperties({
                    left: 0
                });
            }
        },
        _callUser: function() {
            analytics.track(trackingEvent.CALL_USER, {
                targetUserId: this._userId
            });
            if (!this._phoneNumber) return;
            Ti.Platform.openURL("tel:" + this._phoneNumber);
        },
        _openMessages: function() {
            var userId = require("services/resource_owner_service").singleton().get("userId"), threadId = userId < this._userId ? this._userId + "_" + userId : userId + "_" + this._userId;
            Ti.App.fireEvent("carma:open.conversation", {
                threadId: threadId,
                alias: this._alias
            });
            var ui = require("utils/ui");
            var window = ui.getWindow($.contactContainer);
            if (!window || !window.close) return;
            window.close();
        },
        _pokeUser: function() {
            var self = this;
            MessageService.poke({
                recipientUser: this._userId
            }).then(function() {
                alert(String.format(L("widget_messenger_you_poked_user"), self._alias));
            }).catch(function(e) {
                LOGGER.error("[Profie] " + JSON.stringify(e));
            });
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;