function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.profile/" + s : s.substring(0, index) + "/ma.car.app.profile/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.profile");
    this.__widgetId = "ma.car.app.profile";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "map";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.mapWindow = Ti.UI.createView({
        top: 0,
        left: 0,
        width: "100%",
        height: "100%",
        backgroundColor: "white",
        id: "mapWindow"
    });
    $.__views.mapWindow && $.addTopLevelView($.__views.mapWindow);
    $.__views.mapview = Alloy.Globals.Map.createView({
        mapType: Alloy.Globals.Map.NORMAL_TYPE,
        id: "mapview"
    });
    $.__views.mapWindow.add($.__views.mapview);
    exports.destroy = function() {};
    _.extend($, $.__views);
    var i18n = require("i18n/i18n");
    var Globals = require("/v6/infrastructure/Globals"), LoggingService = Globals.IOC.get("LoggingService");
    var args = arguments[0] || {}, trip = args.trip;
    !function() {
        $.mapview.region = {
            latitude: (trip.origin.latitude + trip.destination.latitude) / 2,
            longitude: (trip.origin.longitude + trip.destination.longitude) / 2,
            latitudeDelta: 1.2 * Math.abs(trip.origin.latitude - trip.destination.latitude),
            longitudeDelta: 1.2 * Math.abs(trip.origin.longitude - trip.destination.longitude)
        };
        var originAnnotation = Alloy.Globals.Map.createAnnotation({
            latitude: trip.origin.latitude,
            longitude: trip.origin.longitude,
            title: trip.origin.address,
            subtitle: i18n.formatTime(moment(trip.schedule.effectiveTime)),
            pincolor: Alloy.Globals.Map.ANNOTATION_GREEN
        });
        var destinationAnnotation = Alloy.Globals.Map.createAnnotation({
            latitude: trip.destination.latitude,
            longitude: trip.destination.longitude,
            title: trip.destination.address,
            pincolor: Alloy.Globals.Map.ANNOTATION_RED
        });
        $.mapview.addAnnotation(originAnnotation);
        $.mapview.addAnnotation(destinationAnnotation);
        var url = "http://maps.googleapis.com/maps/api/directions/json?origin=" + trip.origin.latitude + "," + trip.origin.longitude + "&destination=" + trip.destination.latitude + "," + trip.destination.longitude + "&sensor=true";
        var xhr = Titanium.Network.createHTTPClient({
            onerror: function() {},
            onload: function() {
                try {
                    var xml = this.responseText;
                    var leg = JSON.parse(this.responseText).routes[0].legs[0];
                    var position = leg.steps;
                    var points = [];
                    if (null != position[0]) {
                        points.push({
                            latitude: position[0].start_location.lat,
                            longitude: position[0].start_location.lng
                        });
                        for (var i = 0; i < position.length; i++) {
                            var decodedPolyline = require("/utils/gmap").decode(position[i].polyline.points);
                            for (var j = 0; j < decodedPolyline.length; j++) null != decodedPolyline[j] && points.push({
                                latitude: decodedPolyline[j][0],
                                longitude: decodedPolyline[j][1]
                            });
                        }
                        var route = {
                            points: points,
                            color: "blue",
                            width: 5
                        };
                        $.mapview.addRoute(Alloy.Globals.Map.createRoute(route));
                        var minlat = Math.min(trip.origin.latitude, trip.destination.latitude);
                        var maxlat = Math.max(trip.origin.latitude, trip.destination.latitude);
                        var minlon = Math.min(trip.origin.longitude, trip.destination.longitude);
                        var maxlon = Math.max(trip.origin.longitude, trip.destination.longitude);
                        for (var i = 0; i < points.length; i++) {
                            points[i].latitude < minlat ? minlat = points[i].latitude : points[i].latitude > maxlat && (maxlat = points[i].latitude);
                            points[i].longitude < minlon ? minlon = points[i].longitude : points[i].longitude > maxlon && (maxlon = points[i].longitude);
                        }
                        $.mapview.region = {
                            latitude: (minlat + maxlat) / 2,
                            longitude: (minlon + maxlon) / 2,
                            latitudeDelta: 1.2 * Math.abs(maxlat - minlat),
                            longitudeDelta: 1.2 * Math.abs(maxlon - minlon)
                        };
                    }
                } catch (e) {}
            },
            onerror: function() {
                alert("ERROR");
            },
            timeout: 2e4
        });
        xhr.setRequestHeader("Content-Type", "application/json; charset=utf-8");
        xhr.open("GET", url);
        LoggingService.log("network", url);
        xhr.send(null);
    }();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;