function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.profile/" + s : s.substring(0, index) + "/ma.car.app.profile/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.profile");
    this.__widgetId = "ma.car.app.profile";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "profile";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.profileOuterContainer = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.pct100,
        top: 0,
        left: 0,
        height: "100%",
        id: "profileOuterContainer"
    });
    $.__views.profileOuterContainer && $.addTopLevelView($.__views.profileOuterContainer);
    $.__views.loading = Ti.UI.createActivityIndicator({
        top: "60dp",
        style: Ti.UI.ActivityIndicatorStyle.PLAIN,
        id: "loading"
    });
    $.__views.profileOuterContainer.add($.__views.loading);
    $.__views.btnEdit = require("/ui/common/custom_button").createButton({
        normalColor: "#00ffffff",
        selectedColor: "#70ffffff",
        backgroundImage: "none",
        borderColor: "#fff",
        borderWidth: 2,
        disableAnimation: true,
        top: "0dp",
        right: "10dp",
        width: "60dp",
        height: "30dp",
        title: L("btn_edit"),
        visible: false,
        id: "btnEdit"
    });
    $.__views.profileOuterContainer.add($.__views.btnEdit);
    $.__views.profileContainer = Ti.UI.createScrollView({
        width: Alloy.Globals.Style.Size.Width.pct100,
        top: 0,
        layout: "vertical",
        scrollType: "vertical",
        needPullRefresh: true,
        id: "profileContainer"
    });
    $.__views.profileOuterContainer.add($.__views.profileContainer);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, rootWindow = TABS_HELPER.rootWindow(), navigation = args.navigation || Alloy.Globals.Nav.Profile, Globals = require("/v6/infrastructure/Globals"), network = require("/bootstrap/network"), TransactionService = Globals.IOC.get("TransactionService"), ProfileService = Globals.IOC.get("ProfileService");
    exports = new (require("/carmalib/controller").extend($, {
        TAG: "profile",
        _userId: null,
        _isMyProfile: null,
        _profileSections: [],
        _isFirstTimeLoad: true,
        _profileTimestamp: 0,
        _windowOpen: false,
        _profile: null,
        initialize: function() {
            _.bindAll(this, "updateProfileSections", "_loadProfileError", "initProfile", "_initEditButton", "_backAction", "onDestroy", "_handleEditAction", "onRefresh", "refreshProfile");
            var resourceOwner = require("/services/resource_owner_service").singleton(), myUserId = resourceOwner.get("userId");
            args.userId = args.userId || args.id;
            args.userId || (args.userId = myUserId);
            this._isMyProfile = args.userId === myUserId;
            this._userId = args.userId;
            LOGGER.debug("[Profile] - load profile for user #" + this._userId + ", is my profile: " + this._isMyProfile);
            var self = this;
            this.initProfileSections();
            this.displayCachedVersion(this._userId);
            this.initProfile();
            this._initEditButton();
            rootWindow.addAppEventListener("app.carma.profile.change", function(profile) {
                profile.userId === args.userId && self.updateProfileSections(profile);
            });
            $.profileContainer.addEventListener("didTriggeredRefresh", this.onRefresh);
        },
        initProfile: function() {
            var self = this;
            this._loadProfile().then(this.updateProfileSections).catch(this._loadProfileError).finally(function() {
                LOGGER.debug("[Profile] - finish init profile");
                $.profileOuterContainer.remove($.loading);
            });
        },
        ensureLatest: function() {
            if (this._profile) {
                var cached = ProfileService.getCachedProfile(this._userId);
                cached && cached.expiry > this._profile.expiry && this.updateProfileSections(cached);
            }
        },
        displayCachedVersion: function(userId) {
            var profile = null;
            profile = ProfileService.getCachedProfile(userId);
            null !== profile && this.updateProfileSections(profile);
        },
        _loadProfile: function(forceRefresh) {
            var self = this;
            var profile = null;
            var userId = self._userId;
            var level = self._isMyProfile ? ProfileService.FULL_DETAIL : ProfileService.TRIP_DETAIL;
            return ProfileService.getProfile(userId, level, forceRefresh);
        },
        onRefresh: function() {
            var self = this;
            this.refreshProfile().finally(function() {
                self._refreshFinished();
            });
        },
        initProfileSections: function() {
            args.isMyProfile = this._isMyProfile;
            var userInfo = Widget.createWidget("ma.car.app.profile", "user_info", args);
            this._profileSections.push(userInfo);
            var bio = Widget.createWidget("ma.car.app.profile", "bio", args);
            this._profileSections.push(bio);
            var contact = Widget.createWidget("ma.car.app.profile", "contact", args);
            this._profileSections.push(contact);
            if (!this._isMyProfile && network.isConnectionGood()) {
                var tripInfo = Widget.createWidget("ma.car.app.profile", "trip_info", args);
                this._profileSections.push(tripInfo);
            }
            var accountSummary = Widget.createWidget("ma.car.app.profile", "account_summary", args);
            this._profileSections.push(accountSummary);
            if (this._isMyProfile) {
                var bottomAction = Widget.createWidget("ma.car.app.profile", "bottom_action");
                this._profileSections.push(bottomAction);
            }
            var _window = require("utils/ui").getWindow($.profileContainer);
            if (_window) {
                LOGGER.info("[PROFILE] - get windows");
                _window.addAppEventListener("profileWidgetReloadProfile", this.initProfile);
            }
        },
        refreshProfile: function(force) {
            var self = this;
            return self._loadProfile(true).then(function(profile) {
                self.updateProfileSections(profile, force);
            }).catch(function(error) {});
        },
        updateProfileSections: function(profile, force) {
            if (!profile || !this._profileSections) {
                this._loadProfileError();
                return;
            }
            if (!force && this._profile && this._profile.expiry === profile.expiry) {
                LOGGER.debug("[Profile Expiry Check] - profile hasn't changed, no need to update ui");
                return;
            }
            this._profile = profile;
            for (var i = 0; i < this._profileSections.length; i++) {
                var section = this._profileSections[i];
                if (this._isFirstTimeLoad) {
                    var sectionView = section.getView();
                    sectionView.top = "10dp";
                    $.profileContainer.add(sectionView);
                }
                section.showProfile(profile);
            }
            if (this._isFirstTimeLoad) {
                var whiteSpace = Ti.UI.createView();
                $.addClass(whiteSpace, "white-space col-abs-12");
                $.profileContainer.add(whiteSpace);
                this._getAvailableTopups(profile);
            }
            this._isFirstTimeLoad = false;
        },
        _initEditButton: function() {
            if (!this._isMyProfile) return;
            navigation.addEventListener("edit.click", this._handleEditAction);
            navigation.addEventListener("nav.backcomplete", this._backAction);
        },
        _loadProfileError: function(e) {
            if (this._windowOpen) {
                LOGGER.error("[PROFILE] " + JSON.stringify(e));
                Ti.UI.createAlertDialog({
                    title: L("error_title"),
                    message: "Failed to load user profile..."
                }).show();
                if (!TABS_HELPER.isUsingNativeTabs()) {
                    var _window = require("utils/ui").getWindow($.profileContainer);
                    _window && _window.close();
                }
            }
        },
        onOpened: function() {
            this._isMyProfile && navigation.showEditButton();
            this._windowOpen = true;
        },
        onDestroy: function() {
            if (this._isMyProfile) {
                navigation.hideEditButton();
                navigation.removeEventListener("done.click", this._handleEditAction);
                navigation.removeEventListener("nav.backcomplete", this._backAction);
                navigation.setTitle("");
            }
            this._windowOpen = false;
            $.profileContainer.removeEventListener("didTriggeredRefresh", this.onRefresh);
            if (this._profileSections) {
                for (var i = 0; i < this._profileSections.length; i++) this._profileSections[i].onDestroy();
                this._profileSections = null;
            }
        },
        reset: function() {
            $.profileContainer.scrollTo(0, 0);
        },
        _backAction: function(data) {
            if (data.tag !== this.TAG) return;
            navigation.showEditButton();
        },
        _checkFreeRideCoachMark: function() {
            if (!this._isMyProfile) return;
            require("services/user_service").findOwn().then(function(data) {
                var currentDate = new Date(), regDate = new Date(data.registrationTime), startDate = new Date("July 24, 2014 11:59:59 pm"), endDate = new Date("July 31, 2014 11:59:59 pm");
                if (!require("services/action_record_service").get("freeride") && endDate > currentDate && startDate > regDate) {
                    require("services/action_record_service").set("freeride", true);
                    TM.push(function() {
                        Ti.App.fireEvent("carma:coachmark", {
                            name: "freeride"
                        });
                    }, process.backgroundDomain);
                }
            });
        },
        _handleEditAction: function(event) {
            if (event.tag !== this.TAG) return;
            var path = "#myprofile", shell = Alloy.createController("shell", {
                path: path
            }).getView();
            shell.open();
            shell = null;
            path = null;
        },
        _refreshFinished: function() {
            $.profileContainer.cmMarkRefreshFinished && $.profileContainer.cmMarkRefreshFinished();
        },
        _getAvailableTopups: function(profile) {
            this._isMyProfile && profile.creditBalance && TransactionService.fetchAvailableTopup(profile.creditBalance.currency);
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;