function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.profile/" + s : s.substring(0, index) + "/ma.car.app.profile/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.profile");
    this.__widgetId = "ma.car.app.profile";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "trip_info";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.tripsContainer = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: "10dp",
        left: Alloy.Globals.Style.Size.Width.pct4,
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "tripsContainer"
    });
    $.__views.tripsContainer && $.addTopLevelView($.__views.tripsContainer);
    $.__views.trips = Ti.UI.createView({
        height: Ti.UI.SIZE,
        id: "trips"
    });
    $.__views.tripsContainer.add($.__views.trips);
    $.__views.scrollerHeader = Ti.UI.createView({
        width: "100%",
        top: 0,
        left: 0,
        height: "40dp",
        id: "scrollerHeader"
    });
    $.__views.trips.add($.__views.scrollerHeader);
    $.__views.prevDay = require("/ui/common/tactile_label").createLabel({
        color: Alloy.Globals.Style.Color.LightGrey,
        font: {
            fontFamily: "splinico",
            fontSize: "26dp"
        },
        text: "m",
        width: "60dp",
        height: "50dp",
        left: "-7dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        id: "prevDay"
    });
    $.__views.scrollerHeader.add($.__views.prevDay);
    $.__views.tripDate = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp"
        },
        id: "tripDate"
    });
    $.__views.scrollerHeader.add($.__views.tripDate);
    $.__views.nextDay = require("/ui/common/tactile_label").createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontFamily: "splinico",
            fontSize: "26dp"
        },
        text: "l",
        width: "60dp",
        height: "50dp",
        right: "-7dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_RIGHT,
        id: "nextDay"
    });
    $.__views.scrollerHeader.add($.__views.nextDay);
    $.__views.dayView = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: "40dp",
        left: 0,
        layout: "vertical",
        height: "100dp",
        id: "dayView"
    });
    $.__views.trips.add($.__views.dayView);
    $.__views.noTrips = Ti.UI.createView({
        backgroundColor: Alloy.Globals.Style.Color.Grey,
        width: "100%",
        visible: false,
        height: "240dp",
        id: "noTrips"
    });
    $.__views.tripsContainer.add($.__views.noTrips);
    $.__views.noTripIcon = Ti.UI.createLabel({
        color: "#8f8f8f",
        font: {
            fontFamily: "splinico",
            fontSize: "90dp"
        },
        text: "T",
        transform: Alloy.Globals.Style.Rotate.rt125,
        top: "52dp",
        id: "noTripIcon"
    });
    $.__views.noTrips.add($.__views.noTripIcon);
    $.__views.__alloyId553 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_CENTER,
        text: L("widget_profile_trip_info_empty"),
        font: {
            fontSize: "17dp"
        },
        bottom: "38dp",
        id: "__alloyId553"
    });
    $.__views.noTrips.add($.__views.__alloyId553);
    $.__views.__alloyId554 = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        left: 0,
        height: "1px",
        backgroundColor: Alloy.Globals.Style.Color.DarkGray,
        bottom: 0,
        id: "__alloyId554"
    });
    $.__views.noTrips.add($.__views.__alloyId554);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, navigation = args.navigation || Alloy.Globals.Nav.Profile, moment = require("/vendor/moment"), i18n = require("i18n/i18n");
    exports = new (require("/carmalib/controller").extend($, {
        _firstName: null,
        _userId: args.userId,
        _dayOffset: 0,
        _timestamp: args.timestamp,
        _tripId: args.tripId,
        _tripRows: [],
        _TRIP_HEIGHT: 240,
        events: {
            "click prevDay": "_prevDay",
            "click nextDay": "_nextDay"
        },
        initialize: function() {
            _.bindAll(this, "showProfile", "_renderTrips", "_renderTripsError", "_enableDayRoller", "onDestroy");
        },
        onDestroy: function() {
            this._renderTripTable([]);
            $.prevDay.cleanUp();
            $.nextDay.cleanUp();
        },
        cleanMaps: function() {
            for (var i = 0, j = this._tripRows.length; j > i; i++) this._tripRows[i].onDestroy && _.isFunction(this._tripRows[i].onDestroy) && this._tripRows[i].onDestroy();
            this._tripRows = [];
        },
        showProfile: _.once(function(profile) {
            this._firstName = profile.firstName;
            this._loadTrips(profile.userId);
        }),
        _loadTrips: function(userId) {
            if (this._timestamp) {
                this._dayOffset = this._daysFromToday(this._timestamp);
                this._timestamp = null;
            }
            LOGGER.info("[trip info] - _loadTrips _dayOffset: " + this._dayOffset);
            this._displayDate();
            var now = Date.now(), trips = Alloy.createModel("trips", {
                urlParams: {
                    userId: userId
                }
            });
            var self = this;
            TM.push(function() {
                trips.fetch({
                    data: {
                        relativeTime: moment(now + 24 * self._dayOffset * 60 * 60 * 1e3).startOf("day").valueOf()
                    }
                }).then(self._renderTrips, self._renderTripsError);
            });
        },
        _needNextAvailabeDateForTrip: function(tripList, tripId) {
            if (!tripList || !tripId) return false;
            var trip = null;
            for (var i = tripList.length - 1; i >= 0; i--) {
                var _trip = tripList[i].tripOverrideObject || tripList[i].baseTrip;
                if (_trip.id.toString() === tripId.toString()) {
                    trip = _trip;
                    break;
                }
            }
            if (trip.enabled) {
                var timestamp = Date.now() + 24 * this._dayOffset * 60 * 60 * 1e3, thatMoment = moment(timestamp), startOfDay = thatMoment.startOf("day").valueOf(), endOfDay = thatMoment.endOf("day").valueOf(), tripTime = trip.schedule.effectiveTime;
                if (tripTime > startOfDay && endOfDay > tripTime) return false;
                this._dayOffset = this._daysFromToday(tripTime);
                return true;
            }
            return false;
        },
        _renderTrips: function(trips) {
            var bookings = [];
            var tripList = trips.tripList, now = Date.now(), self = this;
            require("services/booking_service").findAll(false).then(function(data) {
                bookings = data.rideBookings || [];
            }).catch(function(e) {}).finally(function() {
                if (self._tripId) {
                    var tripId = self._tripId;
                    self._tripId = null;
                    if (self._needNextAvailabeDateForTrip(tripList, tripId)) {
                        self._loadTrips(self._userId);
                        return;
                    }
                }
                tripList = _.filter(tripList, function(trip) {
                    trip = trip.tripOverrideObject || trip.baseTrip;
                    var enabled = trip.enabled, timestamp = now + 24 * self._dayOffset * 60 * 60 * 1e3;
                    var startOfDay = moment(timestamp).startOf("day").valueOf(), endOfDay = moment(timestamp).endOf("day").valueOf(), tripTime = trip.schedule.effectiveTime;
                    return enabled && tripTime >= startOfDay && endOfDay > tripTime;
                });
                self._renderTripTable(tripList, bookings);
            });
        },
        _renderTripsError: function() {
            this._renderTripTable([]);
        },
        _renderTripTable: function(trips, bookings) {
            this.cleanMaps();
            $.dayView.removeAllChildren();
            true && trips.length > 0 ? setTimeout(this._enableDayRoller, 1500) : this._enableDayRoller();
            if (0 === trips.length) {
                this._renderEmptyTripTable();
                return;
            }
            this._hideEmptyTripTable();
            this._renderTripRows(trips, bookings);
        },
        _hideEmptyTripTable: function() {
            $.dayView.applyProperties({
                visible: true
            });
            $.noTrips.applyProperties({
                visible: false,
                height: 0
            });
        },
        _renderEmptyTripTable: function() {
            $.dayView.applyProperties({
                visible: false,
                height: 0
            });
            $.noTrips.applyProperties({
                visible: true,
                height: "240dp"
            });
        },
        _renderTripRows: function(trips, bookings) {
            $.dayView.height = this._TRIP_HEIGHT * trips.length + "dp";
            for (var i = 0; i < trips.length; i++) {
                var trip = trips[i], booking = this._findBookingByTimetable(trip, bookings), tripRowWidget = Widget.createWidget("ma.car.app.profile", "trip_row", {
                    trip: trip,
                    booking: booking,
                    userId: this._userId,
                    firstName: this._firstName,
                    navigation: navigation
                }), tripRow = tripRowWidget.getView();
                this._tripRows.push(tripRowWidget);
                i > 0 && $.addClass(tripRow, "nth");
                $.dayView.add(tripRow);
                i < trips.length - 1 && this._addHr();
            }
        },
        _findBookingByTimetable: function(trip, bookings) {
            if (!trip || !bookings) return null;
            trip = trip.tripOverrideObject || trip.baseTrip || {};
            for (var i = bookings.length - 1; i >= 0; i--) {
                var booking = bookings[i], bookingTrip = booking.trip.tripOverrideObject || booking.trip.baseTrip || {};
                if (booking.bookingDate === trip.schedule.effectiveTime && bookingTrip.id === trip.id) return booking;
            }
            return null;
        },
        _enableDayRoller: function() {
            $.prevDay.applyProperties({
                color: this._dayOffset > 0 ? Alloy.Globals.Style.Color.DarkGray : Alloy.Globals.Style.Color.LightGrey,
                touchEnabled: true
            });
            $.nextDay.applyProperties({
                color: "#333",
                touchEnabled: true
            });
        },
        _disableDayRoller: function() {
            $.prevDay.applyProperties({
                color: Alloy.Globals.Style.Color.LightGrey,
                touchEnabled: false
            });
            $.nextDay.applyProperties({
                color: Alloy.Globals.Style.Color.LightGrey,
                touchEnabled: false
            });
        },
        _addHr: function() {
            var hr = Ti.UI.createView();
            $.addClass(hr, "hr col-abs-11");
            $.dayView.add(hr);
        },
        _displayDate: function() {
            switch (this._dayOffset) {
              case 0:
                $.tripDate.text = L("date_today");
                break;

              case 1:
                $.tripDate.text = L("date_tomorrow");
                break;

              default:
                $.tripDate.text = i18n.formatVeryLongDate(moment(Date.now() + 24 * this._dayOffset * 60 * 60 * 1e3));
            }
        },
        _prevDay: function() {
            if (0 === this._dayOffset) return;
            this._dayOffset--;
            this._loadTrips(this._userId);
        },
        _nextDay: function() {
            this._dayOffset++;
            this._loadTrips(this._userId);
        },
        _daysFromToday: function(timestamp) {
            var today = new Date(), date = new Date(timestamp);
            today.setHours(0, 0, 0, 0);
            date.setHours(0, 0, 0, 0);
            if (date.getTime() < today.getTime()) return 0;
            return (date.getTime() - today.getTime()) / 864e5;
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;