function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.profile/" + s : s.substring(0, index) + "/ma.car.app.profile/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.profile");
    this.__widgetId = "ma.car.app.profile";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "trip_row";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.trip_row = Ti.UI.createView({
        width: "100%",
        height: "233dp",
        id: "trip_row"
    });
    $.__views.trip_row && $.addTopLevelView($.__views.trip_row);
    $.__views.__alloyId555 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        font: {
            fontFamily: "splinico",
            fontSize: "58dp"
        },
        text: "w",
        top: "-5dp",
        right: "3dp",
        zIndex: 3,
        id: "__alloyId555"
    });
    $.__views.trip_row.add($.__views.__alloyId555);
    $.__views.estPrice = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "12dp"
        },
        top: "1dp",
        right: "13dp",
        zIndex: 4,
        id: "estPrice"
    });
    $.__views.trip_row.add($.__views.estPrice);
    $.__views.__alloyId556 = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "8dp"
        },
        top: "16dp",
        right: "17dp",
        zIndex: 4,
        text: L("widget_profile_trip_row_est_price_desc"),
        id: "__alloyId556"
    });
    $.__views.trip_row.add($.__views.__alloyId556);
    $.__views.mapContainer = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: "2dp",
        left: 0,
        height: "160dp",
        id: "mapContainer"
    });
    $.__views.trip_row.add($.__views.mapContainer);
    $.__views.map = Ti.UI.createImageView({
        defaultImage: "/images/map_background.png",
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: 0,
        left: 0,
        height: "160dp",
        image: "/images/map_background.png",
        id: "map"
    });
    $.__views.mapContainer.add($.__views.map);
    $.__views.tripType = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "12dp"
        },
        top: "167dp",
        left: 0,
        id: "tripType"
    });
    $.__views.trip_row.add($.__views.tripType);
    $.__views.tripTime = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        font: {
            fontSize: "12dp"
        },
        top: "180dp",
        left: 0,
        id: "tripTime"
    });
    $.__views.trip_row.add($.__views.tripTime);
    $.__views.tripRoute = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "12dp"
        },
        top: "200dp",
        left: 0,
        width: "75%",
        height: "30dp",
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_TOP,
        id: "tripRoute"
    });
    $.__views.trip_row.add($.__views.tripRoute);
    $.__views.btnAsk = require("/ui/common/ask").createView({
        top: "180dp",
        right: 0,
        zIndex: 3,
        visible: false,
        id: "btnAsk"
    });
    $.__views.trip_row.add($.__views.btnAsk);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, navigation = args.navigation || Alloy.Globals.Nav.Profile;
    moment = require("/vendor/moment"), i18n = require("i18n/i18n");
    var Globals = require("/v6/infrastructure/Globals"), LoggingService = Globals.IOC.get("LoggingService");
    var CACHE_FOLDER = Ti.Filesystem.getFile(Ti.Filesystem.applicationCacheDirectory, "map-cache");
    CACHE_FOLDER.exists() || CACHE_FOLDER.createDirectory();
    var localFileName = function(imageURL) {
        return Ti.Utils.md5HexDigest(imageURL + "");
    };
    exports = new (require("/carmalib/controller").extend($, {
        _trip: args.trip.tripOverrideObject || args.trip.baseTrip,
        _booking: args.booking,
        _MAP_WIDTH: Math.round(Alloy.Globals.Style.Size.Width.grid10),
        _MAP_HEIGHT_DP: 160,
        _MAP_TIMEOUT: 12e4,
        _DEFAULT_EXPIRED_TIMESTAMP: 9e5,
        _openMap: function() {
            if (!Alloy.Globals.Map) return;
            var wrapperWindow = Alloy.createController("simpleWindow").getView();
            var mapView = Alloy.createWidget("ma.car.app.profile", "map", {
                trip: this._trip
            });
            var navigation = Alloy.Globals.Nav.MapView = Alloy.createController("navigation");
            navigation.init({
                title: String.format(L("widget_profile_mapview_title"), i18n.formatTime(moment(this._trip.schedule.effectiveTime)), L("RIDE" === this._trip.type ? "mode_rider" : "mode_driver")),
                index: mapView,
                historyLimit: 20,
                mainWindow: wrapperWindow,
                transition: "none",
                modal: true
            });
            wrapperWindow.backgroundColor = "#fff";
            var self = this;
            wrapperWindow.addEventListener("close", function handler() {
                wrapperWindow.removeEventListener("close", handler);
                Alloy.Globals.Nav.MapView = null;
            });
            wrapperWindow.open();
        },
        initialize: function() {
            _.bindAll(this, "_showMap", "_openMap", "onDestroy");
            $.map.addEventListener("click", this._openMap);
            this._showTripDetails();
            this._loadMaps();
            this._prepareAskButton();
        },
        onDestroy: function() {
            $.map.removeEventListener("click", this._openMap);
        },
        _prepareAskButton: function() {
            var now = Date.now();
            if (this._trip.schedule.effectiveTime < now) return;
            var resourceOwner = require("services/resource_owner_service").singleton();
            var nextTrip = resourceOwner.get("nextTrip");
            $.btnAsk.setData({
                trip: {
                    id: this._trip.id,
                    type: this._trip.type,
                    effectiveTime: this._trip.schedule.effectiveTime,
                    origin: this._trip.origin,
                    destination: this._trip.destination,
                    user: {
                        userId: args.userId,
                        firstName: args.firstName
                    }
                },
                booking: this._booking,
                groupingKey: require("services/trip_service").groupingKey(nextTrip, this._trip)
            });
            $.btnAsk.visible = true;
        },
        _showTripDetails: function() {
            $.estPrice.text = String.format(L("widget_profile_trip_row_est_price"), this._trip.estimatedCost.toFixed(2));
            $.tripType.text = L("RIDE" === this._trip.type ? "widget_profile_trip_row_rider_trip" : "widget_profile_trip_row_driver_trip");
            $.tripRoute.text = String.format(L("widget_profile_trip_row_route"), this._trip.origin.address, this._trip.destination.address);
            $.tripTime.text = i18n.formatTime(moment().startOf("day").add("minute", this._trip.schedule.startMinutes));
        },
        _loadMaps: function() {
            var units = require("/platform/units");
            var width = units.pixelToDip($.mapContainer.width);
            var height = this._MAP_HEIGHT_DP;
            require("/utils/utils").createMapUrl(this._trip, width, height).then(this._showMap);
        },
        _showMap: function(url) {
            this._downloadMap(url.response);
        },
        _isExpiredTrip: function() {
            var startDate = new Date(parseInt(this._trip.schedule.effectiveTime, 10) + this._DEFAULT_EXPIRED_TIMESTAMP);
            return Date.now() > startDate.getTime();
        },
        _checkTripExpiration: function() {
            if (this._isExpiredTrip()) {
                var overlay = Ti.UI.createView({
                    backgroundColor: "#000",
                    opacity: .7,
                    height: "160dp"
                });
                $.mapContainer.add(overlay);
            }
        },
        _downloadMap: function(url) {
            var file = Ti.Filesystem.getFile(CACHE_FOLDER.resolve(), localFileName(url));
            if (file.exists()) {
                $.map.applyProperties({
                    image: file.getNativePath(),
                    defaultImage: file.getNativePath()
                });
                this._checkTripExpiration();
                return;
            }
            var client = null, self = this;
            var onload = function(response) {
                $.map.image = client.getResponseData();
                self._checkTripExpiration();
                file.write(client.responseData);
            };
            var onerror = function(e) {
                LOGGER.error(e.error);
            };
            client = Ti.Network.createHTTPClient({
                timeout: 12e4,
                onload: onload,
                onerror: onerror
            });
            client.open("GET", url);
            LoggingService.log("network", url);
            client.send();
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;