function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.profile/" + s : s.substring(0, index) + "/ma.car.app.profile/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.profile");
    this.__widgetId = "ma.car.app.profile";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.profileWindow = require("/ui/common/child_window").createView({
        width: "100%",
        height: "100%",
        top: 0,
        left: 0,
        backgroundColor: "white",
        id: "profileWindow"
    });
    $.__views.profileWindow && $.addTopLevelView($.__views.profileWindow);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, Globals = require("/v6/infrastructure/Globals"), ProfileService = Globals.IOC.get("ProfileService"), resourceOwner = require("/services/resource_owner_service").singleton(), myUserId = resourceOwner.get("userId"), wrapperWindow = Alloy.createController("simpleWindow").getView();
    wrapperWindow.backgroundColor = "#fff";
    Alloy.Globals.Nav.Profile = Alloy.Globals.Nav.Profile ? Alloy.Globals.Nav.Profile : Alloy.createController("navigation");
    var navigation = null;
    exports = new (require("/carmalib/controller").extend($, {
        _isMyProfile: null,
        _profileView: null,
        _windowIsOpened: false,
        _profileWindow: null,
        initialize: function() {
            args.userId = args.userId;
            args.userId || (args.userId = myUserId);
            args.isMyProfile = this._isMyProfile = args.userId === myUserId;
            navigation = this._isMyProfile ? Alloy.Globals.Nav.Profile : Alloy.createController("navigation");
            this._profileWindow = this._isMyProfile ? $.profileWindow : wrapperWindow;
            this._initProfileWidget();
        },
        getWindow: function() {
            return this._profileWindow;
        },
        onDestroy: function() {
            Alloy.Globals.Nav.Profile = null;
        },
        _initProfileWidget: function() {
            var options = _.extend({}, args, {
                navigation: navigation
            });
            var profileView = Alloy.createWidget("ma.car.app.profile", "profile", options);
            profileView.trackingData = {
                profileUserId: args.userId
            };
            var self = this;
            this._profileWindow.addEventListener("open", function handler() {
                self._profileWindow.removeEventListener("open", handler);
                self._windowIsOpened = true;
                setTimeout(function() {
                    self._profileWindow.addAppEventListener("app.carma.profile.change", function(profile) {
                        profile.userId === args.userId && profileView.refreshProfile(true);
                    });
                    self._isMyProfile && self._profileWindow.addAppEventListener("carma:feature.toggles", function(profile) {});
                }, 500);
            });
            this._profileWindow.addEventListener("close", function closeHandler() {
                self._profileWindow.removeEventListener("close", closeHandler);
                profileView.onDestroy();
                profileView = null;
                navigation = null;
            });
            this._initNavigation(profileView);
            this._profileView = profileView;
        },
        _initNavigation: function(profileView) {
            navigation.init({
                index: profileView,
                historyLimit: 20,
                mainWindow: this._profileWindow,
                transition: "none",
                modal: !this._isMyProfile,
                disableBack: this._isMyProfile,
                handleClose: args.handleClose,
                title: L("widget_profile_title"),
                around: args.around
            });
        },
        focus: function() {
            this._isMyProfile && this._profileView && this._profileView.ensureLatest();
        },
        open: function(options) {
            options = options || {};
            switch (options.action) {
              case "tolltag":
                this._isMyProfile && Ti.App.fireEvent("carma:openTollTagPopup");
                return;

              case "addphoto":
                this._isMyProfile && Ti.App.fireEvent("carma:editProfile");
                return;

              case "verifyContactData":
                this._isMyProfile && Ti.App.fireEvent("carma:openVerifyContactData");
                return;

              case "invite":
                this._isMyProfile && Ti.App.fireEvent("carma:openInviteFriends");
                return;
            }
            if (!options.topup) {
                this._windowIsOpened || this._profileWindow.open();
                return;
            }
            var currentController = navigation.getCurrentController();
            if (options.topup && currentController && "topup" === currentController.__controllerPath) return;
            var profileCachedData = ProfileService.getCachedProfile(myUserId);
            var stripeView = Alloy.createWidget("ma.car.app.stripePayments", "topup", {
                callback: options.callback,
                __parentSymbol: $.getView()
            });
            stripeView.showTopup(profileCachedData, true);
            if (this._windowIsOpened) navigation.open(stripeView); else {
                var self = this;
                this._profileWindow.addEventListener("open", function handler() {
                    self._profileWindow.removeEventListener("open", handler);
                    setTimeout(function() {
                        navigation.open(stripeView);
                    }, 1e3);
                });
            }
            if (options.callback) {
                var handler = function() {
                    removeListeners();
                    options.callback();
                };
                var removeListeners = function() {
                    Ti.App.removeEventListener("topup.successful", handler);
                    Ti.App.removeEventListener("carma:tab.change", removeListeners);
                    navigation.removeEventListener("nav.backstart", removeListeners);
                };
                Ti.App.addEventListener("topup.successful", handler);
                Ti.App.addEventListener("carma:tab.change", removeListeners);
                navigation.addEventListener("nav.backstart", removeListeners);
            }
            this._windowIsOpened || $.profileWindow.open();
        },
        reset: function() {
            if (!this._isMyProfile) return;
            navigation && navigation.hasHistory() ? navigation.canGoBack() && navigation.backTo(0) : this._profileView && this._profileView.reset();
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;