function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.radiobutton/" + s : s.substring(0, index) + "/ma.car.app.radiobutton/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.radiobutton");
    this.__widgetId = "ma.car.app.radiobutton";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.radioContainer = Ti.UI.createTableView({
        separatorColor: "transparent",
        backgroundColor: "transparent",
        height: Ti.UI.SIZE,
        overScrollMode: Ti.UI.Android.OVER_SCROLL_NEVER,
        id: "radioContainer"
    });
    $.__views.radioContainer && $.addTopLevelView($.__views.radioContainer);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, buttons = [], events = {};
    $.radioContainer.applyProperties(args);
    var uncheckRadios = function() {
        for (var i = 0; i < buttons.length; ++i) {
            buttons[i].getChildren()[0].setColor("#fff");
            buttons[i].getChildren()[1].setVisible(false);
            buttons[i].getChildren()[2].setVisible(false);
            buttons[i].selected = false;
        }
    };
    var checkRadio = function(button) {
        uncheckRadios();
        button.selected = true;
        button.getChildren()[0].setColor(Alloy.Globals.Style.Color.LightBlue);
        button.getChildren()[1].setVisible(true);
        button.getChildren()[2].setVisible(true);
    };
    var getSelected = function() {
        for (var i = 0; i < buttons.length; ++i) if (buttons[i].selected) return buttons[i];
    };
    var addRadioButton = function(text, value) {
        var buttonContainer = Ti.UI.createView({
            selected: false,
            value: value
        });
        var tickerBckg = Ti.UI.createLabel();
        var ticker = Ti.UI.createLabel();
        var button = Ti.UI.createLabel();
        var label = Ti.UI.createLabel({
            text: text
        });
        var tableRow = Ti.UI.createTableViewRow();
        $.addClass(buttonContainer, "buttonContainer");
        $.addClass(tickerBckg, "radioTickerBckg");
        $.addClass(ticker, "radioTicker");
        $.addClass(button, "radioButton");
        $.addClass(label, "radioLabel");
        $.addClass(tableRow, "radioRow");
        tableRow.setHeight("40dp");
        buttonContainer.add(button);
        buttonContainer.add(tickerBckg);
        buttonContainer.add(ticker);
        tableRow.add(buttonContainer);
        tableRow.add(label);
        $.radioContainer.appendRow(tableRow);
        tableRow.addEventListener("click", function() {
            checkRadio(buttonContainer);
            "click" in events && events.click({
                selected: exports.getSelected()
            });
        });
        buttons.push(buttonContainer);
        $.radioContainer.height = 41 * buttons.length + "dp";
    };
    var _selectRadio = function(value) {
        for (var i = 0; i < buttons.length; ++i) buttons[i].value === value && checkRadio(buttons[i]);
    };
    exports.getSelected = getSelected;
    exports.addRadioButton = addRadioButton;
    exports.addEventListener = function(event, callback) {
        events[event] = callback;
    };
    exports.select = function(value) {
        _selectRadio(value);
    };
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;