function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.rating/" + s : s.substring(0, index) + "/ma.car.app.rating/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    function capitalize(text) {
        var text = text || "";
        if (!text.length) return text;
        if (text[0] == text[0].toUpperCase()) return text;
        text = text.trim();
        text = text.charAt(0).toUpperCase() + text.slice(1);
        return text;
    }
    var Widget = new (require("alloy/widget"))("ma.car.app.rating");
    this.__widgetId = "ma.car.app.rating";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.win = require("/ui/common/custom_window").createWindow({
        orientationModes: [ Ti.UI.PORTRAIT ],
        navBarHidden: true,
        backgroundColor: "#111",
        backgroundImage: null,
        opacity: 1,
        modal: false,
        windowSoftInputMode: Alloy.Globals.Style.KeyboardStatePan,
        id: "win"
    });
    $.__views.win && $.addTopLevelView($.__views.win);
    $.__views.ratingInputView = Ti.UI.createScrollView({
        width: Alloy.Globals.Style.Size.Width.pct100,
        bottom: 0,
        left: 0,
        height: "400dp",
        opacity: "1.0",
        id: "ratingInputView"
    });
    $.__views.win.add($.__views.ratingInputView);
    $.__views.lblTripQuestion = Ti.UI.createLabel({
        color: "#fff",
        width: Alloy.Globals.Style.Size.Width.grid11,
        font: {
            fontSize: "15dp"
        },
        text: L("widget_rating_feedback_label"),
        top: "0dp",
        left: Alloy.Globals.Style.Size.Width.pct4,
        id: "lblTripQuestion"
    });
    $.__views.ratingInputView.add($.__views.lblTripQuestion);
    $.__views.lblDriverName = Ti.UI.createLabel({
        color: "#fff",
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: "30dp",
        left: Alloy.Globals.Style.Size.Width.pct4,
        font: {
            fontSize: "30dp"
        },
        id: "lblDriverName"
    });
    $.__views.ratingInputView.add($.__views.lblDriverName);
    $.__views.ratingStars = Alloy.createWidget("ma.car.app.rate", "widget", {
        top: "70dp",
        height: "80dp",
        width: "90%",
        id: "ratingStars",
        rating: "0",
        clickable: "true",
        __parentSymbol: $.__views.ratingInputView
    });
    $.__views.ratingStars.setParent($.__views.ratingInputView);
    $.__views.ratingComment = Ti.UI.createTextArea({
        paddingLeft: "10dp",
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "15dp"
        },
        top: "155dp",
        height: "80dp",
        width: "90%",
        textAlign: "left",
        hintText: L("widget_rating_hint_comments"),
        softKeyboardOnFocus: Ti.UI.Android.SOFT_KEYBOARD_SHOW_ON_FOCUS,
        id: "ratingComment"
    });
    $.__views.ratingInputView.add($.__views.ratingComment);
    $.__views.btnCancel = require("/ui/common/custom_button").createButton({
        width: Alloy.Globals.Style.Size.Width.grid5,
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "60dp",
        font: {
            fontSize: "18dp"
        },
        normalColor: "#00ffffff",
        selectedColor: "#70ffffff",
        backgroundImage: "none",
        borderColor: "#fff",
        borderWidth: 2,
        disableAnimation: true,
        top: "240dp",
        left: Alloy.Globals.Style.Size.Width.pct4,
        title: L("widget_rating_button_cancel"),
        id: "btnCancel"
    });
    $.__views.ratingInputView.add($.__views.btnCancel);
    $.__views.btnRate = require("/ui/common/custom_button").createButton({
        width: Alloy.Globals.Style.Size.Width.grid5,
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "60dp",
        font: {
            fontSize: "18dp"
        },
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        top: "240dp",
        right: Alloy.Globals.Style.Size.Width.pct4,
        title: L("widget_rating_button_rate_now"),
        id: "btnRate"
    });
    $.__views.ratingInputView.add($.__views.btnRate);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var Q = require("vendor/q"), Queue = require("/utils/queue"), BaseController = require("/carmalib/controller");
    var target = arguments[0].target, journeyId = arguments[0].journeyId, handleOK = arguments[0].ok, handleCancel = arguments[0].cancel, handleError = arguments[0].error;
    var RatingController = BaseController.extend($, {
        _ui: new Queue({
            name: "ui"
        }),
        events: {
            "focus[ios] ratingComment": "onFocus",
            "blur[ios] ratingComment": "onBlur",
            "change[ios] ratingComment": "onChange",
            "click btnCancel": "onCancel",
            "click btnRate": "onRate"
        },
        initialize: function() {
            this._ui.bind(this, "onFocus", {
                unique: true
            });
            this._ui.bind(this, "onBlur", {
                unique: true
            });
            this._ui.bind(this, "onChange", {
                unique: true
            });
            this._ui.bind(this, "onCancel", {
                unique: true
            });
            this._ui.bind(this, "onRate", {
                unique: true
            });
            var message = String.format(L("widget_rating_driver_label"), target.firstName);
            $.lblDriverName.text = message;
            $.ratingStars.setRating(0);
            var AnimatedBottomView = require("/ui/common/animated_bottom_view");
            new AnimatedBottomView().setup({
                container: $.ratingInputView,
                triggers: [ $.ratingComment ]
            });
            var hintText;
            $.ratingComment.applyProperties({
                value: "",
                color: "black"
            });
        },
        onDestroy: function() {
            this._ui.clear();
        },
        onFocus: function(e) {
            var hintText = $.ratingComment.hintText;
            $.ratingComment.value === hintText && $.ratingComment.applyProperties({
                value: "",
                color: "black"
            });
        },
        onBlur: function() {
            var hintText = $.ratingComment.hintText;
            "" === $.ratingComment.value && $.ratingComment.applyProperties({
                value: hintText,
                color: "gray"
            });
        },
        onChange: function(e) {
            e.cancelBubble = true;
            var text = capitalize(e.value);
            e.value != text && ($.ratingComment.value = text);
        },
        onCancel: function() {
            $.win.close();
            handleCancel();
        },
        onRate: function() {
            var dfd = Q.defer(), rating = $.ratingStars.getRating();
            var comment = capitalize($.ratingComment.value);
            comment === $.ratingComment.hintText && (comment = "");
            var ratingService = require("services/rating_service");
            ratingService.rate(journeyId, rating, comment).then(function() {
                handleOK();
            }).catch(function(e) {
                handleError(e);
            }).finally(function() {
                $.win.close();
                dfd.resolve();
            });
            return dfd.promise;
        }
    });
    exports = new RatingController();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;