function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.stripePayments/" + s : s.substring(0, index) + "/ma.car.app.stripePayments/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.stripePayments");
    this.__widgetId = "ma.car.app.stripePayments";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "add_card";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.profileOuterContainer = Ti.UI.createView({
        top: 0,
        left: 0,
        height: "100%",
        width: "100%",
        id: "profileOuterContainer"
    });
    $.__views.profileOuterContainer && $.addTopLevelView($.__views.profileOuterContainer);
    $.__views.scrollView = Ti.UI.createScrollView({
        showVerticalScrollIndicator: "false",
        showHorizontalScrollIndicator: "false",
        height: "100%",
        width: "100%",
        id: "scrollView"
    });
    $.__views.profileOuterContainer.add($.__views.scrollView);
    $.__views.stripeList = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: 0,
        layout: "vertical",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        backgroundColor: "transparent",
        id: "stripeList"
    });
    $.__views.scrollView.add($.__views.stripeList);
    $.__views.totalBalance = Ti.UI.createLabel({
        color: "#ff6600",
        font: {
            fontSize: "36dp"
        },
        textAlign: "center",
        id: "totalBalance"
    });
    $.__views.stripeList.add($.__views.totalBalance);
    $.__views.balanceDetails = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        height: "auto",
        textAlign: "center",
        id: "balanceDetails"
    });
    $.__views.stripeList.add($.__views.balanceDetails);
    $.__views.balanceHr = Ti.UI.createView({
        top: "20dp",
        bottom: "20dp",
        height: "2px",
        backgroundColor: Alloy.Globals.Style.Color.DarkGray,
        id: "balanceHr"
    });
    $.__views.stripeList.add($.__views.balanceHr);
    $.__views.cardForm = Alloy.createWidget("ma.car.app.stripePayments", "card_form", {
        id: "cardForm",
        saveCard: "false",
        __parentSymbol: $.__views.stripeList
    });
    $.__views.cardForm.setParent($.__views.stripeList);
    $.__views.addCard = require("/ui/common/custom_button").createButton({
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "60dp",
        font: {
            fontSize: "18dp"
        },
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        width: "100%",
        top: "10dp",
        bottom: "30dp",
        title: L("widget_stripe_add_card_btn"),
        id: "addCard"
    });
    $.__views.stripeList.add($.__views.addCard);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var popupWindow = require("/ui/common/popupWindow"), args = arguments[0] || {}, ui = require("/utils/ui"), parentWindow = TABS_HELPER.isUsingNativeTabs() ? TABS_HELPER.rootWindow() : ui.getWindow(args.__parentSymbol);
    exports = new (require("/carmalib/controller").extend($, {
        _profile: null,
        _expiryValue: false,
        _cardForm: null,
        events: {
            "click[ios] profileOuterContainer": "_blurFields",
            "click[android] profileOuterContainer": "_blurFields",
            "click[ios] addCard": "_validateAddCard",
            "click[android] addCard": "_validateAddCard"
        },
        initialize: function() {
            _.bindAll(this, "showAddCardForm", "_addCardError", "_addCardSuccess", "_addCardCarma", "_scrollToDateInput");
            this._cardForm = $.cardForm;
        },
        showAddCardForm: function(profile) {
            this._profile = profile;
            this._showMyCreditBalance(profile.creditBalances, profile.credit);
            parentWindow.addAppEventListener("picker.show", this._scrollToDateInput);
            parentWindow.addAppEventListener("picker.hide", this._scrollToTop);
        },
        _showMyCreditBalance: function(creditBalances, credit) {
            if (creditBalances && 0 !== creditBalances.length) {
                var balance = creditBalances[0], currencySymbol = balance.currencySymbol, totalBalance = parseFloat(balance.totalBalance, 10).toFixed(2), payableBalance = parseFloat(balance.payableBalance, 10).toFixed(2), bonusBalance = parseFloat(balance.bonusBalance, 10).toFixed(2);
                $.totalBalance.text = String.format(L("widget_profile_summary_balance_total"), currencySymbol, totalBalance);
                $.balanceDetails.text = String.format(L("widget_profile_summary_balance_details"), currencySymbol, payableBalance, bonusBalance);
            } else {
                var currencySymbol = "$", totalBalance = parseFloat(credit).toFixed(2);
                $.totalBalance.text = String.format(L("widget_profile_summary_balance_total"), currencySymbol, totalBalance);
                $.balanceDetails.text = "";
            }
        },
        _validateAddCard: require("/bootstrap/patch").debounce(function() {
            this._cardForm.validateAddCard() && this._createStripeCard();
        }, 250),
        _createStripeCard: function() {
            this._startSpinner();
            var values = this._cardForm.getFieldValues();
            var params = {
                "card[number]": values.number,
                "card[exp_month]": values.exp_month,
                "card[exp_year]": values.exp_year,
                "card[name]": values.name,
                "card[cvc]": values.cvc
            };
            var self = this;
            Alloy.createModel("stripe_api").addCard(params).then(this._addCardCarma).catch(function(data) {
                self._stopSpinner();
                new popupWindow().show(false, L("widget_stripe_invalid_card"), {
                    details: L("widget_stripe_invalid_card_details")
                });
            });
        },
        _addCardCarma: function(cardDetails) {
            var userPaymentToken = {
                token: cardDetails.id
            };
            Alloy.createModel("stripe_card").addCard("Stripe", userPaymentToken).then(this._addCardSuccess).catch(this._addCardError);
        },
        _addCardSuccess: function() {
            LOGGER.info("[add card] success");
            var callback = function() {
                Ti.App.fireEvent("cards.refresh");
                Alloy.Globals.Nav.Profile.back();
            };
            this._stopSpinner();
            new popupWindow().show(true, L("widget_stripe_payments_cash_out_great"), {
                callback: callback
            });
        },
        _addCardError: function(e) {
            LOGGER.info("[add card] error is" + e.description);
            this._stopSpinner();
            new popupWindow().show(false, L("widget_stripe_payments_cash_out_sorry"), {
                details: L("widget_stripe_payments_cash_out_failed")
            });
        },
        _blurFields: function(e) {
            if (!this._cardForm) return;
            this._cardForm.blurFields(e);
        },
        _startSpinner: function() {
            Ti.App.fireEvent("carma:progress.start");
        },
        _stopSpinner: function() {
            Ti.App.fireEvent("carma:progress.stop");
        },
        _scrollToDateInput: function() {
            return;
            var coords;
            var screenHeight;
        },
        _scrollToTop: function() {
            $.scrollView.scrollTo(0, 0);
        },
        onDestroy: function() {
            parentWindow.removeAppEventListener("picker.show", this._scrollToDateInput);
            parentWindow.removeAppEventListener("picker.hide", this._scrollToTop);
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;