function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.stripePayments/" + s : s.substring(0, index) + "/ma.car.app.stripePayments/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.stripePayments");
    this.__widgetId = "ma.car.app.stripePayments";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "card_row";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.cardRow = Ti.UI.createTableViewRow({
        id: "cardRow"
    });
    $.__views.cardRow && $.addTopLevelView($.__views.cardRow);
    $.__views.cardContainer = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: 0,
        height: Ti.UI.SIZE,
        id: "cardContainer"
    });
    $.__views.cardRow.add($.__views.cardContainer);
    $.__views.cardIcon = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        width: "60dp",
        height: "40dp",
        left: "10dp",
        top: "10dp",
        bottom: "10dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_CENTER,
        id: "cardIcon"
    });
    $.__views.cardContainer.add($.__views.cardIcon);
    $.__views.cardNum = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "18dp"
        },
        left: "85dp",
        id: "cardNum"
    });
    $.__views.cardContainer.add($.__views.cardNum);
    $.__views.deleteBtn = require("/ui/common/custom_button").createButton({
        color: "#fff",
        font: {
            fontSize: "12dp"
        },
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        title: L("btn_delete"),
        width: "55dp",
        height: 0,
        right: 0,
        opacity: 0,
        id: "deleteBtn"
    });
    $.__views.cardContainer.add($.__views.deleteBtn);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var card = arguments[0] || {}, popupWindow = require("/ui/common/popupWindow");
    exports = new (require("/carmalib/controller").extend($, {
        events: {
            "click[android] deleteBtn": "_confirmDeleteCard",
            "click[ios] deleteBtn": "_confirmDeleteCard"
        },
        initialize: function() {
            this.rendCardRow();
        },
        rendCardRow: function() {
            this._setCardIcon(card.brand);
            $.cardNum.text = "•••• •••• •••• " + card.alias;
        },
        _setCardIcon: function(brand) {
            $.cardIcon.image = "/images/cards/" + brand.replace(" ", "_") + ".png";
        },
        editAction: function() {
            $.deleteBtn.height = "30dp";
            $.deleteBtn.animate({
                opacity: 1,
                duration: 300
            });
        },
        doneAction: function() {
            $.deleteBtn.animate({
                opacity: 0,
                duration: 250
            }, function() {
                $.deleteBtn.height = 0;
            });
        },
        _confirmDeleteCard: function() {
            var dialog = Ti.UI.createAlertDialog({
                cancel: 1,
                buttonNames: [ L("btn_confirm"), L("btn_cancel") ],
                title: L("widget_stripe_delete_card_title"),
                message: L("widget_stripe_delete_card_text")
            });
            var self = this;
            dialog.addEventListener("click", function clickHandler(e) {
                dialog.removeEventListener("click", clickHandler);
                if (e.index === e.source.cancel) return;
                self._deleteCard();
            });
            dialog.show();
        },
        _deleteCard: function() {
            this._startSpinner();
            var self = this;
            Alloy.createModel("stripe_card", {
                id: card.id
            }).deleteCard({
                id: card.id
            }).then(function() {
                Ti.App.fireEvent("cards.refresh");
            }).catch(function() {
                new popupWindow().show(false, L("widget_stripe_delete_card_error"));
            }).finally(function() {
                self._stopSpinner();
            });
        },
        _startSpinner: function() {
            Ti.App.fireEvent("carma:progress.start");
        },
        _stopSpinner: function() {
            Ti.App.fireEvent("carma:progress.stop");
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;