function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.stripePayments/" + s : s.substring(0, index) + "/ma.car.app.stripePayments/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.stripePayments");
    this.__widgetId = "ma.car.app.stripePayments";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "my_card";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.myCardContainer = Ti.UI.createView({
        width: "100%",
        top: 0,
        left: 0,
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        height: "100%",
        id: "myCardContainer"
    });
    $.__views.myCardContainer && $.addTopLevelView($.__views.myCardContainer);
    $.__views.scrollView = Ti.UI.createScrollView({
        top: 0,
        height: "100%",
        width: "100%",
        showVerticalScrollIndicator: false,
        showHorizontalScrollIndicator: true,
        id: "scrollView"
    });
    $.__views.myCardContainer.add($.__views.scrollView);
    $.__views.myCardsWrapper = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: 0,
        layout: "vertical",
        textAlign: "center",
        backgroundColor: "transparent",
        id: "myCardsWrapper"
    });
    $.__views.scrollView.add($.__views.myCardsWrapper);
    $.__views.totalBalance = Ti.UI.createLabel({
        color: "#ff6600",
        font: {
            fontSize: "36dp"
        },
        width: "100%",
        height: "auto",
        textAlign: "center",
        id: "totalBalance"
    });
    $.__views.myCardsWrapper.add($.__views.totalBalance);
    $.__views.balanceDetails = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        width: "100%",
        height: "auto",
        textAlign: "center",
        id: "balanceDetails"
    });
    $.__views.myCardsWrapper.add($.__views.balanceDetails);
    $.__views.balanceHr = Ti.UI.createView({
        top: "20dp",
        width: "100%",
        height: "2px",
        backgroundColor: Alloy.Globals.Style.Color.DarkGray,
        id: "balanceHr"
    });
    $.__views.myCardsWrapper.add($.__views.balanceHr);
    $.__views.cardList = Ti.UI.createView({
        height: Ti.UI.SIZE,
        id: "cardList"
    });
    $.__views.myCardsWrapper.add($.__views.cardList);
    $.__views.buttonsContainer = Ti.UI.createView({
        width: "100%",
        height: "80dp",
        top: "10dp",
        id: "buttonsContainer"
    });
    $.__views.myCardsWrapper.add($.__views.buttonsContainer);
    $.__views.editCard = require("/ui/common/custom_button").createButton({
        color: Alloy.Globals.Style.Color.DarkGray,
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "60dp",
        font: {
            fontSize: "18dp"
        },
        normalColor: "#00333333",
        selectedColor: "#70333333",
        backgroundImage: "none",
        borderColor: Alloy.Globals.Style.Color.DarkGray,
        borderWidth: 2,
        width: "47%",
        left: 0,
        top: 0,
        title: L("widget_stripe_edit_card_btn"),
        id: "editCard"
    });
    $.__views.buttonsContainer.add($.__views.editCard);
    $.__views.addCard = require("/ui/common/custom_button").createButton({
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "60dp",
        font: {
            fontSize: "18dp"
        },
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        top: 0,
        left: 0,
        width: "100%",
        title: L("widget_stripe_add_card_btn"),
        id: "addCard"
    });
    $.__views.buttonsContainer.add($.__views.addCard);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, ui = require("/utils/ui"), Globals = require("/v6/infrastructure/Globals"), ProfileService = Globals.IOC.get("ProfileService"), parentWindow = ui.getWindow(args.__parentSymbol);
    exports = new (require("/carmalib/controller").extend($, {
        _profile: null,
        _eventSet: false,
        _cardTable: null,
        _editing: false,
        events: {
            "click[ios] addCard": "_addCardAction",
            "click[android] addCard": "_addCardAction",
            "click[ios] editCard": "_editCardAction",
            "click[android] editCard": "_editCardAction"
        },
        initialize: function() {
            _.bindAll(this, "showMyCards", "_addCardAction", "_loadCards", "_updateCards");
        },
        showMyCards: function(profile) {
            this._profile = profile;
            this._showMyCreditBalance(profile.creditBalances, profile.credit);
            if (!this._eventSet) {
                this._eventSet = true;
                parentWindow.addAppEventListener("cards.refresh", this._updateCards);
            }
            this._loadCards();
        },
        _showMyCreditBalance: function(creditBalances, credit) {
            if (creditBalances && 0 !== creditBalances.length) {
                var balance = creditBalances[0], currencySymbol = balance.currencySymbol, totalBalance = parseFloat(balance.totalBalance, 10).toFixed(2), payableBalance = parseFloat(balance.payableBalance, 10).toFixed(2), bonusBalance = parseFloat(balance.bonusBalance, 10).toFixed(2);
                $.totalBalance.text = String.format(L("widget_profile_summary_balance_total"), currencySymbol, totalBalance);
                $.balanceDetails.text = String.format(L("widget_profile_summary_balance_details"), currencySymbol, payableBalance, bonusBalance);
            } else {
                var currencySymbol = "$", totalBalance = parseFloat(credit).toFixed(2);
                $.totalBalance.text = String.format(L("widget_profile_summary_balance_total"), currencySymbol, totalBalance);
                $.balanceDetails.text = "";
            }
        },
        _updateCards: function() {
            var self = this;
            Alloy.createModel("stripe_card").getCards().then(function(data) {
                LOGGER.debug("[Stripe payment] -card data " + data.tokens);
                ProfileService.updateCards(self._profile.userId, data.tokens);
                self._profile = ProfileService.getCachedProfile(self._profile.userId);
                self._addCardsTable(data.tokens);
                Ti.App.fireEvent("app.carma.profile.change", self._profile);
            }).catch(function(e) {
                LOGGER.error("[Stripe payment] -card data " + JSON.stringify(e));
            }).finally(function() {
                self._editing && self._cardTable.editAction();
                self._stopSpinner();
            }).done();
        },
        _loadCards: function() {
            this._startSpinner();
            var self = this;
            if (this._profile.cards) {
                this._addCardsTable(this._profile.cards);
                this._editing && this._cardTable.editAction();
                this._stopSpinner();
            } else Alloy.createModel("stripe_card").getCards().then(function(data) {
                LOGGER.debug("[Stripe payment] -card data " + data.tokens);
                ProfileService.updateCards(self._profile.userId, data.tokens);
                self._profile = ProfileService.getCachedProfile(self._profile.userId);
                self._addCardsTable(data.tokens);
            }).catch(function(e) {
                LOGGER.error("[Stripe payment] -card data " + JSON.stringify(e));
            }).finally(function() {
                self._editing && self._cardTable.editAction();
                self._stopSpinner();
            }).done();
        },
        _addCardsTable: function(cards) {
            LOGGER.debug("[my card] -cards info " + cards);
            if ($.cardList.children && $.cardList.children.length > 0) {
                $.cardList.remove($.cardList.children[0]);
                this._cardTable.emptyTable();
            }
            if (!cards || 0 === cards.length) {
                this._editing && this._editCardAction();
                $.editCard.visible = false;
                $.addCard.applyProperties({
                    width: "100%",
                    right: null,
                    left: 0
                });
                return;
            }
            $.addCard.applyProperties({
                width: "47%",
                right: 0,
                left: null
            });
            $.editCard.visible = true;
            LOGGER.debug("[my card] -create table cards length = " + cards.length);
            this._cardTable = this._cardTable || Widget.createWidget("ma.car.app.stripePayments", "card_table", args);
            this._cardTable.showCards(cards);
            $.cardList.add(this._cardTable.getView());
            $.scrollView.setHeight(Ti.UI.SIZE);
        },
        _addCardAction: function() {
            LOGGER.debug("[my card] -click add card ");
            var navigation = Alloy.Globals.Nav.Profile;
            var addCardView = Alloy.createWidget("ma.car.app.stripePayments", "add_card", {
                __parentSymbol: $.getView()
            });
            navigation.open(addCardView);
            addCardView.showAddCardForm(this._profile);
            this._editing && this._editCardAction();
        },
        _editCardAction: function() {
            if (!this._cardTable) return;
            if (this._editing) {
                $.editCard.setTitle(L("widget_stripe_edit_card_btn"));
                this._editing = false;
                this._cardTable.doneAction();
            } else {
                $.editCard.setTitle(L("btn_done"));
                this._editing = true;
                this._cardTable.editAction();
            }
        },
        onDestroy: function() {
            if (this._eventSet) {
                this._eventSet = false;
                parentWindow.removeAppEventListener("cards.refresh", this._updateCards);
            }
        },
        _startSpinner: function() {
            Ti.App.fireEvent("carma:progress.start");
        },
        _stopSpinner: function() {
            Ti.App.fireEvent("carma:progress.stop");
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;