function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.stripePayments/" + s : s.substring(0, index) + "/ma.car.app.stripePayments/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.stripePayments");
    this.__widgetId = "ma.car.app.stripePayments";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "promo_code";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.promoCodeContainer = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.pct100,
        top: 0,
        left: 0,
        height: "100%",
        id: "promoCodeContainer"
    });
    $.__views.promoCodeContainer && $.addTopLevelView($.__views.promoCodeContainer);
    $.__views.promocode = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: 0,
        layout: "vertical",
        height: "100%",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        backgroundColor: "transparent",
        id: "promocode"
    });
    $.__views.promoCodeContainer.add($.__views.promocode);
    $.__views.totalBalance = Ti.UI.createLabel({
        color: "#ff6600",
        font: {
            fontSize: "36dp"
        },
        width: "100%",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        id: "totalBalance"
    });
    $.__views.promocode.add($.__views.totalBalance);
    $.__views.balanceDetails = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        width: "100%",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        id: "balanceDetails"
    });
    $.__views.promocode.add($.__views.balanceDetails);
    $.__views.balanceHr = Ti.UI.createView({
        top: "20dp",
        width: "100%",
        height: "2px",
        backgroundColor: Alloy.Globals.Style.Color.DarkGray,
        id: "balanceHr"
    });
    $.__views.promocode.add($.__views.balanceHr);
    $.__views.promoCodeTitle = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "18dp"
        },
        top: "15dp",
        text: L("widget_stripe_payments_enter_promo_code_below"),
        id: "promoCodeTitle"
    });
    $.__views.promocode.add($.__views.promoCodeTitle);
    $.__views.textField = require("/ui/common/custom_textfield").createTextField({
        paddingLeft: "10dp",
        height: "60dp",
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        width: "100%",
        top: "15dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        hintText: L("widget_stripe_payments_promo_code_hint"),
        borderColor: Alloy.Globals.Style.Color.DarkGray,
        borderWidth: "1px",
        id: "textField"
    });
    $.__views.promocode.add($.__views.textField);
    $.__views.submit = require("/ui/common/custom_button").createButton({
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "60dp",
        font: {
            fontSize: "18dp"
        },
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        width: "100%",
        top: "10dp",
        title: L("widget_stripe_payments_promo_code_submit"),
        id: "submit"
    });
    $.__views.promocode.add($.__views.submit);
    $.__views.howWorksDescripTitle = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        width: "100%",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        top: "20dp",
        text: L("widget_stripe_payments_promo_code_descrip_title"),
        id: "howWorksDescripTitle"
    });
    $.__views.promocode.add($.__views.howWorksDescripTitle);
    $.__views.howWorkDetails = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp"
        },
        top: "5dp",
        width: "100%",
        text: L("widget_stripe_payments_promo_code_details"),
        id: "howWorkDetails"
    });
    $.__views.promocode.add($.__views.howWorkDetails);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var popupWindow = require("/ui/common/popupWindow"), Globals = require("/v6/infrastructure/Globals"), ProfileService = Globals.IOC.get("ProfileService"), CurrentUserService = Globals.IOC.get("CurrentUserService");
    exports = new (require("/carmalib/controller").extend($, {
        events: {
            "click profileOuterContainer": "_dismissKeyboard",
            "click[ios] submit": "_submitAction",
            "click[android] submit": "_submitAction"
        },
        initialize: function() {
            _.bindAll(this, "_promoCodeError", "_promoCodeSuccess", "_onCodeRedeemed", "_onInput");
            $.textField.addEventListener("change", this._onInput);
        },
        onDestroy: function() {
            $.textField.removeEventListener("change", this._onInput);
            $.submit.buttonCleanUp();
        },
        _onInput: function(data) {},
        showPromoCode: function(profile) {
            this._showMyCreditBalance(profile.creditBalances, profile.credit);
        },
        _showMyCreditBalance: function(creditBalances, credit) {
            if (creditBalances && 0 !== creditBalances.length) {
                var balance = creditBalances[0], currencySymbol = balance.currencySymbol, totalBalance = parseFloat(balance.totalBalance).toFixed(2), payableBalance = parseFloat(balance.payableBalance).toFixed(2), bonusBalance = parseFloat(balance.bonusBalance).toFixed(2);
                $.totalBalance.text = String.format(L("widget_profile_summary_balance_total"), currencySymbol, totalBalance);
                $.balanceDetails.text = String.format(L("widget_profile_summary_balance_details"), currencySymbol, payableBalance, bonusBalance);
            } else {
                var currencySymbol = "$", totalBalance = parseFloat(credit).toFixed(2);
                $.totalBalance.text = String.format(L("widget_profile_summary_balance_total"), currencySymbol, totalBalance);
                $.balanceDetails.text = "";
            }
        },
        _submitAction: function() {
            LOGGER.info("[Code Redeeming] - submit " + $.textField.value);
            if ("" === $.textField.value) return;
            var gps = require("gps/gps_manager");
            var location = gps.lastLocation();
            var option = location ? {
                lat: location.lat,
                lon: location.lon
            } : {};
            this._startSpinner();
            Alloy.createModel("user_redeem").redeem($.textField.value, option).then(this._onCodeRedeemed).catch(this._promoCodeError);
        },
        _onCodeRedeemed: function(result) {
            result.inviterId ? this._onInviteCodeRedeemed(result.inviterId) : this._promoCodeSuccess(result.userCurrencyBalance);
        },
        _onInviteCodeRedeemed: function(inviterId) {
            var callback = function() {
                Alloy.Globals.Nav.Profile.back();
                $.textField.value = "";
            };
            var options = {
                callback: callback,
                details: L("widget_stripe_payments_enter_invite_code_success_detail"),
                timeout: 5e3
            };
            this._stopSpinner();
            var _window = Ti.UI.createWindow({
                backgroundColor: "#fff",
                opacity: 1,
                width: "100%",
                height: "100%",
                id: "popupInviteWin",
                navBarHidden: true
            });
            var _widget = Alloy.createWidget("ma.car.app.invites", "inviteeRewardShare", _.extend({
                window: _window
            }, {
                invitee: inviterId,
                noReward: true
            }));
            _window.add(_widget.getView());
            _window.open({
                modal: false
            });
        },
        _promoCodeSuccess: function(result) {
            var callback = function() {
                Alloy.Globals.Nav.Profile.back();
                Ti.App.fireEvent("paymentRefreshBalance", {
                    bonusBalance: result.bonusBalance
                });
                $.textField.value = "";
            };
            var options = {
                callback: callback,
                details: L("widget_stripe_payments_enter_promo_success_detail")
            };
            ProfileService.updateBonusBalance(CurrentUserService.id, result.bonusBalance);
            require("services/user_service").findOwn().then(function(data) {
                Ti.App.fireEvent("app.carma.profile.change", data);
            });
            this._stopSpinner();
            new popupWindow().show(true, L("widget_stripe_payments_enter_promo_success"), options);
        },
        _promoCodeError: function(e) {
            LOGGER.info("[Promo code] error is" + e.description);
            var options = {
                details: L("widget_stripe_payments_enter_promo_code_invaild_details")
            };
            this._stopSpinner();
            LOGGER.error();
            require("/utils/errorHandler").noticeError(_.extend({
                action: "REDEEM"
            }, e));
        },
        _dismissKeyboard: function(e) {
            e && e.source && "textField" !== e.source.id && $.textField.blur();
        },
        _startSpinner: function() {
            Ti.App.fireEvent("carma:progress.start");
        },
        _stopSpinner: function() {
            Ti.App.fireEvent("carma:progress.stop");
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;