function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.tools/" + s : s.substring(0, index) + "/ma.car.app.tools/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.tools");
    this.__widgetId = "ma.car.app.tools";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "server/widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.win = require("/ui/common/custom_window").createWindow({
        orientationModes: [ Ti.UI.PORTRAIT ],
        backgroundColor: "#fff",
        fullscreen: false,
        navBarHidden: "true",
        layout: "vertical",
        id: "win",
        modal: "true"
    });
    $.__views.win && $.addTopLevelView($.__views.win);
    $.__views.header = Ti.UI.createView({
        top: 0,
        left: 0,
        height: "60dp",
        width: Ti.UI.FILL,
        backgroundColor: "#34495e",
        id: "header"
    });
    $.__views.win.add($.__views.header);
    $.__views.title = Ti.UI.createLabel({
        color: "#fff",
        top: "30dp",
        width: Ti.UI.FILL,
        textAlign: "center",
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        id: "title",
        text: "Tools"
    });
    $.__views.header.add($.__views.title);
    $.__views.back = require("/ui/common/tactile_label").createLabel({
        color: "#fff",
        font: {
            fontSize: "15dp"
        },
        top: "10dp",
        left: "10dp",
        height: "60dp",
        id: "back",
        text: "Back"
    });
    $.__views.header.add($.__views.back);
    $.__views.tableView = Ti.UI.createTableView({
        top: "0dp",
        left: "0dp",
        allowsSelection: true,
        id: "tableView"
    });
    $.__views.win.add($.__views.tableView);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var self = this;
    var args = arguments[0] || {};
    $.header.remove($.back);
    if ($.win) {
        $.win.close();
        args.onClose();
    }
    $.tableView.addEventListener("click", function(e) {
        var profile = e.rowData.profile || e.row.profile;
        require("bootstrap/env").update(profile);
        args.onClose(true);
        $.win.close();
    });
    self.load = function() {
        var tableData = [];
        var index = 0;
        var selectedIndex = index;
        var selectedProfile = require("bootstrap/env").getProfile();
        _.each(require("bootstrap/env").getProfiles(), function(profile) {
            var ctrl = Widget.createController("server/tblRow", profile);
            var row = ctrl.getView();
            row.profile = profile;
            tableData.push(row);
            profile.id === selectedProfile.id && (selectedIndex = index);
            index++;
        });
        $.tableView.setData(tableData);
        $.tableView.getSections()[0].getRows()[selectedIndex].setBackgroundColor(Alloy.Globals.Style.Color.Orange);
    };
    self.load();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;