function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.tripcard/" + s : s.substring(0, index) + "/ma.car.app.tripcard/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    function deviateCurrentTrip(trip, deviationMins) {
        Alloy.createModel("trip_deviation").deviate(trip.id, trip.schedule.baseEffectiveTime, deviationMins).then(function(data) {
            Ti.App.fireEvent("app.carma.profile.change");
        }).catch(function(e) {
            $.whisper("tripcard.show.ErrorDialog", _.extend({
                action: "USER_TRIP_DEVIATION"
            }, e));
        }).finally(function() {}).done();
    }
    function turnOffTrip(trip) {
        if (!trip) return;
        trip.enabled = false;
        trip.matchesCount && delete trip.matchesCount;
        Alloy.createModel("trip").saveTrip(trip).then(function() {
            Ti.App.fireEvent("app.carma.profile.change");
        }).catch(function(e) {
            $.whisper("tripcard.show.ErrorDialog", _.extend({
                action: "TURN_OFF_TRIP"
            }, e));
        }).finally(function() {}).done();
    }
    function confirmTrip(trip, willGoing, options) {
        if (!trip) return;
        options = options || {};
        Alloy.createModel("trip_confirm").confirm(trip.id, trip.schedule.baseEffectiveTime, !!willGoing).catch(function(e) {
            $.whisper("tripcard.show.ErrorDialog", _.extend({
                action: "USER_TRIP_CONFIRM"
            }, e));
        }).finally(function() {
            options.noPopupPrompt || Ti.App.fireEvent("app.carma.profile.change");
            options.callback && _.isFunction(options.callback) && options.callback();
        });
    }
    var Widget = new (require("alloy/widget"))("ma.car.app.tripcard");
    this.__widgetId = "ma.car.app.tripcard";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "tripcard";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.tripcard = Ti.UI.createView({
        width: "100%",
        height: Ti.UI.SIZE,
        id: "tripcard"
    });
    $.__views.tripcard && $.addTopLevelView($.__views.tripcard);
    $.__views.layoutContainer = Ti.UI.createView({
        visible: "false",
        width: "100%",
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "layoutContainer"
    });
    $.__views.tripcard.add($.__views.layoutContainer);
    $.__views.tripCardTitle = Ti.UI.createLabel({
        color: "#fff",
        text: "CARD",
        width: Ti.UI.SIZE,
        height: "50dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        backgroundColor: "transparent",
        id: "tripCardTitle"
    });
    $.__views.layoutContainer.add($.__views.tripCardTitle);
    $.__views.cardContainer = Ti.UI.createView({
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        right: "3dp",
        left: "3dp",
        id: "cardContainer"
    });
    $.__views.layoutContainer.add($.__views.cardContainer);
    $.__views.header = Ti.UI.createView({
        top: 0,
        left: 0,
        height: "65dp",
        width: Ti.UI.FILL,
        zIndex: 100,
        layout: "vertical",
        backgroundColor: "#fff",
        id: "header"
    });
    $.__views.cardContainer.add($.__views.header);
    $.__views.date = Ti.UI.createLabel({
        color: "#666",
        left: "10dp",
        width: Ti.UI.SIZE,
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        top: "6dp",
        id: "date"
    });
    $.__views.header.add($.__views.date);
    $.__views.__alloyId1044 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        id: "__alloyId1044"
    });
    $.__views.header.add($.__views.__alloyId1044);
    $.__views.tripTime = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        left: "10dp",
        width: "70dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        id: "tripTime"
    });
    $.__views.__alloyId1044.add($.__views.tripTime);
    $.__views.origin = Ti.UI.createLabel({
        color: "#666",
        left: "70dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        id: "origin"
    });
    $.__views.__alloyId1044.add($.__views.origin);
    $.__views.__alloyId1045 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        id: "__alloyId1045"
    });
    $.__views.header.add($.__views.__alloyId1045);
    $.__views.tripType = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        left: "10dp",
        width: "70dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        id: "tripType"
    });
    $.__views.__alloyId1045.add($.__views.tripType);
    $.__views.destination = Ti.UI.createLabel({
        color: "#666",
        left: "70dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        id: "destination"
    });
    $.__views.__alloyId1045.add($.__views.destination);
    $.__views.container = Ti.UI.createView({
        top: "65dp",
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        layout: "vertical",
        backgroundColor: "#fff",
        id: "container"
    });
    $.__views.cardContainer.add($.__views.container);
    $.__views.mapWrapper = Ti.UI.createView({
        top: "10dp",
        width: Ti.UI.FILL,
        height: "90dp",
        borderRadius: 0,
        id: "mapWrapper"
    });
    $.__views.container.add($.__views.mapWrapper);
    $.__views.mapImage = Ti.UI.createImageView({
        defaultImage: "/images/map_background.png",
        top: 0,
        width: Ti.UI.FILL,
        height: "90dp",
        image: "/images/map_background.png",
        id: "mapImage"
    });
    $.__views.mapWrapper.add($.__views.mapImage);
    $.__views.__alloyId1046 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "6dp",
        id: "__alloyId1046"
    });
    $.__views.container.add($.__views.__alloyId1046);
    $.__views.__alloyId1047 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "6dp",
        id: "__alloyId1047"
    });
    $.__views.container.add($.__views.__alloyId1047);
    $.__views.lblContainer = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "lblContainer"
    });
    $.__views.container.add($.__views.lblContainer);
    $.__views.lblView = Ti.UI.createView({
        height: Ti.UI.SIZE,
        width: Ti.UI.SIZE,
        layout: "horizontal",
        id: "lblView"
    });
    $.__views.lblContainer.add($.__views.lblView);
    $.__views.lblViewBack = Ti.UI.createView({
        visible: false,
        height: 0,
        id: "lblViewBack"
    });
    $.__views.lblContainer.add($.__views.lblViewBack);
    $.__views.__alloyId1048 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "6dp",
        id: "__alloyId1048"
    });
    $.__views.container.add($.__views.__alloyId1048);
    $.__views.__alloyId1049 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "composite",
        top: "6dp",
        left: "10dp",
        right: "10dp",
        bottom: "10dp",
        id: "__alloyId1049"
    });
    $.__views.container.add($.__views.__alloyId1049);
    $.__views.btnEditTrip = require("/ui/common/custom_button").createButton({
        normalColor: "#00444444",
        selectedColor: "#70444444",
        backgroundImage: "none",
        borderColor: "#444",
        borderWidth: Alloy.Globals.Style.Unit.unit1,
        left: 0,
        width: "48%",
        color: "#555",
        backgroundColor: "#00444444",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "44dp",
        disableAnimation: true,
        title: "",
        id: "btnEditTrip"
    });
    $.__views.__alloyId1049.add($.__views.btnEditTrip);
    $.__views.__alloyId1050 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        id: "__alloyId1050"
    });
    $.__views.btnEditTrip.add($.__views.__alloyId1050);
    $.__views.__alloyId1051 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId1051"
    });
    $.__views.__alloyId1050.add($.__views.__alloyId1051);
    $.__views.btnFirstLabel = Ti.UI.createLabel({
        color: "#555",
        width: Ti.UI.SIZE,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        text: L("widget_samantha_trip_edit_trip"),
        id: "btnFirstLabel"
    });
    $.__views.__alloyId1051.add($.__views.btnFirstLabel);
    $.__views.btnPlanTrip = require("/ui/common/custom_button").createButton({
        right: 0,
        width: "48%",
        color: "#555",
        normalColor: "#ff6600",
        selectedColor: "#70444444",
        backgroundColor: "#ff6600",
        backgroundImage: "none",
        borderColor: "transparent",
        borderWidth: 0,
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "44dp",
        title: "",
        id: "btnPlanTrip"
    });
    $.__views.__alloyId1049.add($.__views.btnPlanTrip);
    $.__views.__alloyId1052 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        id: "__alloyId1052"
    });
    $.__views.btnPlanTrip.add($.__views.__alloyId1052);
    $.__views.__alloyId1053 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId1053"
    });
    $.__views.__alloyId1052.add($.__views.__alloyId1053);
    $.__views.btnSecondLabel = Ti.UI.createLabel({
        color: "white",
        width: Ti.UI.SIZE,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        text: L("widget_decision_future_button"),
        id: "btnSecondLabel"
    });
    $.__views.__alloyId1053.add($.__views.btnSecondLabel);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var trackingEvent = require("/tracking/tracking_event"), analytics = require("/tracking/tracking_manager"), i18n = require("i18n/i18n"), utils = require("utils/utils"), appSound = require("/utils/appSound"), args = arguments[0] || {}, css = require("ui/css"), tripcard = args.tripcard, rootWindow = TABS_HELPER.rootWindow(), index = args.index;
    var _tripConfirmedSound = null, thisTrip = null, thisBookings = null;
    exports = new (require(WPATH("cardTemplate")).extend($, {
        tripcard: tripcard,
        cardName: "tripcard",
        customAnimation: false,
        _trip: null,
        _bookings: null,
        _driver: null,
        _tripOnging: false,
        _tripDate: null,
        _inviteId: null,
        _inviteCode: null,
        _openingShare: false,
        _shareOpening: false,
        events: {
            "click btnPlanTrip": "_planTripEvent",
            "click btnEditTrip": "_editEvent",
            "click mapWrapper": "_openMapEvent"
        },
        initialize: function() {
            _.bindAll(this, "editTripAction", "_openNativeShare", "_openShare");
        },
        configure: function() {
            _.bindAll(this, "_enableStartTrip", "_disableStartTrip", "_updateDetail", "destoryEvent");
            rootWindow.addAppEventListener("carma:trips.trip_started", this._disableStartTrip);
            rootWindow.addAppEventListener("carma:boarding.driver.starttrip", this._disableStartTrip);
            rootWindow.addAppEventListener("carma:boarding.solo.endtrip", this._enableStartTrip);
            rootWindow.addAppEventListener("carma:boarding.trip_ended", this._enableStartTrip);
            rootWindow.addAppEventListener("carma:boarding.trip_completed", this._enableStartTrip);
            rootWindow.addAppEventListener("carma:boarding.dropoff", this._enableStartTrip);
            rootWindow.addAppEventListener("carma:boarding.countdown.cancel", this._enableStartTrip);
            rootWindow.addAppEventListener("carma:start.boarding.count.down", this._disableStartTrip);
            rootWindow.addAppEventListener("carma:boarding.details_updated", this._updateDetail);
        },
        onDestroy: function() {
            this.destoryEvent();
        },
        _updateDetail: function(event) {
            var trip = event.trip;
            if (trip.invalid) return;
            LOGGER.info("[tripcard] got event, updating the view...");
            this._checkOnGoingTrip();
        },
        destoryEvent: function() {
            rootWindow.removeAppEventListener("carma:trips.trip_started", this._disableStartTrip);
            rootWindow.removeAppEventListener("carma:boarding.driver.starttrip", this._disableStartTrip);
            rootWindow.removeAppEventListener("carma:boarding.solo.endtrip", this._enableStartTrip);
            rootWindow.removeAppEventListener("carma:boarding.trip_ended", this._enableStartTrip);
            rootWindow.removeAppEventListener("carma:boarding.trip_completed", this._enableStartTrip);
            rootWindow.removeAppEventListener("carma:boarding.dropoff", this._enableStartTrip);
            rootWindow.removeAppEventListener("carma:boarding.countdown.cancel", this._enableStartTrip);
            rootWindow.removeAppEventListener("carma:start.boarding.count.down", this._disableStartTrip);
            rootWindow.removeAppEventListener("carma:boarding.details_updated", this._updateDetail);
        },
        _disableStartTrip: function() {
            null != thisBookings && (this._tripOnging = true);
        },
        _enableStartTrip: function() {
            null != thisBookings && (this._tripOnging = false);
        },
        calculateLayoutContainerHeight: function() {
            return $.cardContainer.size.height + utils.dpToPixel(30);
        },
        _openMapEvent: function(e) {
            tripcard.whisper("tripcard.open.map", {
                trip: this._trip
            });
        },
        _editEvent: function(e) {
            var opts = {};
            opts.options = [ L("widget_decision_edittrip_notthistime"), L("widget_decision_edittrip_delay5"), L("widget_decision_edittrip_delay15"), L("widget_decision_edittrip_delay60"), L("widget_decision_edittrip_edittrip") ];
            opts.cancel = -1;
            if (this._bookings) {
                opts.options = [ L("widget_decision_edittrip_delay5"), L("widget_decision_edittrip_delay15"), L("widget_decision_edittrip_delay60") ];
                opts.cancel = -1;
            }
            var editTripDialog = Ti.UI.createOptionDialog(opts), self = this;
            editTripDialog.addEventListener("click", function clickHandler(e) {
                editTripDialog.removeEventListener("click", clickHandler);
                self.editTripAction(e);
            });
            editTripDialog.show();
        },
        _planTripEvent: function(e) {
            if (!$.btnPlanTrip.enabled) return;
            if (this._tripOnging) {
                Ti.App.fireEvent("carma:starttrip.tab");
                return;
            }
            if (null != thisBookings) if ("DRIVE" === this._trip.type) {
                Ti.App.fireEvent("carma:starttrip.tab", {
                    driving: true
                });
                this._disableStartTrip();
            } else this._startRide(); else Ti.App.fireEvent("carma:plantrip.tab");
        },
        _isBalanceRunningLow: function() {
            var resourceOwner = require("services/resource_owner_service").singleton();
            return parseFloat(resourceOwner.get("credit")) <= 0;
        },
        lowCreditPopup: function(freeRider) {
            var buttons = [ L("btn_ok"), L("widget_boarding_no_credits_buy_now") ], cancelIndex = 0;
            buttons = [ L("widget_boarding_no_credits_buy_now"), L("btn_ok") ];
            cancelIndex = 1;
            var dialog = Ti.UI.createAlertDialog({
                cancel: cancelIndex,
                buttonNames: buttons,
                message: L("widget_boarding_no_credits_message")
            });
            var self = this;
            dialog.addEventListener("click", function clickHandler(e) {
                dialog.removeEventListener("click", clickHandler);
                if (e.index !== cancelIndex) Ti.App.fireEvent("carma:topup.open", {
                    tab: "startTrip"
                }); else if (self._driver.canUserGiveFreeDrive) {
                    var params = {};
                    params.riding = true;
                    params.driver = self._driver;
                    Ti.App.fireEvent("carma:starttrip.tab", params);
                    self._disableStartTrip();
                }
            });
            dialog.show();
            TM.push(function() {
                require("services/user_service").findOwn().then(function(data) {
                    Ti.App.fireEvent("app.carma.profile.change", data);
                });
            });
        },
        _startRide: function() {
            var buttons = [ L("btn_cancel"), L("btn_confirm") ], cancelIndex = 0;
            buttons = [ L("btn_confirm"), L("btn_cancel") ];
            cancelIndex = 1;
            var dialog = Ti.UI.createAlertDialog({
                cancel: cancelIndex,
                buttonNames: buttons,
                title: L("widget_crew_board_help_title"),
                message: L("widget_crew_board_help_message")
            });
            var self = this;
            dialog.addEventListener("click", function clickHandler(e) {
                dialog.removeEventListener("click", clickHandler);
                if (e.index === cancelIndex || null == self._driver) return;
                self._driver.id = self._driver.userId;
                var params = {};
                params.riding = true;
                params.driver = self._driver;
                if (self._isBalanceRunningLow()) self.lowCreditPopup(); else {
                    Ti.App.fireEvent("carma:starttrip.tab", params);
                    self._disableStartTrip();
                }
            });
            dialog.show();
        },
        prepareView: function(options) {
            var trip = options.trip, availableScreenHeight = options.availableScreenHeight;
            var dateMoment = moment(trip.schedule.effectiveTime), dateTime = i18n.formatTime(dateMoment);
            $.date.text = moment(trip.schedule.effectiveTime).format("Do MMM");
            $.tripTime.setText(dateTime);
            this._tripDate = moment(trip.schedule.effectiveTime).format("Do MMM");
            $.tripType.setText(L("widget_decision_samantha_" + trip.type));
            $.origin.setText(trip.origin.address);
            $.destination.setText(String.format(L("widget_decision_samantha_destination"), trip.destination.address));
            if (this._bookings) {
                $.tripCardTitle.setText(L("widget_samantha_your_booked_trip_title"));
                this._createCaptionLabel(this._bookings);
            } else {
                $.tripCardTitle.setText(L(index ? "widget_samantha_your_upcoming_trip_title" : "widget_samantha_your_next_trip_title"));
                this._createCaptionLabel(null);
            }
            if (null != index && index > 0) {
                $.btnPlanTrip.setVisible(false);
                $.btnEditTrip.setWidth(Ti.UI.FILL);
            }
            this.requestStaticMapImgAndResizeMap(trip, availableScreenHeight);
        },
        checkBooking: function(trip) {
            var self = this;
            require("services/booking_service").findByTrip(trip.id, false).then(function(data) {
                if (data && data.rideBookings.length > 0) {
                    self._bookings = data.rideBookings;
                    thisBookings = data.rideBookings;
                    $.tripCardTitle.setText(L("widget_samantha_your_booked_trip_title"));
                    self._createCaptionLabel(data.rideBookings);
                } else {
                    $.tripCardTitle.setText(L("widget_samantha_your_next_trip_title"));
                    self._createCaptionLabel(null);
                }
            });
        },
        display: function(options) {
            if (!options.trip) return;
            $.layoutContainer.width = options.cardWidth + "dp";
            $.layoutContainer.height = options.availableScreenHeight + "dp";
            thisTrip = options.trip;
            this._trip = options.trip;
            this._bookings = options.booking;
            thisBookings = options.booking;
            this.prepareView(options);
            $.layoutContainer.show();
        },
        _checkOnGoingTrip: function() {
            this._tripOnging = false;
        },
        _createCaptionLabel: function(bookings) {
            $.lblView.removeAllChildren();
            var self = this, myUserId = require("services/resource_owner_service").singleton().get("userId");
            if (bookings) {
                $.btnSecondLabel.text = L("widget_crew_start_trip");
                this._checkOnGoingTrip();
                if (bookings[0].rider.userId === myUserId) {
                    var booking = bookings[0];
                    if (booking) {
                        this._driver = booking.driver;
                        $.tripTime.setText(i18n.formatTime(moment(booking.trip.baseTrip.schedule.effectiveTime)));
                        $.lblView.hide();
                        var labelView1 = this.linkLabel(booking.driver.alias);
                        $.lblView.add(labelView1);
                        var label2 = this.textLabel(L("widget_tripcard_driver_msg"));
                        $.lblView.add(label2);
                        var userId = booking.driver.userId;
                        labelView1.addEventListener("click", function() {
                            self._openProfile(userId);
                        });
                        $.lblView.applyProperties({
                            width: Ti.UI.SIZE
                        });
                        $.lblView.show();
                    }
                } else {
                    var riders = [];
                    for (var i = 0; i < bookings.length; i++) (bookings[i].trip.baseTrip.id == this._trip.id || bookings[i].sourceTrip.baseTrip.id == this._trip.id) && riders.indexOf(bookings[i].rider.userId) < 0 && riders.push(bookings[i].rider.userId);
                    riders.length > 0 && $.lblView.hide();
                    for (var i = 0; i < riders.length; i++) {
                        var labelView1 = this.linkLabel(bookings[i].rider.alias);
                        $.lblView.add(labelView1);
                        labelView1.userId = bookings[i].rider.userId;
                        labelView1.addEventListener("click", function() {
                            self._openProfile(this.userId);
                        });
                        if (riders.length > 1) if (i < riders.length - 2) {
                            var label2 = this.textLabel(",");
                            $.lblView.add(label2);
                        } else if (i == riders.length - 2) {
                            var label2 = this.textLabel(" and ");
                            $.lblView.add(label2);
                        }
                    }
                    if (riders.length > 0) {
                        var text = L(riders.length > 1 ? "widget_tripcard_rider_msg" : "widget_tripcard_one_rider_msg");
                        var words = text.split(" ");
                        for (var i = 0; i < words.length; i++) {
                            var label3 = this.textLabel(" " + words[i]);
                            $.lblViewBack.add(label3);
                        }
                        setTimeout(function updateLabelText() {
                            var children1 = $.lblView.getChildren();
                            if (children1[0].getSize().width <= 0) {
                                setTimeout(updateLabelText, 1e3);
                                return;
                            }
                            var children = $.lblViewBack.getChildren();
                            $.lblViewBack.removeAllChildren();
                            $.lblViewBack.setHeight(0);
                            var width = 0;
                            for (var i = 0; i < children.length; i++) {
                                width += children[i].getSize().width;
                                if (width >= $.lblView.getSize().width) {
                                    children[i].setWidth(children[i].getSize().width + 4);
                                    width = children[i].getWidth();
                                }
                                $.lblView.add(children[i]);
                            }
                            $.lblView.applyProperties({
                                width: "90%"
                            });
                            $.lblView.show();
                        }, 1e3);
                    }
                }
            } else {
                $.lblView.hide();
                var labelView1 = this.linkLabel(L("widget_tripcard_share1_msg"));
                $.lblView.add(labelView1);
                var label2 = this.textLabel(L("widget_tripcard_share2_msg"));
                $.lblView.add(label2);
                $.lblContainer.addEventListener("click", this._openNativeShare);
                $.lblView.applyProperties({
                    width: Ti.UI.SIZE
                });
                $.lblView.show();
            }
        },
        textLabel: function(text) {
            var label = Ti.UI.createLabel({
                text: text,
                color: "#666",
                height: "15dp",
                width: Ti.UI.SIZE,
                wordwrap: true,
                font: {
                    fontSize: "17dp"
                }
            });
            label.applyProperties({
                height: "22dp",
                top: -1
            });
            return label;
        },
        linkLabel: function(text) {
            var label = Ti.UI.createLabel({
                top: 0,
                text: text,
                width: Ti.UI.SIZE,
                color: Alloy.Globals.Style.Color.LightBlue,
                font: {
                    fontSize: "17dp"
                }
            });
            var decoratedView = Titanium.UI.createView({
                width: Titanium.UI.SIZE,
                height: Titanium.UI.SIZE,
                layout: "vertical",
                left: 0
            });
            decoratedView.add(label);
            setTimeout(function updateUnderline() {
                if (null == label || null == label.getSize() || label.getSize().width <= 0) {
                    setTimeout(updateUnderline, 1e3);
                    return;
                }
                var lineView = Titanium.UI.createView({
                    width: label.getSize().width,
                    left: label.left,
                    height: "1dp",
                    backgroundColor: label.color ? label.color : "white",
                    top: "-1dp",
                    bottom: 0
                });
                decoratedView.add(lineView);
            }, 1e3);
            return decoratedView;
        },
        _openNativeShare: function() {
            if (this.__openingShare) return;
            this._openingShare = true;
            var self = this;
            this._inviteId ? this._openShare() : Alloy.createModel("invitation").generate({
                method: "UNKNOWN",
                entity: "user"
            }).then(function(data) {
                self._inviteId = data.id;
                self._openShare();
            });
        },
        _openShare: function() {
            this._openingShare = false;
            require("ui/common/sharing").openShare({
                type: "tripCard",
                tripDate: this._tripDate,
                inviteId: this._inviteId,
                headerData: $.header.toImage(null, true),
                mapData: $.mapWrapper.toImage(null, true)
            }, this);
        },
        _openProfile: function(userId) {
            Ti.App.fireEvent("carma:profile.open", {
                userId: userId
            });
        },
        editTripAction: function(params) {
            var trip = this._trip;
            if (thisBookings) switch (params.index) {
              case 0:
                deviateCurrentTrip(trip, 5);
                break;

              case 1:
                deviateCurrentTrip(trip, 15);
                break;

              case 2:
                deviateCurrentTrip(trip, 60);
                break;

              case 3:            } else switch (params.index) {
              case 0:
                confirmTrip(trip, false);
                break;

              case 1:
                deviateCurrentTrip(trip, 5);
                break;

              case 2:
                deviateCurrentTrip(trip, 15);
                break;

              case 3:
                deviateCurrentTrip(trip, 60);
                break;

              case 4:
                Alloy.createWidget("ma.car.app.trip", {
                    tripId: trip.id
                }).getView().open();
                break;

              case 5:            }
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;