function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.tripcard/" + s : s.substring(0, index) + "/ma.car.app.tripcard/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.tripcard");
    this.__widgetId = "ma.car.app.tripcard";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "trips";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.layoutContainer = Ti.UI.createView({
        visible: "false",
        height: Ti.UI.SIZE,
        top: 0,
        layout: "vertical",
        id: "layoutContainer"
    });
    $.__views.layoutContainer && $.addTopLevelView($.__views.layoutContainer);
    var __alloyId1054 = [];
    $.__views.tripsContainer = Ti.UI.createScrollableView({
        showPagingControl: true,
        top: 0,
        disableBounce: true,
        pagingControlColor: "transparent",
        width: Ti.UI.FILL,
        views: __alloyId1054,
        id: "tripsContainer"
    });
    $.__views.layoutContainer.add($.__views.tripsContainer);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, Q = require("vendor/q"), utils = require("utils/utils"), Queue = require("/utils/queue"), currentPage = 0, tripcard = args.tripcard;
    exports = new (require(WPATH("cardTemplate")).extend($, {
        _trips: null,
        cardName: "trips",
        customAnimation: false,
        tripcard: args.tripcard,
        _screenWidth: 0,
        _cards: [],
        _ui: new Queue({
            name: "ui",
            timeout: 200
        }),
        _widgets: [],
        _cardWidth: 0,
        _cardHeight: 0,
        display: function(options) {
            if (!options.trips) return;
            this._trips = options.trips;
            this.prepareView(options);
            $.layoutContainer.show();
            tripcard.whisper("tripcard.showCard", {
                cardName: this.cardName
            });
        },
        prepareView: function(options) {
            var self = this;
            _.bindAll(this, "_createNativeCards");
            this._screenWidth = require("utils/utils").pixelToDp(Ti.Platform.displayCaps.platformWidth);
            this._cardWidth = this._screenWidth - 20;
            this._cardHeight = options.availableScreenHeight;
            options.cardWidth = this._cardWidth;
            for (var i = 0; i < this._widgets.length; i++) this._widgets[i].destoryEvent();
            $.layoutContainer.hide();
            $.layoutContainer.removeAllChildren();
            $.layoutContainer.applyProperties({
                height: options.availableScreenHeight + "dp"
            });
            var widgets = [];
            this._widgets = [];
            for (var i = 0; i < this._trips.length; i++) {
                var booking = this.getConfirmedBookingsFromTrip(options.bookings, this._trips[i].baseTrip);
                var tripCardWidget = Alloy.createWidget("ma.car.app.tripcard", "tripcard", {
                    tripcard: tripcard,
                    index: i
                });
                options.trip = this._trips[i].baseTrip;
                options.booking = booking;
                tripCardWidget.display(options);
                widgets.push(tripCardWidget);
                this._widgets.push(tripCardWidget);
            }
            this._createNativeCardsForAndroid();
            return;
            var topScrollContainerGroup, sViewPagingControl;
            var PagingControl;
        },
        getConfirmedBookingsFromTrip: function(abookings, trip) {
            var bookings = [], myUserId = require("services/resource_owner_service").singleton().get("userId");
            _.each(abookings, function(booking) {
                if ("ACCEPTED" === booking.state && "MANUAL" === booking.trigger) {
                    var mybookingTrip = myUserId === booking.trip.ownerUid ? booking.trip : booking.sourceTrip;
                    if (mybookingTrip && mybookingTrip.baseTrip) {
                        mybookingTrip = mybookingTrip.baseTrip;
                        if (mybookingTrip.id === trip.id && mybookingTrip.schedule.baseEffectiveTime === trip.schedule.baseEffectiveTime) {
                            booking.buddy = myUserId === booking.driver.userId ? booking.rider : booking.driver;
                            bookings.push(booking);
                        }
                    }
                }
            });
            return bookings.length > 0 ? bookings : null;
        },
        setViewWidth: function(view) {
            var self = this;
            this._ui.push(function() {
                var dfd = Q.defer();
                view.animate({
                    duration: 0,
                    width: Math.floor(.92 * self._screenWidth)
                }, function() {
                    dfd.resolve();
                });
                return dfd.promise;
            });
        },
        _createNativeCards: function() {
            var macarnativecode = require("ma.car.nativecode");
            this._cardLength = this._widgets.length;
            var startLeft = Math.floor(this._screenWidth - this._cardWidth) / 2;
            var badgeScrollableView = Titanium.UI.createView({
                top: 0,
                left: startLeft,
                height: this._cardHeight + "dp",
                width: (this._cardWidth + 5) * this._cardLength + "dp"
            });
            for (var i = 0; i < this._widgets.length; i++) {
                var badgeWidget = this._widgets[i].getView();
                badgeWidget.top = 0;
                badgeWidget.left = (this._cardWidth + 5) * i;
                badgeScrollableView.add(badgeWidget);
            }
            var self = this;
            var slideView = macarnativecode.createSlideView({
                color: "#0c0c0c0c",
                top: 0,
                left: 0,
                width: this._screenWidth,
                height: this._cardHeight,
                touchWidth: this._screenWidth,
                pageWidth: this._cardWidth + 5,
                viewContainer: badgeScrollableView,
                pageNum: this._cardLength,
                startLeft: startLeft,
                duration: 400,
                outerScrollView: tripcard.outerScrollView,
                zoomAnim: false
            });
            $.layoutContainer.add(slideView);
        },
        _createNativeCardsForAndroid: function(argument) {
            var module = require("ma.car.nativecode");
            this._cardLength = this._widgets.length;
            var self = this;
            var slideView = module.createSlideView({
                color: "#0c0c0c0c",
                top: 0,
                left: 0,
                width: this._screenWidth + "dp",
                height: this._cardHeight + "dp",
                pageWidth: this._cardWidth + "dp",
                zoomAnim: false
            });
            $.layoutContainer.add(slideView);
            for (var i = 0; i < this._widgets.length; i++) slideView.add(this._widgets[i].getView());
            if (this._widgets.length > 1) {
                slideView.addEventListener("slide.animation.started", function(res) {
                    tripcard.trigger("slide.animation.started");
                });
                slideView.addEventListener("slide.animation.end", function(res) {
                    tripcard.trigger("slide.animation.end");
                });
            }
        },
        disappear: function(callback) {
            for (var i = 0; i < this._widgets.length; i++) this._widgets[i].destoryEvent();
            this.layoutContainer.hide();
            this.tripcard.removeCard(this.cardName);
            callback && _.isFunction(callback) && callback();
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;