"use strict";

!function() {
    var domainStack = [];
    module.exports = {
        getCurrentDomain: function() {
            return 0 === domainStack.length ? null : domainStack[domainStack.length - 1];
        },
        getCurrentDomainName: function() {
            return 0 === domainStack.length ? null : domainStack[domainStack.length - 1].getName();
        },
        create: function(key) {
            var self = this;
            return {
                getName: function() {
                    return key;
                },
                enter: function() {
                    domainStack.push(this);
                    process && (process.domain = this);
                },
                exit: function() {
                    domainStack.pop();
                    process && (process.domain = self.getCurrentDomain());
                },
                bind: function(cb) {
                    var theDomain = this;
                    return function() {
                        theDomain.enter();
                        try {
                            cb();
                        } catch (e) {
                            LOGGER.error("Bound callback threw exception: " + JSON.stringify(e));
                        }
                        theDomain.exit();
                    };
                }
            };
        }
    };
}();