"use strict";

var online = true, experience = true;

var _isConnectionGood = function() {
    if (!Ti.Network.online) return false;
    return experience;
};

var handleNetwork = function(newNetworkStatus, newExperience) {
    if (online === newNetworkStatus && experience === newExperience) return;
    online = newNetworkStatus;
    experience = newExperience;
    Ti.App.fireEvent("carma:network.change", {
        connected: online,
        experience: experience,
        networkType: Ti.Network.networkType,
        networkTypeName: Ti.Network.networkTypeName
    });
};

module.exports = {
    _initialized: false,
    init: function() {
        if (this._initialized) return;
        this._initialized = true;
        var eventManagerModule = require("/ui/common/eventManager");
        eventManagerModule.setEventDomain("carma:network.change", process.backgroundDomain);
        Ti.Network.addEventListener("change", function() {
            LOGGER.info("[NETWORK] network change: " + Ti.Network.online);
            handleNetwork(Ti.Network.online, experience);
        });
        Ti.App.addAppEventListener("carma:network.experience", function(data) {
            var newExperience = data.value;
            handleNetwork(newExperience || Ti.Network.online, newExperience);
        });
        Ti.App.addAppEventListener("carma:life.cycle.resume", function(data) {
            handleNetwork(Ti.Network.online, experience);
        });
    },
    isConnectionGood: function() {
        return _isConnectionGood();
    },
    isConnected: function() {
        return Ti.Network.online;
    },
    experience: function() {
        return experience;
    }
};