"use strict";

!function() {
    var getValue = function(object, prop) {
        if (!(object && object[prop])) return null;
        return _.isFunction(object[prop]) ? object[prop]() : object[prop];
    };
    Backbone.Model.prototype.url = function() {
        var base = getValue(this, "urlRoot") || getValue(this.collection, "url");
        if (!base) return null;
        if (this.isNew()) return base;
        return base + ("/" === base.charAt(base.length - 1) ? "" : "/") + encodeURIComponent(this.id);
    };
    _.debounce = function(func, wait, immediate) {
        var timeout = null;
        var result = null;
        return function() {
            var context = this, args = arguments;
            var later = function() {
                timeout = null;
                immediate || (result = func.apply(context, args));
            };
            var callNow = immediate && !timeout;
            clearTimeout(timeout);
            timeout = setTimeout(later, wait);
            callNow && (result = func.apply(context, args));
            return result;
        };
    };
    exports.debounce = _.debounce;
}();