"use strict";

var unitCalc = require("/platform/units"), deviceWidth = Ti.Platform.displayCaps.platformWidth, deviceHeight = Ti.Platform.displayCaps.platformHeight;

Alloy.Globals.Style = {
    Color: {},
    Size: {
        Width: {},
        Height: {}
    },
    Unit: {},
    Rotate: {}
};

var commonColors = function() {
    Alloy.Globals.Style.Color.Orange = "#ff6600";
    Alloy.Globals.Style.Color.LightBlue = "#6699ff";
    Alloy.Globals.Style.Color.DarkBlue = "#003333";
    Alloy.Globals.Style.Color.LightGrey = "#858585";
    Alloy.Globals.Style.Color.Yellow = "#f6cc01";
    Alloy.Globals.Style.Color.Purple = "#e70068";
    Alloy.Globals.Style.Color.Grey = "#ccc";
    Alloy.Globals.Style.Color.DarkGray = "#333";
    Alloy.Globals.Style.Color.TRANSPARENT = "#00ffffff";
    Alloy.Globals.Style.KeyboardStatePan = Ti.UI.Android.SOFT_INPUT_STATE_HIDDEN | Ti.UI.Android.SOFT_INPUT_ADJUST_PAN;
    Alloy.Globals.Style.KeyboardStateResize = Ti.UI.Android.SOFT_INPUT_STATE_HIDDEN | Ti.UI.Android.SOFT_INPUT_ADJUST_RESIZE;
};

var calc = function() {
    for (var i = 1; 100 >= i; i++) {
        var percentage = "pct" + i;
        Alloy.Globals.Style.Size.Width[percentage] = deviceWidth * (i / 100);
        Alloy.Globals.Style.Size.Height[percentage] = deviceHeight * (i / 100);
        if (12 >= i) {
            var grid = "grid" + i;
            Alloy.Globals.Style.Size.Width[grid] = deviceWidth * (i / 12);
            Alloy.Globals.Style.Size.Height[grid] = deviceHeight * (i / 12);
        }
        var unit = "unit" + i;
        Alloy.Globals.Style.Unit[unit] = unitCalc.dipToPixel(i);
    }
    Alloy.Globals.Style.Size.Width.halfGrid = Alloy.Globals.Style.Size.Width.grid1 / 2;
};

var rotation = function() {
    var angles = [ -90, 45, 90, 125 ], anglesLength = angles.length, key;
    Alloy.Globals.rotate = {};
    for (var i = 0; anglesLength > i; ++i) {
        key = "rt" + angles[i];
        Alloy.Globals.Style.Rotate[key] = Ti.UI.create2DMatrix().rotate(angles[i]);
    }
};

var scale = function() {
    Alloy.Globals.scaleDown = Ti.UI.create2DMatrix().scale(0);
};

var underline = function() {
    Alloy.Globals.setUnderline = function(view, text, enable) {
        "boolean" == typeof text && (enable = text);
        view.setUnderline(enable);
        return;
        var lblText;
        var attr;
    };
};

module.exports = {
    preCalculate: function() {
        commonColors();
        calc();
        rotation();
        scale();
        underline();
    }
};