"use strict";

!function() {
    var deferredList = [];
    var isTaskRunning = false;
    var popNextTask = function() {
        if (0 === deferredList.length) return null;
        for (var i = 0, len = deferredList.length; len > i; i++) if (deferredList[i][1] !== process.backgroundDomain) return deferredList.splice(i, 1)[0];
        return deferredList.shift();
    };
    var pump = function() {
        if (deferredList.length > 0) {
            isTaskRunning = true;
            _.defer(function() {
                if (deferredList.length > 0) {
                    var item = popNextTask();
                    var deferred = item[0];
                    try {
                        item[1].enter();
                        deferred();
                    } catch (e) {
                        LOGGER.error("Background task threw exception: " + JSON.stringify(e));
                    } finally {
                        item[1].exit();
                    }
                    pump();
                } else isTaskRunning = false;
            });
        } else isTaskRunning = false;
    };
    module.exports = {
        init: function(Q) {
            TM.later = function() {
                var currentDomain = process.domain;
                var deferred = Q.defer();
                setTimeout(function() {
                    currentDomain.enter();
                    try {
                        deferred.resolve();
                    } finally {
                        currentDomain.exit();
                    }
                }, 0);
                return deferred.promise;
            };
        },
        push: function(deferred, domain) {
            var item = [ deferred, domain ? domain : process.domain ];
            deferredList.push(item);
            isTaskRunning || pump();
        },
        remove: function(domain) {
            deferredList = domain ? _.reject(deferredList, function(item) {
                return item[1] === domain;
            }) : [];
        }
    };
}();