"use strict";

module.exports = {
    init: function(webview) {
        webview.addWeb2NativeHandler("webapppushtest://requestask", function(data) {
            var service = require("services/booking_service");
            var trip = {};
            trip.user = data.url.param("user");
            trip.id = data.url.param("id");
            trip.effectiveTime = parseInt(data.url.param("effectiveTime"), 10);
            trip.schedule = {
                effectiveTime: trip.effectiveTime
            };
            trip.destination = data.url.param("destination");
            var resourceOwner = require("services/resource_owner_service").singleton();
            var nextTrip = resourceOwner.get("nextTrip");
            var groupingKey = require("services/trip_service").groupingKey(nextTrip, trip);
            "request" === data.url.param("askType") ? service.rideRequest(trip, groupingKey).then(function() {
                webview.native2web("avego.rtr.utils.NativeAppConnector.askRequestSuccess", [ trip.id, "" + trip.effectiveTime ]);
            }).catch(function() {
                webview.native2web("avego.rtr.utils.NativeAppConnector.askRequestError");
            }) : service.rideOffer(trip, groupingKey).then(function() {
                webview.native2web("avego.rtr.utils.NativeAppConnector.askRequestSuccess", [ trip.id, "" + trip.effectiveTime ]);
            }).catch(function() {
                webview.native2web("avego.rtr.utils.NativeAppConnector.askRequestError");
            });
        });
    }
};