"use strict";

var gps = require("gps/gps_manager"), ui = require("utils/ui");

var sendLocationToWebView = function(webview, location) {
    webview.native2web("avego.util.bb.globalEvents.trigger", [ "positionInject.LocationService", location ]);
};

module.exports = {
    init: function(webview) {
        webview.addEventListener("carma:webview.load", function handleLoad() {
            var lastLocation = gps.lastLocation();
            lastLocation && setTimeout(function() {
                sendLocationToWebView(webview, lastLocation);
            }, 1e3);
            webview.removeEventListener("carma:webview.load", handleLoad);
            var window = ui.getWindow(webview);
            if (!window) return;
            var updateLocation = function(e) {
                var _webview = webview;
                sendLocationToWebView(_webview, {
                    lat: e.lat,
                    lon: e.lon,
                    accuracy: e.accuracy,
                    timestamp: e.timestamp
                });
                _webview = null;
            };
            Ti.App.addAppEventListener("carma:valid.location.update", updateLocation);
            window.addEventListener("close", function handleClose() {
                window.removeEventListener("close", handleClose);
                Ti.App.removeAppEventListener("carma:valid.location.update", updateLocation);
            });
        });
    }
};