"use strict";

module.exports = {
    init: function(webview) {
        webview.addEventListener("carma:beforeload", function() {
            webview.addShouldOverrideUrls("webapppushtest:");
            webview.addShouldOverrideUrls("toggleRefresh");
            webview.addShouldOverrideUrls("closeNativeApp");
        });
        webview.addEventListener("carma:webview.load", function handleLoad() {
            webview.removeEventListener("carma:webview.load", handleLoad);
            var version = Alloy.Globals.APP.VERSION + " #" + Alloy.Globals.APP.REVISION + " Bundle " + Alloy.Globals.APP.BUNDLEID;
            webview.native2web("avego.rtr.utils.ResourceOwner.storeUserNativeVersion", [ version ]);
        });
        require("bridge/bridge_gps").init(webview);
        require("bridge/bridge_facebook").init(webview);
        require("bridge/bridge_photo").init(webview);
        require("bridge/bridge_analytics").init(webview);
        require("bridge/bridge_logout").init(webview);
        require("bridge/bridge_back").init(webview);
        require("bridge/bridge_profile").init(webview);
        require("bridge/bridge_paypal").init(webview);
        require("bridge/bridge_messenger").init(webview);
        require("bridge/bridge_ask").init(webview);
        require("bridge/bridge_tos").init(webview);
        require("bridge/bridge_trip").init(webview);
    }
};