"use strict";

var ui = require("utils/ui");

module.exports = {
    init: function(webview) {
        webview.addWeb2NativeHandler("/profile/paypalconfirm", function(data) {
            var funcs = [];
            funcs.push(function() {
                var _window = ui.getWindow(webview);
                _window && _window.close && _window.close();
            });
            funcs.push(function() {
                var url = data.url.attr("source");
                var purl = require("utils/purl").purl(url.replace("#", "/"));
                var token = purl.param("token");
                return require("services/paypal_service").topup(token).then(function() {
                    LOGGER.info("[PAYPAL] Successfully topuped up the account...");
                });
            });
            funcs.push(function() {
                return require("services/user_service").findOwn().then(function(profile) {
                    LOGGER.info("[PAYPAL] Successfully updated user profile...");
                    Ti.App.fireEvent("app.carma.profile.change", profile ? profile : {});
                }).finally(function() {
                    Ti.App.fireEvent("carma:progress.stop");
                });
            });
            require("utils/executor")(funcs).withProgress(true).errorMessage(L("error_paypal_topup")).endWith(function() {
                var _window = ui.getWindow(webview);
                _window && _window.close && _window.close();
            }).run();
        });
        webview.addWeb2NativeHandler("/profile/paypalcancel", function(data) {
            var _window = ui.getWindow(webview);
            _window && _window.close && _window.close();
        });
    }
};