"use strict";

var WEB_ROOT = "WEB_ROOT";

var API_ROOT = "API_ROOT";

var OAUTH_CLIENT_ID = "OAUTH_CLIENT_ID";

var OAUTH_CLIENT_SECRET = "OAUTH_CLIENT_SECRET";

var APP_NAME = "carma-splinter";

var TEMPLATES = {
    TRACKING_EVENT_CONFIG: "https://developer.avego.com/libs/rtr-config/tracking_config.json",
    USER_ACHIEVENMENTS: "https://developer.avego.com/assets/achievements/",
    GEOIP_REQUEST: API_ROOT + "/ip?api_key=6587gYi_th1X",
    USER_ID_REQUEST_WITH_FB: API_ROOT + "/security/oauth/authorize?client_id=" + OAUTH_CLIENT_ID + "&response_type=token&redirect_uri=<%= redirectURL %>&scope=<%= scope %>",
    USER: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>",
    USER_TRIP: API_ROOT + "/api/rtr/v1.0/object/user/<%= userId %>/trip",
    USER_TRIPS: API_ROOT + "/api/rtr/v1.0/object/user/<%= userId %>/trips",
    USER_PREFERENCES: API_ROOT + "/api/object/users/<%= userId %>/preferences",
    USER_MESSAGES: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/user-messages",
    GROUP_MESSAGES: API_ROOT + "/api/rtr/v1.0/object/groups/<%= groupId %>/user-messages",
    USER_CONVERSATIONS: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/user-messages/threads",
    USER_CHAT: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/user-messages/threads/<%= threadId %>",
    MARK_THREAD_READ: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/user-messages/threads/<%= threadId %>/read",
    COUNT_THREAD_UNREAD: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/user-messages/threads/<%= threadId %>/countUnread",
    USER_ID_REQUEST: API_ROOT + "/api/object/users/auth",
    USER_TRACK: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/track?app=" + APP_NAME,
    USER_VALIDATION_REQUEST: API_ROOT + "/api/object/users/<%= userId %>/validation/send?type=<%= type %>",
    USER_VALIDATION_CONFIRM: API_ROOT + "/api/object/users/<%= userId %>/validation/confirm?key=<%= key %>",
    SIGN_UP_URL: API_ROOT + "/api/rtr/v1.0/object/users/create?client_id=" + OAUTH_CLIENT_ID + "&client_secret=" + OAUTH_CLIENT_SECRET,
    CREATE_PUSH_TOKEN: API_ROOT + "/api/object/users/<%= uid %>/pushToken",
    DELETE_PUSH_TOKEN: API_ROOT + "/api/object/users/<%= uid %>/pushToken?appKey=<%= appKey %>&token=<%= token %>",
    PERFECT_MATCH: API_ROOT + "/api/rtr/v1.0/object/trip/tripMatches",
    HOME_CITY: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/homeCity?pageSize=5&pageNum=1",
    PUBLIC_PROFILE: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/profile",
    PUBLIC_PROFILE_LIST: API_ROOT + "/api/rtr/v1.0/object/users/profiles?ids=<%= ids %>",
    PROMO_CODE: API_ROOT + "/api/rtr/v1.0/object/promocode/<%= code %>/redeem",
    REDEEM: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/code/<%= code %>",
    CASH_OUT: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/credit/requestWithdrawal",
    PASSWORD_RESET: API_ROOT + "/api/object/users/passwordreset/request",
    PASSWORD_RESET_CONFIRM: API_ROOT + "/api/object/users/passwordreset/confirm",
    PUSH_TOKEN_TRACK: API_ROOT + "/s/tracking/<%= token %>",
    CREATE_ACCOUNT_FROM_EXTERNAL_SERVICE: API_ROOT + "/api/rtr/v1.0/object/users/createAccountFromExternalService?client_id=" + OAUTH_CLIENT_ID + "&externalService=FACEBOOK&externalCredentials=<%= credentials %>",
    USER_PHOTO: API_ROOT + "/api/object/users/<%= userId %>/photo?useDefault=true&width=<%= width %>&height=<%= height %>&ts=<%= timestamp %>",
    USER_TRIP_BEST_MATCHES: API_ROOT + "/api/rtr/v1.0/object/trip/tripMatches?pageNum=<%= pageNum %>&pageSize=<%= pageSize %>&sortBy=<%= sortBy %>&nextTripTimestamp=<%= nextTripTimestamp %>&searchTargetType=<%= searchTargetType %>&includeTypeCounts=<%= includeTypeCounts %>",
    USER_TRIP_MATCHES: API_ROOT + "/api/rtr/v1.0/object/trip/tripMatches?searchTargetType=<%= searchTargetType %>&pageNum=<%= pageNum %>&pageSize=<%= pageSize %>&sortBy=<%= sortBy %>&nextTripTimestamp=<%= nextTripTimestamp %>",
    TRIP_REQUEST_URL: API_ROOT + "/api/rtr/v1.0/object/invites/trip/requestUrl?tripId=<%= tripId %>&method=<%= method %>",
    CREW: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/crew?userFields=FULL_PUBLIC,DISTANCE",
    CREW_WITH_LOCATION: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/crew?userFields=FULL_PUBLIC,DISTANCE&lat=<%= lat %>&lon=<%= lon %>",
    TRIP_RATING: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/review?journeyId=<%= journeyId %>",
    OAUTH_TOKEN: API_ROOT + "/security/oauth/token",
    INVITES_REQUEST_URL: API_ROOT + "/api/rtr/v1.0/object/invites/<%= entity %>/requestUrl",
    STATIC_MAP: WEB_ROOT + "/staticMap",
    USER_FAVOURITE_LOCATIONS: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/favouriteLocation",
    USER_HOME_LOCATION: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/location/home",
    USER_LAST_LOCATION: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/location",
    USER_LIVE_LOCATION: API_ROOT + "/api/rtr/v2.0/object/users/<%= userId%>?userFields=LAST_KNOWN_LOCATION_ADDRESS,LAST_KNOWN_LOCATION",
    USER_RIDE_BOOKING: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/rideBookings",
    USER_RIDE_BOOKING_STATE: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/trip/<%= tripId %>/rideBookings",
    USER_TRIP_RIDE_BOOKING: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/trip/<%= tripId %>/rideBookings?states=<%= statesQuery %>&userFields=PHOTO_URL,ALIAS,PHONE_NUMBER,IS_FREE_DRIVER",
    USER_TRIP_DEVIATION: API_ROOT + "/api/rtr/v1.0/object/user/<%= userId %>/trip/<%= tripId %>/deviation",
    USER_TRIP_CONFIRM: API_ROOT + "/api/rtr/v1.0/object/user/<%= userId %>/trip/<%= tripId %>/confirmation",
    CARPOOL_FINDING: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/autoRideMatchRequests",
    USER_NOTIFICATION: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/notifications",
    USER_GROUPS: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/groups",
    FAVOURITE_USER_COUNT: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/favouriteUsers?pageSize=0&pageNum=1",
    RIDE_HISTORY_COUNT: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/rideHistory?pageSize=0&pageNum=1&includeTotalDistance=false&startTime=0&endTime=0&includeUnlikelyRides=false",
    MESSAGE_STATISTICS: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/user-messages/statistics?fromTimestamp=<%= timestamp %>",
    PAYPAL_TOKEN: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/transactions/paypal/token",
    PAYPAL_TOPUP: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/transactions/paypal/top-up",
    STRIPE_PAYMENT_PROVIDER: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/paymentTokens/<%= paymentProvider %>",
    FAVOURITE_USER: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/favouriteUsers?userFields=FULL_PUBLIC&pageSize=<%= pageSize %>&pageNum=1",
    FAVOURITE_USER_ADD: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/favouriteUsers/<%= favouriteUserId %>/add",
    FAVOURITE_USER_REMOVE: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/favouriteUsers/<%= favouriteUserId %>/remove",
    FREEZONE: API_ROOT + "/api/rtr/v1.0/object/locations/<%= lon %>,<%= lat %>/inFreeZone",
    USER_VEHICLES: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/vehicles?emailTemplate=<%=emailTemplate %>",
    USER_VEHICLE: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/vehicles/<%= vehicleId %>?emailTemplate=<%=emailTemplate%>",
    STRIPE_PAYMENT_TRANSACTION: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/transactions/<%= paymentProvider %>/topupInOne",
    AVAILABLE_TOPUP: API_ROOT + "/api/rtr/v1.0/object/transactions/topups/<%= currencyCode %>",
    AVAILABLE_TOPUP_PROVIDER: API_ROOT + "/api/rtr/v1.0/object/transactions/<%= paymentProvider %>/topups/<%= currencyCode %>",
    BATCH_API: API_ROOT + "/api/rtr/v1.0/object/batchApiCall",
    RIDE_ACTIVITY: API_ROOT + "/api/rtr/v1.0/object/rides/location?centerLat=<%= centerLat %>&centerLon=<%= centerLon%>&radius=10000&photoRequired=true&startTime=<%= startTime%>",
    NEW_USERS: API_ROOT + "/api/rtr/v1.0/object/users/recentSignups?centreLat=<%= centerLat %>&centreLon=<%= centerLon%>&radius=<%= radius%>&userFields=ALIAS,PHOTO_URL,LAST_KNOWN_LOCATION_ADDRESS",
    WELCOME_USER: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId%>/welcome?message=<%= message%>",
    WELCOME_USER_V2: API_ROOT + "/api/rtr/v2.0/object/users/<%= userId%>/welcome",
    AUTO_RIDE_REQUEST: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/autoRideMatchRequests/<%= rideRequestId %>",
    USER_SEARCH: API_ROOT + "/api/rtr/v1.0/object/users/search/?userId=<%= userId %>&keyword=<%= keyword %>",
    FREE_RIDERS: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/freeRiders",
    FREE_RIDER: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/freeRiders/<%= freeRiderId %>",
    REFERRAL_CODE: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/requestReferralCode",
    INFORMATION_CARDS: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/informationCards",
    USER_TRIPS_NEXTN: API_ROOT + "/api/rtr/v1.0/object/user/<%= userId %>/trips/nextn?numTrips=<%= numTrips %>",
    REDEEM_INVITE_CODE: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/inviteCode?code=<%=code %>",
    GET_INVITE: API_ROOT + "/api/rtr/v1.0/object/invites/<%=inviteId%>?userFields=ALIAS,NAME,PHOTO_URL,GENDER",
    TRACK_INVITE: API_ROOT + "/api/rtr/v1.0/object/invites/<%=inviteId%>/track?type=<%=eventType %>",
    CARMA_COMPLETENESS: API_ROOT + "/v1/object/users/SELF/carmaCompleteness",
    BEACONS: API_ROOT + "/v1/users/<%= userId %>/beacons",
    USER_NEXT_TRIP: API_ROOT + "/v2/users/SELF/trips/next",
    USER_TRIP_V2: API_ROOT + "/v2/users/SELF/trips/<%= tripId %>",
    GEOFENCES: API_ROOT + "/v1/object/users/SELF/geofences",
    AUTO_RIDE_ENABLE_PUSH_NOTIFICATION: API_ROOT + "/api/rtr/v1.0/object/users/<%= userId %>/autoRideMatchRequests/enablePushNotifications"
};

var _update = function() {
    var env = require("bootstrap/env");
    env.init();
    var apiRoot = env.getApiURL();
    var webRoot = env.getWebHybridURL();
    var oauth = env.getOAuth();
    var isCarmaSplinter = Ti.App.Properties.getString("client.id", false);
    isCarmaSplinter || (oauth.clientId = "rtr-mobile-web-client");
    for (var key in TEMPLATES) {
        var url = TEMPLATES[key].replace(API_ROOT, apiRoot);
        url = url.replace(WEB_ROOT, webRoot);
        url = url.replace(OAUTH_CLIENT_ID, oauth.clientId);
        url = url.replace(OAUTH_CLIENT_SECRET, oauth.clientSecret);
        module.exports[key] = url;
    }
};

Ti.App.addAppEventListener && Ti.App.addAppEventListener("carma:env.changed", function() {
    _update();
    Ti.App.fireEvent("carma:logout", {});
});

_update();