"use strict";

var Q = require("vendor/q");

var assert = require("/utils/assert");

var Globals = require("/v6/infrastructure/Globals"), LoggingService = Globals.IOC.get("LoggingService");

var _upload = function(params) {
    assert.required(params, [ "token", "data", "deferred" ]);
    var url = _.template(require("carmalib/url").CREATE_ACCOUNT_FROM_EXTERNAL_SERVICE, {
        credentials: params.token
    });
    params.invited && (url += "&inviteId=" + params.inviteId);
    var xhr = Ti.Network.createHTTPClient({
        onload: function() {
            LOGGER.info("Created user with FB info successfully...");
            var user = params.data;
            params.deferred.resolve(user);
        },
        onerror: function(e) {
            LOGGER.error("Failed to create use with FB info: " + this.responseText + " " + JSON.stringify(e));
            var error = this.responseText;
            try {
                error = JSON.parse(error);
            } catch (e) {}
            params.deferred.reject(error);
        },
        timeout: 2e4
    });
    xhr.open("POST", url);
    LoggingService.log("network", url);
    xhr.setRequestHeader("Content-Type", "application/json");
    xhr.setRequestHeader("Accept", "application/json");
    xhr.send(JSON.stringify(params.data));
};

module.exports = {
    save: function(fbToken, data) {
        var deferred = Q.defer();
        _upload({
            token: fbToken,
            data: data,
            deferred: deferred
        });
        return deferred.promise;
    }
};