"use strict";

function androidConfig() {
    LOGGER.debug("=== android gps configurations ===");
    var module = require("ma.car.ti.module.location");
    LOGGER.debug("enable manual gps mode");
    Android.manualMode = true;
    LOGGER.debug("enabling location providers: gps, network, passive");
    LOGGER.debug("location rule: min update time: " + LOCATION_MIN_UPDATE_TIME_SECS);
    LOGGER.debug("location rule: min update distance: " + LOCATION_MIN_UPDATE_DISTANCE_METRES_ANDROID);
    LOGGER.debug("location rule: min age: " + LOCATION_RULE_MINAGE_MS);
    var config = module.createLocationRequestConfig({});
    config.interval = 1e3 * LOCATION_MIN_UPDATE_TIME_SECS;
    config.fastestInterval = 1e3 * LOCATION_MIN_UPDATE_TIME_SECS;
    config.smallestDisplacement = LOCATION_MIN_UPDATE_DISTANCE_METRES_ANDROID;
    config.expirationDuration = 864e5;
    config.priority = module.PRIORITY_HIGH_ACCURACY;
    config.addProvider(module.PROVIDER_GPS);
    config.addProvider(module.PROVIDER_NETWORK);
    module.requestLocationUpdate(config);
}

function iosConfig() {
    LOGGER.debug("=== ios gps configurations ===");
    iOS.accuracy = GeoLocation.ACCURACY_NEAREST_TEN_METERS;
    iOS.activityType = GeoLocation.ACTIVITYTYPE_AUTOMOTIVE_NAVIGATION;
    iOS.distanceFilter = LOCATION_MIN_UPDATE_DISTANCE_METRES_IOS;
    iOS.pauseLocationUpdateAutomatically = true;
    iOS.purpose = L("gps_reason");
    LOGGER.debug("location rule: accuracy: ACCURACY_NEAREST_TEN_METERS");
    LOGGER.debug("location rule: activity type: ACTIVITYTYPE_AUTOMOTIVE_NAVIGATION");
    LOGGER.debug("location rule: min update distance: " + LOCATION_MIN_UPDATE_DISTANCE_METRES_IOS);
    LOGGER.debug("auto pause location update: true");
}

var LOCATION_SERVER_UPDATE_TIME_SECS = 60, LOCATION_MIN_UPDATE_TIME_SECS = 10, LOCATION_MIN_UPDATE_DISTANCE_METRES_IOS = 0, LOCATION_MIN_UPDATE_DISTANCE_METRES_ANDROID = .1, LOCATION_RULE_MINAGE_MS = 5e3, Android = Ti.Geolocation.Android, iOS = Ti.Geolocation, GeoLocation = Ti.Geolocation;

module.exports = {
    getServerUpdateTimeSecs: function() {
        return LOCATION_SERVER_UPDATE_TIME_SECS;
    },
    getMinUpdateTimeSecs: function() {
        return LOCATION_MIN_UPDATE_TIME_SECS;
    },
    getLocationRuleMinageMS: function() {
        return LOCATION_RULE_MINAGE_MS;
    },
    config: function() {
        androidConfig();
        return;
    }
};