"use strict";

function PagingControl(scrollableView) {
    var pages = [], numberOfPages = scrollableView.getViews().length;
    var view = function() {
        var pageColor = "#000";
        var container = Ti.UI.createView({
            width: Ti.UI.SIZE,
            height: "60dp",
            bottom: 0
        });
        var utils = require("utils/utils");
        var borderDp = utils.dpToPixel(8);
        for (var i = 0; numberOfPages > i; i++) {
            var page = Ti.UI.createView({
                borderRadius: borderDp,
                width: "8dp",
                height: "8dp",
                left: 15 * i + "dp",
                backgroundColor: pageColor,
                opacity: .5
            });
            pages.push(page);
            container.add(page);
        }
        pages[scrollableView.getCurrentPage()].setOpacity(1);
        return container;
    }();
    var _onScroll = function(event) {
        for (var i = 0; numberOfPages > i; i++) pages[i].setOpacity(.5);
        pages[event.currentPage].setOpacity(1);
    };
    scrollableView.addEventListener("scrollend", _onScroll);
    return {
        getView: function() {
            return view;
        },
        destroy: function() {
            view.applyProperties({
                views: []
            });
            view = null;
            scrollableView.removeEventListener("scrollend", _onScroll);
        }
    };
}

module.exports = PagingControl;