"use strict";

var units = require("platform/units"), utils = require("utils/utils"), retinaIOS = "high" === Ti.Platform.displayCaps.density ? true : false, lastPanel = utils.pixelToDp(Alloy.Globals.Style.Size.Height.pct100), panelHeights = new Array(553, 585, 457, 615, 657, 651, 654, 654, 484, 710, lastPanel), foregroundPositions = new Array(16, 400, 2576, 2576, 1098, 1356, 2082, 2486, 2906, 3208, 3578, 4300, 4472, 4628, 5840), foregroundHeights = new Array(81, 79, 129, 129, 158, 123, 191, 80, 520, 99, 161, 192, 273, 115, 189), _carVisible = false, screenWidth = Ti.Platform.displayCaps.getPlatformWidth(), _backgroundImageNames = [], walkerImages = [], tandemScrollBuilder = null, scrollViews = [], walkerImages = [], scrollEndPosition = 0, speechBubble = null, _hiTomBubble = null, _carSwear = null, _curveSwear = null, _sheep = null, _sheep2 = null, _whosDrivingPanel = null, _whosDrivingCurrent = 1, walkerView = null, background = null, foreground = null, carView = null, fireCarView = null, counterView = null, odometerElements = null, CAR_ENTRY, CAR_EXIT, FIRE_CAR_ENTRY, FIRE_CAR_EXIT, CONTAINER_HEIGHT, BUBBLE_ENTRY, BUBBLE_EXIT, SPEECH_ENTRY, SPEECH_EXIT, WALKER_ENTRY, WALKER_END, WALKER_EXIT, SWEAR_ENTRY, SWEAR_EXIT, SHEEP_ENTRY, SHEEP_EXIT, COUNTER_ENTRY, COUNTER_EXIT, PANEL_ANIMATION_START, PANEL_ANIMATION_END, WALKER_INCREMENT, MILE_INCREMENT, ANIMATION_INCREMENT, CURVE_ENTRY, CURVE_EXIT, car = null, fireCar = [], counter = null, walker = null, loginView = null, finishScroll = false, _visibilityTracker = {};

var FIRST_PANEL = 1, SECOND_PANEL = 2, HI_TOM_BUBBLE = 3, SCROLL_DOWN = 4, THIRD_PANEL = 5, FINAL_PANEL = 6, COLLECT_SIGN = 7, ELECTRONIC_SIGN = 10, GREEN_SIGN = 11, RED_SIGN = 12, SPEECH_BUBBLE = 13;

var disposeIntroScreen = function() {
    if (scrollViews && scrollViews.length > 0) {
        finishScroll = true;
        Titanium.App.Properties.setBool("carma:intro.displayed", true);
        loginView.visible = true;
        for (var i = 0; i < scrollViews.length; i++) {
            scrollViews[i].visible = false;
            scrollViews[i].removeAllChildren();
            scrollViews[i] = null;
        }
        scrollViews = [];
    }
};

var init = function(parentWindow) {
    _visibilityTracker.car = false;
    _visibilityTracker.helloBubble = false;
    _visibilityTracker.walker = false;
    _visibilityTracker.odometer = false;
    _visibilityTracker.goodbye = false;
    _visibilityTracker.curveSwear = false;
    _visibilityTracker.carSwear = false;
    _visibilityTracker.fireCar = false;
    parentWindow.addAppEventListener("carma:dispose.intro", function handler() {
        parentWindow.removeAppEventListener("carma:dispose.intro", handler);
        disposeIntroScreen();
    });
    var totalHeight = 0;
    for (i = 0; i < panelHeights.length; i++) totalHeight += panelHeights[i];
    tandemScrollBuilder = require("ma.car.ti.module.tandemscroll.android");
    var dipFactor = Ti.Platform.displayCaps.dpi / 160;
    CONTAINER_HEIGHT = totalHeight + "dp", CAR_ENTRY = utils.dpToPixel(1e3), CAR_EXIT = utils.dpToPixel(5025), 
    FIRE_CAR_ENTRY = CAR_EXIT, FIRE_CAR_EXIT = utils.dpToPixel(5740), COUNTER_ENTRY = utils.dpToPixel(2173), 
    COUNTER_EXIT = utils.dpToPixel(4200), MILE_INCREMENT = utils.dpToPixel(254), WALKER_ENTRY = utils.dpToPixel(1114), 
    WALKER_END = utils.dpToPixel(1300), WALKER_EXIT = utils.dpToPixel(1300), WALKER_INCREMENT = utils.dpToPixel(9.3);
    SPEECH_ENTRY = utils.dpToPixel(1262), SPEECH_EXIT = utils.dpToPixel(1300), PANEL_ANIMATION_START = utils.dpToPixel(1447), 
    PANEL_ANIMATION_END = utils.dpToPixel(1652), ANIMATION_INCREMENT = utils.dpToPixel(100);
    SWEAR_ENTRY = utils.dpToPixel(2373), SWEAR_EXIT = utils.dpToPixel(2800), SHEEP_ENTRY = utils.dpToPixel(2385), 
    SHEEP_EXIT = utils.dpToPixel(2650), CURVE_ENTRY = utils.dpToPixel(2967), CURVE_EXIT = utils.dpToPixel(3500), 
    BUBBLE_ENTRY = utils.dpToPixel(4528), BUBBLE_EXIT = utils.dpToPixel(5e3), _backgroundImageNames = new Array("/images/intro/scroller_one_hannah.png", "/images/intro/scroller_two_tomcontact.png", "/images/intro/scroller_three_pickup.png", "/images/intro/scroller_four_incarframe1.png", "/images/intro/scroller_five_longroad1.png", "/images/intro/scroller_five_longroad2.png", "/images/intro/scroller_five_longroad3.png", "/images/intro/scroller_five_longroad4.png", "/images/intro/scroller_six_tripdone.png", "/images/intro/scroller_seven_tunnel.png", "/images/intro/scroller_eight_loginbackground.png");
    car = "/images/intro/scroller_three_carmacar_1080.png";
    fireCar = new Array("/images/intro/scroller_seven_carflame1.png", "/images/intro/scroller_seven_carflame2.png");
    counter = "/images/intro/scroller_five_odometer_1080.png";
    walker = "/images/intro/walker/scrollerthree_tomwalk1_1080.png";
    for (var i = 0; 20 > i; i++) walkerImages.push("/images/intro/scrollerthree_tomwalk" + i + "_1080.png");
};

var getPositionForPanel = function(index) {
    var position = 0;
    for (var i = 0; index > i; i++) position += panelHeights[i];
    return position;
};

var attachText = function(layer, panel) {
    var options = new Object({
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        left: 0,
        right: 0,
        color: "#ffffff",
        font: {
            fontSize: "18dp"
        }
    });
    switch (panel) {
      case FIRST_PANEL:
        _.extend(options, {
            text: L("widget_intro_hannah_drives_label"),
            top: "95dp",
            height: "55dp"
        });
        break;

      case SECOND_PANEL:
        _.extend(options, {
            text: L("widget_intro_tom_lift_label"),
            top: "40dp",
            height: "100dp"
        });
        break;

      case THIRD_PANEL:
        _.extend(options, {
            text: L("widget_intro_tom_aboard_label"),
            top: "30dp",
            height: "100dp"
        });
        break;

      case COLLECT_SIGN:
        _.extend(options, {
            text: L("widget_intro_tom_collect_label"),
            top: convertPixels(20),
            height: convertPixels(200)
        });
        break;

      case FINAL_PANEL:
        _.extend(options, {
            text: L("widget_intro_hannah_payment"),
            top: "0dp",
            height: "100dp"
        });
        break;

      case SCROLL_DOWN:
        _.extend(options, {
            text: L("widget_intro_scroll_down"),
            bottom: "160dp",
            shadowColor: "#ff6600"
        });
        break;

      case ELECTRONIC_SIGN:
        _.extend(options, {
            text: L("widget_intro_tom_contact_label"),
            top: convertPixels(20),
            bottom: convertPixels(20),
            shadowColor: "#ff6600"
        });
        break;

      case GREEN_SIGN:
        _.extend(options, {
            text: L("widget_intro_app_records_label"),
            top: "13dp",
            bottom: "50dp"
        });
        break;

      case RED_SIGN:
        _.extend(options, {
            text: L("widget_intro_dropoff_label"),
            top: "13dp",
            bottom: "50dp"
        });
        break;

      case HI_TOM_BUBBLE:
        _.extend(options, {
            text: L("widget_intro_hi_tom_label"),
            color: "#000000",
            left: "16dp",
            width: "98dp"
        });
        break;

      case SPEECH_BUBBLE:
        _.extend(options, {
            text: L("widget_intro_thanks_label"),
            right: "7dp",
            width: "134dp",
            color: "#000000"
        });
        options = _.omit(options, "left");
    }
    var label = Ti.UI.createLabel(options);
    layer.add(label);
};

var addBackgroundImages = function(layer) {
    var top = 0;
    for (var i = 0; i < _backgroundImageNames.length; i++) {
        var height = panelHeights[i] + "dp";
        var path = "";
        (3 !== i || 9 !== i) && (path = _backgroundImageNames[i]);
        var img = Ti.UI.createView({
            height: height,
            width: "100%",
            backgroundImage: path,
            backgroundSelectedImage: "",
            backgroundFocusedImage: "",
            backgroundDisabledImage: "",
            top: top + "dp",
            parentView: layer
        });
        if (0 === i) {
            attachText(img, FIRST_PANEL);
            attachText(img, SCROLL_DOWN);
        }
        1 === i && attachText(img, SECOND_PANEL);
        top += parseInt(height, 10);
        layer.add(img);
    }
    walkerView = Ti.UI.createView({
        height: "67dp",
        top: "1378dp",
        left: 0,
        right: 0,
        image: walker,
        zindex: 2,
        parentView: layer
    });
    layer.add(walkerView);
};

var addForegroundImages = function(layer) {
    var carmaLogo = {
        top: foregroundPositions[0] + "dp",
        image: "/images/intro/scroller_one_logo.png",
        height: foregroundHeights[0] + "dp",
        left: 0
    };
    var scrollHint = {
        top: foregroundPositions[1] + "dp",
        image: "/images/intro/scroller_one_scrollhint_1080.png",
        height: foregroundHeights[1] + "dp",
        left: 0
    };
    var sheep = {
        top: foregroundPositions[2] + "dp",
        image: "/images/intro/scroller_five_sheep1_1080.png",
        height: foregroundHeights[2] + "dp",
        left: 0
    };
    var sheep2 = {
        top: foregroundPositions[3] + "dp",
        image: "/images/intro/scroller_five_sheep2_1080.png",
        height: foregroundHeights[3] + "dp",
        left: 0
    };
    var thirdPanel = {
        top: getPositionForPanel(3) + "dp",
        image: _backgroundImageNames[3],
        height: panelHeights[3] + "dp",
        width: screenWidth,
        left: 0,
        caption: THIRD_PANEL
    };
    var fifthPanel = {
        top: getPositionForPanel(8) + "dp",
        image: _backgroundImageNames[8],
        height: panelHeights[8] + "dp",
        width: screenWidth,
        left: 0,
        caption: FINAL_PANEL
    };
    var electronicSign = {
        top: foregroundPositions[4] + "dp",
        image: "/images/intro/scroller_twothree_roadsign_1080.png",
        height: foregroundHeights[4] + "dp",
        left: 0,
        caption: COLLECT_SIGN
    };
    var hiTomBubble = {
        top: foregroundPositions[5] + "dp",
        image: "/images/intro/scroller_three_hitomspeechbubble.png",
        height: foregroundHeights[5] + "dp",
        left: 0,
        caption: HI_TOM_BUBBLE
    };
    var greenSign = {
        top: foregroundPositions[6] + "dp",
        image: "/images/intro/scroller_fourfive_greensign_1080.png",
        height: foregroundHeights[6] + "dp",
        width: screenWidth,
        caption: GREEN_SIGN
    };
    var carSwear = {
        top: foregroundPositions[7] + "dp",
        image: "/images/intro/scroller_five_swearing_1080.png",
        height: foregroundHeights[7] + "dp",
        width: screenWidth
    };
    var theBridge = {
        top: foregroundPositions[8] + "dp",
        image: "/images/intro/scroller_five_curvedbridge_1080.png",
        width: screenWidth,
        height: foregroundHeights[8] + "dp"
    };
    var curveSwear = {
        top: foregroundPositions[9] + "dp",
        image: "/images/intro/scroller_five_bridgeswearing_1080.png",
        width: screenWidth,
        height: foregroundHeights[9] + "dp"
    };
    var horizontalBridge = {
        top: foregroundPositions[10] + "dp",
        image: "/images/intro/scroller_five_horizontalbridge.png",
        height: foregroundHeights[10] + "dp",
        left: 0
    };
    var redSign = {
        top: foregroundPositions[11] + "dp",
        image: "/images/intro/scroller_five_redsign_1080.png",
        height: foregroundHeights[11] + "dp",
        width: screenWidth,
        caption: RED_SIGN
    };
    var work = {
        top: foregroundPositions[12] + "dp",
        image: "/images/intro/scroller_five_workoffice_1080.png",
        height: foregroundHeights[12] + "dp",
        width: screenWidth,
        left: 0
    };
    var bubble = {
        top: foregroundPositions[13] + "dp",
        height: foregroundHeights[13] + "dp",
        image: "/images/intro/scroller_five_speechbubble_1080.png",
        width: screenWidth,
        caption: SPEECH_BUBBLE
    };
    var theTunnel = {
        top: foregroundPositions[14] + "dp",
        image: "/images/intro/scroller_seven_tunneloverhead_1080.png",
        height: foregroundHeights[14] + "dp",
        left: 0
    };
    var assets = new Array(carmaLogo, scrollHint, electronicSign, thirdPanel, fifthPanel, hiTomBubble, greenSign, carSwear, sheep, sheep2, theBridge, curveSwear, horizontalBridge, redSign, work, bubble, theTunnel);
    var zindex = 1;
    for (var i = 0; i < assets.length; i++) {
        var width = Ti.UI.FILL;
        assets[i].width && (width = assets[i].width);
        var img1 = Ti.UI.createView({
            height: assets[i].height,
            width: width,
            left: assets[i].left,
            backgroundImage: assets[i].image,
            backgroundSelectedImage: "",
            backgroundFocusedImage: "",
            backgroundDisabledImage: "",
            top: assets[i].top,
            zIndex: zindex,
            parentView: layer
        });
        if (assets[i] === hiTomBubble) {
            _hiTomBubble = img1;
            _hiTomBubble.applyProperties({
                visible: false
            });
        }
        assets[i] === thirdPanel && (_whosDrivingPanel = img1);
        assets[i] === scrollHint && img1.addEventListener("click", function() {
            tandemScrollBuilder.scrollTo(0, 300);
            setTimeout(function() {
                tandemScrollBuilder.scrollTo(0, 0);
            }, 300);
        });
        assets[i] === sheep && (_sheep = img1);
        if (assets[i] === sheep2) {
            _sheep2 = img1;
            _sheep2.applyProperties({
                visible: false
            });
        }
        if (assets[i] === carSwear) {
            _carSwear = img1;
            _carSwear.applyProperties({
                visible: false
            });
        }
        if (assets[i] === curveSwear) {
            _curveSwear = img1;
            _curveSwear.applyProperties({
                visible: false
            });
        }
        if (assets[i] === bubble) {
            speechBubble = img1;
            speechBubble.applyProperties({
                visible: false
            });
        }
        assets[i].caption && attachText(img1, assets[i].caption);
        zindex++;
        layer.add(img1);
    }
    scrollEndPosition = getPositionForPanel(10) + "dp";
    var homeView = Alloy.createWidget("ma.car.app.home").getView("viewHome");
    homeView.applyProperties({
        top: scrollEndPosition
    });
    layer.add(homeView);
};

var createOdometerParts = function(view) {
    var parts = {};
    var bottomMargin = "7dp";
    parts.subtitleStatic = Ti.UI.createLabel({
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        left: "15dp",
        color: "#ffffff",
        font: {
            fontSize: "12dp",
            fontWeight: "bold"
        },
        text: L("widget_intro_cost_label"),
        bottom: bottomMargin,
        width: "34dp"
    });
    parts.subtitleCost = Ti.UI.createLabel({
        color: "#35AC61",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        left: "50dp",
        width: "36dp",
        text: "$1.00",
        bottom: bottomMargin,
        font: {
            fontSize: "12dp",
            fontWeight: "bold"
        }
    });
    view.add(parts.subtitleStatic);
    view.add(parts.subtitleCost);
    parts.decimal = Ti.UI.createLabel({
        font: {
            fontSize: "25dp"
        },
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        left: "11dp",
        color: "#ffffff",
        text: "0",
        width: "38dp",
        top: "13dp"
    });
    view.add(parts.decimal);
    parts.unit = Ti.UI.createLabel({
        font: {
            fontSize: "25dp"
        },
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        left: "50dp",
        color: "#ffffff",
        text: "0",
        width: "38dp",
        top: "13dp"
    });
    view.add(parts.decimal);
    view.add(parts.unit);
    parts.distance = 0;
    return parts;
};

var buildLayers = function(container) {
    var backgroundScrollOptions = {
        contentHeight: Ti.UI.SIZE,
        contentWidth: Ti.UI.FILL,
        showHorizontalScrollIndicator: false,
        showVerticalScrollIndication: true,
        height: Ti.UI.SIZE,
        scrollType: "vertical",
        width: "100%",
        zIndex: 1,
        disableBounce: true
    }, foregroundScrollOptions = {
        contentHeight: Ti.UI.SIZE,
        contentWidth: Ti.UI.FILL,
        showHorizontalScrollIndicator: false,
        showVerticalScrollIndication: true,
        scrollType: "vertical",
        width: "100%",
        zIndex: 3,
        disableBounce: true
    };
    background = tandemScrollBuilder.createTandemScroll(backgroundScrollOptions);
    foreground = tandemScrollBuilder.createTandemScroll(foregroundScrollOptions);
    var backgroundView = Ti.UI.createView({
        height: CONTAINER_HEIGHT,
        width: "100%"
    });
    container.add(background);
    addBackgroundImages(backgroundView);
    background.add(backgroundView);
    scrollViews.push(background);
    carView = Ti.UI.createImageView({
        height: "69dp",
        left: 0,
        right: 0,
        top: "100dp",
        zIndex: 2,
        touchEnabled: false,
        image: car,
        visible: false,
        parentView: container
    });
    container.add(carView);
    fireCarView = Ti.UI.createImageView({
        height: "114dp",
        left: 0,
        right: 0,
        top: "100dp",
        zIndex: 2,
        touchEnabled: false,
        image: fireCar[0],
        visible: false,
        parentView: container
    });
    container.add(fireCarView);
    counterView = Ti.UI.createView({
        height: "74dp",
        left: 0,
        right: 0,
        top: "100dp",
        zIndex: 2,
        touchEnabled: false,
        backgroundImage: counter,
        backgroundSelectedImage: "",
        backgroundFocusedImage: "",
        backgroundDisabledImage: "",
        visible: false,
        parentView: container
    });
    container.add(counterView);
    odometerElements = createOdometerParts(counterView);
    var invisibleFront = Ti.UI.createView({
        bottom: 0,
        height: CONTAINER_HEIGHT,
        right: 0,
        top: 0,
        width: Ti.Platform.displayCaps.width
    });
    foreground.add(invisibleFront);
    container.add(foreground);
    addForegroundImages(invisibleFront);
    scrollViews.push(foreground);
    loginView = Alloy.createWidget("ma.car.app.home").getView("viewHome");
    container.add(loginView);
};

var convertPixels = function(pixels) {
    var dip = utils.pixelToDp(pixels);
    return dip + "dp";
};

var handleDriveAnimations = function(y) {
    if (y > SHEEP_ENTRY && SHEEP_EXIT > y) {
        if (!_sheep2.getVisible()) {
            _sheep.applyProperties({
                visible: false
            });
            _sheep2.applyProperties({
                visible: true
            });
        }
    } else if (!_sheep.getVisible()) {
        _sheep.applyProperties({
            visible: true
        });
        _sheep2.applyProperties({
            visible: false
        });
    }
    if (y > SWEAR_ENTRY && SWEAR_EXIT > y) {
        if (!_visibilityTracker.carSwear) {
            _visibilityTracker.carSwear = true;
            _carSwear.applyProperties({
                visible: true
            });
        }
    } else if (_visibilityTracker.carSwear) {
        _visibilityTracker.carSwear = false;
        _carSwear.applyProperties({
            visible: false
        });
    }
    if (y > CURVE_ENTRY && CURVE_EXIT > y) {
        if (!_visibilityTracker.curveSwear) {
            _visibilityTracker.curveSwear = true;
            _curveSwear.applyProperties({
                visible: true
            });
        }
    } else if (_visibilityTracker.curveSwear) {
        _visibilityTracker.curveSwear = false;
        _curveSwear.applyProperties({
            visible: false
        });
    }
};

var handleVisibility = function(y) {
    if (y > WALKER_ENTRY && PANEL_ANIMATION_END > y) {
        if (y > WALKER_ENTRY && WALKER_EXIT > y) {
            moveWalker(y);
            _visibilityTracker.walker = true;
        } else if (_visibilityTracker.walker) {
            _visibilityTracker.walker = false;
            walkerView.applyProperties({
                visible: false
            });
        }
        if (y > SPEECH_ENTRY && SPEECH_EXIT > y) {
            if (!_visibilityTracker.helloBubble) {
                _visibilityTracker.helloBubble = true;
                _hiTomBubble.applyProperties({
                    visible: true
                });
            }
        } else if (_visibilityTracker.helloBubble) {
            _visibilityTracker.helloBubble = false;
            _hiTomBubble.applyProperties({
                visible: false
            });
        }
        if (y > PANEL_ANIMATION_START && PANEL_ANIMATION_END > y && false) {
            var touchDistance = y - PANEL_ANIMATION_START;
            var panelIndex = Math.floor(touchDistance / ANIMATION_INCREMENT) + 1;
            if (6 >= panelIndex && panelIndex !== _whosDrivingCurrent) {
                _whosDrivingCurrent = panelIndex;
                _whosDrivingPanel.applyProperties({
                    backgroundImage: "/images/intro/scroller_four_incarframe" + panelIndex + ".png",
                    backgroundSelectedImage: "",
                    backgroundFocusedImage: "",
                    backgroundDisabledImage: ""
                });
            }
        }
    } else if (y > COUNTER_ENTRY && COUNTER_EXIT > y) {
        if (!_visibilityTracker.odometer) {
            _visibilityTracker.odometer = true;
            counterView.applyProperties({
                visible: true
            });
        }
        var dist = Math.floor((y - COUNTER_ENTRY) / MILE_INCREMENT);
        if (dist !== odometerElements.distance) {
            odometerElements.distance = dist;
            odometerElements.unit.applyProperties({
                text: odometerElements.distance
            });
            var cost = .2 * odometerElements.distance + 1;
            odometerElements.subtitleCost.applyProperties({
                text: "$" + cost.toFixed(2)
            });
        }
        handleDriveAnimations(y);
    } else {
        if (_visibilityTracker.odometer) {
            _visibilityTracker.odometer = false;
            counterView.applyProperties({
                visible: false
            });
        }
        if (y > BUBBLE_ENTRY && BUBBLE_EXIT > y) {
            if (!_visibilityTracker.goodbye) {
                _visibilityTracker.goodbye = true;
                speechBubble.applyProperties({
                    visible: true
                });
            }
        } else if (_visibilityTracker.goodbye) {
            _visibilityTracker.goodbye = false;
            speechBubble.applyProperties({
                visible: false
            });
        }
    }
};

var animateFireCar = function(y) {
    fireCarView.applyProperties(y % 3 === 0 ? {
        image: fireCar[0]
    } : {
        image: fireCar[1]
    });
};

var scrollListener = function(evt) {
    if (evt.y > CAR_ENTRY && evt.y < CAR_EXIT) {
        if (!_visibilityTracker.car) {
            _visibilityTracker.car = true;
            carView.applyProperties({
                visible: true
            });
        }
        if (_visibilityTracker.fireCar) {
            _visibilityTracker.fireCar = false;
            fireCarView.applyProperties({
                visible: false
            });
        }
        handleVisibility(evt.y);
    } else {
        if (_visibilityTracker.car) {
            _visibilityTracker.car = false;
            carView.applyProperties({
                visible: false
            });
        }
        if (evt.y > FIRE_CAR_ENTRY && evt.y < FIRE_CAR_EXIT) {
            if (!_visibilityTracker.fireCar) {
                _visibilityTracker.fireCar = true;
                fireCarView.applyProperties({
                    visible: true
                });
            }
            animateFireCar(evt.y);
        } else if (_visibilityTracker.fireCar) {
            _visibilityTracker.fireCar = false;
            fireCarView.applyProperties({
                visible: false
            });
        }
    }
};

var moveWalker = function(location) {
    var index = Math.floor((location - WALKER_ENTRY) / WALKER_INCREMENT);
    walkerView.applyProperties(20 > index ? {
        visible: true,
        backgroundImage: walkerImages[index],
        backgroundSelectedImage: "",
        backgroundFocusedImage: "",
        backgroundDisabledImage: ""
    } : {
        visible: true
    });
};

module.exports = {
    initialise: function(parentWindow) {
        init(parentWindow);
    },
    createScreens: function(mainView) {
        buildLayers(mainView);
    },
    addListeners: function() {
        tandemScrollBuilder.lockTogether(scrollViews);
        foreground.addEventListener("scroll", scrollListener);
    }
};