"use strict";

var TactileRow = function(args) {
    var view = Ti.UI.createView(args);
    view.addEventListener("touchstart", this.press);
    view.addEventListener("touchend", this.release);
    view.addEventListener("touchcancel", this.release);
    view.addEventListener("touchmove", this.release);
    var self = this;
    view.cleanUp = function() {
        view.addEventListener("touchstart", self.press);
        view.addEventListener("touchend", self.release);
        view.addEventListener("touchcancel", self.release);
        view.addEventListener("touchmove", self.release);
    };
    return view;
};

TactileRow.prototype.press = function() {
    this.backgroundColor = "#70ffffff";
};

TactileRow.prototype.release = function() {
    this.backgroundColor = "#00ffffff";
    return;
};

exports.createView = function(args) {
    return new TactileRow(args);
};