"use strict";

var utils = require("utils/utils"), CARD_TEMPLATE_MAP_PROPKEY = "cardTemplate.map", CARD_TEMPLATE_MAP_WIDTH_PROPKEY = CARD_TEMPLATE_MAP_PROPKEY + ".width", CARD_TEMPLATE_MAP_HEIGHT_PROPKEY = CARD_TEMPLATE_MAP_PROPKEY + ".height";

module.exports = require("/carmalib/controller").extend({}, {
    samantha: null,
    cardName: null,
    customAnimation: false,
    waitUntilReady: true,
    configure: function() {},
    prepareView: function(options) {},
    requestStaticMapImgAndResizeMap: function(trip, availableScreenHeight, options) {
        var mapWrapper = this.mapWrapper, mapImage = this.mapImage, layoutContainer = this.layoutContainer, self = this;
        if (options) {
            options.mapWrapper && (mapWrapper = options.mapWrapper);
            options.mapImage && (mapImage = options.mapImage);
            options.layoutContainer && (layoutContainer = options.layoutContainer);
        }
        var mapWidth = Ti.App.Properties.getInt(CARD_TEMPLATE_MAP_WIDTH_PROPKEY, 0), mapHeight = Ti.App.Properties.getInt(CARD_TEMPLATE_MAP_HEIGHT_PROPKEY, 0);
        if (!mapWidth && 0 === parseFloat(mapWrapper.size.width)) {
            _.delay(function() {
                self.requestStaticMapImgAndResizeMap(trip, availableScreenHeight, options);
            }, 500);
            return;
        }
        if (!mapWidth) {
            mapWidth = utils.defaultToDp(mapWrapper.size.width);
            mapHeight = utils.defaultToDp(mapWrapper.size.height);
            Ti.App.Properties.setInt(CARD_TEMPLATE_MAP_WIDTH_PROPKEY, mapWidth);
            Ti.App.Properties.setInt(CARD_TEMPLATE_MAP_HEIGHT_PROPKEY, mapHeight);
        }
        utils.createMapUrl(trip, mapWidth, mapHeight).then(require("/utils/photoCache").getRemoteFile).then(function(localPath) {
            mapImage.applyProperties({
                image: localPath
            });
        }).catch(function(e) {
            self.samantha.markForceFullReloadingNextTime();
        }).finally(function() {
            options && options.callback && _.isFunction(options.callback) && options.callback.call(self);
        });
    },
    finishDisplay: function() {
        this.layoutContainer.show();
    },
    display: function(options, callback) {},
    displayWithAnimation: function() {},
    cleanUp: function() {},
    disappear: function(callback) {
        this.layoutContainer.hide();
        this.samantha.removeCard(this.cardName);
        this.cleanUp && this.cleanUp();
        callback && _.isFunction(callback) && callback();
    },
    disappearWithAnimation: function() {}
});