"use strict";

var Controller = require("/carmalib/controller"), deepLinker = require("/bootstrap/deepLinker");

var MessageControllerBuilder = {
    create: function($, samantha, cardName) {
        var Dialog = Controller.extend($, {
            cardName: cardName,
            events: {
                "click[ios] btn": "_btnClickHandler",
                "click[android] btn": "_btnClickHandler"
            },
            configure: function() {},
            display: function(options, callback) {
                callback && _.isFunction(callback) ? callback() : $.layout.show();
            },
            displayWithAnimation: function() {},
            disappear: function() {
                $.layout.hide();
                samantha.removeCard(this.cardName);
            },
            _btnClickHandler: function() {
                if ("tripsDisabled" === cardName) {
                    deepLinker.handleUrl("/mytrips");
                    $.btn.stopIndicator();
                    return;
                }
                $.btn.stopIndicator();
                Alloy.createWidget("ma.car.app.trip", {
                    addTrip: true
                });
                return false;
            }
        });
        return new Dialog();
    }
};

module.exports = MessageControllerBuilder;