"use strict";

var purl = require("/utils/purl");

module.exports = {
    init: function(webview) {
        webview.autoDetect = [];
        var _handlers = {};
        webview.native2web = function(func, params, callback) {
            if (func) {
                var parameters = "";
                for (var index in params) parameters += JSON.stringify(params[index]) + ",";
                parameters = parameters ? parameters.substring(0, parameters.length - 1) : "";
                var expression = func + "(" + parameters + ")";
                if (callback && "function" == typeof callback) {
                    var token = "_" + Date.now();
                    var url = "webapppushtest://" + token;
                    expression = "window.location = '" + url + "?result=' + encodeURIComponent(JSON.stringify(" + expression + "))";
                    webview.addWeb2NativeHandler(token, callback);
                }
                webview.evalJSX(expression);
            }
        };
        webview.addWeb2NativeHandler = function(urlToken, func) {
            if (urlToken && func && "function" == typeof func) {
                var token = urlToken.toLowerCase();
                _handlers[token] = function(e) {
                    var _webView = webview;
                    if (e.url && -1 !== e.url.toLowerCase().indexOf(token)) {
                        var url = purl.purl(e.url);
                        var result = url.param("result");
                        var callback = url.param("callback");
                        var value = func({
                            url: url,
                            token: token,
                            result: result,
                            callback: callback
                        });
                        callback ? _webView.native2web(callback, value ? [ value ] : []) : "";
                        0 === token.indexOf("_") ? _webView.removeWeb2NativeHandler(token) : "";
                    }
                    _webView = null;
                };
                webview.addEventListener("beforeload", _handlers[token]);
            }
        };
        webview.removeWeb2NativeHandler = function(urlToken) {
            if (urlToken) {
                var token = urlToken.toLowerCase();
                webview.removeEventListener("beforeload", _handlers[token]);
                delete _handlers[token];
            }
        };
    }
};