"use strict";

var PopupWindow = function() {
    var _init = function(isSuccess, message, options) {
        options = options || {};
        var details = options.details || false;
        var popupWin = Ti.UI.createWindow({
            backgroundColor: "transparent",
            layout: "vertical",
            opacity: 1,
            width: "100%",
            height: "100%",
            id: "popupWin",
            navBarHidden: true
        });
        var backgroundContainer = Ti.UI.createView({
            width: "100%",
            height: "100%",
            opacity: .88,
            backgroundColor: "black",
            modal: false
        });
        popupWin.add(backgroundContainer);
        backgroundContainer.add(Ti.UI.createLabel({
            width: "90%",
            height: "auto",
            top: "63dp",
            text: message,
            backgroundColor: "transparent",
            textAlign: "center",
            color: "white",
            font: {
                fontSize: "36dp"
            }
        }));
        if (details) {
            var detailsLab = Ti.UI.createLabel({
                width: "90%",
                height: "auto",
                top: "115dp",
                backgroundColor: "transparent",
                textAlign: "center",
                color: "white",
                font: {
                    fontSize: "16dp",
                    fontWeight: "bold"
                },
                text: details
            });
            backgroundContainer.add(detailsLab);
        }
        var utils = require("utils/utils");
        var circleView = Ti.UI.createView({
            width: "150dp",
            height: "150dp",
            opacity: 1,
            backgroundColor: "white",
            borderRadius: utils.dpToPixel(75),
            borderWidth: 1,
            borderColor: "white",
            zIndex: 1002,
            top: Ti.Platform.displayCaps.platformHeight >= 480 ? "-70%" : "-55%"
        });
        var iconLabel = Ti.UI.createLabel({
            width: "80dp",
            height: "80dp",
            top: "35dp",
            opacity: 1,
            text: isSuccess ? "c" : "h",
            backgroundColor: "white",
            textAlign: "center",
            color: "#333333",
            font: {
                fontSize: "60dp",
                fontWeight: "bold",
                fontFamily: "splinico"
            }
        });
        circleView.add(iconLabel);
        popupWin.add(circleView);
        popupWin.open({
            modal: false
        });
        popupWin.addEventListener("close", function onClose() {
            popupWin.removeEventListener("close", onClose);
            options.callback && options.callback();
        });
        var windowCloseHandler = function() {
            popupWin.close();
            circleView.removeEventListener("click", windowCloseHandler);
            popupWin.removeEventListener("click", windowCloseHandler);
        };
        circleView.addEventListener("click", windowCloseHandler);
        popupWin.addEventListener("click", windowCloseHandler);
        _.delay(function() {
            popupWin.close();
        }, isSuccess ? 2e3 : 3e3);
    };
    this.show = function(isSuccess, message, options) {
        _init(isSuccess, message, options);
    };
};

module.exports = PopupWindow;