function PagingControl(scrollableView) {
    var page;
    var pageColor = "#fff";
    var container = Titanium.UI.createView({
        width: Ti.UI.SIZE,
        height: "15dp"
    });
    numberOfPages = scrollableView.getViews().length;
    _scrollableView = scrollableView;
    pages = [];
    var utils = require("utils/utils");
    var borderDp = utils.dpToPixel(8);
    for (var i = 0; numberOfPages > i; i++) {
        page = Titanium.UI.createView({
            borderRadius: borderDp,
            width: "8dp",
            height: "8dp",
            left: 15 * i + "dp",
            backgroundColor: pageColor,
            opacity: .5
        });
        pages.push(page);
        container.add(page);
    }
    pages[scrollableView.getCurrentPage()].setOpacity(1);
    scrollableView.addEventListener("scroll", onScroll);
    scrollableView.addEventListener("postlayout", onPostLayout);
    return container;
}

var numberOfPages = 0, pages = [], _scrollableView = null;

onScroll = function(event) {
    for (var i = 0; numberOfPages > i; i++) pages[i].setOpacity(.5);
    pages[event.currentPage].setOpacity(1);
};

onPostLayout = function(event) {
    for (var i = 0; numberOfPages > i; i++) pages[i].setOpacity(.5);
    pages[_scrollableView.currentPage].setOpacity(1);
};

module.exports = PagingControl;