"use strict";

var Q = require("vendor/q");

var assert = require("/utils/assert");

var _createOptions = function(deferred, errorMessage) {
    return {
        mediaTypes: [ Ti.Media.MEDIA_TYPE_PHOTO ],
        success: function(e) {
            deferred.resolve(e.media);
        },
        error: function(e) {
            Ti.UI.createAlertDialog({
                title: L("error_title"),
                message: errorMessage
            }).show();
            deferred.reject(e);
        },
        cancel: function(e) {
            e.canceled = true;
            deferred.reject(e);
        }
    };
};

var _pickPhoto = function() {
    var deferred = Q.defer();
    var dialog = Ti.UI.createOptionDialog({
        cancel: 2,
        options: [ L("photo_module_take_photo"), L("photo_module_select_photo"), L("btn_cancel") ]
    });
    dialog.addEventListener("click", function(e) {
        if (0 === e.index) {
            var options = _createOptions(deferred, L("photo_module_camera_error"));
            require("ma.car.ti.module.media").showCamera(options);
            return;
        }
        if (1 === e.index) {
            var options = _createOptions(deferred, L("photo_module_library_error"));
            require("ma.car.ti.module.media").openPhotoGallery(options);
            return;
        }
        if (2 === e.index) {
            deferred.reject(e);
            return;
        }
    });
    dialog.show();
    return deferred.promise;
};

module.exports = {
    pickPhoto: function() {
        return _pickPhoto();
    }
};