"use strict";

var units = require("/platform/units"), os = require("/platform/os"), ANDROID_STATUS_BAR_HEIGHT = 25, ANDROID_NAV_BAR_HEIGHT = 48, IOS_STATUS_BAR_HEIGHT = 20, IOS_NAV_BAR_HEIGHT = 44;

module.exports = {
    statusBarHeightInSystemUnit: function() {
        return units.dipToPixel(ANDROID_STATUS_BAR_HEIGHT);
    },
    navBarHeightInSystemUnit: function() {
        return units.dipToPixel(ANDROID_NAV_BAR_HEIGHT);
    },
    windowHeightInSystemUnit: function() {
        return Ti.Platform.displayCaps.platformHeight - module.exports.statusBarHeightInSystemUnit();
    },
    windowTopInSystemUnit: function() {
        if (!os.isIOS7Plus()) return 0;
        return module.exports.statusBarHeightInSystemUnit();
    }
};