"use strict";

!function() {
    var deviceToken = null;
    var _SERVICE = "GCM", _APP = "rtr-mobile-web";
    var registerForAndroid = function() {
        if (deviceToken) {
            Ti.App.fireEvent("carma:push.notification.token.updated", {
                params: [ deviceToken, _SERVICE, _APP, {} ]
            });
            return;
        }
        var gcm = require("com.activate.gcm");
        gcm.registerC2dm({
            success: function(e) {
                deviceToken = e.registrationId;
                Ti.App.fireEvent("carma:push.notification.token.updated", {
                    params: [ deviceToken, _SERVICE, _APP, {} ]
                });
                LOGGER.info("JS registration success event: " + e.registrationId);
            },
            error: function(e) {
                LOGGER.info("Error during registration : " + e.error);
            },
            callback: function(e) {
                var params = e || {};
                params.ignoreRedirection = true;
                Ti.App.fireEvent("carma:push.notification.open", params);
            }
        });
    };
    module.exports = {
        register: function() {
            registerForAndroid();
        },
        deleteToken: function() {
            deviceToken = null;
        },
        getDeviceToken: function() {
            return deviceToken;
        }
    };
}();