"use strict";

!function() {
    var pns = null, _pushTokenModel = null;
    var _getPushTokenModel = function() {
        _pushTokenModel || (_pushTokenModel = Alloy.createModel("pushToken"));
        return _pushTokenModel;
    };
    var deletePushToken = function(userId, oAuthToken) {
        _getPushTokenModel().deleteToken({
            uid: userId,
            oAuthToken: oAuthToken,
            token: pns.getDeviceToken(),
            appKey: "rtr-mobile-web"
        });
    };
    var createPushToken = function(userId, oAuthToken, token) {
        _getPushTokenModel().createToken({
            uid: userId,
            token: token[0],
            deviceId: Ti.Platform.getId(),
            service: token[1],
            appKey: token[2]
        });
    };
    module.exports = {
        init: function() {
            pns = require("/pushnotification/androidgcm");
            Ti.App.addAppEventListener("carma:push.notification.token.updated", function(params) {
                LOGGER.info("PN: Push token available, registering with the server");
                var resourceOwner = require("/services/resource_owner_service").singleton();
                var oAuthToken = resourceOwner.get("token") ? resourceOwner.get("token").token : null;
                var userId = resourceOwner.get("userId");
                createPushToken(userId, oAuthToken, params.params);
            });
            Ti.App.addAppEventListener("carma:push.notification.register", function() {
                LOGGER.info("carma:push.notification.register");
                LOGGER.info("PN: Logged in, registering push token");
                pns.register();
            });
            Ti.App.addAppEventListener("carma:push.notification.unregister", function(params) {
                LOGGER.info("carma:push.notification.unregister");
                Ti.Android.NotificationManager.cancelAll();
                LOGGER.info("PN: Not logged in, deleting push token {userId: " + params.userId + ", oAuthToken: " + params.oAuthToken + "}");
                params && params.userId && params.oAuthToken && deletePushToken(params.userId, params.oAuthToken);
                pns.deleteToken();
            });
        }
    };
}();