"use strict";

var Q = require("vendor/q");

module.exports = {
    _saveToResourceOwner: function(beacons) {
        var resourceOwner = require("services/resource_owner_service").singleton();
        resourceOwner && resourceOwner.save({
            beacons: beacons
        });
    },
    _getSavedBeacons: function() {
        var resourceOwner = require("services/resource_owner_service").singleton(), beacons = resourceOwner.get("beacons");
        return beacons;
    },
    list: function() {
        var beacons = null, deferred = Q.defer(), self = this;
        Alloy.createModel("beacons").list().then(function(list) {
            if (list && list.beacons) {
                beacons = list.beacons;
                self._saveToResourceOwner(beacons);
                deferred.resolve({
                    beacons: beacons
                });
            } else deferred.reject({
                reason: "beacons list constructure may has been changed"
            });
        }).catch(function(e) {
            LOGGER.error("[beacons services] - error: " + JSON.stringify(e));
            beacons = self._getSavedBeacons();
            beacons ? deferred.resolve({
                beacons: beacons
            }) : deferred.reject(e);
        }).done();
        return deferred.promise;
    },
    connect: function(beaconId) {
        return Alloy.createModel("beacons").connect(beaconId);
    },
    disconnect: function(beaconId) {
        return Alloy.createModel("beacons").delete(beaconId);
    }
};