"use strict";

module.exports = {
    _cap: 1e3,
    _collection: require("/vendor/scule").factoryCollection("scule+titanium://log", {
        remoteBackup: true
    }),
    count: function(query) {
        return this._collection.count(query);
    },
    findAll: function(query) {
        var deferred = require("vendor/q").defer();
        try {
            this._collection.find(query, {
                $sort: {
                    timestamp: -1
                }
            }, function(data) {
                deferred.resolve(data);
            });
        } catch (e) {
            console.error(e);
            deferred.reject(e);
        }
        return deferred.promise;
    },
    save: function(value) {
        try {
            var now = Date.now();
            this._collection.save({
                timestamp: now,
                level: value.level,
                message: value.message
            });
            var count = this._collection.count({});
            this._cap < count && this._collection.remove({}, {
                $limit: count - this._cap
            });
            this._collection.commit();
        } catch (e) {
            console.error(e);
        }
    },
    deleteAll: function(query) {
        try {
            this._collection.remove(query);
        } catch (e) {
            console.error(e);
        }
    }
};