"use strict";

module.exports = {
    fetchPreferences: function() {
        var resourceOwner = require("services/resource_owner_service").singleton();
        return Alloy.createModel("preferences", {
            urlParams: {
                userId: resourceOwner.get("userId")
            }
        }).fetch().then(function(data) {
            if (data) {
                var cachedPreferences = require("services/cached_preferences_service").singleton();
                cachedPreferences.save(data);
                Ti.App.fireEvent("app.carma.preferences.changes");
            }
            return data;
        });
    },
    updateLanguage: function(language) {
        var resourceOwner = require("services/resource_owner_service").singleton(), preferences = Alloy.createModel("preferences", {
            name: "preferred_locale",
            value: language,
            urlParams: {
                userId: resourceOwner.get("userId")
            }
        }), options = {
            method: "PUT",
            url: _.template(require("/carmalib/url")["USER_PREFERENCES"] + "/preferred_locale", {
                userId: resourceOwner.get("userId")
            })
        };
        return preferences.save(null, options);
    },
    updateLocationSpecific: function(locationId) {
        var resourceOwner = require("services/resource_owner_service").singleton(), preferences = Alloy.createModel("preferences", {
            name: "preferred_location_" + locationId,
            value: 1,
            urlParams: {
                userId: resourceOwner.get("userId")
            }
        }), options = {
            method: "PUT",
            url: _.template(require("/carmalib/url")["USER_PREFERENCES"] + "/preferred_location_" + locationId, {
                userId: resourceOwner.get("userId")
            })
        };
        return preferences.save(null, options);
    }
};