"use strict";

module.exports = {
    getUserById: function(userId, offlineOnly) {
        var profile = Alloy.createModel("public_profile", {
            userId: userId
        });
        offlineOnly = offlineOnly || false;
        return profile.fetch({
            localOnly: offlineOnly
        });
    },
    getUsersByIds: function(idList, offlineOnly) {
        var profiles = Alloy.createModel("public_profile");
        var userFields = "FULL_PUBLIC";
        offlineOnly = offlineOnly || false;
        return profiles.fetchProfiles({
            idList: idList,
            userFields: userFields,
            localOnly: offlineOnly
        });
    },
    getUserByPhoneNumber: function(phoneNumber) {
        var profile = Alloy.createModel("public_profile");
        phoneNumber && phoneNumber.length > 1 && (phoneNumber = phoneNumber.substring(1));
        var phoneNumberRegex = new RegExp(".*" + phoneNumber);
        return profile.fetch({
            query: {
                telephoneNumber: phoneNumberRegex,
                "validations.phoneValidated": true
            },
            localOnly: true
        });
    }
};