"use strict";

var trackingConfig = null, UPDATE_FREQUENCY = 36e5;

module.exports = {
    getTrackingConfig: function() {
        if (!trackingConfig) {
            var config = Alloy.createModel("cached_tracking_config");
            config.fetch();
            trackingConfig = config.toJSON();
        }
        return trackingConfig;
    },
    fetchTrackingConfig: function() {
        TM.push(function() {
            var config = module.exports.getTrackingConfig();
            (!config || !config.timestamp || Date.now() - config.timestamp > UPDATE_FREQUENCY) && Alloy.createModel("tracking_config").fetch().then(function(data) {
                data.timestamp = Date.now();
                var remoteConfig = Alloy.createModel("cached_tracking_config");
                remoteConfig.save(data);
                trackingConfig = data;
            });
        }, process.backgroundDomain);
    }
};

Ti.App.addAppEventListener("carma:life.cycle.refresh", function() {
    module.exports.fetchTrackingConfig();
});