"use strict";

var Q = require("vendor/q");

var purl = require("utils/purl");

var _startSpinner = function() {
    return Q.fcall(function() {
        Ti.App.fireEvent("carma:progress.start");
        return true;
    });
};

var _stopSpinner = function() {
    Ti.App.fireEvent("carma:progress.stop");
};

var _handleRequestSuccess = function() {
    _stopSpinner();
    Ti.UI.createAlertDialog({
        title: L("widget_verification_email_title"),
        message: L("widget_verification_email_success")
    }).show();
};

var _handleRequestError = function() {
    _stopSpinner();
    Ti.UI.createAlertDialog({
        title: L("widget_verification_email_title"),
        message: L("widget_verification_email_error")
    }).show();
};

var _verify = function(url) {
    var params = purl.purl(url);
    var key = params.param("token");
    var userId = params.param("uid");
    return Alloy.createModel("verification_confirm", {
        userId: userId,
        key: key
    }).fetch();
};

module.exports = {
    verify: function(url) {
        _startSpinner().then(function() {
            return _verify(url);
        }).then(_handleRequestSuccess).catch(_handleRequestError);
    }
};