"use strict";

var Q = require("/vendor/q"), WM = require("/ui/windowManager");

var testUtils = function() {
    var _openTab = function(tab, viewToCheck) {
        var deferred = Q.defer();
        TS.waitForViewById(tab, 2e3, true).then(function(tab) {
            tab.setActive(true);
        }).then(function() {
            return TS.waitForViewById(viewToCheck);
        }).then(function() {
            deferred.resolve();
        }).catch(function() {
            deferred.reject();
        });
        return deferred.promise;
    };
    return {
        login: function(user) {
            var deferred = Q.defer();
            if (!user) {
                console.error("[testUtils] - User not provided");
                deferred.reject();
                return deferred.promise;
            }
            try {
                var win = TS.findViewById("windowHome");
            } catch (e) {
                console.error("[testUtils] - User is not on home screen");
                deferred.reject();
                return deferred.promise;
            }
            TS.findViewById("btnLogin").fireEvent("click");
            TS.waitForViewById("email").then(function(textView) {
                textView.setValue(user.email);
                TS.findViewById("password").setValue("eirlift");
                TS.findViewById("submit").fireEvent("click");
            }).then(function() {
                return TS.waitForViewById("tabGroup");
            }).then(function(tabGroup) {
                deferred.resolve();
            }).catch(function() {
                deferred.reject();
            });
            return deferred.promise;
        },
        logout: function() {
            var deferred = Q.defer();
            Q().then(function() {
                Ti.App.fireEvent("carma:logout");
            }).delay(2e3).then(function() {
                return TS.waitForViewById("windowHome");
            }).then(function() {
                deferred.resolve();
            }).catch(function() {
                deferred.reject();
            });
            return deferred.promise;
        },
        openMatchMe: function() {
            return _openTab("planTripTab", "exploreWin");
        }
    };
};

module.exports = new testUtils();