"use strict";

var KEY = "TRACK_PUSH_NOTIFICATION";

var _push = function(event) {
    var items = Ti.App.Properties.getList(KEY, []);
    items.push(event);
    Ti.App.Properties.setList(KEY, items);
};

var _pop = function() {
    var events = Ti.App.Properties.getList(KEY, []);
    Ti.App.Properties.setList(KEY, []);
    return events;
};

module.exports = {
    track: function(event, properties) {
        LOGGER.debug("[TRACKING] - push notification track");
        _push({
            event: event,
            timestamp: Date.now(),
            properties: properties
        });
        module.exports.flush();
    },
    flush: require("/bootstrap/patch").debounce(function() {
        LOGGER.debug("[TRACKING] - push notification flush");
        if (!require("bootstrap/network").isConnectionGood()) {
            LOGGER.warn("[TRACKING] - bad connection, wait for next turn");
            return;
        }
        var events = _pop();
        _.map(events, function(event) {
            if (event.properties && event.properties.token) {
                var token = event.properties.token;
                LOGGER.debug("[TRACKING] - tracking push notification for token: " + token);
                var tracking = Alloy.createModel("pushTokenTracking", {
                    token: token
                });
                tracking.fetch().then(function() {
                    LOGGER.info("[TRACKING] - Successfully flushed the queue for push notification: " + events.length);
                }).catch(function() {
                    LOGGER.warn("[TRACKING] - Failed to flush the queue for push notification: " + events.length);
                    _push(event);
                });
            }
        });
    }, 5e3)
};