"use strict";

var _ = require("/vendor/underscore");

var Helper = function(layout) {
    if (!layout) throw "layout can not be null.";
    this.layout = layout;
    this._map = {};
};

_.extend(Helper.prototype, {
    add: function(id, widget) {
        if (!widget) return false;
        this._map["" + id] = widget;
        this.layout.add(widget.getView());
    },
    remove: function(id) {
        var widget = this.findById(id);
        if (widget) {
            delete this._map[id];
            this.layout.remove(widget.getView());
        }
        if (_.isEmpty(this._map)) {
            this.layout.visible = false;
            this.layout.visible = true;
        }
        return widget;
    },
    findById: function(id) {
        var _id = "" + id;
        return _id ? this._map[_id] : null;
    },
    clear: function() {
        for (var key in this._map) this.layout.remove(this._map[key].getView());
        this._map = {};
    },
    getAll: function() {
        var _children = [];
        for (var key in this._map) _children.push(this._map[key]);
        return _children;
    }
});

module.exports = Helper;