function PagingControl(scrollableView, pageViews) {
    var page;
    _scrollableView = scrollableView;
    var pageColor = "#c99ed5";
    var container = Titanium.UI.createView({
        height: 60,
        top: 0
    });
    numberOfPages = pageViews.length;
    pages = [];
    for (var i = 0; numberOfPages > i; i++) {
        page = Titanium.UI.createView({
            borderRadius: 4,
            width: 8,
            height: 8,
            left: 15 * i,
            backgroundColor: pageColor,
            opacity: .5
        });
        pages.push(page);
        container.add(page);
    }
    pages[scrollableView.getCurrentPage()].setOpacity(1);
    scrollableView.addEventListener("scroll", onScroll);
    scrollableView.addEventListener("postlayout", onPostLayout);
    return container;
}

var numberOfPages = 0;

var pages = [];

var _scrollableView = null;

onScroll = function(event) {
    for (var i = 0; numberOfPages > i; i++) pages[i].setOpacity(.5);
    pages[event.currentPage].setOpacity(1);
};

onPostLayout = function(event) {
    for (var i = 0; numberOfPages > i; i++) pages[i].setOpacity(.5);
    pages[_scrollableView.currentPage].setOpacity(1);
};

module.exports = PagingControl;