"use strict";

var registerAppEvents = function(window) {
    var appEventListers = [];
    window.addAppEventListener = function(event, callback) {
        Ti.App.addEventListener(event, callback);
        appEventListers.push({
            event: event,
            callback: callback
        });
    };
    window.addEventListener("close", function handler() {
        LOGGER.debug("[CustomWindow] removign global event listener: " + window.id);
        window.removeEventListener("close", handler);
        _.each(appEventListers, function(item) {
            LOGGER.debug("[CustomWindow] removing global event listener: " + item.event);
            Ti.App.removeEventListener(item.event, item.callback);
        });
    });
};

var registerAutoClose = function(window) {
    Ti.App.addEventListener("carma:window.destroy", function handler() {
        Ti.App.removeEventListener("carma:window.destroy", handler);
        LOGGER.debug("[CustomWindow] destroy window: " + window.id);
        window.fireEvent("close");
    });
};

var registerDestroy = function(window) {
    window.addEventListener("close", function handler() {
        window.removeEventListener("close", handler);
        window.removeAllChildren();
    });
};

var registerOpen = function(window) {
    window.open = function() {
        window.fireEvent("open");
    };
};

var registerClose = function(window) {
    window.close = function() {
        window.fireEvent("close");
    };
};

exports.createView = function(args) {
    var childWindow = Ti.UI.createView(args);
    registerAppEvents(childWindow);
    registerAutoClose(childWindow);
    registerDestroy(childWindow);
    registerOpen(childWindow);
    registerClose(childWindow);
    return childWindow;
};