"use strict";

var utils = require("utils/utils");

exports.createView = function(args) {
    var isVisible = false;
    var container = Ti.UI.createView(_.extend(args, {
        top: 0,
        left: 0,
        width: Ti.UI.FILL,
        height: 0,
        backgroundColor: "#fff"
    }));
    var message = Ti.UI.createLabel({
        top: 0,
        left: 0,
        width: "100%",
        height: "30dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        color: "#000",
        font: {
            fontSize: "13dp"
        }
    });
    container.add(message);
    var update = function(connected, experience) {
        if (connected) {
            isVisible = false;
            container.height = 0;
            message.text = "";
        } else {
            message.text = L("widget_connection_state_offline");
            container.height = "30dp";
            isVisible = true;
        }
    };
    container.handleNetwork = function(data) {
        update(data.connected, data.experience);
        container.fireEvent("change");
    };
    container.isBarVisible = function() {
        return isVisible;
    };
    container.getBarHeight = function() {
        return isVisible ? utils.dpToDefault(30) : 0;
    };
    container.getVisibleBarHeight = function() {
        return utils.dpToDefault(30);
    };
    var network = require("bootstrap/network");
    update(network.isConnected(), network.experience());
    return container;
};