"use strict";

var CustomLabel = function(args) {
    var params = _.clone(args), label = Ti.UI.createLabel(params);
    label.isErrorState = false;
    label.isError = function() {
        return label.isErrorState;
    };
    label.showError = function(message) {
        label.isErrorState = true;
        label.applyProperties({
            text: message,
            color: "red"
        });
    };
    var resetField = function() {
        label.applyProperties(params);
    };
    label.clearError = function() {
        if (!label.isErrorState) return;
        label.text = "";
        resetField();
        label.isErrorState = false;
    };
    return label;
};

exports.createLabel = function(args) {
    return new CustomLabel(args);
};