"use strict";

var isIOS7Plus = require("/platform/os").isIOS7Plus();

var CustomTextField = function(args) {
    var params = _.clone(args), passwordMask = !!params.passwordMask && "true" === params.passwordMask.toString(), textfield = Ti.UI.createTextField(params);
    textfield.isErrorState = false;
    textfield.showError = function(message) {
        if (!textfield.isErrorState) {
            passwordMask = textfield.passwordMask;
            textfield.isErrorState = true;
            textfield.applyProperties({
                value: message,
                color: "red",
                passwordMask: false
            });
        }
    };
    textfield.updateProperties = function(properties) {
        textfield.applyProperties(properties);
        params = _.extend({}, params, properties);
    };
    var resetField = function(fromClearError) {
        var paramsCopy = _.clone(params);
        paramsCopy.passwordMask = passwordMask;
        fromClearError && (paramsCopy.value = "");
        textfield.applyProperties(paramsCopy);
    };
    textfield.clearError = function() {
        if (!textfield.isErrorState) return;
        textfield.isErrorState = false;
        resetField(true);
    };
    textfield.addEventListener("click", textfield.clearError);
    textfield.addEventListener("focus", textfield.clearError);
    textfield.addEventListener("blur", function() {
        if (textfield.isErrorState) return;
        resetField();
    });
    return textfield;
};

exports.createTextField = function(args) {
    return new CustomTextField(args);
};