"use strict";

var deepLinker = require("bootstrap/deepLinker");

var _checkDeepLinker = function() {
    if (Alloy.Globals.loadUrl) {
        var url = JSON.parse(JSON.stringify(Alloy.Globals.loadUrl));
        Alloy.Globals.loadUrl = null;
        deepLinker.handleUrl(url);
    }
    Alloy.Globals.isWindowLoaded = true;
};

var handleAndroidNewIntent = function(params) {
    require("/pushnotification/pushNotificationHandler").handleAndroidNewIntent(params.intent);
};

exports.createWindow = function(args) {
    var window = Ti.UI.createWindow(args);
    window.addEventListener("open", function handler() {
        window.removeEventListener("open", handler);
        var isHeavyWeightWindow = "undefined" != typeof window.activity;
        if (!isHeavyWeightWindow) return;
        LOGGER.debug("[CustomWindow] - heavy weight window, listen to life cycle events");
        _checkDeepLinker();
        window.activity.removeEventListener && window.activity.removeEventListener("newintent", handleAndroidNewIntent);
        window.activity.addEventListener && window.activity.addEventListener("newintent", handleAndroidNewIntent);
    });
    var eventManager = require("/ui/common/eventManager").createEventManager();
    eventManager.manageEvents(window.id, window);
    window.autoClose = false === window.autoClose || "false" === window.autoClose ? false : true;
    var autocloseHandler = function() {
        try {
            LOGGER.debug("[CustomWindow] destroy window: " + window.id);
            window && window.autoClose && window.close();
        } catch (e) {
            LOGGER.error(e);
        }
    };
    window.addAppEventListener("carma:window.destroy", autocloseHandler);
    window.addEventListener("close", function handler() {
        window.removeEventListener("close", handler);
        LOGGER.info("[CustomWindow] Removing events for Window: " + window.id);
        window.removeAllChildren();
        window.removeAppEventListener("carma:window.destroy", autocloseHandler);
        autocloseHandler = null;
        window.removeAllAppEventListeners();
    });
    return window;
};