"use strict";

module.exports = {
    isOpen: false,
    turnOnGPSPrompt: function() {
        if (this.isOpen || this.hasShownToday()) return;
        this.isOpen = true;
        var buttons = [ L("gps_modal_disabled_button_ok") ], cancelIndex = 0;
        buttons = [ L("gps_modal_disabled_button_settings"), L("gps_modal_disabled_button_cancel") ];
        cancelIndex = 1;
        var dialog = Ti.UI.createAlertDialog({
            buttonNames: buttons,
            cancel: cancelIndex,
            title: L("gps_modal_disabled_title"),
            message: L("gps_modal_disabled_message")
        });
        var self = this;
        dialog.addEventListener("click", function(e) {
            self.isOpen = false;
            if (e.index === e.source.cancel) return;
            var locationSettings = Ti.Android.createIntent({
                action: "android.settings.LOCATION_SOURCE_SETTINGS"
            });
            Ti.Android.currentActivity.startActivity(locationSettings);
        });
        this.setGpsPromptTime(Date.now());
        dialog.show();
    },
    hasShownToday: function() {
        var lastGpsPromptTimestamp = Ti.App.Properties.getString("lastGpsPromptTimestamp");
        if (null === lastGpsPromptTimestamp || "" === lastGpsPromptTimestamp) return false;
        var time = new Date();
        time.setTime(lastGpsPromptTimestamp);
        var timeout = Date.now() - time.getTime();
        return 864e5 > timeout;
    },
    setGpsPromptTime: function(time) {
        var timestamp = time || Date.now();
        Ti.App.Properties.setString("lastGpsPromptTimestamp", "" + timestamp);
    }
};