var event = require("/tracking/tracking_event"), analytics = require("/tracking/tracking_manager"), shareModule = require("ma.car.ti.module.share");

module.exports = {
    shareByEmail: function() {
        var emailDialog = Ti.UI.createEmailDialog();
        emailDialog.html = true;
        emailDialog.subject = L("widget_invite_email_subject");
        emailDialog.messageBody = L("widget_invite_email_body");
        emailDialog.open();
        emailDialog.addEventListener("complete", function(e) {
            Ti.UI.Android.hideSoftKeyboard();
            e.result === emailDialog.CANCELLED && TM.push(function() {
                analytics.track(event.INVITE_CANCELLED, {
                    source: "email"
                });
            });
            e.result === emailDialog.SENT && TM.push(function() {
                analytics.track(event.INVITE_COMPLETED, {
                    source: "email"
                });
            });
        });
    },
    shareByNative: function(content, imageName, imagePath, subject) {
        var content = content ? content : L("widget_invite_twitter_body");
        subject = subject ? subject : L("widget_invite_subject");
        var json = {
            text: content,
            callback: function(res) {
                if ("SUCCESS" === res.state) {
                    LOGGER.info("[Profile] - share successed on " + res.platform);
                    Ti.App.fireEvent("carma.share.success");
                    TM.push(function() {
                        analytics.track(event.INVITE_COMPLETED, {
                            source: res.platform
                        });
                    });
                } else if ("CANCEL" === res.state) {
                    LOGGER.info("[Profile] - share cancelled on " + res.platform);
                    TM.push(function() {
                        analytics.track(event.INVITE_CANCELLED, {
                            source: res.platform
                        });
                    });
                } else LOGGER.info("[Profile] - share failed");
            }
        };
        _.extend(json, {
            mime: imagePath ? "image/*" : "text/plain",
            subject: subject
        });
        imagePath && _.extend(json, {
            stream: imagePath
        });
        shareModule.share(json);
        json = null;
    },
    openShare: function(options, view) {
        if (!require("bootstrap/network").isConnectionGood()) {
            view._shareOpening = false;
            return;
        }
        if (view._shareOpening) return;
        view._shareOpening = true;
        var shareController = Alloy.createWidget("ma.car.app.share", options);
        setTimeout(function() {
            view && (view._shareOpening = false);
        }, 1e4);
        shareController.getView().addEventListener("close", function handler() {
            shareController.getView().removeEventListener("close", handler);
            shareController = null;
            view._shareOpening = false;
        });
        try {
            shareController.getView().open();
        } catch (e) {
            view._shareOpening = false;
        }
    }
};