"use strict";

function createErrorDialog(title, message) {
    return Carma.UI.createAlertWindow(title === NO_TITLE ? {
        message: message || L("form_validation_error_popup_message")
    } : {
        title: title || L("form_validation_error_popup_title"),
        message: message || L("form_validation_error_popup_message")
    });
}

var NO_TITLE = "<NO_TITLE>";

module.exports = {
    show: function(title, message) {
        var dialog = createErrorDialog(title, message);
        dialog.show();
    },
    showSimple: function(message) {
        var dialog = createErrorDialog(NO_TITLE, message);
        dialog.show();
    }
};