"use strict";

var windowStack = [];

module.exports = {
    trackWindow: function(wnd) {
        windowStack.push(wnd);
        wnd.addEventListener("close", function onClose() {
            wnd.removeEventListener("close", onClose);
            while (true) {
                if (!windowStack.length) {
                    LOGGER.error("ERROR: Could not find Window on stack: " + wnd.id);
                    return;
                }
                var topWindow = windowStack.pop();
                if (topWindow === wnd) return;
                LOGGER.error("ERROR: Window not closed properly: " + topWindow.id);
            }
        });
    },
    getCurrentWindow: function() {
        return windowStack.length ? windowStack[windowStack.length - 1] : null;
    }
};