"use strict";

var _soundResources = [];

var _checkAndInitSound = function(sound, extention) {
    if (sound in _soundResources) return;
    extention = extention || "wav";
    _soundResources[sound] = Ti.Media.createSound({
        url: "/sounds/" + sound + "." + extention,
        volume: 1
    });
};

module.exports = {
    play: function(sound) {
        switch (sound) {
          case "endtrip":
          case "joincar":
          case "snuffle":
          case "swish":
          case "recharge":
          case "confirmed":
          case "completeness":
          case "gobutton":
          case "selectionerror":
            _checkAndInitSound(sound);
            break;

          default:
            alert("File " + sound + ".wav could not be found");
            return;
        }
        _soundResources[sound].stop();
        _soundResources[sound].play();
    },
    prepare: function(sound, extention) {
        sound && _checkAndInitSound(sound, extention);
    }
};