"use strict";

module.exports = {
    countries: [ {
        name: "Afghanistan",
        tld: ".af",
        cca2: "AF",
        ccn3: 4,
        cca3: "AFG",
        currency: "AFN",
        dialingCode: "93",
        capital: "Kabul",
        "alt-spellings": "AF,Afġānistān",
        relevance: 0,
        region: "Asia",
        subregion: "Southern Asia"
    }, {
        name: "Åland Islands",
        tld: ".ax",
        cca2: "AX",
        ccn3: 248,
        cca3: "ALA",
        currency: "EUR",
        dialingCode: "358",
        capital: "Mariehamn",
        "alt-spellings": "AX,Aaland,Aland",
        relevance: .5,
        region: "Europe",
        subregion: "Northern Europe"
    }, {
        name: "Albania",
        tld: ".al",
        cca2: "AL",
        ccn3: 8,
        cca3: "ALB",
        currency: "ALL",
        dialingCode: "355",
        capital: "Tirana",
        "alt-spellings": "AL,Shqipëri,Shqipëria,Shqipnia",
        relevance: 0,
        region: "Europe",
        subregion: "Southern Europe"
    }, {
        name: "Algeria",
        tld: ".dz",
        cca2: "DZ",
        ccn3: 12,
        cca3: "DZA",
        currency: "DZD",
        dialingCode: "213",
        capital: "Algiers",
        "alt-spellings": "DZ,al-Jazā'ir",
        relevance: 0,
        region: "Africa",
        subregion: "Northern Africa"
    }, {
        name: "American Samoa",
        tld: ".as",
        cca2: "AS",
        ccn3: 16,
        cca3: "ASM",
        currency: "USD",
        dialingCode: "1684",
        capital: "Pago Pago",
        "alt-spellings": "AS,Amerika Sāmoa",
        relevance: .5,
        region: "Oceania",
        subregion: "Polynesia"
    }, {
        name: "Andorra",
        tld: ".ad",
        cca2: "AD",
        ccn3: 20,
        cca3: "AND",
        currency: "EUR",
        dialingCode: "376",
        capital: "Andorra la Vella",
        "alt-spellings": "AD",
        relevance: .5,
        region: "Europe",
        subregion: "Southern Europe"
    }, {
        name: "Angola",
        tld: ".ao",
        cca2: "AO",
        ccn3: 24,
        cca3: "AGO",
        currency: "AOA",
        dialingCode: "244",
        capital: "Luanda",
        "alt-spellings": "AO",
        relevance: 0,
        region: "Africa",
        subregion: "Middle Africa"
    }, {
        name: "Anguilla",
        tld: ".ai",
        cca2: "AI",
        ccn3: 660,
        cca3: "AIA",
        currency: "XCD",
        dialingCode: "1264",
        capital: "The Valley",
        "alt-spellings": "AI",
        relevance: .5,
        region: "Americas",
        subregion: "Caribbean"
    }, {
        name: "Antarctica",
        tld: ".aq",
        cca2: "AQ",
        ccn3: 10,
        cca3: "ATA",
        currency: "",
        dialingCode: "",
        capital: "",
        "alt-spellings": "AQ",
        relevance: .5,
        region: "",
        subregion: ""
    }, {
        name: "Antigua and Barbuda",
        tld: ".ag",
        cca2: "AG",
        ccn3: 28,
        cca3: "ATG",
        currency: "XCD",
        dialingCode: "1268",
        capital: "Saint John's",
        "alt-spellings": "AG",
        relevance: .5,
        region: "Americas",
        subregion: "Caribbean"
    }, {
        name: "Argentina",
        tld: ".ar",
        cca2: "AR",
        ccn3: 32,
        cca3: "ARG",
        currency: "ARS",
        dialingCode: "54",
        capital: "Buenos Aires",
        "alt-spellings": "AR",
        relevance: 0,
        region: "Americas",
        subregion: "South America"
    }, {
        name: "Armenia",
        tld: ".am",
        cca2: "AM",
        ccn3: 51,
        cca3: "ARM",
        currency: "AMD",
        dialingCode: "374",
        capital: "Yerevan",
        "alt-spellings": "AM,Hayastan",
        relevance: 0,
        region: "Asia",
        subregion: "Western Asia"
    }, {
        name: "Aruba",
        tld: ".aw",
        cca2: "AW",
        ccn3: 533,
        cca3: "ABW",
        currency: "AWG",
        dialingCode: "297",
        capital: "Oranjestad",
        "alt-spellings": "AW",
        relevance: .5,
        region: "Americas",
        subregion: "Caribbean"
    }, {
        name: "Australia",
        tld: ".au",
        cca2: "AU",
        ccn3: 36,
        cca3: "AUS",
        currency: "AUD",
        dialingCode: "61",
        capital: "Canberra",
        "alt-spellings": "AU",
        relevance: 1.5,
        region: "Oceania",
        subregion: "Australia,New Zealand"
    }, {
        name: "Austria",
        tld: ".at",
        cca2: "AT",
        ccn3: 40,
        cca3: "AUT",
        currency: "EUR",
        dialingCode: "43",
        capital: "Vienna",
        "alt-spellings": "AT,Österreich,Osterreich,Oesterreich",
        relevance: 0,
        region: "Europe",
        subregion: "Western Europe"
    }, {
        name: "Azerbaijan",
        tld: ".az",
        cca2: "AZ",
        ccn3: 31,
        cca3: "AZE",
        currency: "AZN",
        dialingCode: "994",
        capital: "Baku",
        "alt-spellings": "AZ",
        relevance: 0,
        region: "Asia",
        subregion: "Western Asia"
    }, {
        name: "Bahamas",
        tld: ".bs",
        cca2: "BS",
        ccn3: 44,
        cca3: "BHS",
        currency: "BSD",
        dialingCode: "1242",
        capital: "Nassau",
        "alt-spellings": "BS",
        relevance: 0,
        region: "Americas",
        subregion: "Caribbean"
    }, {
        name: "Bahrain",
        tld: ".bh",
        cca2: "BH",
        ccn3: 48,
        cca3: "BHR",
        currency: "BHD",
        dialingCode: "973",
        capital: "Manama",
        "alt-spellings": "BH",
        relevance: 0,
        region: "Asia",
        subregion: "Western Asia"
    }, {
        name: "Bangladesh",
        tld: ".bd",
        cca2: "BD",
        ccn3: 50,
        cca3: "BGD",
        currency: "BDT",
        dialingCode: "880",
        capital: "Dhaka",
        "alt-spellings": "BD",
        relevance: 2,
        region: "Asia",
        subregion: "Southern Asia"
    }, {
        name: "Barbados",
        tld: ".bb",
        cca2: "BB",
        ccn3: 52,
        cca3: "BRB",
        currency: "BBD",
        dialingCode: "1246",
        capital: "Bridgetown",
        "alt-spellings": "BB",
        relevance: 0,
        region: "Americas",
        subregion: "Caribbean"
    }, {
        name: "Belarus",
        tld: ".by",
        cca2: "BY",
        ccn3: 112,
        cca3: "BLR",
        currency: "BYR",
        dialingCode: "375",
        capital: "Minsk",
        "alt-spellings": "BY",
        relevance: 0,
        region: "Europe",
        subregion: "Eastern Europe"
    }, {
        name: "Belgium",
        tld: ".be",
        cca2: "BE",
        ccn3: 56,
        cca3: "BEL",
        currency: "EUR",
        dialingCode: "32",
        capital: "Brussels",
        "alt-spellings": "BE,België,Belgie,Belgien,Belgique",
        relevance: 1.5,
        region: "Europe",
        subregion: "Western Europe"
    }, {
        name: "Belize",
        tld: ".bz",
        cca2: "BZ",
        ccn3: 84,
        cca3: "BLZ",
        currency: "BZD",
        dialingCode: "501",
        capital: "Belmopan",
        "alt-spellings": "BZ",
        relevance: 0,
        region: "Americas",
        subregion: "Central America"
    }, {
        name: "Benin",
        tld: ".bj",
        cca2: "BJ",
        ccn3: 204,
        cca3: "BEN",
        currency: "XOF",
        dialingCode: "229",
        capital: "Porto-Novo",
        "alt-spellings": "BJ",
        relevance: 0,
        region: "Africa",
        subregion: "Western Africa"
    }, {
        name: "Bermuda",
        tld: ".bm",
        cca2: "BM",
        ccn3: 60,
        cca3: "BMU",
        currency: "BMD",
        dialingCode: "1441",
        capital: "Hamilton",
        "alt-spellings": "BM",
        relevance: .5,
        region: "Americas",
        subregion: "Northern America"
    }, {
        name: "Bhutan",
        tld: ".bt",
        cca2: "BT",
        ccn3: 64,
        cca3: "BTN",
        currency: "BTN,INR",
        dialingCode: "975",
        capital: "Thimphu",
        "alt-spellings": "BT",
        relevance: 0,
        region: "Asia",
        subregion: "Southern Asia"
    }, {
        name: "Bolivia",
        tld: ".bo",
        cca2: "BO",
        ccn3: 68,
        cca3: "BOL",
        currency: "BOB,BOV",
        dialingCode: "591",
        capital: "Sucre",
        "alt-spellings": "BO",
        relevance: 0,
        region: "Americas",
        subregion: "South America"
    }, {
        name: "Bonaire",
        tld: ".bq",
        cca2: "BQ",
        ccn3: 535,
        cca3: "BES",
        currency: "USD",
        dialingCode: "599",
        capital: "Kralendijk",
        "alt-spellings": "BQ",
        relevance: 0,
        region: "",
        subregion: ""
    }, {
        name: "Bosnia and Herzegovina",
        tld: ".ba",
        cca2: "BA",
        ccn3: 70,
        cca3: "BIH",
        currency: "BAM",
        dialingCode: "387",
        capital: "Sarajevo",
        "alt-spellings": "BA",
        relevance: 0,
        region: "Europe",
        subregion: "Southern Europe"
    }, {
        name: "Botswana",
        tld: ".bw",
        cca2: "BW",
        ccn3: 72,
        cca3: "BWA",
        currency: "BWP",
        dialingCode: "267",
        capital: "Gaborone",
        "alt-spellings": "BW",
        relevance: 0,
        region: "Africa",
        subregion: "Southern Africa"
    }, {
        name: "Bouvet Island",
        tld: ".bv",
        cca2: "BV",
        ccn3: 74,
        cca3: "BVT",
        currency: "NOK",
        dialingCode: "47",
        capital: "",
        "alt-spellings": "BV,Bouvetøya",
        relevance: 0,
        region: "",
        subregion: ""
    }, {
        name: "Brazil",
        tld: ".br",
        cca2: "BR",
        ccn3: 76,
        cca3: "BRA",
        currency: "BRL",
        dialingCode: "55",
        capital: "Brasília",
        "alt-spellings": "BR,Brasil",
        relevance: 2,
        region: "Americas",
        subregion: "South America"
    }, {
        name: "British Indian Ocean Territory",
        tld: ".io",
        cca2: "IO",
        ccn3: 86,
        cca3: "IOT",
        currency: "USD",
        dialingCode: "246",
        capital: "",
        "alt-spellings": "IO",
        relevance: 0,
        region: "Africa",
        subregion: "Eastern Africa"
    }, {
        name: "Brunei Darussalam",
        tld: ".bn",
        cca2: "BN",
        ccn3: 96,
        cca3: "BRN",
        currency: "BND",
        dialingCode: "673",
        capital: "Bandar Seri Begawan",
        "alt-spellings": "BN",
        relevance: 0,
        region: "Asia",
        subregion: "South-Eastern,Asia"
    }, {
        name: "Bulgaria",
        tld: ".bg",
        cca2: "BG",
        ccn3: 100,
        cca3: "BGR",
        currency: "BGN",
        dialingCode: "359",
        capital: "Sofia",
        "alt-spellings": "BG",
        relevance: 0,
        region: "Europe",
        subregion: "Eastern Europe"
    }, {
        name: "Burkina Faso",
        tld: ".bf",
        cca2: "BF",
        ccn3: 854,
        cca3: "BFA",
        currency: "XOF",
        dialingCode: "226",
        capital: "Ouagadougou",
        "alt-spellings": "BF",
        relevance: 0,
        region: "Africa",
        subregion: "Western Africa"
    }, {
        name: "Burundi",
        tld: ".bi",
        cca2: "BI",
        ccn3: 108,
        cca3: "BDI",
        currency: "BIF",
        dialingCode: "257",
        capital: "Bujumbura",
        "alt-spellings": "BI",
        relevance: 0,
        region: "Africa",
        subregion: "Eastern Africa"
    }, {
        name: "Cambodia",
        tld: ".kh",
        cca2: "KH",
        ccn3: 116,
        cca3: "KHM",
        currency: "KHR",
        dialingCode: "855",
        capital: "Phnom Penh",
        "alt-spellings": "KH",
        relevance: 0,
        region: "Asia",
        subregion: "South-Eastern,Asia"
    }, {
        name: "Cameroon",
        tld: ".cm",
        cca2: "CM",
        ccn3: 120,
        cca3: "CMR",
        currency: "XAF",
        dialingCode: "237",
        capital: "Yaoundé",
        "alt-spellings": "CM",
        relevance: 0,
        region: "Africa",
        subregion: "Middle Africa"
    }, {
        name: "Canada",
        tld: ".ca",
        cca2: "CA",
        ccn3: 124,
        cca3: "CAN",
        currency: "CAD",
        dialingCode: "1",
        capital: "Ottawa",
        "alt-spellings": "CA",
        relevance: 2,
        region: "Americas",
        subregion: "Northern America"
    }, {
        name: "Cape Verde",
        tld: ".cv",
        cca2: "CV",
        ccn3: 132,
        cca3: "CPV",
        currency: "CVE",
        dialingCode: "238",
        capital: "Praia",
        "alt-spellings": "CV,Cabo",
        relevance: 0,
        region: "Africa",
        subregion: "Western Africa"
    }, {
        name: "Cayman Islands",
        tld: ".ky",
        cca2: "KY",
        ccn3: 136,
        cca3: "CYM",
        currency: "KYD",
        dialingCode: "1345",
        capital: "George Town",
        "alt-spellings": "KY",
        relevance: .5,
        region: "Americas",
        subregion: "Caribbean"
    }, {
        name: "Central African Republic",
        tld: ".cf",
        cca2: "CF",
        ccn3: 140,
        cca3: "CAF",
        currency: "XAF",
        dialingCode: "236",
        capital: "Bangui",
        "alt-spellings": "CF",
        relevance: 0,
        region: "Africa",
        subregion: "Middle Africa"
    }, {
        name: "Chad",
        tld: ".td",
        cca2: "TD",
        ccn3: 148,
        cca3: "TCD",
        currency: "XAF",
        dialingCode: "235",
        capital: "N'Djamena",
        "alt-spellings": "TD,Tchad",
        relevance: 0,
        region: "Africa",
        subregion: "Middle Africa"
    }, {
        name: "Chile",
        tld: ".cl",
        cca2: "CL",
        ccn3: 152,
        cca3: "CHL",
        currency: "CLF,CLP",
        dialingCode: "56",
        capital: "Santiago",
        "alt-spellings": "CL",
        relevance: 0,
        region: "Americas",
        subregion: "South America"
    }, {
        name: "China",
        tld: ".cn",
        cca2: "CN",
        ccn3: 156,
        cca3: "CHN",
        currency: "CNY",
        dialingCode: "86",
        capital: "Beijing",
        "alt-spellings": "CN,Zhongguo,Zhonghua,Peoples Republic",
        relevance: 0,
        region: "Asia",
        subregion: "Eastern Asia"
    }, {
        name: "Christmas Island",
        tld: ".cx",
        cca2: "CX",
        ccn3: 162,
        cca3: "CXR",
        currency: "AUD",
        dialingCode: "61",
        capital: "Flying Fish Cove",
        "alt-spellings": "CX",
        relevance: .5,
        region: "Oceania",
        subregion: "Australia,New Zealand"
    }, {
        name: "Cocos (Keeling) Islands",
        tld: ".cc",
        cca2: "CC",
        ccn3: 166,
        cca3: "CCK",
        currency: "AUD",
        dialingCode: "61",
        capital: "West Island",
        "alt-spellings": "CC",
        relevance: 0,
        region: "Oceania",
        subregion: "Australia,New Zealand"
    }, {
        name: "Colombia",
        tld: ".co",
        cca2: "CO",
        ccn3: 170,
        cca3: "COL",
        currency: "COP,COU",
        dialingCode: "57",
        capital: "Bogotá",
        "alt-spellings": "CO",
        relevance: 0,
        region: "Americas",
        subregion: "South America"
    }, {
        name: "Comoros",
        tld: ".km",
        cca2: "KM",
        ccn3: 174,
        cca3: "COM",
        currency: "KMF",
        dialingCode: "269",
        capital: "Moroni",
        "alt-spellings": "KM",
        relevance: 0,
        region: "Africa",
        subregion: "Eastern Africa"
    }, {
        name: "Republic of the Congo",
        tld: ".cg",
        cca2: "CG",
        ccn3: 178,
        cca3: "COG",
        currency: "XAF",
        dialingCode: "242",
        capital: "Brazzaville",
        "alt-spellings": "CG",
        relevance: 0,
        region: "Africa",
        subregion: "Middle Africa"
    }, {
        name: "Democratic Republic of the Congo",
        tld: ".cd",
        cca2: "CD",
        ccn3: 180,
        cca3: "COD",
        currency: "CDF",
        dialingCode: "243",
        capital: "Kinshasa",
        "alt-spellings": "CD,Congo-Brazzaville,Repubilika ya Kongo",
        relevance: 0,
        region: "Africa",
        subregion: "Middle Africa"
    }, {
        name: "Cook Islands",
        tld: ".ck",
        cca2: "CK",
        ccn3: 184,
        cca3: "COK",
        currency: "NZD",
        dialingCode: "682",
        capital: "Avarua",
        "alt-spellings": "CK",
        relevance: .5,
        region: "Oceania",
        subregion: "Polynesia"
    }, {
        name: "Costa Rica",
        tld: ".cr",
        cca2: "CR",
        ccn3: 188,
        cca3: "CRI",
        currency: "CRC",
        dialingCode: "506",
        capital: "San José",
        "alt-spellings": "CR",
        relevance: 0,
        region: "Americas",
        subregion: "Central America"
    }, {
        name: "Côte d'Ivoire",
        tld: ".ci",
        cca2: "CI",
        ccn3: 384,
        cca3: "CIV",
        currency: "XOF",
        dialingCode: "225",
        capital: "Yamoussoukro",
        "alt-spellings": "CI,Cote,dIvoire",
        relevance: 0,
        region: "Africa",
        subregion: "Western Africa"
    }, {
        name: "Croatia",
        tld: ".hr",
        cca2: "HR",
        ccn3: 191,
        cca3: "HRV",
        currency: "HRK",
        dialingCode: "385",
        capital: "Zagreb",
        "alt-spellings": "HR,Hrvatska",
        relevance: 0,
        region: "Europe",
        subregion: "Southern Europe"
    }, {
        name: "Cuba",
        tld: ".cu",
        cca2: "CU",
        ccn3: 192,
        cca3: "CUB",
        currency: "CUC,CUP",
        dialingCode: "53",
        capital: "Havana",
        "alt-spellings": "CU",
        relevance: 0,
        region: "Americas",
        subregion: "Caribbean"
    }, {
        name: "Curaçao",
        tld: ".cw",
        cca2: "CW",
        ccn3: 531,
        cca3: "CUW",
        currency: "ANG",
        dialingCode: "599",
        capital: "Willemstad",
        "alt-spellings": "CW,Curacao",
        relevance: 0,
        region: "",
        subregion: ""
    }, {
        name: "Cyprus",
        tld: ".cy",
        cca2: "CY",
        ccn3: 196,
        cca3: "CYP",
        currency: "EUR",
        dialingCode: "357",
        capital: "Nicosia",
        "alt-spellings": "CY,Kýpros",
        relevance: 0,
        region: "Asia",
        subregion: "Western Asia"
    }, {
        name: "Czech Republic",
        tld: ".cz",
        cca2: "CZ",
        ccn3: 203,
        cca3: "CZE",
        currency: "CZK",
        dialingCode: "420",
        capital: "Prague",
        "alt-spellings": "CZ,Česká republika,Česko",
        relevance: 0,
        region: "Europe",
        subregion: "Eastern Europe"
    }, {
        name: "Denmark",
        tld: ".dk",
        cca2: "DK",
        ccn3: 208,
        cca3: "DNK",
        currency: "DKK",
        dialingCode: "45",
        capital: "Copenhagen",
        "alt-spellings": "DK,Danmark",
        relevance: 1.5,
        region: "Europe",
        subregion: "Northern Europe"
    }, {
        name: "Djibouti",
        tld: ".dj",
        cca2: "DJ",
        ccn3: 262,
        cca3: "DJI",
        currency: "DJF",
        dialingCode: "253",
        capital: "Djibouti",
        "alt-spellings": "DJ,Jabuuti,Gabuuti",
        relevance: 0,
        region: "Africa",
        subregion: "Eastern Africa"
    }, {
        name: "Dominica",
        tld: ".dm",
        cca2: "DM",
        ccn3: 212,
        cca3: "DMA",
        currency: "XCD",
        dialingCode: "1767",
        capital: "Roseau",
        "alt-spellings": "DM,Dominique",
        relevance: .5,
        region: "Americas",
        subregion: "Caribbean"
    }, {
        name: "Dominican Republic",
        tld: ".do",
        cca2: "DO",
        ccn3: 214,
        cca3: "DOM",
        currency: "DOP",
        dialingCode: "1809,1829,1849",
        capital: "Santo Domingo",
        "alt-spellings": "DO",
        relevance: 0,
        region: "Americas",
        subregion: "Caribbean"
    }, {
        name: "Ecuador",
        tld: ".ec",
        cca2: "EC",
        ccn3: 218,
        cca3: "ECU",
        currency: "USD",
        dialingCode: "593",
        capital: "Quito",
        "alt-spellings": "EC",
        relevance: 0,
        region: "Americas",
        subregion: "South America"
    }, {
        name: "Egypt",
        tld: ".eg",
        cca2: "EG",
        ccn3: 818,
        cca3: "EGY",
        currency: "EGP",
        dialingCode: "20",
        capital: "Cairo",
        "alt-spellings": "EG",
        relevance: 1.5,
        region: "Africa",
        subregion: "Northern Africa"
    }, {
        name: "El Salvador",
        tld: ".sv",
        cca2: "SV",
        ccn3: 222,
        cca3: "SLV",
        currency: "SVC,USD",
        dialingCode: "503",
        capital: "San Salvador",
        "alt-spellings": "SV",
        relevance: 0,
        region: "Americas",
        subregion: "Central America"
    }, {
        name: "Equatorial Guinea",
        tld: ".gq",
        cca2: "GQ",
        ccn3: 226,
        cca3: "GNQ",
        currency: "XAF",
        dialingCode: "240",
        capital: "Malabo",
        "alt-spellings": "GQ",
        relevance: 0,
        region: "Africa",
        subregion: "Middle Africa"
    }, {
        name: "Eritrea",
        tld: ".er",
        cca2: "ER",
        ccn3: 232,
        cca3: "ERI",
        currency: "ERN",
        dialingCode: "291",
        capital: "Asmara",
        "alt-spellings": "ER",
        relevance: 0,
        region: "Africa",
        subregion: "Eastern Africa"
    }, {
        name: "Estonia",
        tld: ".ee",
        cca2: "EE",
        ccn3: 233,
        cca3: "EST",
        currency: "EUR",
        dialingCode: "372",
        capital: "Tallinn",
        "alt-spellings": "EE,Eesti",
        relevance: 0,
        region: "Europe",
        subregion: "Northern Europe"
    }, {
        name: "Ethiopia",
        tld: ".et",
        cca2: "ET",
        ccn3: 231,
        cca3: "ETH",
        currency: "ETB",
        dialingCode: "251",
        capital: "Addis Ababa",
        "alt-spellings": "ET",
        relevance: 0,
        region: "Africa",
        subregion: "Eastern Africa"
    }, {
        name: "Falkland Islands (Malvinas)",
        tld: ".fk",
        cca2: "FK",
        ccn3: 238,
        cca3: "FLK",
        currency: "FKP",
        dialingCode: "500",
        capital: "Stanley",
        "alt-spellings": "FK",
        relevance: .5,
        region: "Americas",
        subregion: "South America"
    }, {
        name: "Faroe Islands",
        tld: ".fo",
        cca2: "FO",
        ccn3: 234,
        cca3: "FRO",
        currency: "DKK",
        dialingCode: "298",
        capital: "Tórshavn",
        "alt-spellings": "FO,Føroyar,Færøerne",
        relevance: .5,
        region: "Europe",
        subregion: "Northern Europe"
    }, {
        name: "Fiji",
        tld: ".fj",
        cca2: "FJ",
        ccn3: 242,
        cca3: "FJI",
        currency: "FJD",
        dialingCode: "679",
        capital: "Suva",
        "alt-spellings": "FJ,Viti",
        relevance: 0,
        region: "Oceania",
        subregion: "Melanesia"
    }, {
        name: "Finland",
        tld: ".fi",
        cca2: "FI",
        ccn3: 246,
        cca3: "FIN",
        currency: "EUR",
        dialingCode: "358",
        capital: "Helsinki",
        "alt-spellings": "FI,Suomi",
        relevance: 0,
        region: "Europe",
        subregion: "Northern Europe"
    }, {
        name: "France",
        tld: ".fr",
        cca2: "FR",
        ccn3: 250,
        cca3: "FRA",
        currency: "EUR",
        dialingCode: "33",
        capital: "Paris",
        "alt-spellings": "FR,République française",
        relevance: 2.5,
        region: "Europe",
        subregion: "Western Europe"
    }, {
        name: "French Guiana",
        tld: ".gf",
        cca2: "GF",
        ccn3: 254,
        cca3: "GUF",
        currency: "EUR",
        dialingCode: "594",
        capital: "Cayenne",
        "alt-spellings": "GF",
        relevance: 0,
        region: "Americas",
        subregion: "South America"
    }, {
        name: "French Polynesia",
        tld: ".pf",
        cca2: "PF",
        ccn3: 258,
        cca3: "PYF",
        currency: "XPF",
        dialingCode: "689",
        capital: "Papeete",
        "alt-spellings": "PF,Polynésie française",
        relevance: 0,
        region: "Oceania",
        subregion: "Polynesia"
    }, {
        name: "French Southern Territories",
        tld: ".tf",
        cca2: "TF",
        ccn3: 260,
        cca3: "ATF",
        currency: "EUR",
        dialingCode: "",
        capital: "Port-Aux-Français",
        "alt-spellings": "TF",
        relevance: 0,
        region: "",
        subregion: ""
    }, {
        name: "Gabon",
        tld: ".ga",
        cca2: "GA",
        ccn3: 266,
        cca3: "GAB",
        currency: "XAF",
        dialingCode: "241",
        capital: "Libreville",
        "alt-spellings": "GA,République Gabonaise",
        relevance: 0,
        region: "Africa",
        subregion: "Middle Africa"
    }, {
        name: "Gambia",
        tld: ".gm",
        cca2: "GM",
        ccn3: 270,
        cca3: "GMB",
        currency: "GMD",
        dialingCode: "220",
        capital: "Banjul",
        "alt-spellings": "GM",
        relevance: 0,
        region: "Africa",
        subregion: "Western Africa"
    }, {
        name: "Georgia",
        tld: ".ge",
        cca2: "GE",
        ccn3: 268,
        cca3: "GEO",
        currency: "GEL",
        dialingCode: "995",
        capital: "Tbilisi",
        "alt-spellings": "GE",
        relevance: 0,
        region: "Asia",
        subregion: "Western Asia"
    }, {
        name: "Germany",
        tld: ".de",
        cca2: "DE",
        ccn3: 276,
        cca3: "DEU",
        currency: "EUR",
        dialingCode: "49",
        capital: "Berlin",
        "alt-spellings": "DE,Bundesrepublik,Deutschland",
        relevance: 3,
        region: "Europe",
        subregion: "Western Europe"
    }, {
        name: "Ghana",
        tld: ".gh",
        cca2: "GH",
        ccn3: 288,
        cca3: "GHA",
        currency: "GHS",
        dialingCode: "233",
        capital: "Accra",
        "alt-spellings": "GH",
        relevance: 0,
        region: "Africa",
        subregion: "Western Africa"
    }, {
        name: "Gibraltar",
        tld: ".gi",
        cca2: "GI",
        ccn3: 292,
        cca3: "GIB",
        currency: "GIP",
        dialingCode: "350",
        capital: "Gibraltar",
        "alt-spellings": "GI",
        relevance: .5,
        region: "Europe",
        subregion: "Southern Europe"
    }, {
        name: "Greece",
        tld: ".gr",
        cca2: "GR",
        ccn3: 300,
        cca3: "GRC",
        currency: "EUR",
        dialingCode: "30",
        capital: "Athens",
        "alt-spellings": "GR",
        relevance: 1.5,
        region: "Europe",
        subregion: "Southern Europe"
    }, {
        name: "Greenland",
        tld: ".gl",
        cca2: "GL",
        ccn3: 304,
        cca3: "GRL",
        currency: "DKK",
        dialingCode: "299",
        capital: "Nuuk",
        "alt-spellings": "GL,grønland",
        relevance: .5,
        region: "Americas",
        subregion: "Northern America"
    }, {
        name: "Grenada",
        tld: ".gd",
        cca2: "GD",
        ccn3: 308,
        cca3: "GRD",
        currency: "XCD",
        dialingCode: "1473",
        capital: "St. George's",
        "alt-spellings": "GD",
        relevance: 0,
        region: "Americas",
        subregion: "Caribbean"
    }, {
        name: "Guadeloupe",
        tld: ".gp",
        cca2: "GP",
        ccn3: 312,
        cca3: "GLP",
        currency: "EUR",
        dialingCode: "590",
        capital: "Basse-Terre",
        "alt-spellings": "GP",
        relevance: 0,
        region: "Americas",
        subregion: "Caribbean"
    }, {
        name: "Guam",
        tld: ".gu",
        cca2: "GU",
        ccn3: 316,
        cca3: "GUM",
        currency: "USD",
        dialingCode: "1671",
        capital: "Hagåtña",
        "alt-spellings": "GU",
        relevance: 0,
        region: "Oceania",
        subregion: "Micronesia"
    }, {
        name: "Guatemala",
        tld: ".gt",
        cca2: "GT",
        ccn3: 320,
        cca3: "GTM",
        currency: "GTQ",
        dialingCode: "502",
        capital: "Guatemala City",
        "alt-spellings": "GT",
        relevance: 0,
        region: "Americas",
        subregion: "Central America"
    }, {
        name: "Guernsey",
        tld: ".gg",
        cca2: "GG",
        ccn3: 831,
        cca3: "GGY",
        currency: "GBP",
        dialingCode: "44",
        capital: "St. Peter Port",
        "alt-spellings": "GG",
        relevance: .5,
        region: "Europe",
        subregion: "Northern Europe"
    }, {
        name: "Guinea",
        tld: ".gn",
        cca2: "GN",
        ccn3: 324,
        cca3: "GIN",
        currency: "GNF",
        dialingCode: "224",
        capital: "Conakry",
        "alt-spellings": "GN",
        relevance: 0,
        region: "Africa",
        subregion: "Western Africa"
    }, {
        name: "Guinea-Bissau",
        tld: ".gw",
        cca2: "GW",
        ccn3: 624,
        cca3: "GNB",
        currency: "XOF",
        dialingCode: "245",
        capital: "Bissau",
        "alt-spellings": "GW",
        relevance: 0,
        region: "Africa",
        subregion: "Western Africa"
    }, {
        name: "Guyana",
        tld: ".gy",
        cca2: "GY",
        ccn3: 328,
        cca3: "GUY",
        currency: "GYD",
        dialingCode: "592",
        capital: "Georgetown",
        "alt-spellings": "GY",
        relevance: 0,
        region: "Americas",
        subregion: "South America"
    }, {
        name: "Haiti",
        tld: ".ht",
        cca2: "HT",
        ccn3: 332,
        cca3: "HTI",
        currency: "HTG,USD",
        dialingCode: "509",
        capital: "Port-au-Prince",
        "alt-spellings": "HT",
        relevance: 0,
        region: "Americas",
        subregion: "Caribbean"
    }, {
        name: "Heard Island and McDonald Islands",
        tld: ".hm",
        cca2: "HM",
        ccn3: 334,
        cca3: "HMD",
        currency: "AUD",
        dialingCode: "",
        capital: "",
        "alt-spellings": "HM",
        relevance: 0,
        region: "",
        subregion: ""
    }, {
        name: "Vatican City",
        tld: ".va",
        cca2: "VA",
        ccn3: 336,
        cca3: "VAT",
        currency: "EUR",
        dialingCode: "39066,379",
        capital: "Vatican City",
        "alt-spellings": "VA",
        relevance: .5,
        region: "Europe",
        subregion: "Southern Europe"
    }, {
        name: "Honduras",
        tld: ".hn",
        cca2: "HN",
        ccn3: 340,
        cca3: "HND",
        currency: "HNL",
        dialingCode: "504",
        capital: "Tegucigalpa",
        "alt-spellings": "HN",
        relevance: 0,
        region: "Americas",
        subregion: "Central America"
    }, {
        name: "Hong Kong",
        tld: ".hk",
        cca2: "HK",
        ccn3: 344,
        cca3: "HKG",
        currency: "HKD",
        dialingCode: "852",
        capital: "City of Victoria",
        "alt-spellings": "HK",
        relevance: 0,
        region: "Asia",
        subregion: "Eastern Asia"
    }, {
        name: "Hungary",
        tld: ".hu",
        cca2: "HU",
        ccn3: 348,
        cca3: "HUN",
        currency: "HUF",
        dialingCode: "36",
        capital: "Budapest",
        "alt-spellings": "HU,Magyarország",
        relevance: 0,
        region: "Europe",
        subregion: "Eastern Europe"
    }, {
        name: "Iceland",
        tld: ".is",
        cca2: "IS",
        ccn3: 352,
        cca3: "ISL",
        currency: "ISK",
        dialingCode: "354",
        capital: "Reykjavik",
        "alt-spellings": "IS,Island",
        relevance: 0,
        region: "Europe",
        subregion: "Northern Europe"
    }, {
        name: "India",
        tld: ".in",
        cca2: "IN",
        ccn3: 356,
        cca3: "IND",
        currency: "INR",
        dialingCode: "91",
        capital: "New Delhi",
        "alt-spellings": "IN,Hindustan",
        relevance: 3,
        region: "Asia",
        subregion: "Southern Asia"
    }, {
        name: "Indonesia",
        tld: ".id",
        cca2: "ID",
        ccn3: 360,
        cca3: "IDN",
        currency: "IDR",
        dialingCode: "62",
        capital: "Jakarta",
        "alt-spellings": "ID",
        relevance: 2,
        region: "Asia",
        subregion: "South-Eastern,Asia"
    }, {
        name: "Iran",
        tld: ".ir",
        cca2: "IR",
        ccn3: 364,
        cca3: "IRN",
        currency: "IRR",
        dialingCode: "98",
        capital: "Tehran",
        "alt-spellings": "IR",
        relevance: 0,
        region: "Asia",
        subregion: "Southern Asia"
    }, {
        name: "Iraq",
        tld: ".iq",
        cca2: "IQ",
        ccn3: 368,
        cca3: "IRQ",
        currency: "IQD",
        dialingCode: "964",
        capital: "Baghdad",
        "alt-spellings": "IQ",
        relevance: 0,
        region: "Asia",
        subregion: "Western Asia"
    }, {
        name: "Ireland",
        tld: ".ie",
        cca2: "IE",
        ccn3: 372,
        cca3: "IRL",
        currency: "EUR",
        dialingCode: "353",
        capital: "Dublin",
        "alt-spellings": "IE,Éire",
        relevance: 1.2,
        region: "Europe",
        subregion: "Northern Europe"
    }, {
        name: "Isle of Man",
        tld: ".im",
        cca2: "IM",
        ccn3: 833,
        cca3: "IMN",
        currency: "GBP",
        dialingCode: "44",
        capital: "Douglas",
        "alt-spellings": "IM",
        relevance: .5,
        region: "Europe",
        subregion: "Northern Europe"
    }, {
        name: "Israel",
        tld: ".il",
        cca2: "IL",
        ccn3: 376,
        cca3: "ISR",
        currency: "ILS",
        dialingCode: "972",
        capital: "Jerusalem",
        "alt-spellings": "IL",
        relevance: 0,
        region: "Asia",
        subregion: "Western Asia"
    }, {
        name: "Italy",
        tld: ".it",
        cca2: "IT",
        ccn3: 380,
        cca3: "ITA",
        currency: "EUR",
        dialingCode: "39",
        capital: "Rome",
        "alt-spellings": "IT,Italia",
        relevance: 2,
        region: "Europe",
        subregion: "Southern Europe"
    }, {
        name: "Jamaica",
        tld: ".jm",
        cca2: "JM",
        ccn3: 388,
        cca3: "JAM",
        currency: "JMD",
        dialingCode: "1876",
        capital: "Kingston",
        "alt-spellings": "JM",
        relevance: 0,
        region: "Americas",
        subregion: "Caribbean"
    }, {
        name: "Japan",
        tld: ".jp",
        cca2: "JP",
        ccn3: 392,
        cca3: "JPN",
        currency: "JPY",
        dialingCode: "81",
        capital: "Tokyo",
        "alt-spellings": "JP,Nippon,Nihon",
        relevance: 2.5,
        region: "Asia",
        subregion: "Eastern Asia"
    }, {
        name: "Jersey",
        tld: ".je",
        cca2: "JE",
        ccn3: 832,
        cca3: "JEY",
        currency: "GBP",
        dialingCode: "44",
        capital: "Saint Helier",
        "alt-spellings": "JE",
        relevance: .5,
        region: "Europe",
        subregion: "Northern Europe"
    }, {
        name: "Jordan",
        tld: ".jo",
        cca2: "JO",
        ccn3: 400,
        cca3: "JOR",
        currency: "JOD",
        dialingCode: "962",
        capital: "Amman",
        "alt-spellings": "JO",
        relevance: 0,
        region: "Asia",
        subregion: "Western Asia"
    }, {
        name: "Kazakhstan",
        tld: ".kz",
        cca2: "KZ",
        ccn3: 398,
        cca3: "KAZ",
        currency: "KZT",
        dialingCode: "76,77",
        capital: "Astana",
        "alt-spellings": "KZ",
        relevance: 0,
        region: "Asia",
        subregion: "Central Asia"
    }, {
        name: "Kenya",
        tld: ".ke",
        cca2: "KE",
        ccn3: 404,
        cca3: "KEN",
        currency: "KES",
        dialingCode: "254",
        capital: "Nairobi",
        "alt-spellings": "KE",
        relevance: 0,
        region: "Africa",
        subregion: "Eastern Africa"
    }, {
        name: "Kiribati",
        tld: ".ki",
        cca2: "KI",
        ccn3: 296,
        cca3: "KIR",
        currency: "AUD",
        dialingCode: "686",
        capital: "South Tarawa",
        "alt-spellings": "KI",
        relevance: 0,
        region: "Oceania",
        subregion: "Micronesia"
    }, {
        name: "Kuwait",
        tld: ".kw",
        cca2: "KW",
        ccn3: 414,
        cca3: "KWT",
        currency: "KWD",
        dialingCode: "965",
        capital: "Kuwait City",
        "alt-spellings": "KW",
        relevance: 0,
        region: "Asia",
        subregion: "Western Asia"
    }, {
        name: "Kyrgyzstan",
        tld: ".kg",
        cca2: "KG",
        ccn3: 417,
        cca3: "KGZ",
        currency: "KGS",
        dialingCode: "996",
        capital: "Bishkek",
        "alt-spellings": "KG",
        relevance: 0,
        region: "Asia",
        subregion: "Central Asia"
    }, {
        name: "Laos",
        tld: ".la",
        cca2: "LA",
        ccn3: 418,
        cca3: "LAO",
        currency: "LAK",
        dialingCode: "856",
        capital: "Vientiane",
        "alt-spellings": "LA",
        relevance: 0,
        region: "Asia",
        subregion: "South-Eastern,Asia"
    }, {
        name: "Latvia",
        tld: ".lv",
        cca2: "LV",
        ccn3: 428,
        cca3: "LVA",
        currency: "LVL",
        dialingCode: "371",
        capital: "Riga",
        "alt-spellings": "LV,Latvija",
        relevance: 0,
        region: "Europe",
        subregion: "Northern Europe"
    }, {
        name: "Lebanon",
        tld: ".lb",
        cca2: "LB",
        ccn3: 422,
        cca3: "LBN",
        currency: "LBP",
        dialingCode: "961",
        capital: "Beirut",
        "alt-spellings": "LB",
        relevance: 0,
        region: "Asia",
        subregion: "Western Asia"
    }, {
        name: "Lesotho",
        tld: ".ls",
        cca2: "LS",
        ccn3: 426,
        cca3: "LSO",
        currency: "LSL,ZAR",
        dialingCode: "266",
        capital: "Maseru",
        "alt-spellings": "LS",
        relevance: 0,
        region: "Africa",
        subregion: "Southern Africa"
    }, {
        name: "Liberia",
        tld: ".lr",
        cca2: "LR",
        ccn3: 430,
        cca3: "LBR",
        currency: "LRD",
        dialingCode: "231",
        capital: "Monrovia",
        "alt-spellings": "LR",
        relevance: 0,
        region: "Africa",
        subregion: "Western Africa"
    }, {
        name: "Libya",
        tld: ".ly",
        cca2: "LY",
        ccn3: 434,
        cca3: "LBY",
        currency: "LYD",
        dialingCode: "218",
        capital: "Tripoli",
        "alt-spellings": "LY",
        relevance: 0,
        region: "Africa",
        subregion: "Northern Africa"
    }, {
        name: "Liechtenstein",
        tld: ".li",
        cca2: "LI",
        ccn3: 438,
        cca3: "LIE",
        currency: "CHF",
        dialingCode: "423",
        capital: "Vaduz",
        "alt-spellings": "LI",
        relevance: 0,
        region: "Europe",
        subregion: "Western Europe"
    }, {
        name: "Lithuania",
        tld: ".lt",
        cca2: "LT",
        ccn3: 440,
        cca3: "LTU",
        currency: "LTL",
        dialingCode: "370",
        capital: "Vilnius",
        "alt-spellings": "LT,Lietuva",
        relevance: 0,
        region: "Europe",
        subregion: "Northern Europe"
    }, {
        name: "Luxembourg",
        tld: ".lu",
        cca2: "LU",
        ccn3: 442,
        cca3: "LUX",
        currency: "EUR",
        dialingCode: "352",
        capital: "Luxembourg",
        "alt-spellings": "LU",
        relevance: 0,
        region: "Europe",
        subregion: "Western Europe"
    }, {
        name: "Macao",
        tld: ".mo",
        cca2: "MO",
        ccn3: 446,
        cca3: "MAC",
        currency: "MOP",
        dialingCode: "853",
        capital: "",
        "alt-spellings": "MO",
        relevance: 0,
        region: "Asia",
        subregion: "Eastern Asia"
    }, {
        name: "Macedonia",
        tld: ".mk",
        cca2: "MK",
        ccn3: 807,
        cca3: "MKD",
        currency: "MKD",
        dialingCode: "389",
        capital: "Skopje",
        "alt-spellings": "MK",
        relevance: 0,
        region: "Europe",
        subregion: "Southern Europe"
    }, {
        name: "Madagascar",
        tld: ".mg",
        cca2: "MG",
        ccn3: 450,
        cca3: "MDG",
        currency: "MGA",
        dialingCode: "261",
        capital: "Antananarivo",
        "alt-spellings": "MG,Madagasikara",
        relevance: 0,
        region: "Africa",
        subregion: "Eastern Africa"
    }, {
        name: "Malawi",
        tld: ".mw",
        cca2: "MW",
        ccn3: 454,
        cca3: "MWI",
        currency: "MWK",
        dialingCode: "265",
        capital: "Lilongwe",
        "alt-spellings": "MW",
        relevance: 0,
        region: "Africa",
        subregion: "Eastern Africa"
    }, {
        name: "Malaysia",
        tld: ".my",
        cca2: "MY",
        ccn3: 458,
        cca3: "MYS",
        currency: "MYR",
        dialingCode: "60",
        capital: "Kuala Lumpur",
        "alt-spellings": "MY",
        relevance: 0,
        region: "Asia",
        subregion: "South-Eastern,Asia"
    }, {
        name: "Maldives",
        tld: ".mv",
        cca2: "MV",
        ccn3: 462,
        cca3: "MDV",
        currency: "MVR",
        dialingCode: "960",
        capital: "Malé",
        "alt-spellings": "MV",
        relevance: 0,
        region: "Asia",
        subregion: "Southern Asia"
    }, {
        name: "Mali",
        tld: ".ml",
        cca2: "ML",
        ccn3: 466,
        cca3: "MLI",
        currency: "XOF",
        dialingCode: "223",
        capital: "Bamako",
        "alt-spellings": "ML",
        relevance: 0,
        region: "Africa",
        subregion: "Western Africa"
    }, {
        name: "Malta",
        tld: ".mt",
        cca2: "MT",
        ccn3: 470,
        cca3: "MLT",
        currency: "EUR",
        dialingCode: "356",
        capital: "Valletta",
        "alt-spellings": "MT",
        relevance: 0,
        region: "Europe",
        subregion: "Southern Europe"
    }, {
        name: "Marshall Islands",
        tld: ".mh",
        cca2: "MH",
        ccn3: 584,
        cca3: "MHL",
        currency: "USD",
        dialingCode: "692",
        capital: "Majuro",
        "alt-spellings": "MH",
        relevance: .5,
        region: "Oceania",
        subregion: "Micronesia"
    }, {
        name: "Martinique",
        tld: ".mq",
        cca2: "MQ",
        ccn3: 474,
        cca3: "MTQ",
        currency: "EUR",
        dialingCode: "596",
        capital: "Fort-de-France",
        "alt-spellings": "MQ",
        relevance: 0,
        region: "Americas",
        subregion: "Caribbean"
    }, {
        name: "Mauritania",
        tld: ".mr",
        cca2: "MR",
        ccn3: 478,
        cca3: "MRT",
        currency: "MRO",
        dialingCode: "222",
        capital: "Nouakchott",
        "alt-spellings": "MR",
        relevance: 0,
        region: "Africa",
        subregion: "Western Africa"
    }, {
        name: "Mauritius",
        tld: ".mu",
        cca2: "MU",
        ccn3: 480,
        cca3: "MUS",
        currency: "MUR",
        dialingCode: "230",
        capital: "Port Louis",
        "alt-spellings": "MU",
        relevance: 0,
        region: "Africa",
        subregion: "Eastern Africa"
    }, {
        name: "Mayotte",
        tld: ".yt",
        cca2: "YT",
        ccn3: 175,
        cca3: "MYT",
        currency: "EUR",
        dialingCode: "262",
        capital: "Mamoudzou",
        "alt-spellings": "YT",
        relevance: 0,
        region: "Africa",
        subregion: "Eastern Africa"
    }, {
        name: "Mexico",
        tld: ".mx",
        cca2: "MX",
        ccn3: 484,
        cca3: "MEX",
        currency: "MXN,MXV",
        dialingCode: "52",
        capital: "Mexico City",
        "alt-spellings": "MX,Mexicanos",
        relevance: 1.5,
        region: "Americas",
        subregion: "Central America"
    }, {
        name: "Micronesia",
        tld: ".fm",
        cca2: "FM",
        ccn3: 583,
        cca3: "FSM",
        currency: "USD",
        dialingCode: "691",
        capital: "",
        "alt-spellings": "FM",
        relevance: 0,
        region: "Oceania",
        subregion: "Micronesia"
    }, {
        name: "Moldova",
        tld: ".md",
        cca2: "MD",
        ccn3: 498,
        cca3: "MDA",
        currency: "MDL",
        dialingCode: "373",
        capital: "Chisinau",
        "alt-spellings": "MD",
        relevance: 0,
        region: "Europe",
        subregion: "Eastern Europe"
    }, {
        name: "Monaco",
        tld: ".mc",
        cca2: "MC",
        ccn3: 492,
        cca3: "MCO",
        currency: "EUR",
        dialingCode: "377",
        capital: "Monaco",
        "alt-spellings": "MC",
        relevance: 0,
        region: "Europe",
        subregion: "Western Europe"
    }, {
        name: "Mongolia",
        tld: ".mn",
        cca2: "MN",
        ccn3: 496,
        cca3: "MNG",
        currency: "MNT",
        dialingCode: "976",
        capital: "Ulan Bator",
        "alt-spellings": "MN",
        relevance: 0,
        region: "Asia",
        subregion: "Eastern Asia"
    }, {
        name: "Montenegro",
        tld: ".me",
        cca2: "ME",
        ccn3: 499,
        cca3: "MNE",
        currency: "EUR",
        dialingCode: "382",
        capital: "Podgorica",
        "alt-spellings": "ME",
        relevance: 0,
        region: "Europe",
        subregion: "Southern Europe"
    }, {
        name: "Montserrat",
        tld: ".ms",
        cca2: "MS",
        ccn3: 500,
        cca3: "MSR",
        currency: "XCD",
        dialingCode: "1664",
        capital: "Plymouth",
        "alt-spellings": "MS",
        relevance: .5,
        region: "Americas",
        subregion: "Caribbean"
    }, {
        name: "Morocco",
        tld: ".ma",
        cca2: "MA",
        ccn3: 504,
        cca3: "MAR",
        currency: "MAD",
        dialingCode: "212",
        capital: "Rabat",
        "alt-spellings": "MA",
        relevance: 0,
        region: "Africa",
        subregion: "Northern Africa"
    }, {
        name: "Mozambique",
        tld: ".mz",
        cca2: "MZ",
        ccn3: 508,
        cca3: "MOZ",
        currency: "MZN",
        dialingCode: "258",
        capital: "Maputo",
        "alt-spellings": "MZ,Moçambique",
        relevance: 0,
        region: "Africa",
        subregion: "Eastern Africa"
    }, {
        name: "Myanmar (Burma)",
        tld: ".mm",
        cca2: "MM",
        ccn3: 104,
        cca3: "MMR",
        currency: "MMK",
        dialingCode: "95",
        capital: "Naypyidaw",
        "alt-spellings": "MM",
        relevance: 0,
        region: "Asia",
        subregion: "South-Eastern,Asia"
    }, {
        name: "Namibia",
        tld: ".na",
        cca2: "NA",
        ccn3: 516,
        cca3: "NAM",
        currency: "NAD,ZAR",
        dialingCode: "264",
        capital: "Windhoek",
        "alt-spellings": "NA,Namibië",
        relevance: 0,
        region: "Africa",
        subregion: "Southern Africa"
    }, {
        name: "Nauru",
        tld: ".nr",
        cca2: "NR",
        ccn3: 520,
        cca3: "NRU",
        currency: "AUD",
        dialingCode: "674",
        capital: "Yaren",
        "alt-spellings": "NR,Naoero",
        relevance: .5,
        region: "Oceania",
        subregion: "Micronesia"
    }, {
        name: "Nepal",
        tld: ".np",
        cca2: "NP",
        ccn3: 524,
        cca3: "NPL",
        currency: "NPR",
        dialingCode: "977",
        capital: "Kathmandu",
        "alt-spellings": "NP",
        relevance: 0,
        region: "Asia",
        subregion: "Southern Asia"
    }, {
        name: "Netherlands",
        tld: ".nl",
        cca2: "NL",
        ccn3: 528,
        cca3: "NLD",
        currency: "EUR",
        dialingCode: "31",
        capital: "Amsterdam",
        "alt-spellings": "NL,Holland,Nederland",
        relevance: 1.5,
        region: "Europe",
        subregion: "Western Europe"
    }, {
        name: "New Caledonia",
        tld: ".nc",
        cca2: "NC",
        ccn3: 540,
        cca3: "NCL",
        currency: "XPF",
        dialingCode: "687",
        capital: "Nouméa",
        "alt-spellings": "NC",
        relevance: .5,
        region: "Oceania",
        subregion: "Melanesia"
    }, {
        name: "New Zealand",
        tld: ".nz",
        cca2: "NZ",
        ccn3: 554,
        cca3: "NZL",
        currency: "NZD",
        dialingCode: "64",
        capital: "Wellington",
        "alt-spellings": "NZ,Aotearoa",
        relevance: 0,
        region: "Oceania",
        subregion: "Australia,New Zealand"
    }, {
        name: "Nicaragua",
        tld: ".ni",
        cca2: "NI",
        ccn3: 558,
        cca3: "NIC",
        currency: "NIO",
        dialingCode: "505",
        capital: "Managua",
        "alt-spellings": "NI",
        relevance: 0,
        region: "Americas",
        subregion: "Central America"
    }, {
        name: "Niger",
        tld: ".ne",
        cca2: "NE",
        ccn3: 562,
        cca3: "NER",
        currency: "XOF",
        dialingCode: "227",
        capital: "Niamey",
        "alt-spellings": "NE,Nijar",
        relevance: 0,
        region: "Africa",
        subregion: "Western Africa"
    }, {
        name: "Nigeria",
        tld: ".ng",
        cca2: "NG",
        ccn3: 566,
        cca3: "NGA",
        currency: "NGN",
        dialingCode: "234",
        capital: "Abuja",
        "alt-spellings": "NG,Nijeriya,Naíjíríà",
        relevance: 1.5,
        region: "Africa",
        subregion: "Western Africa"
    }, {
        name: "Niue",
        tld: ".nu",
        cca2: "NU",
        ccn3: 570,
        cca3: "NIU",
        currency: "NZD",
        dialingCode: "683",
        capital: "Alofi",
        "alt-spellings": "NU",
        relevance: .5,
        region: "Oceania",
        subregion: "Polynesia"
    }, {
        name: "Norfolk Island",
        tld: ".nf",
        cca2: "NF",
        ccn3: 574,
        cca3: "NFK",
        currency: "AUD",
        dialingCode: "672",
        capital: "Kingston",
        "alt-spellings": "NF",
        relevance: .5,
        region: "Oceania",
        subregion: "Australia,New Zealand"
    }, {
        name: "North Korea",
        tld: ".kp",
        cca2: "KP",
        ccn3: 408,
        cca3: "PRK",
        currency: "KPW",
        dialingCode: "850",
        capital: "Pyongyang",
        "alt-spellings": "KP",
        relevance: 0,
        region: "Asia",
        subregion: "Eastern Asia"
    }, {
        name: "Northern Mariana Islands",
        tld: ".mp",
        cca2: "MP",
        ccn3: 580,
        cca3: "MNP",
        currency: "USD",
        dialingCode: "1670",
        capital: "Saipan",
        "alt-spellings": "MP",
        relevance: .5,
        region: "Oceania",
        subregion: "Micronesia"
    }, {
        name: "Norway",
        tld: ".no",
        cca2: "NO",
        ccn3: 578,
        cca3: "NOR",
        currency: "NOK",
        dialingCode: "47",
        capital: "Oslo",
        "alt-spellings": "NO,Norge,Noreg",
        relevance: 1.5,
        region: "Europe",
        subregion: "Northern Europe"
    }, {
        name: "Oman",
        tld: ".om",
        cca2: "OM",
        ccn3: 512,
        cca3: "OMN",
        currency: "OMR",
        dialingCode: "968",
        capital: "Muscat",
        "alt-spellings": "OM",
        relevance: 0,
        region: "Asia",
        subregion: "Western Asia"
    }, {
        name: "Pakistan",
        tld: ".pk",
        cca2: "PK",
        ccn3: 586,
        cca3: "PAK",
        currency: "PKR",
        dialingCode: "92",
        capital: "Islamabad",
        "alt-spellings": "PK",
        relevance: 2,
        region: "Asia",
        subregion: "Southern Asia"
    }, {
        name: "Palau",
        tld: ".pw",
        cca2: "PW",
        ccn3: 585,
        cca3: "PLW",
        currency: "USD",
        dialingCode: "680",
        capital: "Ngerulmud",
        "alt-spellings": "PW",
        relevance: .5,
        region: "Oceania",
        subregion: "Micronesia"
    }, {
        name: "Palestinian Territory",
        tld: ".ps",
        cca2: "PS",
        ccn3: 275,
        cca3: "PSE",
        currency: "",
        dialingCode: "970",
        capital: "Ramallah",
        "alt-spellings": "PS",
        relevance: 0,
        region: "Asia",
        subregion: "Western Asia"
    }, {
        name: "Panama",
        tld: ".pa",
        cca2: "PA",
        ccn3: 591,
        cca3: "PAN",
        currency: "PAB,USD",
        dialingCode: "507",
        capital: "Panama City",
        "alt-spellings": "PA",
        relevance: 0,
        region: "Americas",
        subregion: "Central America"
    }, {
        name: "Papua New Guinea",
        tld: ".pg",
        cca2: "PG",
        ccn3: 598,
        cca3: "PNG",
        currency: "PGK",
        dialingCode: "675",
        capital: "Port Moresby",
        "alt-spellings": "PG",
        relevance: 0,
        region: "Oceania",
        subregion: "Melanesia"
    }, {
        name: "Paraguay",
        tld: ".py",
        cca2: "PY",
        ccn3: 600,
        cca3: "PRY",
        currency: "PYG",
        dialingCode: "595",
        capital: "Asunción",
        "alt-spellings": "PY",
        relevance: 0,
        region: "Americas",
        subregion: "South America"
    }, {
        name: "Peru",
        tld: ".pe",
        cca2: "PE",
        ccn3: 604,
        cca3: "PER",
        currency: "PEN",
        dialingCode: "51",
        capital: "Lima",
        "alt-spellings": "PE",
        relevance: 0,
        region: "Americas",
        subregion: "South America"
    }, {
        name: "Philippines",
        tld: ".ph",
        cca2: "PH",
        ccn3: 608,
        cca3: "PHL",
        currency: "PHP",
        dialingCode: "63",
        capital: "Manila",
        "alt-spellings": "PH,Pilipinas",
        relevance: 1.5,
        region: "Asia",
        subregion: "South-Eastern,Asia"
    }, {
        name: "Pitcairn",
        tld: ".pn",
        cca2: "PN",
        ccn3: 612,
        cca3: "PCN",
        currency: "NZD",
        dialingCode: "64",
        capital: "Adamstown",
        "alt-spellings": "PN",
        relevance: .5,
        region: "Oceania",
        subregion: "Polynesia"
    }, {
        name: "Poland",
        tld: ".pl",
        cca2: "PL",
        ccn3: 616,
        cca3: "POL",
        currency: "PLN",
        dialingCode: "48",
        capital: "Warsaw",
        "alt-spellings": "PL,Polska",
        relevance: 1.25,
        region: "Europe",
        subregion: "Eastern Europe"
    }, {
        name: "Portugal",
        tld: ".pt",
        cca2: "PT",
        ccn3: 620,
        cca3: "PRT",
        currency: "EUR",
        dialingCode: "351",
        capital: "Lisbon",
        "alt-spellings": "PT,Portuguesa",
        relevance: 1.5,
        region: "Europe",
        subregion: "Southern Europe"
    }, {
        name: "Puerto Rico",
        tld: ".pr",
        cca2: "PR",
        ccn3: 630,
        cca3: "PRI",
        currency: "USD",
        dialingCode: "1787,1939",
        capital: "San Juan",
        "alt-spellings": "PR",
        relevance: 0,
        region: "Americas",
        subregion: "Caribbean"
    }, {
        name: "Qatar",
        tld: ".qa",
        cca2: "QA",
        ccn3: 634,
        cca3: "QAT",
        currency: "QAR",
        dialingCode: "974",
        capital: "Doha",
        "alt-spellings": "QA",
        relevance: 0,
        region: "Asia",
        subregion: "Western Asia"
    }, {
        name: "Réunion",
        tld: ".re",
        cca2: "RE",
        ccn3: 638,
        cca3: "REU",
        currency: "EUR",
        dialingCode: "262",
        capital: "",
        "alt-spellings": "RE,Reunion",
        relevance: 0,
        region: "Africa",
        subregion: "Eastern Africa"
    }, {
        name: "Romania",
        tld: ".ro",
        cca2: "RO",
        ccn3: 642,
        cca3: "ROU",
        currency: "RON",
        dialingCode: "40",
        capital: "Bucharest",
        "alt-spellings": "RO,Rumania,Roumania,România",
        relevance: 0,
        region: "Europe",
        subregion: "Eastern Europe"
    }, {
        name: "Russian Federation",
        tld: ".ru",
        cca2: "RU",
        ccn3: 643,
        cca3: "RUS",
        currency: "RUB",
        dialingCode: "7",
        capital: "Moscow",
        "alt-spellings": "RU,Rossiya",
        relevance: 2.5,
        region: "Europe",
        subregion: "Eastern Europe"
    }, {
        name: "Rwanda",
        tld: ".rw",
        cca2: "RW",
        ccn3: 646,
        cca3: "RWA",
        currency: "RWF",
        dialingCode: "250",
        capital: "Kigali",
        "alt-spellings": "RW",
        relevance: 0,
        region: "Africa",
        subregion: "Eastern Africa"
    }, {
        name: "Saint Barthélemy",
        tld: ".bl",
        cca2: "BL",
        ccn3: 652,
        cca3: "BLM",
        currency: "EUR",
        dialingCode: "590",
        capital: "Gustavia",
        "alt-spellings": "BL,St. Barthelemy",
        relevance: 0,
        region: "Americas",
        subregion: "Caribbean"
    }, {
        name: "Saint Helena",
        tld: ".sh",
        cca2: "SH",
        ccn3: 654,
        cca3: "SHN",
        currency: "SHP",
        dialingCode: "290",
        capital: "Jamestown",
        "alt-spellings": "SH,St.",
        relevance: 0,
        region: "Africa",
        subregion: "Western Africa"
    }, {
        name: "Saint Kitts and Nevis",
        tld: ".kn",
        cca2: "KN",
        ccn3: 659,
        cca3: "KNA",
        currency: "XCD",
        dialingCode: "1869",
        capital: "Basseterre",
        "alt-spellings": "KN,St.",
        relevance: 0,
        region: "Americas",
        subregion: "Caribbean"
    }, {
        name: "Saint Lucia",
        tld: ".lc",
        cca2: "LC",
        ccn3: 662,
        cca3: "LCA",
        currency: "XCD",
        dialingCode: "1758",
        capital: "Castries",
        "alt-spellings": "LC,St.",
        relevance: 0,
        region: "Americas",
        subregion: "Caribbean"
    }, {
        name: "Saint Martin",
        tld: ".mf",
        cca2: "MF",
        ccn3: 663,
        cca3: "MAF",
        currency: "EUR",
        dialingCode: "590",
        capital: "Marigot",
        "alt-spellings": "MF,St.",
        relevance: 0,
        region: "Americas",
        subregion: "Caribbean"
    }, {
        name: "Saint Pierre and Miquelon",
        tld: ".pm",
        cca2: "PM",
        ccn3: 666,
        cca3: "SPM",
        currency: "EUR",
        dialingCode: "508",
        capital: "Saint-Pierre",
        "alt-spellings": "PM,St.",
        relevance: 0,
        region: "Americas",
        subregion: "Northern America"
    }, {
        name: "Saint Vincent and the Grenadines",
        tld: ".vc",
        cca2: "VC",
        ccn3: 670,
        cca3: "VCT",
        currency: "XCD",
        dialingCode: "1784",
        capital: "Kingstown",
        "alt-spellings": "VC,St.",
        relevance: 0,
        region: "Americas",
        subregion: "Caribbean"
    }, {
        name: "Samoa",
        tld: ".ws",
        cca2: "WS",
        ccn3: 882,
        cca3: "WSM",
        currency: "WST",
        dialingCode: "685",
        capital: "Apia",
        "alt-spellings": "WS",
        relevance: 0,
        region: "Oceania",
        subregion: "Polynesia"
    }, {
        name: "San Marino",
        tld: ".sm",
        cca2: "SM",
        ccn3: 674,
        cca3: "SMR",
        currency: "EUR",
        dialingCode: "378",
        capital: "City of San Marino",
        "alt-spellings": "SM",
        relevance: 0,
        region: "Europe",
        subregion: "Southern Europe"
    }, {
        name: "São Tomé and Príncipe",
        tld: ".st",
        cca2: "ST",
        ccn3: 678,
        cca3: "STP",
        currency: "STD",
        dialingCode: "239",
        capital: "São Tomé",
        "alt-spellings": "ST",
        relevance: 0,
        region: "Africa",
        subregion: "Middle Africa"
    }, {
        name: "Saudi Arabia",
        tld: ".sa",
        cca2: "SA",
        ccn3: 682,
        cca3: "SAU",
        currency: "SAR",
        dialingCode: "966",
        capital: "Riyadh",
        "alt-spellings": "SA",
        relevance: 0,
        region: "Asia",
        subregion: "Western Asia"
    }, {
        name: "Senegal",
        tld: ".sn",
        cca2: "SN",
        ccn3: 686,
        cca3: "SEN",
        currency: "XOF",
        dialingCode: "221",
        capital: "Dakar",
        "alt-spellings": "SN,Sénégal",
        relevance: 0,
        region: "Africa",
        subregion: "Western Africa"
    }, {
        name: "Serbia",
        tld: ".rs",
        cca2: "RS",
        ccn3: 688,
        cca3: "SRB",
        currency: "RSD",
        dialingCode: "381",
        capital: "Belgrade",
        "alt-spellings": "RS,Srbija",
        relevance: 0,
        region: "Europe",
        subregion: "Southern Europe"
    }, {
        name: "Seychelles",
        tld: ".sc",
        cca2: "SC",
        ccn3: 690,
        cca3: "SYC",
        currency: "SCR",
        dialingCode: "248",
        capital: "Victoria",
        "alt-spellings": "SC",
        relevance: .5,
        region: "Africa",
        subregion: "Eastern Africa"
    }, {
        name: "Sierra Leone",
        tld: ".sl",
        cca2: "SL",
        ccn3: 694,
        cca3: "SLE",
        currency: "SLL",
        dialingCode: "232",
        capital: "Freetown",
        "alt-spellings": "SL",
        relevance: 0,
        region: "Africa",
        subregion: "Western Africa"
    }, {
        name: "Singapore",
        tld: ".sg",
        cca2: "SG",
        ccn3: 702,
        cca3: "SGP",
        currency: "SGD",
        dialingCode: "65",
        capital: "Singapore",
        "alt-spellings": "SG,Singapura",
        relevance: 0,
        region: "Asia",
        subregion: "South-Eastern,Asia"
    }, {
        name: "Sint Maarten",
        tld: ".sx",
        cca2: "SX",
        ccn3: 534,
        cca3: "SXM",
        currency: "ANG",
        dialingCode: "1721",
        capital: "Philipsburg",
        "alt-spellings": "SX",
        relevance: 0,
        region: "",
        subregion: ""
    }, {
        name: "Slovakia",
        tld: ".sk",
        cca2: "SK",
        ccn3: 703,
        cca3: "SVK",
        currency: "EUR",
        dialingCode: "421",
        capital: "Bratislava",
        "alt-spellings": "SK,Slovenská republika,Slovensko",
        relevance: 0,
        region: "Europe",
        subregion: "Eastern Europe"
    }, {
        name: "Slovenia",
        tld: ".si",
        cca2: "SI",
        ccn3: 705,
        cca3: "SVN",
        currency: "EUR",
        dialingCode: "386",
        capital: "Ljubljana",
        "alt-spellings": "SI,Slovenija",
        relevance: 0,
        region: "Europe",
        subregion: "Southern Europe"
    }, {
        name: "Solomon Islands",
        tld: ".sb",
        cca2: "SB",
        ccn3: 90,
        cca3: "SLB",
        currency: "SDB",
        dialingCode: "677",
        capital: "Honiara",
        "alt-spellings": "SB",
        relevance: 0,
        region: "Oceania",
        subregion: "Melanesia"
    }, {
        name: "Somalia",
        tld: ".so",
        cca2: "SO",
        ccn3: 706,
        cca3: "SOM",
        currency: "SOS",
        dialingCode: "252",
        capital: "Mogadishu",
        "alt-spellings": "SO",
        relevance: 0,
        region: "Africa",
        subregion: "Eastern Africa"
    }, {
        name: "South Africa",
        tld: ".za",
        cca2: "ZA",
        ccn3: 710,
        cca3: "ZAF",
        currency: "ZAR",
        dialingCode: "27",
        capital: "Cape Town",
        "alt-spellings": "ZA,RSA,Suid-Afrika",
        relevance: 0,
        region: "Africa",
        subregion: "Southern Africa"
    }, {
        name: "South Georgia",
        tld: ".gs",
        cca2: "GS",
        ccn3: 239,
        cca3: "SGS",
        currency: "GBP",
        dialingCode: "500",
        capital: "",
        "alt-spellings": "GS",
        relevance: 0,
        region: "Americas",
        subregion: "South America"
    }, {
        name: "South Korea",
        tld: ".kr",
        cca2: "KR",
        ccn3: 410,
        cca3: "KOR",
        currency: "KRW",
        dialingCode: "82",
        capital: "Seoul",
        "alt-spellings": "KR",
        relevance: 1.5,
        region: "Asia",
        subregion: "Eastern Asia"
    }, {
        name: "South Sudan",
        tld: ".ss",
        cca2: "SS",
        ccn3: 728,
        cca3: "SSD",
        currency: "SSP",
        dialingCode: "211",
        capital: "Juba",
        "alt-spellings": "SS",
        relevance: 0,
        region: "",
        subregion: ""
    }, {
        name: "Spain",
        tld: ".es",
        cca2: "ES",
        ccn3: 724,
        cca3: "ESP",
        currency: "EUR",
        dialingCode: "34",
        capital: "Madrid",
        "alt-spellings": "ES,España",
        relevance: 2,
        region: "Europe",
        subregion: "Southern Europe"
    }, {
        name: "Sri Lanka",
        tld: ".lk",
        cca2: "LK",
        ccn3: 144,
        cca3: "LKA",
        currency: "LKR",
        dialingCode: "94",
        capital: "Colombo",
        "alt-spellings": "LK",
        relevance: 0,
        region: "Asia",
        subregion: "Southern Asia"
    }, {
        name: "Sudan",
        tld: ".sd",
        cca2: "SD",
        ccn3: 729,
        cca3: "SDN",
        currency: "SDG",
        dialingCode: "249",
        capital: "Khartoum",
        "alt-spellings": "SD",
        relevance: 0,
        region: "Africa",
        subregion: "Northern Africa"
    }, {
        name: "Suriname",
        tld: ".sr",
        cca2: "SR",
        ccn3: 740,
        cca3: "SUR",
        currency: "SRD",
        dialingCode: "597",
        capital: "Paramaribo",
        "alt-spellings": "SR,Sarnam,Sranangron",
        relevance: 0,
        region: "Americas",
        subregion: "South America"
    }, {
        name: "Svalbard and Jan Mayen",
        tld: ".sj",
        cca2: "SJ",
        ccn3: 744,
        cca3: "SJM",
        currency: "NOK",
        dialingCode: "47",
        capital: "Longyearbyen",
        "alt-spellings": "SJ",
        relevance: .5,
        region: "Europe",
        subregion: "Northern Europe"
    }, {
        name: "Swaziland",
        tld: ".sz",
        cca2: "SZ",
        ccn3: 748,
        cca3: "SWZ",
        currency: "SZL",
        dialingCode: "268",
        capital: "Lobamba",
        "alt-spellings": "SZ,weSwatini,Swatini,Ngwane",
        relevance: 0,
        region: "Africa",
        subregion: "Southern Africa"
    }, {
        name: "Sweden",
        tld: ".se",
        cca2: "SE",
        ccn3: 752,
        cca3: "SWE",
        currency: "SEK",
        dialingCode: "46",
        capital: "Stockholm",
        "alt-spellings": "SE,Sverige",
        relevance: 1.5,
        region: "Europe",
        subregion: "Northern Europe"
    }, {
        name: "Switzerland",
        tld: ".ch",
        cca2: "CH",
        ccn3: 756,
        cca3: "CHE",
        currency: "CHE,CHF,CHW",
        dialingCode: "41",
        capital: "Bern",
        "alt-spellings": "CH,Swiss Confederation,Schweiz,Suisse,Svizzera,Svizra",
        relevance: 1.5,
        region: "Europe",
        subregion: "Western Europe"
    }, {
        name: "Syrian Arab Republic",
        tld: ".sy",
        cca2: "SY",
        ccn3: 760,
        cca3: "SYR",
        currency: "SYP",
        dialingCode: "963",
        capital: "Damascus",
        "alt-spellings": "SY,Syria",
        relevance: 0,
        region: "Asia",
        subregion: "Western Asia"
    }, {
        name: "Taiwan",
        tld: ".tw",
        cca2: "TW",
        ccn3: 158,
        cca3: "TWN",
        currency: "TWD",
        dialingCode: "886",
        capital: "Taipei",
        "alt-spellings": "TW",
        relevance: 0,
        region: "Asia",
        subregion: "Eastern Asia"
    }, {
        name: "Tajikistan",
        tld: ".tj",
        cca2: "TJ",
        ccn3: 762,
        cca3: "TJK",
        currency: "TJS",
        dialingCode: "992",
        capital: "Dushanbe",
        "alt-spellings": "TJ,Toçikiston",
        relevance: 0,
        region: "Asia",
        subregion: "Central Asia"
    }, {
        name: "Tanzania",
        tld: ".tz",
        cca2: "TZ",
        ccn3: 834,
        cca3: "TZA",
        currency: "TZS",
        dialingCode: "255",
        capital: "Dodoma",
        "alt-spellings": "TZ",
        relevance: 0,
        region: "Africa",
        subregion: "Eastern Africa"
    }, {
        name: "Thailand",
        tld: ".th",
        cca2: "TH",
        ccn3: 764,
        cca3: "THA",
        currency: "THB",
        dialingCode: "66",
        capital: "Bangkok",
        "alt-spellings": "TH,Prathet,Thai",
        relevance: 0,
        region: "Asia",
        subregion: "South-Eastern,Asia"
    }, {
        name: "Timor-Leste",
        tld: ".tl",
        cca2: "TL",
        ccn3: 626,
        cca3: "TLS",
        currency: "USD",
        dialingCode: "670",
        capital: "Dili",
        "alt-spellings": "TL",
        relevance: 0,
        region: "Asia",
        subregion: "South-Eastern,Asia"
    }, {
        name: "Togo",
        tld: ".tg",
        cca2: "TG",
        ccn3: 768,
        cca3: "TGO",
        currency: "XOF",
        dialingCode: "228",
        capital: "Lomé",
        "alt-spellings": "TG,Togolese",
        relevance: 0,
        region: "Africa",
        subregion: "Western Africa"
    }, {
        name: "Tokelau",
        tld: ".tk",
        cca2: "TK",
        ccn3: 772,
        cca3: "TKL",
        currency: "NZD",
        dialingCode: "690",
        capital: "Fakaofo",
        "alt-spellings": "TK",
        relevance: .5,
        region: "Oceania",
        subregion: "Polynesia"
    }, {
        name: "Tonga",
        tld: ".to",
        cca2: "TO",
        ccn3: 776,
        cca3: "TON",
        currency: "TOP",
        dialingCode: "676",
        capital: "Nuku'alofa",
        "alt-spellings": "TO",
        relevance: 0,
        region: "Oceania",
        subregion: "Polynesia"
    }, {
        name: "Trinidad and Tobago",
        tld: ".tt",
        cca2: "TT",
        ccn3: 780,
        cca3: "TTO",
        currency: "TTD",
        dialingCode: "1868",
        capital: "Port of Spain",
        "alt-spellings": "TT",
        relevance: 0,
        region: "Americas",
        subregion: "Caribbean"
    }, {
        name: "Tunisia",
        tld: ".tn",
        cca2: "TN",
        ccn3: 788,
        cca3: "TUN",
        currency: "TND",
        dialingCode: "216",
        capital: "Tunis",
        "alt-spellings": "TN",
        relevance: 0,
        region: "Africa",
        subregion: "Northern Africa"
    }, {
        name: "Turkey",
        tld: ".tr",
        cca2: "TR",
        ccn3: 792,
        cca3: "TUR",
        currency: "TRY",
        dialingCode: "90",
        capital: "Ankara",
        "alt-spellings": "TR,Türkiye,Turkiye",
        relevance: 0,
        region: "Asia",
        subregion: "Western Asia"
    }, {
        name: "Turkmenistan",
        tld: ".tm",
        cca2: "TM",
        ccn3: 795,
        cca3: "TKM",
        currency: "TMT",
        dialingCode: "993",
        capital: "Ashgabat",
        "alt-spellings": "TM,Türkmenistan",
        relevance: 0,
        region: "Asia",
        subregion: "Central Asia"
    }, {
        name: "Turks and Caicos Islands",
        tld: ".tc",
        cca2: "TC",
        ccn3: 796,
        cca3: "TCA",
        currency: "USD",
        dialingCode: "1649",
        capital: "Cockburn Town",
        "alt-spellings": "TC",
        relevance: .5,
        region: "Americas",
        subregion: "Caribbean"
    }, {
        name: "Tuvalu",
        tld: ".tv",
        cca2: "TV",
        ccn3: 798,
        cca3: "TUV",
        currency: "AUD",
        dialingCode: "688",
        capital: "Funafuti",
        "alt-spellings": "TV",
        relevance: .5,
        region: "Oceania",
        subregion: "Polynesia"
    }, {
        name: "Uganda",
        tld: ".ug",
        cca2: "UG",
        ccn3: 800,
        cca3: "UGA",
        currency: "UGX",
        dialingCode: "256",
        capital: "Kampala",
        "alt-spellings": "UG",
        relevance: 0,
        region: "Africa",
        subregion: "Eastern Africa"
    }, {
        name: "Ukraine",
        tld: ".ua",
        cca2: "UA",
        ccn3: 804,
        cca3: "UKR",
        currency: "UAH",
        dialingCode: "380",
        capital: "Kiev",
        "alt-spellings": "UA,Ukrayina",
        relevance: 0,
        region: "Europe",
        subregion: "Eastern Europe"
    }, {
        name: "United Arab Emirates",
        tld: ".ae",
        cca2: "AE",
        ccn3: 784,
        cca3: "ARE",
        currency: "AED",
        dialingCode: "971",
        capital: "Abu Dhabi",
        "alt-spellings": "AE,UAE",
        relevance: 0,
        region: "Asia",
        subregion: "Western Asia"
    }, {
        name: "United Kingdom",
        tld: ".uk",
        cca2: "GB",
        ccn3: 826,
        cca3: "GBR",
        currency: "GBP",
        dialingCode: "44",
        capital: "London",
        "alt-spellings": "GB,Great Britain,England,UK,Wales,Scotland,Northern Ireland",
        relevance: 2.5,
        region: "Europe",
        subregion: "Northern Europe"
    }, {
        name: "United States",
        tld: ".us",
        cca2: "US",
        ccn3: 840,
        cca3: "USA",
        currency: "USD,USN,USS",
        dialingCode: "1",
        capital: "Washington D.C.",
        "alt-spellings": "US,USA,United States of America",
        relevance: 3.5,
        region: "Americas",
        subregion: "Northern America"
    }, {
        name: "United States Minor Outlying Islands",
        tld: ".us",
        cca2: "UM",
        ccn3: 581,
        cca3: "UMI",
        currency: "USD",
        dialingCode: "1",
        capital: "",
        "alt-spellings": "UM",
        relevance: 0,
        region: "Americas",
        subregion: "Northern America"
    }, {
        name: "Uruguay",
        tld: ".uy",
        cca2: "UY",
        ccn3: 858,
        cca3: "URY",
        currency: "UYI,UYU",
        dialingCode: "598",
        capital: "Montevideo",
        "alt-spellings": "UY",
        relevance: 0,
        region: "Americas",
        subregion: "South America"
    }, {
        name: "Uzbekistan",
        tld: ".uz",
        cca2: "UZ",
        ccn3: 860,
        cca3: "UZB",
        currency: "UZS",
        dialingCode: "998",
        capital: "Tashkent",
        "alt-spellings": "UZ,O'zbekstan,O‘zbekiston",
        relevance: 0,
        region: "Asia",
        subregion: "Central Asia"
    }, {
        name: "Vanuatu",
        tld: ".vu",
        cca2: "VU",
        ccn3: 548,
        cca3: "VUT",
        currency: "VUV",
        dialingCode: "678",
        capital: "Port Vila",
        "alt-spellings": "VU",
        relevance: 0,
        region: "Oceania",
        subregion: "Melanesia"
    }, {
        name: "Venezuela",
        tld: ".ve",
        cca2: "VE",
        ccn3: 862,
        cca3: "VEN",
        currency: "VEF",
        dialingCode: "58",
        capital: "Caracas",
        "alt-spellings": "VE",
        relevance: 0,
        region: "Americas",
        subregion: "South America"
    }, {
        name: "Vietnam",
        tld: ".vn",
        cca2: "VN",
        ccn3: 704,
        cca3: "VNM",
        currency: "VND",
        dialingCode: "84",
        capital: "Hanoi",
        "alt-spellings": "VN,Viet,Nam",
        relevance: 1.5,
        region: "Asia",
        subregion: "South-Eastern,Asia"
    }, {
        name: "Virgin Islands (British)",
        tld: ".vg",
        cca2: "VG",
        ccn3: 92,
        cca3: "VGB",
        currency: "USD",
        dialingCode: "1284",
        capital: "",
        "alt-spellings": "VG",
        relevance: .5,
        region: "Americas",
        subregion: "Caribbean"
    }, {
        name: "Virgin Islands (U.S.)",
        tld: ".vi",
        cca2: "VI",
        ccn3: 850,
        cca3: "VIR",
        currency: "USD",
        dialingCode: "1340",
        capital: "",
        "alt-spellings": "VI",
        relevance: .5,
        region: "Americas",
        subregion: "Caribbean"
    }, {
        name: "Wallis and Futuna",
        tld: ".wf",
        cca2: "WF",
        ccn3: 876,
        cca3: "WLF",
        currency: "XPF",
        dialingCode: "681",
        capital: "Mata-Utu",
        "alt-spellings": "WF",
        relevance: .5,
        region: "Oceania",
        subregion: "Polynesia"
    }, {
        name: "Western Sahara",
        tld: ".eh",
        cca2: "EH",
        ccn3: 732,
        cca3: "ESH",
        currency: "MAD,DZD,MRO",
        dialingCode: "212",
        capital: "El Aaiún",
        "alt-spellings": "EH",
        relevance: 0,
        region: "Africa",
        subregion: "Northern Africa"
    }, {
        name: "Yemen",
        tld: ".ye",
        cca2: "YE",
        ccn3: 887,
        cca3: "YEM",
        currency: "YER",
        dialingCode: "967",
        capital: "Sana'a",
        "alt-spellings": "YE",
        relevance: 0,
        region: "Asia",
        subregion: "Western Asia"
    }, {
        name: "Zambia",
        tld: ".zm",
        cca2: "ZM",
        ccn3: 894,
        cca3: "ZMB",
        currency: "ZMK",
        dialingCode: "260",
        capital: "Lusaka",
        "alt-spellings": "ZM",
        relevance: 0,
        region: "Africa",
        subregion: "Eastern Africa"
    }, {
        name: "Zimbabwe",
        tld: ".zw",
        cca2: "ZW",
        ccn3: 716,
        cca3: "ZWE",
        currency: "ZWL",
        dialingCode: "263",
        capital: "Harare",
        "alt-spellings": "ZW",
        relevance: 0,
        region: "Africa",
        subregion: "Eastern Africa"
    } ],
    countryCodes: {
        "1": [ "us", "ca" ],
        "7": [ "ru", "kz" ],
        "20": [ "eg" ],
        "27": [ "za" ],
        "30": [ "gr" ],
        "31": [ "nl" ],
        "32": [ "be" ],
        "33": [ "fr" ],
        "34": [ "es" ],
        "36": [ "hu" ],
        "39": [ "it" ],
        "40": [ "ro" ],
        "41": [ "ch" ],
        "43": [ "at" ],
        "44": [ "gb", "gg", "im", "je" ],
        "45": [ "dk" ],
        "46": [ "se" ],
        "47": [ "no", "sj" ],
        "48": [ "pl" ],
        "49": [ "de" ],
        "51": [ "pe" ],
        "52": [ "mx" ],
        "53": [ "cu" ],
        "54": [ "ar" ],
        "55": [ "br" ],
        "56": [ "cl" ],
        "57": [ "co" ],
        "58": [ "ve" ],
        "60": [ "my" ],
        "61": [ "au", "cc", "cx" ],
        "62": [ "id" ],
        "63": [ "ph" ],
        "64": [ "nz" ],
        "65": [ "sg" ],
        "66": [ "th" ],
        "81": [ "jp" ],
        "82": [ "kr" ],
        "84": [ "vn" ],
        "86": [ "cn" ],
        "90": [ "tr" ],
        "91": [ "in" ],
        "92": [ "pk" ],
        "93": [ "af" ],
        "94": [ "lk" ],
        "95": [ "mm" ],
        "98": [ "ir" ],
        "211": [ "ss" ],
        "212": [ "ma", "eh" ],
        "213": [ "dz" ],
        "216": [ "tn" ],
        "218": [ "ly" ],
        "220": [ "gm" ],
        "221": [ "sn" ],
        "222": [ "mr" ],
        "223": [ "ml" ],
        "224": [ "gn" ],
        "225": [ "ci" ],
        "226": [ "bf" ],
        "227": [ "ne" ],
        "228": [ "tg" ],
        "229": [ "bj" ],
        "230": [ "mu" ],
        "231": [ "lr" ],
        "232": [ "sl" ],
        "233": [ "gh" ],
        "234": [ "ng" ],
        "235": [ "td" ],
        "236": [ "cf" ],
        "237": [ "cm" ],
        "238": [ "cv" ],
        "239": [ "st" ],
        "240": [ "gq" ],
        "241": [ "ga" ],
        "242": [ "cg" ],
        "243": [ "cd" ],
        "244": [ "ao" ],
        "245": [ "gw" ],
        "246": [ "io" ],
        "247": [ "ac" ],
        "248": [ "sc" ],
        "249": [ "sd" ],
        "250": [ "rw" ],
        "251": [ "et" ],
        "252": [ "so" ],
        "253": [ "dj" ],
        "254": [ "ke" ],
        "255": [ "tz" ],
        "256": [ "ug" ],
        "257": [ "bi" ],
        "258": [ "mz" ],
        "260": [ "zm" ],
        "261": [ "mg" ],
        "262": [ "re", "yt" ],
        "263": [ "zw" ],
        "264": [ "na" ],
        "265": [ "mw" ],
        "266": [ "ls" ],
        "267": [ "bw" ],
        "268": [ "sz" ],
        "269": [ "km" ],
        "290": [ "sh" ],
        "291": [ "er" ],
        "297": [ "aw" ],
        "298": [ "fo" ],
        "299": [ "gl" ],
        "350": [ "gi" ],
        "351": [ "pt" ],
        "352": [ "lu" ],
        "353": [ "ie" ],
        "354": [ "is" ],
        "355": [ "al" ],
        "356": [ "mt" ],
        "357": [ "cy" ],
        "358": [ "fi", "ax" ],
        "359": [ "bg" ],
        "370": [ "lt" ],
        "371": [ "lv" ],
        "372": [ "ee" ],
        "373": [ "md" ],
        "374": [ "am" ],
        "375": [ "by" ],
        "376": [ "ad" ],
        "377": [ "mc" ],
        "378": [ "sm" ],
        "379": [ "va" ],
        "380": [ "ua" ],
        "381": [ "rs" ],
        "382": [ "me" ],
        "385": [ "hr" ],
        "386": [ "si" ],
        "387": [ "ba" ],
        "389": [ "mk" ],
        "420": [ "cz" ],
        "421": [ "sk" ],
        "423": [ "li" ],
        "500": [ "fk" ],
        "501": [ "bz" ],
        "502": [ "gt" ],
        "503": [ "sv" ],
        "504": [ "hn" ],
        "505": [ "ni" ],
        "506": [ "cr" ],
        "507": [ "pa" ],
        "508": [ "pm" ],
        "509": [ "ht" ],
        "590": [ "gp", "bl", "mf" ],
        "591": [ "bo" ],
        "592": [ "gy" ],
        "593": [ "ec" ],
        "594": [ "gf" ],
        "595": [ "py" ],
        "596": [ "mq" ],
        "597": [ "sr" ],
        "598": [ "uy" ],
        "599": [ "cw", "bq" ],
        "670": [ "tl" ],
        "672": [ "nf" ],
        "673": [ "bn" ],
        "674": [ "nr" ],
        "675": [ "pg" ],
        "676": [ "to" ],
        "677": [ "sb" ],
        "678": [ "vu" ],
        "679": [ "fj" ],
        "680": [ "pw" ],
        "681": [ "wf" ],
        "682": [ "ck" ],
        "683": [ "nu" ],
        "685": [ "ws" ],
        "686": [ "ki" ],
        "687": [ "nc" ],
        "688": [ "tv" ],
        "689": [ "pf" ],
        "690": [ "tk" ],
        "691": [ "fm" ],
        "692": [ "mh" ],
        "850": [ "kp" ],
        "852": [ "hk" ],
        "853": [ "mo" ],
        "855": [ "kh" ],
        "856": [ "la" ],
        "880": [ "bd" ],
        "886": [ "tw" ],
        "960": [ "mv" ],
        "961": [ "lb" ],
        "962": [ "jo" ],
        "963": [ "sy" ],
        "964": [ "iq" ],
        "965": [ "kw" ],
        "966": [ "sa" ],
        "967": [ "ye" ],
        "968": [ "om" ],
        "970": [ "ps" ],
        "971": [ "ae" ],
        "972": [ "il" ],
        "973": [ "bh" ],
        "974": [ "qa" ],
        "975": [ "bt" ],
        "976": [ "mn" ],
        "977": [ "np" ],
        "992": [ "tj" ],
        "993": [ "tm" ],
        "994": [ "az" ],
        "995": [ "ge" ],
        "996": [ "kg" ],
        "998": [ "uz" ],
        "1242": [ "bs" ],
        "1246": [ "bb" ],
        "1264": [ "ai" ],
        "1268": [ "ag" ],
        "1284": [ "vg" ],
        "1340": [ "vi" ],
        "1345": [ "ky" ],
        "1441": [ "bm" ],
        "1473": [ "gd" ],
        "1649": [ "tc" ],
        "1664": [ "ms" ],
        "1671": [ "gu" ],
        "1684": [ "as" ],
        "1758": [ "lc" ],
        "1767": [ "dm" ],
        "1784": [ "vc" ],
        "1787": [ "pr" ],
        "1809": [ "do" ],
        "1868": [ "tt" ],
        "1869": [ "kn" ],
        "1876": [ "jm" ]
    },
    countriesWith: function(attribute) {
        return _.filter(this.countries, function(country) {
            return country[attribute];
        });
    }
};