"use strict";

var errorTranslator = require("./errorTranslator"), popupWindow = require("/ui/common/popupWindow");

var errorHandler = {
    noticeError: function(options) {
        var error = errorTranslator.translate(options.action, options.errorCode, options.status);
        if (!error) {
            LOGGER.error("[errorHandler] - missing required parameters!");
            return;
        }
        new popupWindow().show(false, error.title, {
            details: error.message,
            callback: function() {
                options.callback && _.isFunction(options.callback) && options.callback();
            }
        });
    }
};

module.exports = errorHandler;