"use strict";

var defaultErrorMessage = {
    title: L("error_title"),
    message: L("generic_error_message")
};

var safeGetString = function(id) {
    try {
        var translation = L(id, null);
        if (null == translation) return null;
        translation.trim ? translation = translation.trim() : _.trim && (translation = _.trim(translation));
        if (translation === id) return null;
        if ("" === translation) return null;
        return translation;
    } catch (e) {
        return null;
    }
};

module.exports = {
    translate: function(action, errorCode, status, defaultMessageId, defaultTitleId) {
        action && (action = action.toLowerCase());
        errorCode && (errorCode = errorCode.toLowerCase());
        status && ("string" == typeof status || status instanceof String) && (status = status.toLowerCase());
        var message = safeGetString("error_user_" + action + "_" + status);
        message && "" !== message || !action || !errorCode || (message = safeGetString("error_user_" + action + "_" + errorCode));
        message && "" !== message || !action || (message = safeGetString("error_user_" + action));
        message && "" !== message || !status || (message = safeGetString("error_user_" + status));
        message && "" !== message || !errorCode || (message = safeGetString("error_user_" + errorCode));
        message && "" !== message || (message = safeGetString(defaultMessageId ? defaultMessageId : "generic_error_message"));
        var title = safeGetString("error_user_" + action + "_" + status + "_title");
        title && "" !== title || !action || !errorCode || (title = safeGetString("error_user_" + action + "_" + errorCode + "_title"));
        title && "" !== title || !action || (title = safeGetString("error_user_" + action + "_title"));
        title && "" !== title || !status || (title = safeGetString("error_user_" + status + "_title"));
        title && "" !== title || !errorCode || (title = safeGetString("error_user_" + errorCode + "_title"));
        title && "" !== title || (title = safeGetString(defaultTitleId ? defaultTitleId : "error_title"));
        return {
            title: title,
            message: message
        };
    }
};