"use strict";

module.exports = {
    toUrl: function(url) {
        if (!url) return null;
        var result = url.toLowerCase();
        if (-1 !== result.indexOf("http://") || -1 !== result.indexOf("https://")) return result;
        return "http://" + result;
    },
    toName: function(firstName, lastName) {
        var name = "";
        !_.isEmpty(firstName) && _.isString(firstName) && (name += firstName.substr(0, 1).toUpperCase() + firstName.substr(1));
        !_.isEmpty(lastName) && _.isString(lastName) && (name += " " + lastName.substr(0, 1).toUpperCase() + ".");
        return name;
    },
    toFullName: function(firstName, lastName) {
        var name = "";
        firstName && (name += firstName);
        lastName && (name += " " + lastName);
        return name;
    },
    toCamelCase: function(text) {
        return text.charAt(0).toUpperCase() + text.slice(1);
    },
    toNumber: function(number, width) {
        width -= number.toString().length;
        if (width > 0) return new Array(width + (/\./.test(number) ? 2 : 1)).join("0") + number;
        return number + "";
    }
};