"use strict";

function resizeCloudinaryPhoto(url, size, circular) {
    var splitIdx = url.indexOf("upload/");
    if (splitIdx > 0) {
        var prefix = url.substring(0, splitIdx + 7), suffix = url.substring(splitIdx + 7);
        var circularShape = circular ? ",r_max" : "";
        url = prefix + "w_" + size.width + ",h_" + size.height + ",c_fill/w_" + size.width + ",h_" + size.height + circularShape + ",c_crop/";
    }
    var extension = suffix.substring(suffix.lastIndexOf("."), suffix.length);
    url += suffix.replace(extension, defaultExtension);
    return url;
}

function resizeAPIPhoto(url, size) {
    if (url.indexOf("?") > 0) return url += "&width=" + size.width + "&height=" + size.height;
    return url += "?width=" + size.width + "&height=" + size.height;
}

function resize(widthInDP, heightInDP) {
    return {
        width: units.dipToPixel(widthInDP),
        height: units.dipToPixel(heightInDP)
    };
}

var units = require("/platform/units"), defaultExtension = ".png";

module.exports = {
    toURL: function(url, options) {
        if (!url) return null;
        options = options || {};
        var size = resize(options.width, options.height);
        var url = -1 !== url.indexOf("cloudinary") ? resizeCloudinaryPhoto(url, size, options.circular) : resizeAPIPhoto(url, size);
        return url;
    }
};