"use strict";

var _hasOwnProperty = function(element, attribute) {
    return element && void 0 !== element[attribute] && null !== element[attribute];
};

var _isWindow = function(element) {
    return _hasOwnProperty(element, "exitOnClose") || _hasOwnProperty(element, "orientationModes") || _hasOwnProperty(element, "navBarHidden") || !_hasOwnProperty(element, "getParent") || !element.getParent();
};

module.exports = {
    isWindow: function(element) {
        return _isWindow(element);
    },
    getWindow: function(element) {
        if (!_isWindow(element)) {
            var parent = element.getParent();
            while (parent) {
                if (_isWindow(parent)) return parent;
                parent = parent.getParent();
            }
            return parent;
        }
        return element;
    }
};