"use strict";

var Globals = require("/v6/infrastructure/Globals"), ObjectStorage = require("/v6/infrastructure/storage/ObjectStorage"), wORMExtensions = require("/v6/infrastructure/backbone/wORM/Extensions");

var Bootstrap = function(options) {
    options = options || {};
    Globals.IOC.register("ConfigService", require("/v6/common/ConfigurationService"), "singleton");
    Globals.IOC.register("LoggingService", require("/v6/common/LoggingService"), "singleton");
    Globals.IOC.register("EventLoopService", require("/v6/common/EventLoopService"), "singleton");
    Globals.IOC.register("exploreService", require("/v6/explore/ExploreService"), "singleton");
    Globals.IOC.register("completenessService", require("/v6/carmacompleteness/CompletenessService"), "singleton");
    Globals.IOC.register("bookingService", require("/v6/trip/BookingService"), "singleton");
    Globals.IOC.register("tripService", require("/v6/trip/TripService"), "singleton");
    Globals.IOC.register("messageService", require("/v6/messenger/MessageService"), "singleton");
    Globals.IOC.register("inviteService", require("/v6/invites/InviteService"), "singleton");
    Globals.IOC.register("CurrentUserService", require("/v6/common/CurrentUserService"), "singleton");
    Globals.IOC.register("NetworkService", require("/v6/network/NetworkService"), "singleton");
    Globals.IOC.register("ProfileService", require("/v6/profile/ProfileService"), "singleton");
    Globals.IOC.register("TransactionService", require("/v6/transaction/TransactionService"), "singleton");
    Globals.IOC.register("favoriteUserService", require("/services/favourite_user_service"), "singleton");
    Globals.IOC.register("freeRiderService", require("/services/free_rider_service"), "singleton");
    Globals.IOC.register("UIMessengerService", require("/v6/uiMessenger/UIMessengerService"), "singleton");
    Globals.IOC.register("beaconsHelper", require("/utils/beaconsHelper"), "singleton");
    Globals.IOC.register("geofenceHelper", require("/utils/GeofenceHelper"), "singleton");
    Globals.IOC.register("BoardingService", require("/v6/boarding/BoardingService"), "singleton");
    Globals.IOC.register("SummaryService", require("/v6/boarding/SummaryService"), "singleton");
    Globals.IOC.register("BoardingBgService", require("/v6/boarding/BoardingBackgroundService"), "singleton");
    Globals.IOC.get("exploreService");
    Globals.IOC.get("tripService");
    Globals.IOC.get("messageService");
    Globals.IOC.get("completenessService");
    Globals.IOC.get("bookingService");
    Globals.IOC.get("inviteService");
    Globals.IOC.get("CurrentUserService");
    Globals.IOC.get("NetworkService");
    Globals.IOC.get("ProfileService");
    Globals.IOC.get("LoggingService");
    wORMExtensions.getStorage = function(modelName) {
        var currentUserService = Globals.IOC.get("CurrentUserService"), storagePrefix = currentUserService.id + "-", prefix = storagePrefix + modelName;
        return new ObjectStorage(prefix);
    };
    Globals.IOC.get("BoardingBgService").start();
    Globals.IOC.get("ConfigService").isDev() && Globals.IOC.get("EventLoopService").monitor();
};

module.exports = Bootstrap;