"use strict";

var _ = require("/vendor/underscore"), BoardingApiCallFactory = require("/v6/boarding/helpers/BoardingApiCallFactory");

module.exports = {
    compile: function(currentUser, drives) {
        var operations = [], apiFactory = new BoardingApiCallFactory(currentUser);
        drives = _.sortBy(drives, function(drive) {
            return drive.startTimestamp;
        });
        _.each(drives, function(drive) {
            var rideCalls = [];
            _.each(drive.rides, function(ride) {
                rideCalls = rideCalls.concat(apiFactory.createJoinCarApiCall(drive, ride).concat(apiFactory.createLeaveCarApiCall(drive, ride)));
            });
            operations = operations.concat(apiFactory.createStartTripApiCall(drive)).concat(rideCalls).concat(apiFactory.createEndDriveApiCall(drive));
        });
        return operations;
    }
};