"use strict";

var DriveHelper = {
    isServerAwareOfRide: function(ride) {
        if (!ride) return false;
        return !!ride.rideId;
    },
    isDriving: function(userId, drive) {
        return drive && userId == drive.driverId;
    },
    isDriveStartedSolo: function(userId, drive) {
        if (!userId || !drive || !this.isDriving(userId, drive)) return false;
        if (!drive.rides) return true;
        var startedSolo = true;
        drive.rides.forEach(function(ride) {
            ride.startTimestamp === drive.startTimestamp && (startedSolo = false);
        });
        return startedSolo;
    },
    isDriveFinished: function(userId, drive) {
        if (drive.endTimestamp || drive.state.done || drive.state.error) return true;
        if (this.isDriving(userId, drive)) return false;
        if (drive.rides.length && drive.rides[0].endTimestamp) return true;
        return false;
    }
};

module.exports = DriveHelper;