"use strict";

var Backbone = require("/v6/infrastructure/backbone/BackboneExtend"), Drive = require("/v6/boarding/models/Drive");

var BoardingInfo = Backbone.ExtendedModel.extend({
    config: {
        sync: require("/v6/infrastructure/backbone/wORM/Sync")
    },
    wORM: {
        module: "boarding",
        name: "BoardingInfo",
        fields: {
            current: {
                cascadeDelete: false
            }
        }
    },
    initialize: function(attr) {
        attr = attr || {};
        attr.current instanceof Drive ? this.set("current", attr.current, {
            silent: true
        }) : this.set("current", null, {
            silent: true
        });
    },
    id: function() {
        return this.get("id") || "";
    },
    current: function() {
        return this.get("current");
    },
    validate: function() {
        if (null !== this.current() && !(this.current() instanceof Drive)) throw new Error("BoardingInfo.current should be an instance of Drive");
    }
});

module.exports = BoardingInfo;