"use strict";

var _ = require("/vendor/underscore"), Backbone = require("/v6/infrastructure/backbone/BackboneExtend"), Validation = require("../helpers/Validation");

var SummaryAchievement = Backbone.ExtendedModel.extend({
    config: {
        sync: require("/v6/infrastructure/backbone/wORM/Sync")
    },
    wORM: {
        module: "boarding",
        name: "SummaryAchievement"
    },
    initialize: function(attr) {
        attr = attr || {};
    },
    id: function() {
        return this.get("id") || "";
    },
    timestamp: function() {
        return this.get("timestamp") || 0;
    },
    title: function() {
        return this.get("title") || "";
    },
    description: function() {
        return this.get("description") || "";
    },
    value: function() {
        return this.get("value") || "";
    },
    type: function() {
        return this.get("type") || "";
    },
    iconUrl: function() {
        return this.get("iconUrl") || "";
    },
    validate: function() {
        Validation.required(this.get("timestamp"), "timestamp");
        Validation.required(this.get("title"), "title");
        Validation.required(this.get("description"), "description");
        Validation.required(this.get("value"), "value");
        Validation.required(this.get("type"), "type");
    }
});

module.exports = SummaryAchievement;