"use strict";

var _ = require("/vendor/underscore"), Backbone = require("/v6/infrastructure/backbone/BackboneExtend"), Validation = require("../helpers/Validation");

var SummaryEarning = Backbone.ExtendedModel.extend({
    config: {
        sync: require("/v6/infrastructure/backbone/wORM/Sync")
    },
    wORM: {
        module: "boarding",
        name: "SummaryEarning"
    },
    initialize: function(attr) {
        attr = attr || {};
    },
    id: function() {
        return this.get("id") || "";
    },
    amount: function() {
        return this.get("amount") || 0;
    },
    currency: function() {
        return this.get("currency") || "";
    },
    validate: function() {
        Validation.required(this.get("amount"), "amount");
        Validation.required(this.get("currency"), "currency");
    }
});

module.exports = SummaryEarning;