"use strict";

var _ = require("/vendor/underscore"), Backbone = require("/v6/infrastructure/backbone/BackboneExtend"), Validation = require("../helpers/Validation");

var SummaryRide = Backbone.ExtendedModel.extend({
    config: {
        sync: require("/v6/infrastructure/backbone/wORM/Sync")
    },
    wORM: {
        module: "boarding",
        name: "SummaryRide"
    },
    initialize: function(attr) {
        attr = attr || {};
    },
    id: function() {
        return this.get("id") || "";
    },
    driveId: function() {
        return this.get("driveId") || 0;
    },
    riderId: function() {
        return this.get("riderId") || 0;
    },
    duration: function() {
        return this.get("duration") || 0;
    },
    freeRide: function() {
        return !!this.get("freeRide");
    },
    validate: function() {
        Validation.required(this.get("driveId"), "driveId");
        Validation.required(this.get("riderId"), "riderId");
        Validation.required(this.get("duration"), "duration");
    }
});

module.exports = SummaryRide;