"use strict";

var _ = require("/vendor/underscore"), Validation = require("../helpers/Validation"), Backbone = require("/v6/infrastructure/backbone/BackboneExtend");

var SyncState = Backbone.ExtendedModel.extend({
    config: {
        sync: require("/v6/infrastructure/backbone/wORM/Sync")
    },
    wORM: {
        module: "boarding",
        name: "SyncState"
    },
    initialize: function(attr) {
        attr = attr || {};
        this.set("createdOn", attr.createdOn || Date.now());
        this.set("updatedOn", attr.createdOn || Date.now());
        this.set("done", attr.done || false);
        this.set("error", attr.error || false);
        this.set("errorCode", attr.errorCode || null);
        this.set("errorMessage", attr.errorMessage || null);
    },
    id: function() {
        return this.get("id") || "";
    },
    createdOn: function() {
        return this.get("createdOn");
    },
    updatedOn: function() {
        return this.get("updatedOn");
    },
    done: function() {
        return !!this.get("done");
    },
    error: function() {
        return this.get("error");
    },
    errorCode: function() {
        return this.get("errorCode");
    },
    errorMessage: function() {
        return this.get("errorMessage");
    },
    validate: function() {
        var self = this;
        var notRedifined = [ "done", "error", "errorMessage", "errorCode" ];
        _.each(notRedifined, function(fieldName) {
            Validation.cannotBeRedefined(self.previous(fieldName), self.get(fieldName), fieldName);
        });
        this.get("error") && Validation.allAreOk([ this.get("done"), this.get("errorMessage") ], "Done and ErrorMessage");
    }
});

module.exports = SyncState;