"use strict";

var _ = require("/vendor/underscore"), LocalServerStatusCollection = require("../models/LocalServerStatusCollection"), LocalServerStatus = require("../models/LocalServerStatus");

var LocalServerStatusStorage = {
    get: function() {
        var localServerStatus = new LocalServerStatusCollection().fetch().pop();
        localServerStatus || (localServerStatus = new LocalServerStatus().save());
        return localServerStatus.toJSON();
    },
    save: function(options) {
        options = options || {};
        options.updatedOn = options.updatedOn || Date.now();
        var localServerStatus = LocalServerStatusStorage.get();
        return new LocalServerStatus().fetch({
            id: localServerStatus.id
        }).set({
            updatedOn: options.updatedOn
        }).save().toJSON();
    }
};

module.exports = LocalServerStatusStorage;