"use strict";

var _ = require("/vendor/underscore");

var DeclarativeObject = function(data) {
    data = data || {};
    var getArrayKey = function(key) {
        var matches = /(.*)\[(\d)*\]$/.exec(key);
        if (!matches) return "";
        return matches.slice(1, 3);
    };
    var explicitGet = function(expression, data, options) {
        expression = expression || "";
        options = options || {};
        options.onValue = "function" == typeof options.onValue ? options.onValue : null;
        var expressions = expression.split("."), curExpression = expressions.shift(), remainingExpression = expressions.join("."), arrayExpression = getArrayKey(curExpression);
        if (arrayExpression) {
            var arrayName = arrayExpression[0], arrayIndex = arrayExpression[1];
            data = data || [];
            var value = data[arrayName];
            if (!value) {
                options.onValue && options.onValue(null, arrayName);
                return arrayIndex ? [] : null;
            }
            if (null != arrayIndex) {
                var value = explicitGet(remainingExpression, value[arrayIndex], options);
                !remainingExpression && options.onValue && options.onValue(list, arrayName);
                return remainingExpression ? value : [ value ];
            }
            var list = [];
            _.each(value, function(val) {
                var values = explicitGet(remainingExpression, val, options);
                list = list.concat(values);
            });
            !remainingExpression && options.onValue && options.onValue(list, arrayName);
            return [ list ];
        }
        if (curExpression) {
            if (null == data) return null;
            var value = data[curExpression];
            value = null != value ? value : null;
            !options.onValue || null != value && remainingExpression || options.onValue(value, curExpression);
            if (null == value) return null;
            value = explicitGet(remainingExpression, value, options);
            value instanceof Array || (value = [ value ]);
            return value;
        }
        return null != data ? data : null;
    };
    var explicitSet = function(data, expression, values) {
        expression = expression || "";
        var expressions = expression.split("."), curExpression = expressions.shift(), remainingExpression = expressions.join("."), arrayExpression = getArrayKey(curExpression);
        if (arrayExpression) {
            var arrayName = arrayExpression[0], arrayIndex = arrayExpression[1];
            null == data && (data = {});
            data[arrayName] instanceof Array || (data[arrayName] = []);
            var values = values[0], array = data[arrayName];
            if (!remainingExpression && values instanceof Array) {
                data[arrayName] = values;
                return data;
            }
            if (!(values instanceof Array)) return data;
            for (var i = 0; i < values.length; i++) {
                var inner = values[i];
                var value = explicitSet(array[i], remainingExpression, [ inner ]);
                null != value && (array[i] = value);
            }
            return data;
        }
        if (curExpression) {
            null == data && (data = {});
            null == data[curExpression] && (data[curExpression] = {});
            remainingExpression ? values = explicitSet(data[curExpression], remainingExpression, values) : values instanceof Array && (values = 1 == values.length ? values[0] : void 0);
            if (void 0 !== values) {
                data[curExpression] = null != values ? values : null;
                return data;
            }
            delete data[curExpression];
            return void 0;
        }
        return null != values ? values : null;
    };
    return {
        get: function(expression, options) {
            var values = explicitGet(expression, data, options);
            null == values && (values = []);
            return values;
        },
        set: function(expression, values) {
            var result = explicitSet(data, expression, values);
            void 0 !== result && (data = result);
            return data;
        }
    };
};

module.exports = DeclarativeObject;