"use strict";

var EventLoop = function() {
    var intervalPeriodMs = 5e3, intervalId = null, intervalFn = null;
    var setPerformanceEvalInterval = function() {
        var lastDate = Date.now();
        clearTimeout(intervalId);
        intervalId = setTimeout(function() {
            var now = Date.now(), diff = now - lastDate;
            diff > intervalPeriodMs + 2e3 && intervalFn && intervalFn(diff - intervalPeriodMs);
            setPerformanceEvalInterval();
        }, intervalPeriodMs);
    };
    var onAppPaused = function() {
        clearTimeout(intervalId);
    };
    var onAppResumed = function() {
        setPerformanceEvalInterval();
    };
    setTimeout(function() {
        Ti.App.addAppEventListener("pause", onAppPaused);
        Ti.App.addAppEventListener("resumed", onAppResumed);
    }, 5e3);
    return {
        monitor: function() {
            intervalFn = function(eventLoopOffMs) {};
            setPerformanceEvalInterval();
        },
        dispose: function() {
            intervalFn = null;
            Ti.App.removeAppEventListener("pause", onAppPaused);
            Ti.App.removeAppEventListener("resumed", onAppResumed);
        }
    };
};

EventLoop.$inject = [];

EventLoop.$isRevealingModule = true;

module.exports = EventLoop;