"use strict";

var EventEmitter = require("/v6/infrastructure/EventEmitter/Extend");

var GlobalEvents = function() {
    var ee = new EventEmitter();
    var events = {
        TOPUP_TIMEOUT_RESPONSE: "topup_timeout_response",
        OPEN_MY_TRIPS: "open_my_trips",
        TRIP_FINISHED: "trip_finished"
    };
    var self = {
        onTopupTimeoutResponse: function(fn, once) {
            once ? ee.once(events.TOPUP_TIMEOUT_RESPONSE, fn) : ee.on(events.TOPUP_TIMEOUT_RESPONSE, fn);
        },
        fireTopupTimeoutResponse: function(args) {
            ee.emit(events.TOPUP_TIMEOUT_RESPONSE, args);
        },
        onOpenMyTrips: function(fn) {
            ee.on(events.OPEN_MY_TRIPS, fn);
        },
        fireOpenMyTrips: function(args) {
            ee.emit(events.OPEN_MY_TRIPS, args);
        },
        onTripFinished: function(fn) {
            ee.on(events.TRIP_FINISHED, fn);
        },
        fireTripFinished: function(args) {
            ee.emit(events.TRIP_FINISHED, args);
        }
    };
    Ti.App.addEventListener("carma:logout", function() {
        ee.removeAllListeners();
    });
    return self;
};

module.exports = new GlobalEvents();