"use strict";

var Q = require("/vendor/q"), Queue = require("/v6/common/queue/Queue");

var PeriodicService = function(options) {
    options = options || {};
    options.interval = options.interval;
    var interval = options.interval || 6e4;
    var queue = new Queue({
        timeout: 6e4
    });
    var timeout = null;
    var resetLoop = function() {
        timeout = setTimeout(manager.sync, interval);
    };
    var manager = {
        sync: function() {
            queue.stop = true;
            clearTimeout(timeout);
            queue.length < 2 && queue.push(function() {
                return manager.tick();
            }, {
                name: "PeriodicService.tick"
            });
            return Q().then(function() {
                return queue.all();
            }).finally(function() {
                queue.stop = false;
                resetLoop();
            });
        },
        start: function() {
            resetLoop();
        },
        stop: function() {
            clearTimeout(timeout);
            queue.stop = true;
            queue.clear();
        },
        tick: function() {
            throw new Error("Not implemented. You need to extend this method!");
        }
    };
    return manager;
};

module.exports = PeriodicService;