"use strict";

var _ = require("/vendor/underscore");

var NetworkError = function(data, inner) {
    data = data || {};
    this.message = data.message || null;
    this.isOffline = !!data.isOffline;
    this.code = data.code || "?";
    this.status = data.status || "?";
    this.verb = data.verb || "?";
    this.url = data.url || "?";
    this.inner = inner;
    this.inner && !this.message && (this.message = inner.toString());
    this.message || (this.message = _.template("Unknown error! Message was not specified. ([<%= verb %>] [<%= url %>] [<%= status %>] [<%= code %>])", this));
    this.toString = function() {
        return _.template("<%= message %> [<%= verb %>] [<%= url %>]", this);
    };
};

NetworkError.prototype = new Error();

NetworkError.prototype.constructor = NetworkError;

module.exports = NetworkError;