"use strict";

var EventEmitter = require("/v6/infrastructure/EventEmitter/Extend"), _ = require("/vendor/underscore"), userservice = require("services/user_service");

var InviteService = function() {};

InviteService.prototype = new EventEmitter();

InviteService.prototype.constructor = InviteService;

_.extend(InviteService.prototype, {
    _inviteId: null,
    _inviteCode: null,
    inviteFriend: function() {
        this._inviteCode = userservice.getCachReferralCode();
        var self = this;
        this._inviteId && this._inviteCode ? this._openShare() : this._inviteId ? this._inviteCode ? this._openShare() : userservice.getReferralCode().then(function(data) {
            userservice.cachReferralCode(data.referralCode);
            self._inviteCode = data.referralCode;
            self._openShare();
        }) : Alloy.createModel("invitation").generate({
            method: "UNKNOWN",
            entity: "user"
        }).then(function(data) {
            self._inviteId = data.id;
            self._inviteCode ? self._openShare() : userservice.getReferralCode().then(function(data) {
                userservice.cachReferralCode(data.referralCode);
                self._inviteCode = data.referralCode;
                self._openShare();
            });
        });
    },
    _openShare: function() {
        require("ui/common/sharing").openShare({
            type: "invitefriends",
            inviteId: this._inviteId,
            inviteCode: this._inviteCode,
            subject: L("native_share_no_matches_subject")
        }, this);
    }
});

module.exports = InviteService;