"use strict";

var _ = require("/vendor/underscore"), APIData = require("./APIData");

var ApiUrl = function(options) {
    options = options || {};
    options.url = options.url || "";
    options.verb = options.verb || "POST";
    options.urlData = options.urlData || new APIData();
    options.queryData = options.queryData || new APIData();
    options.postData = options.postData || new APIData();
    options.responseData = options.responseData || new APIData();
    options.errorData = options.errorData || new APIData();
    return {
        verb: function() {
            return options.verb;
        },
        getUrl: function(data, dataOptions) {
            var url = _.template(options.url, options.urlData.literals(data, dataOptions));
            var queryParams = options.queryData.literals(data, dataOptions), queryParamsKeys = _.keys(queryParams);
            if (queryParamsKeys.length) {
                url += "?";
                _.each(queryParams, function(value, name) {
                    url += _.template("<%= name %>=<%= value %><%= separator %>", {
                        name: name,
                        value: value,
                        separator: "&"
                    });
                });
            }
            "&" == url[url.length - 1] && (url = url.substring(0, url.length - 1));
            return url;
        },
        getPostData: function(postData, dataOptions) {
            postData = options.postData.literals(postData, dataOptions);
            return postData;
        },
        getResponseData: function(responseData, dataOptions) {
            responseData = options.responseData.complex(responseData, dataOptions);
            return responseData;
        },
        getErrorData: function(errorData, dataOptions) {
            errorData = options.errorData.literals(errorData, dataOptions);
            return errorData;
        }
    };
};

module.exports = ApiUrl;