"use strict";

var _ = require("/vendor/underscore"), Backbone = require("/v6/infrastructure/backbone/BackboneExtend");

var TimeInfo = Backbone.ExtendedModel.extend({
    config: {
        sync: require("/v6/infrastructure/backbone/wORM/Sync")
    },
    wORM: {
        module: "network",
        name: "TimeInfo"
    },
    initialize: function(attr) {
        attr = attr || {};
        this.set("serverTime", new Date(1985, 11, 5).getTime());
        var now = Date.now();
        this.set("createdOn", attr.createdOn || now);
        this.set("updatedOn", attr.createdOn || now);
    },
    id: function() {
        return this.get("id") || "";
    },
    serverTime: function() {
        return this.get("serverTime") || 0;
    },
    createdOn: function() {
        return this.get("createdOn");
    },
    updatedOn: function() {
        return this.get("updatedOn");
    },
    validate: function() {
        var serverTime = this.get("serverTime"), createdOn = this.get("createdOn"), updatedOn = this.get("updatedOn");
        if ("number" != typeof serverTime || serverTime % 1 > 0) throw new Error("serverTime should be a integer number");
        if ("number" != typeof createdOn || createdOn % 1 > 0) throw new Error("createdOn should be a integer number");
        if ("number" != typeof updatedOn || updatedOn % 1 > 0) throw new Error("updatedOn should be a integer number");
    }
});

module.exports = TimeInfo;