"use strict";

var APICall = require("/v6/network/entity/APICall"), PendingDataAPICall = require("/v6/network/entity/PendingDataAPICall"), APICallType = require("/v6/network/entity/APICallType"), moment = require("/vendor/moment");

var ProfileApiCallFactory = function() {
    return {
        createFullProfileCall: function(userId) {
            return new APICall(APICallType.FullUserProfile, Date.now(), {
                targetUserId: userId
            });
        },
        createBasicProfileCall: function(userId) {
            return new APICall(APICallType.BasicUserProfile, Date.now(), {
                targetUserId: userId
            });
        },
        createProfileListCall: function(userIds) {
            return new APICall(APICallType.GetListOfProfiles, Date.now(), {
                uids: userIds
            });
        },
        createGetTripsCall: function(userId) {
            var relativeTime = moment(Date.now()).startOf("day").valueOf();
            return new APICall(APICallType.GetTrips, Date.now(), {
                targetUserId: userId,
                relativeTime: relativeTime
            });
        },
        createGetCardsCall: function(userId) {
            return new APICall(APICallType.GetCreditCards, Date.now(), {
                userId: userId,
                paymentProvider: "Stripe"
            });
        }
    };
};

module.exports = ProfileApiCallFactory;