"use strict";

var Backbone = require("/v6/infrastructure/backbone/BackboneExtend"), TripCollection = require("./TripCollection"), MessagingStats = require("./MessagingStats"), CreditBalance = require("./CreditBalance"), Validations = require("./Validations"), VehicleCollection = require("./VehicleCollection");

var Profile = Backbone.ExtendedModel.extend({
    config: {
        sync: require("/v6/infrastructure/backbone/wORM/Sync")
    },
    wORM: {
        module: "profile",
        name: "Profile",
        id: "userId",
        fields: {
            messagingStats: {
                module: "profile",
                name: "MessagingStats",
                create: false,
                cascadeDelete: true
            },
            creditBalance: {
                module: "profile",
                name: "CreditBalance",
                create: false,
                cascadeDelete: true
            },
            validations: {
                module: "profile",
                name: "Validations",
                create: false,
                cascadeDelete: true
            },
            trips: {
                module: "profile",
                name: "TripCollection",
                create: false,
                cascadeDelete: true
            },
            cards: {
                module: "profile",
                name: "CardCollection",
                create: false,
                cascadeDelete: true
            },
            vehicles: {
                module: "profile",
                name: "VehicleCollection",
                create: false,
                cascadeDelete: true
            },
            affiliateNames: {
                literal: true
            },
            beacons: {
                literal: true
            }
        }
    },
    initialize: function(attr) {
        attr = attr || {};
    },
    id: function() {
        return this.get("id") || "";
    },
    setMessagingStats: function(stats) {
        this.set("messagingStats", stats);
    },
    setCreditBalance: function(balance) {
        this.set("creditBalance", balance);
    },
    setValidations: function(validations) {
        this.set("validations", validations);
    },
    setTrips: function(trips) {
        this.set("trips", trips);
    },
    setCards: function(cards) {
        this.set("cards", cards);
    },
    setVehicles: function(vehicles) {
        this.set("vehicles", vehicles);
    },
    validate: function() {}
});

module.exports = Profile;