"use strict";

var Backbone = require("/v6/infrastructure/backbone/BackboneExtend"), Schedule = require("./Schedule"), CreditBalance = require("./CreditBalance");

var Trip = Backbone.ExtendedModel.extend({
    config: {
        sync: require("/v6/infrastructure/backbone/wORM/Sync")
    },
    wORM: {
        module: "profile",
        name: "Trip",
        fields: {
            estimatedEarning: {
                module: "profile",
                name: "CreditBalance",
                create: false,
                cascadeDelete: true
            },
            estimatedCost: {
                module: "profile",
                name: "CreditBalance",
                create: false,
                cascadeDelete: true
            },
            schedule: {
                module: "profile",
                name: "Schedule",
                create: false,
                cascadeDelete: true
            }
        }
    },
    initialize: function(attr) {
        attr = attr || {};
    },
    id: function() {
        return this.get("id") || "";
    },
    setEstimatedEarning: function(balance) {
        this.set("estimatedEarning", balance);
    },
    setEstimatedCost: function(balance) {
        this.set("estimatedCost", balance);
    },
    setSchedule: function(schedule) {
        this.set("schedule", schedule);
    },
    validate: function() {}
});

module.exports = Trip;