"use strict";

var _ = require("/vendor/underscore");

var EventEmitter = require("/v6/infrastructure/EventEmitter/Extend");

var TransactionService = function() {
    var eventDispatcher = new EventEmitter();
    var _TOPUPS_READY = "topups_ready", _availableTopups = null;
    return {
        fetchAvailableTopup: function(currency) {
            return Alloy.createModel("available_topup").getTopupsForProvider({
                currencyCode: currency,
                paymentProvider: "Stripe"
            }).then(function(data) {
                _availableTopups = data || {};
                eventDispatcher.emit(_TOPUPS_READY);
                return data;
            }).catch(function() {
                LOGGER.debug("[topup.js] - get available topups error");
            });
        },
        getAvailableTopup: function(options) {
            var Q = require("vendor/q");
            if (_availableTopups) return Q.fcall(function() {
                return _availableTopups;
            });
            var defer = Q.defer();
            eventDispatcher.once(_TOPUPS_READY, function() {
                defer.resolve(_availableTopups);
            });
            return defer.promise;
        }
    };
};

TransactionService.$isRevealingModule = true;

module.exports = TransactionService;