"use strict";

var _ = require("/vendor/underscore"), EventEmitter = require("/v6/infrastructure/EventEmitter/Extend"), UIMessageTypes = require("./entity/UIMessageTypes");

var UIMessengerService = function() {
    var messenger = new EventEmitter();
    var validateMessageType = function(messageName) {
        if (!UIMessageTypes[messageName]) throw new Error(_.template("Message <%= name %> is not allowed.", {
            name: messageName
        }));
    };
    return {
        on: function(messageName, fn) {
            validateMessageType(messageName);
            "function" == typeof fn && messenger.addListener(messageName, fn);
        },
        send: function(messageName, data) {
            validateMessageType(messageName);
            messenger.emit(messageName, data);
        }
    };
};

UIMessengerService.$isRevealingModule = true;

module.exports = UIMessengerService;