"use strict";

var LibPhoneNumber = require("/vendor/phone_format");

module.exports = {
    isPhoneNumber: function(val) {
        return /^[0-9+.,\-\s\)\(]+$/.test(val);
    },
    isValidPhoneNumber: function(phoneNumber, country) {
        if (!phoneNumber) return false;
        country || (country = Ti.Locale.getCurrentCountry().toUpperCase());
        return LibPhoneNumber.isValidNumber(phoneNumber, country);
    },
    matchPhoneNumber: function(phone1, phone2) {
        phone1 = phone1 || "";
        phone2 = phone2 || "";
        return phone1.toString().slice(-7) + "" == phone2.toString().slice(-7) + "";
    }
};