function crop(blob, options, height) {
    "object" != typeof options && (options = {
        width: options,
        height: height
    });
    if (!blob.width || !blob.width) return blob;
    false !== options.fix && (blob = blob.imageAsResized(blob.width, blob.height));
    false !== options.hires && (options = pixels(options));
    if (options.width && options.height) {
        var blob_ratio = blob.width / blob.height;
        var ratio = options.width / options.height;
        blob_ratio !== ratio && (blob = blob.imageAsCropped(blob_ratio > ratio ? {
            width: Math.round(blob.height * ratio)
        } : {
            height: Math.round(blob.width / ratio)
        }));
        (blob.width !== options.width || blob.height !== options.height) && (blob = blob.imageAsResized(options.width, options.height));
        return blob;
    }
    return blob.imageAsCropped(options);
}

function pixels(dimension) {
    if ("number" == typeof dimension) return dimension * pixelFactor();
    dimension.width && (dimension.width = dimension.width * pixelFactor());
    dimension.height && (dimension.height = dimension.height * pixelFactor());
    return dimension;
}

function pixelFactor() {
    if (!_factor) {
        _factor = 1;
        _factor = Ti.Platform.displayCaps.dpi / 160;
    }
    return _factor;
}

var _factor;

exports.crop = crop;

exports.pixels = pixels;

exports.pixelFactor = pixelFactor;