var Message = require("widget/messenger/Message");

var ChatListItemFactory = function() {};

ChatListItemFactory.prototype.create = function(message, options) {
    if (Message.isBookingRequest(message)) {
        var ListItem = require("widget/messenger/MessageBookingRequestListItem");
        return new ListItem(message, options);
    }
    if (Message.isBookingAccepted(message)) {
        var ListItem = require("widget/messenger/MessageBookingAcceptedRequestListItem");
        return new ListItem(message, options);
    }
    if (Message.isBookingCancelled(message)) {
        var ListItem = require("widget/messenger/MessageBookingCancelledRequestListItem");
        return new ListItem(message, options);
    }
    if (Message.isOwnMessage(message)) {
        var ListItem = require("widget/messenger/MessageListItem");
        return new ListItem(message, options);
    }
    var ListItem = require("widget/messenger/MessageLeftListItem");
    return new ListItem(message, options);
};

ChatListItemFactory.prototype.createLoadButton = function(options) {
    var ListItem = require("widget/messenger/MessageLoadMoreListItem");
    return new ListItem(options);
};

ChatListItemFactory.prototype.createLoadingButton = function(options) {
    var ListItem = require("widget/messenger/MessageLoadingMoreListItem");
    return new ListItem(options);
};

module.exports = ChatListItemFactory;