function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    function handleError() {
        $.shellWindow.close();
        var alertWindow = Carma.UI.createAlertWindow({
            title: L("error_title"),
            message: "Failed to load. Try again later..."
        });
        alertWindow.addEventListener("close", function() {
            Ti.App.fireEvent("carma:progress.stop");
        });
        alertWindow.show();
    }
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "shell";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.shellWindow = require("/ui/common/custom_window").createWindow({
        orientationModes: [ Ti.UI.PORTRAIT ],
        navBarHidden: true,
        top: 0,
        left: 0,
        width: "100%",
        height: "100%",
        transparentBackground: true,
        backgroundColor: "#90111111",
        backgroundImage: null,
        opacity: 1,
        modal: false,
        windowSoftInputMode: Alloy.Globals.Style.KeyboardStateResize,
        id: "shellWindow"
    });
    $.__views.shellWindow && $.addTopLevelView($.__views.shellWindow);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, webview = null;
    var androidbackHandler = function() {
        webview.native2web("avego.rtr.utils.NativeAppConnector.back");
    };
    "production" === Ti.App.getDeployType() && $.shellWindow.applyProperties({
        fullscreen: true
    });
    $.shellWindow.addEventListener("androidback", androidbackHandler);
    $.shellWindow.addEventListener("open", function() {
        if (!Ti.Network.online) {
            handleError();
            return;
        }
        Ti.App.fireEvent("carma:progress.start");
        var webshell = Alloy.createWidget("ma.car.app.shell", args);
        $.shellWindow.add(webshell.getView());
        var loaded = false, loadError = false;
        webview = webshell.__views.shell.webview;
        webview.addEventListener("carma:webview.load", function handleLoad() {
            webview.removeEventListener("carma:webview.load", handleLoad);
            loaded = true;
            if (loadError) {
                handleError();
                return;
            }
            setTimeout(function() {
                $.shellWindow.visible = true;
                setTimeout(function() {
                    Ti.App.fireEvent("carma:progress.stop");
                }, 1e3);
            }, 300);
        });
        webview.addEventListener("error", function handleLoadError() {
            loadError = true;
            webview.removeEventListener("error", handleLoadError);
        });
        $.shellWindow.addEventListener("close", function() {
            (false || true && !loadError) && require("services/user_service").findOwn().then(function(profile) {
                Ti.App.fireEvent("app.carma.profile.change", profile ? profile : {});
            });
        });
        $.shellWindow.addAppEventListener("carma:open.conversation", function handleConflictWindow() {
            $.shellWindow.close();
        });
        setTimeout(function() {
            loaded || handleError();
        }, 3e4);
        webshell = null;
    });
    $.shellWindow.visible = false;
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;